/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/platform/log/common/log","vs/base/common/network","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(J){for(var e=[],v=0,R=J.length;v<R;v++)e[v]=be[J[v]];return e};define(be[42],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,C){if(!R)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=v}),define(be[52],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function R(A){const c=[];for(let g in A)v.call(A,g)&&c.push(A[g]);return c}e.values=R;function C(A,c){for(let g in A)if(v.call(A,g)&&c({key:g,value:A[g]},function(){delete A[g]})===!1)return}e.forEach=C;function T(A,c){const g=Object.create(null);for(const r of A){const a=c(r);let p=g[a];p||(p=g[a]=[]),p.push(r)}return g}e.groupBy=T;function E(A,c){const g=new Map;for(const r of A){const a=c(r);let p=g.get(a);p||(p=[],g.set(a,p)),p.push(r)}return g}e.groupByNumber=E;function D(A){const c=Object.create(null);return A&&A.forEach((g,r)=>{c[r]=g}),c}e.fromMap=D;function S(A,c){const g=[],r=[];for(let a of A)c.has(a)||g.push(a);for(let a of c)A.has(a)||r.push(a);return{removed:g,added:r}}e.diffSets=S;function k(A,c){const g=[],r=[];for(let[a,p]of A)c.has(a)||g.push(p);for(let[a,p]of c)A.has(a)||r.push(p);return{removed:g,added:r}}e.diffMaps=k;class i{constructor(){this.map=new Map}add(c,g){let r=this.map.get(c);r||(r=new Set,this.map.set(c,r)),r.add(g)}delete(c,g){const r=this.map.get(c);!r||(r.delete(g),r.size===0&&this.map.delete(c))}forEach(c,g){const r=this.map.get(c);!r||r.forEach(g)}}e.SetMap=i}),define(be[53],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(E){return(D,S,k)=>{let i=null,A=null;if(typeof k.value=="function"?(i="value",A=k.value):typeof k.get=="function"&&(i="get",A=k.get),!A)throw new Error("not supported");k[i]=E(A,S)}}e.createDecorator=v;function R(E,D,S){let k=null,i=null;if(typeof S.value=="function"?(k="value",i=S.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",i=S.get),!i)throw new Error("not supported");const A=`$memoize$${D}`;S[k]=function(...c){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,c)}),this[A]}}e.memoize=R;function C(E,D,S){return v((k,i)=>{const A=`$debounce$${i}`,c=`$debounce$result$${i}`;return function(...g){this[c]||(this[c]=S?S():void 0),clearTimeout(this[A]),D&&(this[c]=D(this[c],...g),g=[this[c]]),this[A]=setTimeout(()=>{k.apply(this,g),this[c]=S?S():void 0},E)}})}e.debounce=C;function T(E,D,S){return v((k,i)=>{const A=`$throttle$timer$${i}`,c=`$throttle$result$${i}`,g=`$throttle$lastRun$${i}`,r=`$throttle$pending$${i}`;return function(...a){if(this[c]||(this[c]=S?S():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),D&&(this[c]=D(this[c],...a)),!this[r]){const p=this[g]+E;p<=Date.now()?(this[g]=Date.now(),k.apply(this,[this[c]]),this[c]=S?S():void 0):(this[r]=!0,this[A]=setTimeout(()=>{this[r]=!1,this[g]=Date.now(),k.apply(this,[this[c]]),this[c]=S?S():void 0},p-Date.now()))}}})}e.throttle=T}),define(be[12],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=R;function C(f){S(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=C;function T(f){S(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=T;function E(f){if(f instanceof Error){let{name:t,message:n}=f;const s=f.stacktrace||f.stack;return{$isError:!0,name:t,message:n,stack:s}}return f}e.transformErrorForSerialization=E;const D="Canceled";function S(f){return f instanceof Error&&f.name===D&&f.message===D}e.isPromiseCanceledError=S;class k extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=k;function i(){const f=new Error(D);return f.name=f.message,f}e.canceled=i;function A(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=A;function c(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=c;function g(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function r(f){const t=new Error(`${f} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function a(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=a;class p extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=p;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function l(f){const t=f;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function d(f,t=Object.create(null)){const n=new Error(f);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=d}),define(be[13],we([0,1,12]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(W,P=0){return W[W.length-(1+P)]}e.tail=R;function C(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=C;function T(W,P,H=(L,$)=>L===$){if(W===P)return!0;if(!W||!P||W.length!==P.length)return!1;for(let L=0,$=W.length;L<$;L++)if(!H(W[L],P[L]))return!1;return!0}e.equals=T;function E(W,P,H){let L=0,$=W.length-1;for(;L<=$;){const Q=(L+$)/2|0,q=H(W[Q],P);if(q<0)L=Q+1;else if(q>0)$=Q-1;else return Q}return-(L+1)}e.binarySearch=E;function D(W,P){let H=0,L=W.length;if(L===0)return 0;for(;H<L;){const $=Math.floor((H+L)/2);P(W[$])?L=$:H=$+1}return H}e.findFirstInSorted=D;function S(W,P,H){if(W=W|0,W>=P.length)throw new TypeError("invalid index");let L=P[Math.floor(P.length*Math.random())],$=[],Q=[],q=[];for(let ae of P){const fe=H(ae,L);fe<0?$.push(ae):fe>0?Q.push(ae):q.push(ae)}return W<$.length?S(W,$,H):W<$.length+q.length?q[0]:S(W-($.length+q.length),Q,H)}e.quickSelect=S;function k(W,P){const H=[];let L;for(const $ of W.slice(0).sort(P))!L||P(L[0],$)!==0?(L=[$],H.push(L)):L.push($);return H}e.groupBy=k;function i(W,P,H){const L=[];function $(ae,fe,Le){if(!(fe===0&&Le.length===0)){const xe=L[L.length-1];xe&&xe.start+xe.deleteCount===ae?(xe.deleteCount+=fe,xe.toInsert.push(...Le)):L.push({start:ae,deleteCount:fe,toInsert:Le})}}let Q=0,q=0;for(;;){if(Q===W.length){$(Q,0,P.slice(q));break}if(q===P.length){$(Q,W.length-Q,[]);break}const ae=W[Q],fe=P[q],Le=H(ae,fe);Le===0?(Q+=1,q+=1):Le<0?($(Q,1,[]),Q+=1):Le>0&&($(Q,0,[fe]),q+=1)}return L}e.sortedDiff=i;function A(W,P,H){const L=i(W,P,H),$=[],Q=[];for(const q of L)$.push(...W.slice(q.start,q.start+q.deleteCount)),Q.push(...q.toInsert);return{removed:$,added:Q}}e.delta=A;function c(W,P,H){if(H===0)return[];const L=W.slice(0,H).sort(P);return r(W,P,L,H,W.length),L}e.top=c;function g(W,P,H,L,$){return H===0?Promise.resolve([]):new Promise((Q,q)=>{(async()=>{const ae=W.length,fe=W.slice(0,H).sort(P);for(let Le=H,xe=Math.min(H+L,ae);Le<ae;Le=xe,xe=Math.min(xe+L,ae)){if(Le>H&&await new Promise(Fe=>setTimeout(Fe)),$&&$.isCancellationRequested)throw(0,v.canceled)();r(W,P,fe,Le,xe)}return fe})().then(Q,q)})}e.topAsync=g;function r(W,P,H,L,$){for(const Q=H.length;L<$;L++){const q=W[L];if(P(q,H[Q-1])<0){H.pop();const ae=D(H,fe=>P(q,fe)<0);H.splice(ae,0,q)}}}function a(W){return W.filter(P=>!!P)}e.coalesce=a;function p(W){let P=0;for(let H=0;H<W.length;H++)W[H]&&(W[P]=W[H],P+=1);W.length=P}e.coalesceInPlace=p;function m(W,P,H){W.splice(H,0,W.splice(P,1)[0])}e.move=m;function y(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=y;function l(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=l;function d(W,P){if(!P)return W.filter((L,$)=>W.indexOf(L)===$);const H=Object.create(null);return W.filter(L=>{const $=P(L);return H[$]?!1:(H[$]=!0,!0)})}e.distinct=d;function f(W){const P=new Set;return W.filter(H=>P.has(H)?!1:(P.add(H),!0))}e.distinctES6=f;function t(W){const P=Object.create(null);return H=>{const L=W(H);return P[L]?!1:(P[L]=!0,!0)}}e.uniqueFilter=t;function n(W,P){for(let H=W.length-1;H>=0;H--){const L=W[H];if(P(L))return H}return-1}e.lastIndex=n;function s(W,P){return W.length>0?W[0]:P}e.firstOrDefault=s;function o(W,P,H=(L,$)=>L===$){let L=0;for(let $=0,Q=Math.min(W.length,P.length);$<Q&&H(W[$],P[$]);$++)L++;return L}e.commonPrefixLength=o;function u(W){return[].concat(...W)}e.flatten=u;function w(W,P){let H=typeof P=="number"?W:0;typeof P=="number"?H=W:(H=0,P=W);const L=[];if(H<=P)for(let $=H;$<P;$++)L.push($);else for(let $=H;$>P;$--)L.push($);return L}e.range=w;function b(W,P,H){return W.reduce((L,$)=>(L[P($)]=H?H($):$,L),Object.create(null))}e.index=b;function I(W,P){return W.push(P),()=>h(W,P)}e.insert=I;function h(W,P){const H=W.indexOf(P);if(H>-1)return W.splice(H,1),P}e.remove=h;function _(W,P,H){const L=W.slice(0,P),$=W.slice(P);return L.concat(H,$)}e.arrayInsert=_;function F(W,P){let H;if(typeof P=="number"){let L=P;H=()=>{const $=Math.sin(L++)*179426549;return $-Math.floor($)}}else H=Math.random;for(let L=W.length-1;L>0;L-=1){const $=Math.floor(H()*(L+1)),Q=W[L];W[L]=W[$],W[$]=Q}}e.shuffle=F;function N(W,P){const H=W.indexOf(P);H>-1&&(W.splice(H,1),W.unshift(P))}e.pushToStart=N;function z(W,P){const H=W.indexOf(P);H>-1&&(W.splice(H,1),W.push(P))}e.pushToEnd=z;function ce(W,P){return Array.isArray(W)?W.map(P):P(W)}e.mapArrayOrNot=ce;function de(W){return Array.isArray(W)?W:[W]}e.asArray=de;function B(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=B;function j(W,P){for(const H of W){const L=P(H);if(L!==void 0)return L}}e.mapFind=j}),define(be[54],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const C=this;let T=!1,E;return function(){return T||(T=!0,E=R.apply(C,arguments)),E}}e.once=v}),define(be[55],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class v{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=v,e.defaultGenerator=new v("id#")}),define(be[43],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function C(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}R.is=C;const T=Object.freeze([]);function E(){return T}R.empty=E;function*D(f){yield f}R.single=D;function S(f){return f||T}R.from=S;function k(f){return!f||f[Symbol.iterator]().next().done===!0}R.isEmpty=k;function i(f){return f[Symbol.iterator]().next().value}R.first=i;function A(f,t){for(const n of f)if(t(n))return!0;return!1}R.some=A;function c(f,t){for(const n of f)if(t(n))return n}R.find=c;function*g(f,t){for(const n of f)t(n)&&(yield n)}R.filter=g;function*r(f,t){for(const n of f)yield t(n)}R.map=r;function*a(...f){for(const t of f)for(const n of t)yield n}R.concat=a;function*p(f){for(const t of f)for(const n of t)yield n}R.concatNested=p;function m(f,t,n){let s=n;for(const o of f)s=t(s,o);return s}R.reduce=m;function*y(f,t,n=f.length){for(t<0&&(t+=f.length),n<0?n+=f.length:n>f.length&&(n=f.length);t<n;t++)yield f[t]}R.slice=y;function l(f,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,f];const s=f[Symbol.iterator]();for(let o=0;o<t;o++){const u=s.next();if(u.done)return[n,R.empty()];n.push(u.value)}return[n,{[Symbol.iterator](){return s}}]}R.consume=l;function d(f,t,n=(s,o)=>s===o){const s=f[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const u=s.next(),w=o.next();if(u.done!==w.done)return!1;if(u.done)return!0;if(!n(u.value,w.value))return!1}}R.equals=d})(v=e.Iterable||(e.Iterable={}))}),define(be[44],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function E(t,n=!1){let s=0,o=t.length,u="",w=0,b=16,I=0;function h(B){let j=0,W=0;for(;j<B;){const P=t.charCodeAt(s);if(P>=48&&P<=57)W=W*16+P-48;else if(P>=65&&P<=70)W=W*16+P-65+10;else if(P>=97&&P<=102)W=W*16+P-97+10;else break;s++,j++}return j<B&&(W=-1),W}function _(B){s=B,u="",w=0,b=16,I=0}function F(){const B=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return I=3,t.substring(B,s);let j=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;j=s}else I=3;return t.substring(B,j)}function N(){let B="",j=s;for(;;){if(s>=o){B+=t.substring(j,s),I=2;break}const W=t.charCodeAt(s);if(W===34){B+=t.substring(j,s),s++;break}if(W===92){if(B+=t.substring(j,s),s++,s>=o){I=2;break}switch(t.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const H=h(4);H>=0?B+=String.fromCharCode(H):I=4;break;default:I=5}j=s;continue}if(W>=0&&W<=31)if(S(W)){B+=t.substring(j,s),I=2;break}else I=6;s++}return B}function z(){if(u="",I=0,w=s,s>=o)return w=o,b=17;let B=t.charCodeAt(s);if(D(B)){do s++,u+=String.fromCharCode(B),B=t.charCodeAt(s);while(D(B));return b=15}if(S(B))return s++,u+=String.fromCharCode(B),B===13&&t.charCodeAt(s)===10&&(s++,u+=`
`),b=14;switch(B){case 123:return s++,b=1;case 125:return s++,b=2;case 91:return s++,b=3;case 93:return s++,b=4;case 58:return s++,b=6;case 44:return s++,b=5;case 34:return s++,u=N(),b=10;case 47:const j=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<o&&!S(t.charCodeAt(s));)s++;return u=t.substring(j,s),b=12}if(t.charCodeAt(s+1)===42){s+=2;const W=o-1;let P=!1;for(;s<W;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,P=!0;break}s++}return P||(s++,I=1),u=t.substring(j,s),b=13}return u+=String.fromCharCode(B),s++,b=16;case 45:if(u+=String.fromCharCode(B),s++,s===o||!k(t.charCodeAt(s)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=F(),b=11;default:for(;s<o&&ce(B);)s++,B=t.charCodeAt(s);if(w!==s){switch(u=t.substring(w,s),u){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return u+=String.fromCharCode(B),s++,b=16}}function ce(B){if(D(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function de(){let B;do B=z();while(B>=12&&B<=15);return B}return{setPosition:_,getPosition:()=>s,scan:n?de:z,getToken:()=>b,getTokenValue:()=>u,getTokenOffset:()=>w,getTokenLength:()=>s-w,getTokenError:()=>I}}e.createScanner=E;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function A(t,n){const s=[],o=new Object;let u;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function I(h,_,F,N){w.value=h,w.offset=_,w.length=F,w.type=N,w.colonOffset=void 0,u=w}try{l(t,{onObjectBegin:(h,_)=>{if(n<=h)throw o;u=void 0,b=n>h,s.push("")},onObjectProperty:(h,_,F)=>{if(n<_||(I(h,_,F,"property"),s[s.length-1]=h,n<=_+F))throw o},onObjectEnd:(h,_)=>{if(n<=h)throw o;u=void 0,s.pop()},onArrayBegin:(h,_)=>{if(n<=h)throw o;u=void 0,s.push(0)},onArrayEnd:(h,_)=>{if(n<=h)throw o;u=void 0,s.pop()},onLiteralValue:(h,_,F)=>{if(n<_||(I(h,_,F,f(h)),n<=_+F))throw o},onSeparator:(h,_,F)=>{if(n<=_)throw o;if(h===":"&&u&&u.type==="property")u.colonOffset=_,b=!1,u=void 0;else if(h===","){const N=s[s.length-1];typeof N=="number"?s[s.length-1]=N+1:(b=!0,s[s.length-1]=""),u=void 0}}})}catch(h){if(h!==o)throw h}return{path:s,previousNode:u,isAtPropertyKey:b,matches:h=>{let _=0;for(let F=0;_<h.length&&F<s.length;F++)if(h[_]===s[F]||h[_]==="*")_++;else if(h[_]!=="**")return!1;return _===h.length}}}e.getLocation=A;function c(t,n=[],s=T.DEFAULT){let o=null,u=[];const w=[];function b(h){Array.isArray(u)?u.push(h):o!==null&&(u[o]=h)}return l(t,{onObjectBegin:()=>{const h={};b(h),w.push(u),u=h,o=null},onObjectProperty:h=>{o=h},onObjectEnd:()=>{u=w.pop()},onArrayBegin:()=>{const h=[];b(h),w.push(u),u=h,o=null},onArrayEnd:()=>{u=w.pop()},onLiteralValue:b,onError:(h,_,F)=>{n.push({error:h,offset:_,length:F})}},s),u[0]}e.parse=c;function g(t,n=[],s=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(h){o.type==="property"&&(o.length=h-o.offset,o=o.parent)}function w(h){return o.children.push(h),h}l(t,{onObjectBegin:h=>{o=w({type:"object",offset:h,length:-1,parent:o,children:[]})},onObjectProperty:(h,_,F)=>{o=w({type:"property",offset:_,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:h,offset:_,length:F,parent:o})},onObjectEnd:(h,_)=>{o.length=h+_-o.offset,o=o.parent,u(h+_)},onArrayBegin:(h,_)=>{o=w({type:"array",offset:h,length:-1,parent:o,children:[]})},onArrayEnd:(h,_)=>{o.length=h+_-o.offset,o=o.parent,u(h+_)},onLiteralValue:(h,_,F)=>{w({type:f(h),offset:_,length:F,parent:o,value:h}),u(_+F)},onSeparator:(h,_,F)=>{o.type==="property"&&(h===":"?o.colonOffset=_:h===","&&u(_))},onError:(h,_,F)=>{n.push({error:h,offset:_,length:F})}},s);const I=o.children[0];return I&&delete I.parent,I}e.parseTree=g;function r(t,n){if(!!t){let s=t;for(let o of n)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const w of s.children)if(Array.isArray(w.children)&&w.children[0].value===o){s=w.children[1],u=!0;break}if(!u)return}else{const u=o;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}}e.findNodeAtLocation=r;function a(t){if(!t.parent||!t.parent.children)return[];const n=a(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=a;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const n=Object.create(null);for(let s of t.children){const o=s.children[1];o&&(n[s.children[0].value]=p(o))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function m(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=m;function y(t,n,s=!1){if(m(t,n,s)){const o=t.children;if(Array.isArray(o))for(let u=0;u<o.length&&o[u].offset<=n;u++){const w=y(o[u],n,s);if(w)return w}return t}}e.findNodeAtOffset=y;function l(t,n,s=T.DEFAULT){const o=E(t,!1);function u(fe){return fe?()=>fe(o.getTokenOffset(),o.getTokenLength()):()=>!0}function w(fe){return fe?Le=>fe(Le,o.getTokenOffset(),o.getTokenLength()):()=>!0}const b=u(n.onObjectBegin),I=w(n.onObjectProperty),h=u(n.onObjectEnd),_=u(n.onArrayBegin),F=u(n.onArrayEnd),N=w(n.onLiteralValue),z=w(n.onSeparator),ce=u(n.onComment),de=w(n.onError),B=s&&s.disallowComments,j=s&&s.allowTrailingComma;function W(){for(;;){const fe=o.scan();switch(o.getTokenError()){case 4:P(14);break;case 5:P(15);break;case 3:P(13);break;case 1:B||P(11);break;case 2:P(12);break;case 6:P(16);break}switch(fe){case 12:case 13:B?P(10):ce();break;case 16:P(1);break;case 15:case 14:break;default:return fe}}}function P(fe,Le=[],xe=[]){if(de(fe),Le.length+xe.length>0){let Fe=o.getToken();for(;Fe!==17;){if(Le.indexOf(Fe)!==-1){W();break}else if(xe.indexOf(Fe)!==-1)break;Fe=W()}}}function H(fe){const Le=o.getTokenValue();return fe?N(Le):I(Le),W(),!0}function L(){switch(o.getToken()){case 11:let fe=0;try{fe=JSON.parse(o.getTokenValue()),typeof fe!="number"&&(P(2),fe=0)}catch(Le){P(2)}N(fe);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return W(),!0}function $(){return o.getToken()!==10?(P(3,[],[2,5]),!1):(H(!1),o.getToken()===6?(z(":"),W(),ae()||P(4,[],[2,5])):P(5,[],[2,5]),!0)}function Q(){b(),W();let fe=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(fe||P(4,[],[]),z(","),W(),o.getToken()===2&&j)break}else fe&&P(6,[],[]);$()||P(4,[],[2,5]),fe=!0}return h(),o.getToken()!==2?P(7,[2],[]):W(),!0}function q(){_(),W();let fe=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(fe||P(4,[],[]),z(","),W(),o.getToken()===4&&j)break}else fe&&P(6,[],[]);ae()||P(4,[],[4,5]),fe=!0}return F(),o.getToken()!==4?P(8,[4],[]):W(),!0}function ae(){switch(o.getToken()){case 3:return q();case 1:return Q();case 10:return H(!0);default:return L()}}return W(),o.getToken()===17?s.allowEmptyContent?!0:(P(4,[],[]),!1):ae()?(o.getToken()!==17&&P(9,[],[]),!0):(P(4,[],[]),!1)}e.visit=l;function d(t,n){let s=E(t),o=[],u,w=0,b;do switch(b=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:w!==b&&o.push(t.substring(w,b)),n!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,n)),w=s.getPosition();break}while(u!==17);return o.join("")}e.stripComments=d;function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(be[107],we([0,1,44]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(S,k,i){let A,c,g,r,a;if(k){for(r=k.offset,a=r+k.length,g=r;g>0&&!D(S,g-1);)g--;let w=a;for(;w<S.length&&!D(S,w);)w++;c=S.substring(g,w),A=T(c,i)}else c=S,A=0,g=0,r=0,a=S.length;const p=E(i,S);let m=!1,y=0,l;i.insertSpaces?l=C(" ",i.tabSize||4):l="	";const d=(0,v.createScanner)(c,!1);let f=!1;function t(){return p+C(l,A+y)}function n(){let w=d.scan();for(m=!1;w===15||w===14;)m=m||w===14,w=d.scan();return f=w===16||d.getTokenError()!==0,w}const s=[];function o(w,b,I){!f&&b<a&&I>r&&S.substring(b,I)!==w&&s.push({offset:b,length:I-b,content:w})}let u=n();if(u!==17){const w=d.getTokenOffset()+g,b=C(l,A);o(b,g,w)}for(;u!==17;){let w=d.getTokenOffset()+d.getTokenLength()+g,b=n(),I="";for(;!m&&(b===12||b===13);){const _=d.getTokenOffset()+g;o(" ",w,_),w=d.getTokenOffset()+d.getTokenLength()+g,I=b===12?t():"",b=n()}if(b===2)u!==1&&(y--,I=t());else if(b===4)u!==3&&(y--,I=t());else{switch(u){case 3:case 1:y++,I=t();break;case 5:case 12:I=t();break;case 13:m?I=t():I=" ";break;case 6:I=" ";break;case 10:if(b===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?I=" ":b!==5&&b!==17&&(f=!0);break;case 16:f=!0;break}m&&(b===12||b===13)&&(I=t())}const h=d.getTokenOffset()+g;o(I,w,h),u=b}return s}e.format=R;function C(S,k){let i="";for(let A=0;A<k;A++)i+=S;return i}function T(S,k){let i=0,A=0;const c=k.tabSize||4;for(;i<S.length;){const g=S.charAt(i);if(g===" ")A++;else if(g==="	")A+=c;else break;i++}return Math.floor(A/c)}function E(S,k){for(let i=0;i<k.length;i++){const A=k.charAt(i);if(A==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(A===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=E;function D(S,k){return`\r
`.indexOf(S.charAt(k))!==-1}e.isEOL=D}),define(be[108],we([0,1,44,107]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(k,i,A){return T(k,i,void 0,A)}e.removeProperty=C;function T(k,i,A,c,g){const r=i.slice(),a=[],p=(0,v.parseTree)(k,a);let m,y;for(;r.length>0&&(y=r.pop(),m=(0,v.findNodeAtLocation)(p,r),m===void 0&&A!==void 0);)typeof y=="string"?A={[y]:A}:A=[A];if(m)if(m.type==="object"&&typeof y=="string"&&Array.isArray(m.children)){const l=(0,v.findNodeAtLocation)(m,[y]);if(l!==void 0)if(A===void 0){if(!l.parent)throw new Error("Malformed AST");const d=m.children.indexOf(l.parent);let f,t=l.parent.offset+l.parent.length;if(d>0){const n=m.children[d-1];f=n.offset+n.length}else f=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return E(k,{offset:f,length:t-f,content:""},c)}else return E(k,{offset:l.offset,length:l.length,content:JSON.stringify(A)},c);else{if(A===void 0)return[];const d=`${JSON.stringify(y)}: ${JSON.stringify(A)}`,f=g?g(m.children.map(n=>n.children[0].value)):m.children.length;let t;if(f>0){const n=m.children[f-1];t={offset:n.offset+n.length,length:0,content:","+d}}else m.children.length===0?t={offset:m.offset+1,length:0,content:d}:t={offset:m.offset+1,length:0,content:d+","};return E(k,t,c)}}else if(m.type==="array"&&typeof y=="number"&&Array.isArray(m.children))if(A!==void 0){const l=`${JSON.stringify(A)}`;let d;if(m.children.length===0||y===0)d={offset:m.offset+1,length:0,content:m.children.length===0?l:l+","};else{const f=y===-1||y>m.children.length?m.children.length:y,t=m.children[f-1];d={offset:t.offset+t.length,length:0,content:","+l}}return E(k,d,c)}else{const l=y,d=m.children[l];let f;if(m.children.length===1)f={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===l){const t=m.children[l-1],n=t.offset+t.length,s=m.offset+m.length;f={offset:n,length:s-2-n,content:""}}else f={offset:d.offset,length:m.children[l+1].offset-d.offset,content:""};return E(k,f,c)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${m.type}`);else{if(A===void 0)throw new Error("Can not delete in empty document");return E(k,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(A)},c)}}e.setProperty=T;function E(k,i,A){let c=D(k,i),g=i.offset,r=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;g>0&&!(0,R.isEOL)(c,g-1);)g--;for(;r<c.length&&!(0,R.isEOL)(c,r);)r++}const a=(0,R.format)(c,{offset:g,length:r-g},A);for(let m=a.length-1;m>=0;m--){const y=a[m];c=D(c,y),g=Math.min(g,y.offset),r=Math.max(r,y.offset+y.length),r+=y.content.length-y.length}const p=k.length-(c.length-r)-g;return[{offset:g,length:p,content:c.substring(g,r)}]}e.withFormatting=E;function D(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=D;function S(k,i){let A=i.slice(0).sort((g,r)=>{const a=g.offset-r.offset;return a===0?g.length-r.length:a}),c=k.length;for(let g=A.length-1;g>=0;g--){let r=A[g];if(r.offset+r.length<=c)k=D(k,r);else throw new Error("Overlapping edit");c=r.offset}return k}e.applyEdits=S}),define(be[109],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new v(()=>C(this.getValue()))}}e.Lazy=v}),define(be[6],we([0,1,54,43]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const C=!1;let T=null;function E(l){T=l}if(e.setDisposableTracker=E,C){const l="__is_disposable_tracked__";T=new class{trackDisposable(d){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[l]||console.log(f)},3e3)}markTracked(d){if(d&&d!==a.None)try{d[l]=!0}catch(f){}}}}function D(l){!T||T.markTracked(l)}function S(l){return T&&T.trackDisposable(l),l}e.trackDisposable=S;class k extends Error{constructor(d){super(`Encountered errors while disposing of store. Errors: [${d.join(", ")}]`);this.errors=d}}e.MultiDisposeError=k;function i(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=i;function A(l){if(R.Iterable.is(l)){let d=[];for(const f of l)if(f){D(f);try{f.dispose()}catch(t){d.push(t)}}if(d.length===1)throw d[0];if(d.length>1)throw new k(d);return Array.isArray(l)?[]:l}else if(l)return D(l),l.dispose(),l}e.dispose=A;function c(...l){return l.forEach(D),g(()=>A(l))}e.combinedDisposable=c;function g(l){const d=S({dispose:()=>{D(d),l()}});return d}e.toDisposable=g;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{A(this._toDispose.values())}finally{this._toDispose.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return D(d),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(d),d}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this._store=new r,S(this)}dispose(){D(this),this._store.dispose()}_register(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(d)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(d){var f;this._isDisposed||d===this._value||((f=this._value)===null||f===void 0||f.dispose(),d&&D(d),this._value=d)}clear(){this.value=void 0}dispose(){var d;this._isDisposed=!0,D(this),(d=this._value)===null||d===void 0||d.dispose(),this._value=void 0}}e.MutableDisposable=p;class m{constructor(){this.references=new Map}acquire(d,...f){let t=this.references.get(d);t||(t={counter:0,object:this.createReferencedObject(d,...f)},this.references.set(d,t));const{object:n}=t,s=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(d,t.object),this.references.delete(d))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=m;class y{constructor(d){this.object=d}dispose(){}}e.ImmortalReference=y}),define(be[45],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(T){this.element=T,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let T=this._first;for(;T!==v.Undefined;){const E=T.next;T.prev=v.Undefined,T.next=v.Undefined,T=E}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,E){const D=new v(T);if(this._first===v.Undefined)this._first=D,this._last=D;else if(E){const k=this._last;this._last=D,D.prev=k,k.next=D}else{const k=this._first;this._first=D,D.next=k,k.prev=D}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(D))}}shift(){if(this._first!==v.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==v.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==v.Undefined&&T.next!==v.Undefined){const E=T.prev;E.next=T.next,T.next.prev=E}else T.prev===v.Undefined&&T.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):T.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):T.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==v.Undefined;)yield T.element,T=T.next}}e.LinkedList=R}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Se,ye){for(var ke=0;ke<ye.length;ke++){var ne=ye[ke];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Se,ne.key,ne)}}function e(Se,ye,ke){return ye&&J(Se.prototype,ye),ke&&J(Se,ke),Se}function v(Se,ye){if(!!Se){if(typeof Se=="string")return R(Se,ye);var ke=Object.prototype.toString.call(Se).slice(8,-1);if(ke==="Object"&&Se.constructor&&(ke=Se.constructor.name),ke==="Map"||ke==="Set")return Array.from(Se);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return R(Se,ye)}}function R(Se,ye){(ye==null||ye>Se.length)&&(ye=Se.length);for(var ke=0,ne=new Array(ye);ke<ye;ke++)ne[ke]=Se[ke];return ne}function C(Se,ye){var ke;if(typeof Symbol=="undefined"||Se[Symbol.iterator]==null){if(Array.isArray(Se)||(ke=v(Se))||ye&&Se&&typeof Se.length=="number"){ke&&(Se=ke);var ne=0;return function(){return ne>=Se.length?{done:!0}:{done:!1,value:Se[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ke=Se[Symbol.iterator](),ke.next.bind(ke)}function T(Se){var ye={exports:{}};return Se(ye,ye.exports),ye.exports}var E=T(function(Se){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ke(ne){Se.exports.defaults=ne}Se.exports={defaults:ye(),getDefaults:ye,changeDefaults:ke}}),D=/[&<>"']/,S=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,A={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},c=function(ye){return A[ye]};function g(Se,ye){if(ye){if(D.test(Se))return Se.replace(S,c)}else if(k.test(Se))return Se.replace(i,c);return Se}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(Se){return Se.replace(r,function(ye,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var p=/(^|[^\[])\^/g;function m(Se,ye){Se=Se.source||Se,ye=ye||"";var ke={replace:function(oe,O){return O=O.source||O,O=O.replace(p,"$1"),Se=Se.replace(oe,O),ke},getRegex:function(){return new RegExp(Se,ye)}};return ke}var y=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(Se,ye,ke){if(Se){var ne;try{ne=decodeURIComponent(a(ke)).replace(y,"").toLowerCase()}catch(oe){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}ye&&!l.test(ke)&&(ke=o(ye,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(oe){return null}return ke}var f={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(Se,ye){f[" "+Se]||(t.test(Se)?f[" "+Se]=Se+"/":f[" "+Se]=I(Se,"/",!0)),Se=f[" "+Se];var ke=Se.indexOf(":")===-1;return ye.substring(0,2)==="//"?ke?ye:Se.replace(n,"$1")+ye:ye.charAt(0)==="/"?ke?ye:Se.replace(s,"$1")+ye:Se+ye}var u={exec:function(){}};function w(Se){for(var ye=1,ke,ne;ye<arguments.length;ye++){ke=arguments[ye];for(ne in ke)Object.prototype.hasOwnProperty.call(ke,ne)&&(Se[ne]=ke[ne])}return Se}function b(Se,ye){var ke=Se.replace(/\|/g,function(O,Y,re){for(var Ie=!1,_e=Y;--_e>=0&&re[_e]==="\\";)Ie=!Ie;return Ie?"|":" |"}),ne=ke.split(/ \|/),oe=0;if(ne.length>ye)ne.splice(ye);else for(;ne.length<ye;)ne.push("");for(;oe<ne.length;oe++)ne[oe]=ne[oe].trim().replace(/\\\|/g,"|");return ne}function I(Se,ye,ke){var ne=Se.length;if(ne===0)return"";for(var oe=0;oe<ne;){var O=Se.charAt(ne-oe-1);if(O===ye&&!ke)oe++;else if(O!==ye&&ke)oe++;else break}return Se.substr(0,ne-oe)}function h(Se,ye){if(Se.indexOf(ye[1])===-1)return-1;for(var ke=Se.length,ne=0,oe=0;oe<ke;oe++)if(Se[oe]==="\\")oe++;else if(Se[oe]===ye[0])ne++;else if(Se[oe]===ye[1]&&(ne--,ne<0))return oe;return-1}function _(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(Se,ye){if(ye<1)return"";for(var ke="";ye>1;)ye&1&&(ke+=Se),ye>>=1,Se+=Se;return ke+Se}var N={escape:g,unescape:a,edit:m,cleanUrl:d,resolveUrl:o,noopTest:u,merge:w,splitCells:b,rtrim:I,findClosingBracket:h,checkSanitizeDeprecation:_,repeatString:F},z=E.defaults,ce=N.rtrim,de=N.splitCells,B=N.escape,j=N.findClosingBracket;function W(Se,ye,ke){var ne=ye.href,oe=ye.title?B(ye.title):null,O=Se[1].replace(/\\([\[\]])/g,"$1");return Se[0].charAt(0)!=="!"?{type:"link",raw:ke,href:ne,title:oe,text:O}:{type:"image",raw:ke,href:ne,title:oe,text:B(O)}}function P(Se,ye){var ke=Se.match(/^(\s+)(?:```)/);if(ke===null)return ye;var ne=ke[1];return ye.split(`
`).map(function(oe){var O=oe.match(/^\s+/);if(O===null)return oe;var Y=O[0];return Y.length>=ne.length?oe.slice(ne.length):oe}).join(`
`)}var H=function(){function Se(ke){this.options=ke||z}var ye=Se.prototype;return ye.space=function(ne){var oe=this.rules.block.newline.exec(ne);if(oe)return oe[0].length>1?{type:"space",raw:oe[0]}:{raw:`
`}},ye.code=function(ne){var oe=this.rules.block.code.exec(ne);if(oe){var O=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?O:ce(O,`
`)}}},ye.fences=function(ne){var oe=this.rules.block.fences.exec(ne);if(oe){var O=oe[0],Y=P(O,oe[3]||"");return{type:"code",raw:O,lang:oe[2]?oe[2].trim():oe[2],text:Y}}},ye.heading=function(ne){var oe=this.rules.block.heading.exec(ne);if(oe){var O=oe[2].trim();if(/#$/.test(O)){var Y=ce(O,"#");(this.options.pedantic||!Y||/ $/.test(Y))&&(O=Y.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:O}}},ye.nptable=function(ne){var oe=this.rules.block.nptable.exec(ne);if(oe){var O={type:"table",header:de(oe[1].replace(/^ *| *\| *$/g,"")),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:oe[3]?oe[3].replace(/\n$/,"").split(`
`):[],raw:oe[0]};if(O.header.length===O.align.length){var Y=O.align.length,re;for(re=0;re<Y;re++)/^ *-+: *$/.test(O.align[re])?O.align[re]="right":/^ *:-+: *$/.test(O.align[re])?O.align[re]="center":/^ *:-+ *$/.test(O.align[re])?O.align[re]="left":O.align[re]=null;for(Y=O.cells.length,re=0;re<Y;re++)O.cells[re]=de(O.cells[re],O.header.length);return O}}},ye.hr=function(ne){var oe=this.rules.block.hr.exec(ne);if(oe)return{type:"hr",raw:oe[0]}},ye.blockquote=function(ne){var oe=this.rules.block.blockquote.exec(ne);if(oe){var O=oe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:oe[0],text:O}}},ye.list=function(ne){var oe=this.rules.block.list.exec(ne);if(oe){var O=oe[0],Y=oe[2],re=Y.length>1,Ie={type:"list",raw:O,ordered:re,start:re?+Y.slice(0,-1):"",loose:!1,items:[]},_e=oe[0].match(this.rules.block.item),Re=!1,ze,Xe,st,Ye,et,pt,_t,je,me=_e.length;st=this.rules.block.listItemStart.exec(_e[0]);for(var pe=0;pe<me;pe++){if(ze=_e[pe],O=ze,pe!==me-1){if(Ye=this.rules.block.listItemStart.exec(_e[pe+1]),this.options.pedantic?Ye[1].length>st[1].length:Ye[1].length>st[0].length||Ye[1].length>3){_e.splice(pe,2,_e[pe]+`
`+_e[pe+1]),pe--,me--;continue}else(!this.options.pedantic||this.options.smartLists?Ye[2][Ye[2].length-1]!==Y[Y.length-1]:re===(Ye[2].length===1))&&(et=_e.slice(pe+1).join(`
`),Ie.raw=Ie.raw.substring(0,Ie.raw.length-et.length),pe=me-1);st=Ye}Xe=ze.length,ze=ze.replace(/^ *([*+-]|\d+[.)]) ?/,""),~ze.indexOf(`
 `)&&(Xe-=ze.length,ze=this.options.pedantic?ze.replace(/^ {1,4}/gm,""):ze.replace(new RegExp("^ {1,"+Xe+"}","gm"),"")),pt=Re||/\n\n(?!\s*$)/.test(ze),pe!==me-1&&(Re=ze.charAt(ze.length-1)===`
`,pt||(pt=Re)),pt&&(Ie.loose=!0),this.options.gfm&&(_t=/^\[[ xX]\] /.test(ze),je=void 0,_t&&(je=ze[1]!==" ",ze=ze.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:O,task:_t,checked:je,loose:pt,text:ze})}return Ie}},ye.html=function(ne){var oe=this.rules.block.html.exec(ne);if(oe)return{type:this.options.sanitize?"paragraph":"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):B(oe[0]):oe[0]}},ye.def=function(ne){var oe=this.rules.block.def.exec(ne);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var O=oe[1].toLowerCase().replace(/\s+/g," ");return{tag:O,raw:oe[0],href:oe[2],title:oe[3]}}},ye.table=function(ne){var oe=this.rules.block.table.exec(ne);if(oe){var O={type:"table",header:de(oe[1].replace(/^ *| *\| *$/g,"")),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:oe[3]?oe[3].replace(/\n$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=oe[0];var Y=O.align.length,re;for(re=0;re<Y;re++)/^ *-+: *$/.test(O.align[re])?O.align[re]="right":/^ *:-+: *$/.test(O.align[re])?O.align[re]="center":/^ *:-+ *$/.test(O.align[re])?O.align[re]="left":O.align[re]=null;for(Y=O.cells.length,re=0;re<Y;re++)O.cells[re]=de(O.cells[re].replace(/^ *\| *| *\| *$/g,""),O.header.length);return O}}},ye.lheading=function(ne){var oe=this.rules.block.lheading.exec(ne);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1]}},ye.paragraph=function(ne){var oe=this.rules.block.paragraph.exec(ne);if(oe)return{type:"paragraph",raw:oe[0],text:oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1]}},ye.text=function(ne){var oe=this.rules.block.text.exec(ne);if(oe)return{type:"text",raw:oe[0],text:oe[0]}},ye.escape=function(ne){var oe=this.rules.inline.escape.exec(ne);if(oe)return{type:"escape",raw:oe[0],text:B(oe[1])}},ye.tag=function(ne,oe,O){var Y=this.rules.inline.tag.exec(ne);if(Y)return!oe&&/^<a /i.test(Y[0])?oe=!0:oe&&/^<\/a>/i.test(Y[0])&&(oe=!1),!O&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?O=!0:O&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(O=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:oe,inRawBlock:O,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):B(Y[0]):Y[0]}},ye.link=function(ne){var oe=this.rules.inline.link.exec(ne);if(oe){var O=oe[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var Y=ce(O.slice(0,-1),"\\");if((O.length-Y.length)%2==0)return}else{var re=j(oe[2],"()");if(re>-1){var Ie=oe[0].indexOf("!")===0?5:4,_e=Ie+oe[1].length+re;oe[2]=oe[2].substring(0,re),oe[0]=oe[0].substring(0,_e).trim(),oe[3]=""}}var Re=oe[2],ze="";if(this.options.pedantic){var Xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);Xe&&(Re=Xe[1],ze=Xe[3])}else ze=oe[3]?oe[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(O)?Re=Re.slice(1):Re=Re.slice(1,-1)),W(oe,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},oe[0])}},ye.reflink=function(ne,oe){var O;if((O=this.rules.inline.reflink.exec(ne))||(O=this.rules.inline.nolink.exec(ne))){var Y=(O[2]||O[1]).replace(/\s+/g," ");if(Y=oe[Y.toLowerCase()],!Y||!Y.href){var re=O[0].charAt(0);return{type:"text",raw:re,text:re}}return W(O,Y,O[0])}},ye.emStrong=function(ne,oe,O){O===void 0&&(O="");var Y=this.rules.inline.emStrong.lDelim.exec(ne);if(!!Y&&!(Y[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var re=Y[1]||Y[2]||"";if(!re||re&&(O===""||this.rules.inline.punctuation.exec(O))){var Ie=Y[0].length-1,_e,Re,ze=Ie,Xe=0,st=Y[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(st.lastIndex=0,oe=oe.slice(-1*ne.length+Ie);(Y=st.exec(oe))!=null;)if(_e=Y[1]||Y[2]||Y[3]||Y[4]||Y[5]||Y[6],!!_e){if(Re=_e.length,Y[3]||Y[4]){ze+=Re;continue}else if((Y[5]||Y[6])&&Ie%3&&!((Ie+Re)%3)){Xe+=Re;continue}if(ze-=Re,!(ze>0)){if(ze+Xe-Re<=0&&!oe.slice(st.lastIndex).match(st)&&(Re=Math.min(Re,Re+ze+Xe)),Math.min(Ie,Re)%2)return{type:"em",raw:ne.slice(0,Ie+Y.index+Re+1),text:ne.slice(1,Ie+Y.index+Re)};if(Math.min(Ie,Re)%2==0)return{type:"strong",raw:ne.slice(0,Ie+Y.index+Re+1),text:ne.slice(2,Ie+Y.index+Re-1)}}}}}},ye.codespan=function(ne){var oe=this.rules.inline.code.exec(ne);if(oe){var O=oe[2].replace(/\n/g," "),Y=/[^ ]/.test(O),re=/^ /.test(O)&&/ $/.test(O);return Y&&re&&(O=O.substring(1,O.length-1)),O=B(O,!0),{type:"codespan",raw:oe[0],text:O}}},ye.br=function(ne){var oe=this.rules.inline.br.exec(ne);if(oe)return{type:"br",raw:oe[0]}},ye.del=function(ne){var oe=this.rules.inline.del.exec(ne);if(oe)return{type:"del",raw:oe[0],text:oe[2]}},ye.autolink=function(ne,oe){var O=this.rules.inline.autolink.exec(ne);if(O){var Y,re;return O[2]==="@"?(Y=B(this.options.mangle?oe(O[1]):O[1]),re="mailto:"+Y):(Y=B(O[1]),re=Y),{type:"link",raw:O[0],text:Y,href:re,tokens:[{type:"text",raw:Y,text:Y}]}}},ye.url=function(ne,oe){var O;if(O=this.rules.inline.url.exec(ne)){var Y,re;if(O[2]==="@")Y=B(this.options.mangle?oe(O[0]):O[0]),re="mailto:"+Y;else{var Ie;do Ie=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(Ie!==O[0]);Y=B(O[0]),O[1]==="www."?re="http://"+Y:re=Y}return{type:"link",raw:O[0],text:Y,href:re,tokens:[{type:"text",raw:Y,text:Y}]}}},ye.inlineText=function(ne,oe,O){var Y=this.rules.inline.text.exec(ne);if(Y){var re;return oe?re=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):B(Y[0]):Y[0]:re=B(this.options.smartypants?O(Y[0]):Y[0]),{type:"text",raw:Y[0],text:re}}},Se}(),L=N.noopTest,$=N.edit,Q=N.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:L,table:L,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=$(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=$(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=$(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=$(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=$(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=$(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=$(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=Q({},q),q.gfm=Q({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=$(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=$(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=Q({},q.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:L,paragraph:$(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:L,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:L,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=$(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=$(q._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=$(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=$(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=$(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=$(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=$(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=$(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=$(ae.reflink).replace("label",ae._label).getRegex(),ae.reflinkSearch=$(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=Q({},ae),ae.pedantic=Q({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=Q({},ae.normal,{escape:$(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ae.gfm.url=$(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=Q({},ae.gfm,{br:$(ae.br).replace("{2,}","*").getRegex(),text:$(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:q,inline:ae},Le=E.defaults,xe=fe.block,Fe=fe.inline,He=N.repeatString;function x(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(Se){var ye="",ke,ne,oe=Se.length;for(ke=0;ke<oe;ke++)ne=Se.charCodeAt(ke),Math.random()>.5&&(ne="x"+ne.toString(16)),ye+="&#"+ne+";";return ye}var ee=function(){function Se(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||Le,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ne={block:xe.normal,inline:Fe.normal};this.options.pedantic?(ne.block=xe.pedantic,ne.inline=Fe.pedantic):this.options.gfm&&(ne.block=xe.gfm,this.options.breaks?ne.inline=Fe.breaks:ne.inline=Fe.gfm),this.tokenizer.rules=ne}Se.lex=function(ne,oe){var O=new Se(oe);return O.lex(ne)},Se.lexInline=function(ne,oe){var O=new Se(oe);return O.inlineTokens(ne)};var ye=Se.prototype;return ye.lex=function(ne){return ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(ne,oe,O){oe===void 0&&(oe=[]),O===void 0&&(O=!0),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var Y,re,Ie,_e;ne;){if(Y=this.tokenizer.space(ne)){ne=ne.substring(Y.raw.length),Y.type&&oe.push(Y);continue}if(Y=this.tokenizer.code(ne)){ne=ne.substring(Y.raw.length),_e=oe[oe.length-1],_e&&_e.type==="paragraph"?(_e.raw+=`
`+Y.raw,_e.text+=`
`+Y.text):oe.push(Y);continue}if(Y=this.tokenizer.fences(ne)){ne=ne.substring(Y.raw.length),oe.push(Y);continue}if(Y=this.tokenizer.heading(ne)){ne=ne.substring(Y.raw.length),oe.push(Y);continue}if(Y=this.tokenizer.nptable(ne)){ne=ne.substring(Y.raw.length),oe.push(Y);continue}if(Y=this.tokenizer.hr(ne)){ne=ne.substring(Y.raw.length),oe.push(Y);continue}if(Y=this.tokenizer.blockquote(ne)){ne=ne.substring(Y.raw.length),Y.tokens=this.blockTokens(Y.text,[],O),oe.push(Y);continue}if(Y=this.tokenizer.list(ne)){for(ne=ne.substring(Y.raw.length),Ie=Y.items.length,re=0;re<Ie;re++)Y.items[re].tokens=this.blockTokens(Y.items[re].text,[],!1);oe.push(Y);continue}if(Y=this.tokenizer.html(ne)){ne=ne.substring(Y.raw.length),oe.push(Y);continue}if(O&&(Y=this.tokenizer.def(ne))){ne=ne.substring(Y.raw.length),this.tokens.links[Y.tag]||(this.tokens.links[Y.tag]={href:Y.href,title:Y.title});continue}if(Y=this.tokenizer.table(ne)){ne=ne.substring(Y.raw.length),oe.push(Y);continue}if(Y=this.tokenizer.lheading(ne)){ne=ne.substring(Y.raw.length),oe.push(Y);continue}if(O&&(Y=this.tokenizer.paragraph(ne))){ne=ne.substring(Y.raw.length),oe.push(Y);continue}if(Y=this.tokenizer.text(ne)){ne=ne.substring(Y.raw.length),_e=oe[oe.length-1],_e&&_e.type==="text"?(_e.raw+=`
`+Y.raw,_e.text+=`
`+Y.text):oe.push(Y);continue}if(ne){var Re="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return oe},ye.inline=function(ne){var oe,O,Y,re,Ie,_e,Re=ne.length;for(oe=0;oe<Re;oe++)switch(_e=ne[oe],_e.type){case"paragraph":case"text":case"heading":{_e.tokens=[],this.inlineTokens(_e.text,_e.tokens);break}case"table":{for(_e.tokens={header:[],cells:[]},re=_e.header.length,O=0;O<re;O++)_e.tokens.header[O]=[],this.inlineTokens(_e.header[O],_e.tokens.header[O]);for(re=_e.cells.length,O=0;O<re;O++)for(Ie=_e.cells[O],_e.tokens.cells[O]=[],Y=0;Y<Ie.length;Y++)_e.tokens.cells[O][Y]=[],this.inlineTokens(Ie[Y],_e.tokens.cells[O][Y]);break}case"blockquote":{this.inline(_e.tokens);break}case"list":{for(re=_e.items.length,O=0;O<re;O++)this.inline(_e.items[O].tokens);break}}return ne},ye.inlineTokens=function(ne,oe,O,Y){oe===void 0&&(oe=[]),O===void 0&&(O=!1),Y===void 0&&(Y=!1);var re,Ie,_e=ne,Re,ze,Xe;if(this.tokens.links){var st=Object.keys(this.tokens.links);if(st.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(_e))!=null;)st.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(_e=_e.slice(0,Re.index)+"["+He("a",Re[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(_e))!=null;)_e=_e.slice(0,Re.index)+"["+He("a",Re[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(_e))!=null;)_e=_e.slice(0,Re.index)+"++"+_e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;){if(ze||(Xe=""),ze=!1,re=this.tokenizer.escape(ne)){ne=ne.substring(re.raw.length),oe.push(re);continue}if(re=this.tokenizer.tag(ne,O,Y)){ne=ne.substring(re.raw.length),O=re.inLink,Y=re.inRawBlock;var Ye=oe[oe.length-1];Ye&&re.type==="text"&&Ye.type==="text"?(Ye.raw+=re.raw,Ye.text+=re.text):oe.push(re);continue}if(re=this.tokenizer.link(ne)){ne=ne.substring(re.raw.length),re.type==="link"&&(re.tokens=this.inlineTokens(re.text,[],!0,Y)),oe.push(re);continue}if(re=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(re.raw.length);var et=oe[oe.length-1];re.type==="link"?(re.tokens=this.inlineTokens(re.text,[],!0,Y),oe.push(re)):et&&re.type==="text"&&et.type==="text"?(et.raw+=re.raw,et.text+=re.text):oe.push(re);continue}if(re=this.tokenizer.emStrong(ne,_e,Xe)){ne=ne.substring(re.raw.length),re.tokens=this.inlineTokens(re.text,[],O,Y),oe.push(re);continue}if(re=this.tokenizer.codespan(ne)){ne=ne.substring(re.raw.length),oe.push(re);continue}if(re=this.tokenizer.br(ne)){ne=ne.substring(re.raw.length),oe.push(re);continue}if(re=this.tokenizer.del(ne)){ne=ne.substring(re.raw.length),re.tokens=this.inlineTokens(re.text,[],O,Y),oe.push(re);continue}if(re=this.tokenizer.autolink(ne,G)){ne=ne.substring(re.raw.length),oe.push(re);continue}if(!O&&(re=this.tokenizer.url(ne,G))){ne=ne.substring(re.raw.length),oe.push(re);continue}if(re=this.tokenizer.inlineText(ne,Y,x)){ne=ne.substring(re.raw.length),re.raw.slice(-1)!=="_"&&(Xe=re.raw.slice(-1)),ze=!0,Ie=oe[oe.length-1],Ie&&Ie.type==="text"?(Ie.raw+=re.raw,Ie.text+=re.text):oe.push(re);continue}if(ne){var pt="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(pt);break}else throw new Error(pt)}}return oe},e(Se,null,[{key:"rules",get:function(){return{block:xe,inline:Fe}}}]),Se}(),ie=E.defaults,ue=N.cleanUrl,Ee=N.escape,$e=function(){function Se(ke){this.options=ke||ie}var ye=Se.prototype;return ye.code=function(ne,oe,O){var Y=(oe||"").match(/\S*/)[0];if(this.options.highlight){var re=this.options.highlight(ne,Y);re!=null&&re!==ne&&(O=!0,ne=re)}return ne=ne.replace(/\n$/,"")+`
`,Y?'<pre><code class="'+this.options.langPrefix+Ee(Y,!0)+'">'+(O?ne:Ee(ne,!0))+`</code></pre>
`:"<pre><code>"+(O?ne:Ee(ne,!0))+`</code></pre>
`},ye.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},ye.html=function(ne){return ne},ye.heading=function(ne,oe,O,Y){return this.options.headerIds?"<h"+oe+' id="'+this.options.headerPrefix+Y.slug(O)+'">'+ne+"</h"+oe+`>
`:"<h"+oe+">"+ne+"</h"+oe+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ne,oe,O){var Y=oe?"ol":"ul",re=oe&&O!==1?' start="'+O+'"':"";return"<"+Y+re+`>
`+ne+"</"+Y+`>
`},ye.listitem=function(ne){return"<li>"+ne+`</li>
`},ye.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ne){return"<p>"+ne+`</p>
`},ye.table=function(ne,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+oe+`</table>
`},ye.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},ye.tablecell=function(ne,oe){var O=oe.header?"th":"td",Y=oe.align?"<"+O+' align="'+oe.align+'">':"<"+O+">";return Y+ne+"</"+O+`>
`},ye.strong=function(ne){return"<strong>"+ne+"</strong>"},ye.em=function(ne){return"<em>"+ne+"</em>"},ye.codespan=function(ne){return"<code>"+ne+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ne){return"<del>"+ne+"</del>"},ye.link=function(ne,oe,O){if(ne=ue(this.options.sanitize,this.options.baseUrl,ne),ne===null)return O;var Y='<a href="'+Ee(ne)+'"';return oe&&(Y+=' title="'+oe+'"'),Y+=">"+O+"</a>",Y},ye.image=function(ne,oe,O){if(ne=ue(this.options.sanitize,this.options.baseUrl,ne),ne===null)return O;var Y='<img src="'+ne+'" alt="'+O+'"';return oe&&(Y+=' title="'+oe+'"'),Y+=this.options.xhtml?"/>":">",Y},ye.text=function(ne){return ne},Se}(),he=function(){function Se(){}var ye=Se.prototype;return ye.strong=function(ne){return ne},ye.em=function(ne){return ne},ye.codespan=function(ne){return ne},ye.del=function(ne){return ne},ye.html=function(ne){return ne},ye.text=function(ne){return ne},ye.link=function(ne,oe,O){return""+O},ye.image=function(ne,oe,O){return""+O},ye.br=function(){return""},Se}(),Ce=function(){function Se(){this.seen={}}var ye=Se.prototype;return ye.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ne,oe){var O=ne,Y=0;if(this.seen.hasOwnProperty(O)){Y=this.seen[ne];do Y++,O=ne+"-"+Y;while(this.seen.hasOwnProperty(O))}return oe||(this.seen[ne]=Y,this.seen[O]=0),O},ye.slug=function(ne,oe){oe===void 0&&(oe={});var O=this.serialize(ne);return this.getNextSafeSlug(O,oe.dryrun)},Se}(),Te=E.defaults,We=N.unescape,ve=function(){function Se(ke){this.options=ke||Te,this.options.renderer=this.options.renderer||new $e,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new he,this.slugger=new Ce}Se.parse=function(ne,oe){var O=new Se(oe);return O.parse(ne)},Se.parseInline=function(ne,oe){var O=new Se(oe);return O.parseInline(ne)};var ye=Se.prototype;return ye.parse=function(ne,oe){oe===void 0&&(oe=!0);var O="",Y,re,Ie,_e,Re,ze,Xe,st,Ye,et,pt,_t,je,me,pe,se,K,Oe,Ae=ne.length;for(Y=0;Y<Ae;Y++)switch(et=ne[Y],et.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(et.tokens),et.depth,We(this.parseInline(et.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(et.text,et.lang,et.escaped);continue}case"table":{for(st="",Xe="",_e=et.header.length,re=0;re<_e;re++)Xe+=this.renderer.tablecell(this.parseInline(et.tokens.header[re]),{header:!0,align:et.align[re]});for(st+=this.renderer.tablerow(Xe),Ye="",_e=et.cells.length,re=0;re<_e;re++){for(ze=et.tokens.cells[re],Xe="",Re=ze.length,Ie=0;Ie<Re;Ie++)Xe+=this.renderer.tablecell(this.parseInline(ze[Ie]),{header:!1,align:et.align[Ie]});Ye+=this.renderer.tablerow(Xe)}O+=this.renderer.table(st,Ye);continue}case"blockquote":{Ye=this.parse(et.tokens),O+=this.renderer.blockquote(Ye);continue}case"list":{for(pt=et.ordered,_t=et.start,je=et.loose,_e=et.items.length,Ye="",re=0;re<_e;re++)pe=et.items[re],se=pe.checked,K=pe.task,me="",pe.task&&(Oe=this.renderer.checkbox(se),je?pe.tokens.length>0&&pe.tokens[0].type==="text"?(pe.tokens[0].text=Oe+" "+pe.tokens[0].text,pe.tokens[0].tokens&&pe.tokens[0].tokens.length>0&&pe.tokens[0].tokens[0].type==="text"&&(pe.tokens[0].tokens[0].text=Oe+" "+pe.tokens[0].tokens[0].text)):pe.tokens.unshift({type:"text",text:Oe}):me+=Oe),me+=this.parse(pe.tokens,je),Ye+=this.renderer.listitem(me,K,se);O+=this.renderer.list(Ye,pt,_t);continue}case"html":{O+=this.renderer.html(et.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(et.tokens));continue}case"text":{for(Ye=et.tokens?this.parseInline(et.tokens):et.text;Y+1<Ae&&ne[Y+1].type==="text";)et=ne[++Y],Ye+=`
`+(et.tokens?this.parseInline(et.tokens):et.text);O+=oe?this.renderer.paragraph(Ye):Ye;continue}default:{var rt='Token with "'+et.type+'" type was not found.';if(this.options.silent){console.error(rt);return}else throw new Error(rt)}}return O},ye.parseInline=function(ne,oe){oe=oe||this.renderer;var O="",Y,re,Ie=ne.length;for(Y=0;Y<Ie;Y++)switch(re=ne[Y],re.type){case"escape":{O+=oe.text(re.text);break}case"html":{O+=oe.html(re.text);break}case"link":{O+=oe.link(re.href,re.title,this.parseInline(re.tokens,oe));break}case"image":{O+=oe.image(re.href,re.title,re.text);break}case"strong":{O+=oe.strong(this.parseInline(re.tokens,oe));break}case"em":{O+=oe.em(this.parseInline(re.tokens,oe));break}case"codespan":{O+=oe.codespan(re.text);break}case"br":{O+=oe.br();break}case"del":{O+=oe.del(this.parseInline(re.tokens,oe));break}case"text":{O+=oe.text(re.text);break}default:{var _e='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(_e);return}else throw new Error(_e)}}return O},Se}(),Ge=N.merge,V=N.checkSanitizeDeprecation,Z=N.escape,ge=E.getDefaults,Ne=E.changeDefaults,Ve=E.defaults;function Be(Se,ye,ke){if(typeof Se=="undefined"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof ye=="function"&&(ke=ye,ye=null),ye=Ge({},Be.defaults,ye||{}),V(ye),ke){var ne=ye.highlight,oe;try{oe=ee.lex(Se,ye)}catch(Ie){return ke(Ie)}var O=function(_e){var Re;if(!_e)try{Re=ve.parse(oe,ye)}catch(ze){_e=ze}return ye.highlight=ne,_e?ke(_e):ke(null,Re)};if(!ne||ne.length<3||(delete ye.highlight,!oe.length))return O();var Y=0;Be.walkTokens(oe,function(Ie){Ie.type==="code"&&(Y++,setTimeout(function(){ne(Ie.text,Ie.lang,function(_e,Re){if(_e)return O(_e);Re!=null&&Re!==Ie.text&&(Ie.text=Re,Ie.escaped=!0),Y--,Y===0&&O()})},0))}),Y===0&&O();return}try{var re=ee.lex(Se,ye);return ye.walkTokens&&Be.walkTokens(re,ye.walkTokens),ve.parse(re,ye)}catch(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+Z(Ie.message+"",!0)+"</pre>";throw Ie}}Be.options=Be.setOptions=function(Se){return Ge(Be.defaults,Se),Ne(Be.defaults),Be},Be.getDefaults=ge,Be.defaults=Ve,Be.use=function(Se){var ye=Ge({},Se);if(Se.renderer&&function(){var ne=Be.defaults.renderer||new $e,oe=function(re){var Ie=ne[re];ne[re]=function(){for(var _e=arguments.length,Re=new Array(_e),ze=0;ze<_e;ze++)Re[ze]=arguments[ze];var Xe=Se.renderer[re].apply(ne,Re);return Xe===!1&&(Xe=Ie.apply(ne,Re)),Xe}};for(var O in Se.renderer)oe(O);ye.renderer=ne}(),Se.tokenizer&&function(){var ne=Be.defaults.tokenizer||new H,oe=function(re){var Ie=ne[re];ne[re]=function(){for(var _e=arguments.length,Re=new Array(_e),ze=0;ze<_e;ze++)Re[ze]=arguments[ze];var Xe=Se.tokenizer[re].apply(ne,Re);return Xe===!1&&(Xe=Ie.apply(ne,Re)),Xe}};for(var O in Se.tokenizer)oe(O);ye.tokenizer=ne}(),Se.walkTokens){var ke=Be.defaults.walkTokens;ye.walkTokens=function(ne){Se.walkTokens(ne),ke&&ke(ne)}}Be.setOptions(ye)},Be.walkTokens=function(Se,ye){for(var ke=C(Se),ne;!(ne=ke()).done;){var oe=ne.value;switch(ye(oe),oe.type){case"table":{for(var O=C(oe.tokens.header),Y;!(Y=O()).done;){var re=Y.value;Be.walkTokens(re,ye)}for(var Ie=C(oe.tokens.cells),_e;!(_e=Ie()).done;)for(var Re=_e.value,ze=C(Re),Xe;!(Xe=ze()).done;){var st=Xe.value;Be.walkTokens(st,ye)}break}case"list":{Be.walkTokens(oe.items,ye);break}default:oe.tokens&&Be.walkTokens(oe.tokens,ye)}}},Be.parseInline=function(Se,ye){if(typeof Se=="undefined"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");ye=Ge({},Be.defaults,ye||{}),V(ye);try{var ke=ee.lexInline(Se,ye);return ye.walkTokens&&Be.walkTokens(ke,ye.walkTokens),ve.parseInline(ke,ye)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+Z(ne.message+"",!0)+"</pre>";throw ne}},Be.Parser=ve,Be.parser=ve.parse,Be.Renderer=$e,Be.TextRenderer=he,Be.Lexer=ee,Be.lexer=ee.lex,Be.Tokenizer=H,Be.Slugger=Ce,Be.parse=Be;var Ze=Be;return Ze}),define(be[82],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function v(E,D,S){return Math.min(Math.max(E,D),S)}e.clamp=v;function R(E,D){return(D+E%D)%D}e.rot=R;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class T{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function J(C){const T=[];typeof C=="number"&&T.push("code/timeOrigin",C);function E(S){T.push(S,Date.now())}function D(){const S=[];for(let k=0;k<T.length;k+=2)S.push({name:T[k],startTime:T[k+1]});return S}return{mark:E,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const E of performance.getEntriesByType("mark"))T.push({name:E.name,startTime:Math.round(C+E.startTime)});return T}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function v(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))})(),define(be[21],we([0,1]),function(J,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let C=!1,T=!1,E=!1,D=!1,S=!1,k=!1,i=!1,A,c=R,g,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const p=typeof((v=a==null?void 0:a.versions)===null||v===void 0?void 0:v.electron)=="string"&&a.type==="renderer";if(e.isElectronSandboxed=p&&(a==null?void 0:a.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=a==null?void 0:a.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p)r=navigator.userAgent,C=r.indexOf("Windows")>=0,T=r.indexOf("Macintosh")>=0,i=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=r.indexOf("Linux")>=0,k=!0,A=navigator.language,c=A;else if(typeof a=="object"){C=a.platform==="win32",T=a.platform==="darwin",E=a.platform==="linux",D=E&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,A=R,c=R;const o=a.env.VSCODE_NLS_CONFIG;if(o)try{const u=JSON.parse(o),w=u.availableLanguages["*"];A=u.locale,c=w||R,g=u._translationsConfigFile}catch(u){}S=!0}else console.error("Unable to resolve platform.");var m;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function y(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let l=0;T?l=1:C?l=3:E&&(l=2),e.isWindows=C,e.isMacintosh=T,e.isLinux=E,e.isLinuxSnap=D,e.isNative=S,e.isWeb=k,e.isIOS=i,e.platform=l,e.userAgent=r,e.language=c;var d;(function(o){function u(){return e.language}o.value=u;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=w;function b(){return e.language==="en"}o.isDefault=b})(d=e.Language||(e.Language={})),e.locale=A,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let w=[];e.globals.addEventListener("message",I=>{if(I.data&&I.data.vscodeSetImmediateId)for(let h=0,_=w.length;h<_;h++){const F=w[h];if(F.id===I.data.vscodeSetImmediateId){w.splice(h,1),F.callback();return}}});let b=0;return I=>{const h=++b;w.push({id:h,callback:I}),e.globals.postMessage({vscodeSetImmediateId:h},"*")}}if(typeof(a==null?void 0:a.nextTick)=="function")return a.nextTick.bind(a);const u=Promise.resolve();return w=>u.then(w)}();var f;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:C?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(be[46],we([0,1,21]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const C=v.globals.vscode.process;R={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(T){return(0,v.setImmediate)(T)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(C){return(0,v.setImmediate)(C)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(be[14],we([0,1,46]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,C=97,T=90,E=122,D=46,S=47,k=92,i=58,A=63;class c extends Error{constructor(d,f,t){let n;typeof f=="string"&&f.indexOf("not ")===0?(n="must not be",f=f.replace(/^not /,"")):n="must be";const s=d.indexOf(".")!==-1?"property":"argument";let o=`The "${d}" ${s} ${n} of type ${f}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function g(l,d){if(typeof l!="string")throw new c(d,"string",l)}function r(l){return l===S||l===k}function a(l){return l===S}function p(l){return l>=R&&l<=T||l>=C&&l<=E}function m(l,d,f,t){let n="",s=0,o=-1,u=0,w=0;for(let b=0;b<=l.length;++b){if(b<l.length)w=l.charCodeAt(b);else{if(t(w))break;w=S}if(t(w)){if(!(o===b-1||u===1))if(u===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==D||n.charCodeAt(n.length-2)!==D){if(n.length>2){const I=n.lastIndexOf(f);I===-1?(n="",s=0):(n=n.slice(0,I),s=n.length-1-n.lastIndexOf(f)),o=b,u=0;continue}else if(n.length!==0){n="",s=0,o=b,u=0;continue}}d&&(n+=n.length>0?`${f}..`:"..",s=2)}else n.length>0?n+=`${f}${l.slice(o+1,b)}`:n=l.slice(o+1,b),s=b-o-1;o=b,u=0}else w===D&&u!==-1?++u:u=-1}return n}function y(l,d){if(d===null||typeof d!="object")throw new c("pathObject","Object",d);const f=d.dir||d.root,t=d.base||`${d.name||""}${d.ext||""}`;return f?f===d.root?`${f}${t}`:`${f}${l}${t}`:t}e.win32={resolve(...l){let d="",f="",t=!1;for(let n=l.length-1;n>=-1;n--){let s;if(n>=0){if(s=l[n],g(s,"path"),s.length===0)continue}else d.length===0?s=v.cwd():(s=v.env[`=${d}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==d.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${d}\\`));const o=s.length;let u=0,w="",b=!1;const I=s.charCodeAt(0);if(o===1)r(I)&&(u=1,b=!0);else if(r(I))if(b=!0,r(s.charCodeAt(1))){let h=2,_=h;for(;h<o&&!r(s.charCodeAt(h));)h++;if(h<o&&h!==_){const F=s.slice(_,h);for(_=h;h<o&&r(s.charCodeAt(h));)h++;if(h<o&&h!==_){for(_=h;h<o&&!r(s.charCodeAt(h));)h++;(h===o||h!==_)&&(w=`\\\\${F}\\${s.slice(_,h)}`,u=h)}}}else u=1;else p(I)&&s.charCodeAt(1)===i&&(w=s.slice(0,2),u=2,o>2&&r(s.charCodeAt(2))&&(b=!0,u=3));if(w.length>0)if(d.length>0){if(w.toLowerCase()!==d.toLowerCase())continue}else d=w;if(t){if(d.length>0)break}else if(f=`${s.slice(u)}\\${f}`,t=b,b&&d.length>0)break}return f=m(f,!t,"\\",r),t?`${d}\\${f}`:`${d}${f}`||"."},normalize(l){g(l,"path");const d=l.length;if(d===0)return".";let f=0,t,n=!1;const s=l.charCodeAt(0);if(d===1)return a(s)?"\\":l;if(r(s))if(n=!0,r(l.charCodeAt(1))){let u=2,w=u;for(;u<d&&!r(l.charCodeAt(u));)u++;if(u<d&&u!==w){const b=l.slice(w,u);for(w=u;u<d&&r(l.charCodeAt(u));)u++;if(u<d&&u!==w){for(w=u;u<d&&!r(l.charCodeAt(u));)u++;if(u===d)return`\\\\${b}\\${l.slice(w)}\\`;u!==w&&(t=`\\\\${b}\\${l.slice(w,u)}`,f=u)}}}else f=1;else p(s)&&l.charCodeAt(1)===i&&(t=l.slice(0,2),f=2,d>2&&r(l.charCodeAt(2))&&(n=!0,f=3));let o=f<d?m(l.slice(f),!n,"\\",r):"";return o.length===0&&!n&&(o="."),o.length>0&&r(l.charCodeAt(d-1))&&(o+="\\"),t===void 0?n?`\\${o}`:o:n?`${t}\\${o}`:`${t}${o}`},isAbsolute(l){g(l,"path");const d=l.length;if(d===0)return!1;const f=l.charCodeAt(0);return r(f)||d>2&&p(f)&&l.charCodeAt(1)===i&&r(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let d,f;for(let s=0;s<l.length;++s){const o=l[s];g(o,"path"),o.length>0&&(d===void 0?d=f=o:d+=`\\${o}`)}if(d===void 0)return".";let t=!0,n=0;if(typeof f=="string"&&r(f.charCodeAt(0))){++n;const s=f.length;s>1&&r(f.charCodeAt(1))&&(++n,s>2&&(r(f.charCodeAt(2))?++n:t=!1))}if(t){for(;n<d.length&&r(d.charCodeAt(n));)n++;n>=2&&(d=`\\${d.slice(n)}`)}return e.win32.normalize(d)},relative(l,d){if(g(l,"from"),g(d,"to"),l===d)return"";const f=e.win32.resolve(l),t=e.win32.resolve(d);if(f===t||(l=f.toLowerCase(),d=t.toLowerCase(),l===d))return"";let n=0;for(;n<l.length&&l.charCodeAt(n)===k;)n++;let s=l.length;for(;s-1>n&&l.charCodeAt(s-1)===k;)s--;const o=s-n;let u=0;for(;u<d.length&&d.charCodeAt(u)===k;)u++;let w=d.length;for(;w-1>u&&d.charCodeAt(w-1)===k;)w--;const b=w-u,I=o<b?o:b;let h=-1,_=0;for(;_<I;_++){const N=l.charCodeAt(n+_);if(N!==d.charCodeAt(u+_))break;N===k&&(h=_)}if(_!==I){if(h===-1)return t}else{if(b>I){if(d.charCodeAt(u+_)===k)return t.slice(u+_+1);if(_===2)return t.slice(u+_)}o>I&&(l.charCodeAt(n+_)===k?h=_:_===2&&(h=3)),h===-1&&(h=0)}let F="";for(_=n+h+1;_<=s;++_)(_===s||l.charCodeAt(_)===k)&&(F+=F.length===0?"..":"\\..");return u+=h,F.length>0?`${F}${t.slice(u,w)}`:(t.charCodeAt(u)===k&&++u,t.slice(u,w))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const d=e.win32.resolve(l);if(d.length<=2)return l;if(d.charCodeAt(0)===k){if(d.charCodeAt(1)===k){const f=d.charCodeAt(2);if(f!==A&&f!==D)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(p(d.charCodeAt(0))&&d.charCodeAt(1)===i&&d.charCodeAt(2)===k)return`\\\\?\\${d}`;return l},dirname(l){g(l,"path");const d=l.length;if(d===0)return".";let f=-1,t=0;const n=l.charCodeAt(0);if(d===1)return r(n)?l:".";if(r(n)){if(f=t=1,r(l.charCodeAt(1))){let u=2,w=u;for(;u<d&&!r(l.charCodeAt(u));)u++;if(u<d&&u!==w){for(w=u;u<d&&r(l.charCodeAt(u));)u++;if(u<d&&u!==w){for(w=u;u<d&&!r(l.charCodeAt(u));)u++;if(u===d)return l;u!==w&&(f=t=u+1)}}}}else p(n)&&l.charCodeAt(1)===i&&(f=d>2&&r(l.charCodeAt(2))?3:2,t=f);let s=-1,o=!0;for(let u=d-1;u>=t;--u)if(r(l.charCodeAt(u))){if(!o){s=u;break}}else o=!1;if(s===-1){if(f===-1)return".";s=f}return l.slice(0,s)},basename(l,d){d!==void 0&&g(d,"ext"),g(l,"path");let f=0,t=-1,n=!0,s;if(l.length>=2&&p(l.charCodeAt(0))&&l.charCodeAt(1)===i&&(f=2),d!==void 0&&d.length>0&&d.length<=l.length){if(d===l)return"";let o=d.length-1,u=-1;for(s=l.length-1;s>=f;--s){const w=l.charCodeAt(s);if(r(w)){if(!n){f=s+1;break}}else u===-1&&(n=!1,u=s+1),o>=0&&(w===d.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=u))}return f===t?t=u:t===-1&&(t=l.length),l.slice(f,t)}for(s=l.length-1;s>=f;--s)if(r(l.charCodeAt(s))){if(!n){f=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":l.slice(f,t)},extname(l){g(l,"path");let d=0,f=-1,t=0,n=-1,s=!0,o=0;l.length>=2&&l.charCodeAt(1)===i&&p(l.charCodeAt(0))&&(d=t=2);for(let u=l.length-1;u>=d;--u){const w=l.charCodeAt(u);if(r(w)){if(!s){t=u+1;break}continue}n===-1&&(s=!1,n=u+1),w===D?f===-1?f=u:o!==1&&(o=1):f!==-1&&(o=-1)}return f===-1||n===-1||o===0||o===1&&f===n-1&&f===t+1?"":l.slice(f,n)},format:y.bind(null,"\\"),parse(l){g(l,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return d;const f=l.length;let t=0,n=l.charCodeAt(0);if(f===1)return r(n)?(d.root=d.dir=l,d):(d.base=d.name=l,d);if(r(n)){if(t=1,r(l.charCodeAt(1))){let h=2,_=h;for(;h<f&&!r(l.charCodeAt(h));)h++;if(h<f&&h!==_){for(_=h;h<f&&r(l.charCodeAt(h));)h++;if(h<f&&h!==_){for(_=h;h<f&&!r(l.charCodeAt(h));)h++;h===f?t=h:h!==_&&(t=h+1)}}}}else if(p(n)&&l.charCodeAt(1)===i){if(f<=2)return d.root=d.dir=l,d;if(t=2,r(l.charCodeAt(2))){if(f===3)return d.root=d.dir=l,d;t=3}}t>0&&(d.root=l.slice(0,t));let s=-1,o=t,u=-1,w=!0,b=l.length-1,I=0;for(;b>=t;--b){if(n=l.charCodeAt(b),r(n)){if(!w){o=b+1;break}continue}u===-1&&(w=!1,u=b+1),n===D?s===-1?s=b:I!==1&&(I=1):s!==-1&&(I=-1)}return u!==-1&&(s===-1||I===0||I===1&&s===u-1&&s===o+1?d.base=d.name=l.slice(o,u):(d.name=l.slice(o,s),d.base=l.slice(o,u),d.ext=l.slice(s,u))),o>0&&o!==t?d.dir=l.slice(0,o-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let d="",f=!1;for(let t=l.length-1;t>=-1&&!f;t--){const n=t>=0?l[t]:v.cwd();g(n,"path"),n.length!==0&&(d=`${n}/${d}`,f=n.charCodeAt(0)===S)}return d=m(d,!f,"/",a),f?`/${d}`:d.length>0?d:"."},normalize(l){if(g(l,"path"),l.length===0)return".";const d=l.charCodeAt(0)===S,f=l.charCodeAt(l.length-1)===S;return l=m(l,!d,"/",a),l.length===0?d?"/":f?"./":".":(f&&(l+="/"),d?`/${l}`:l)},isAbsolute(l){return g(l,"path"),l.length>0&&l.charCodeAt(0)===S},join(...l){if(l.length===0)return".";let d;for(let f=0;f<l.length;++f){const t=l[f];g(t,"path"),t.length>0&&(d===void 0?d=t:d+=`/${t}`)}return d===void 0?".":e.posix.normalize(d)},relative(l,d){if(g(l,"from"),g(d,"to"),l===d||(l=e.posix.resolve(l),d=e.posix.resolve(d),l===d))return"";const f=1,t=l.length,n=t-f,s=1,o=d.length-s,u=n<o?n:o;let w=-1,b=0;for(;b<u;b++){const h=l.charCodeAt(f+b);if(h!==d.charCodeAt(s+b))break;h===S&&(w=b)}if(b===u)if(o>u){if(d.charCodeAt(s+b)===S)return d.slice(s+b+1);if(b===0)return d.slice(s+b)}else n>u&&(l.charCodeAt(f+b)===S?w=b:b===0&&(w=0));let I="";for(b=f+w+1;b<=t;++b)(b===t||l.charCodeAt(b)===S)&&(I+=I.length===0?"..":"/..");return`${I}${d.slice(s+w)}`},toNamespacedPath(l){return l},dirname(l){if(g(l,"path"),l.length===0)return".";const d=l.charCodeAt(0)===S;let f=-1,t=!0;for(let n=l.length-1;n>=1;--n)if(l.charCodeAt(n)===S){if(!t){f=n;break}}else t=!1;return f===-1?d?"/":".":d&&f===1?"//":l.slice(0,f)},basename(l,d){d!==void 0&&g(d,"ext"),g(l,"path");let f=0,t=-1,n=!0,s;if(d!==void 0&&d.length>0&&d.length<=l.length){if(d===l)return"";let o=d.length-1,u=-1;for(s=l.length-1;s>=0;--s){const w=l.charCodeAt(s);if(w===S){if(!n){f=s+1;break}}else u===-1&&(n=!1,u=s+1),o>=0&&(w===d.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=u))}return f===t?t=u:t===-1&&(t=l.length),l.slice(f,t)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===S){if(!n){f=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":l.slice(f,t)},extname(l){g(l,"path");let d=-1,f=0,t=-1,n=!0,s=0;for(let o=l.length-1;o>=0;--o){const u=l.charCodeAt(o);if(u===S){if(!n){f=o+1;break}continue}t===-1&&(n=!1,t=o+1),u===D?d===-1?d=o:s!==1&&(s=1):d!==-1&&(s=-1)}return d===-1||t===-1||s===0||s===1&&d===t-1&&d===f+1?"":l.slice(d,t)},format:y.bind(null,"/"),parse(l){g(l,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return d;const f=l.charCodeAt(0)===S;let t;f?(d.root="/",t=1):t=0;let n=-1,s=0,o=-1,u=!0,w=l.length-1,b=0;for(;w>=t;--w){const I=l.charCodeAt(w);if(I===S){if(!u){s=w+1;break}continue}o===-1&&(u=!1,o=w+1),I===D?n===-1?n=w:b!==1&&(b=1):n!==-1&&(b=-1)}if(o!==-1){const I=s===0&&f?1:s;n===-1||b===0||b===1&&n===o-1&&n===s+1?d.base=d.name=l.slice(I,o):(d.name=l.slice(I,n),d.base=l.slice(I,o),d.ext=l.slice(n,o))}return s>0?d.dir=l.slice(0,s-1):f&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[56],we([0,1,21]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class C{constructor(E){this._highResolution=R&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new C(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=C}),define(be[3],we([0,1,12,54,6,45,56]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(m){m.None=()=>C.Disposable.None;function y(B){return(j,W=null,P)=>{let H=!1,L;return L=B($=>{if(!H)return L?L.dispose():H=!0,j.call(W,$)},null,P),H&&L.dispose(),L}}m.once=y;function l(B,j){return o((W,P=null,H)=>B(L=>W.call(P,j(L)),null,H))}m.map=l;function d(B,j){return o((W,P=null,H)=>B(L=>{j(L),W.call(P,L)},null,H))}m.forEach=d;function f(B,j){return o((W,P=null,H)=>B(L=>j(L)&&W.call(P,L),null,H))}m.filter=f;function t(B){return B}m.signal=t;function n(...B){return(j,W=null,P)=>(0,C.combinedDisposable)(...B.map(H=>H(L=>j.call(W,L),null,P)))}m.any=n;function s(B,j,W){let P=W;return l(B,H=>(P=j(P,H),P))}m.reduce=s;function o(B){let j;const W=new c({onFirstListenerAdd(){j=B(W.fire,W)},onLastListenerRemove(){j.dispose()}});return W.event}m.snapshot=o;function u(B,j,W=100,P=!1,H){let L,$,Q,q=0;const ae=new c({leakWarningThreshold:H,onFirstListenerAdd(){L=B(fe=>{q++,$=j($,fe),P&&!Q&&(ae.fire($),$=void 0),clearTimeout(Q),Q=setTimeout(()=>{const Le=$;$=void 0,Q=void 0,(!P||q>1)&&ae.fire(Le),q=0},W)})},onLastListenerRemove(){L.dispose()}});return ae.event}m.debounce=u;function w(B){const j=new Date().getTime();return l(y(B),W=>new Date().getTime()-j)}m.stopwatch=w;function b(B,j=(W,P)=>W===P){let W=!0,P;return f(B,H=>{const L=W||!j(H,P);return W=!1,P=H,L})}m.latch=b;function I(B,j){return[m.filter(B,j),m.filter(B,W=>!j(W))]}m.split=I;function h(B,j=!1,W=[]){let P=W.slice(),H=B(Q=>{P?P.push(Q):$.fire(Q)});const L=()=>{P&&P.forEach(Q=>$.fire(Q)),P=null},$=new c({onFirstListenerAdd(){H||(H=B(Q=>$.fire(Q)))},onFirstListenerDidAdd(){P&&(j?setTimeout(L):L())},onLastListenerRemove(){H&&H.dispose(),H=null}});return $.event}m.buffer=h;class _{constructor(j){this.event=j}map(j){return new _(l(this.event,j))}forEach(j){return new _(d(this.event,j))}filter(j){return new _(f(this.event,j))}reduce(j,W){return new _(s(this.event,j,W))}latch(){return new _(b(this.event))}debounce(j,W=100,P=!1,H){return new _(u(this.event,j,W,P,H))}on(j,W,P){return this.event(j,W,P)}once(j,W,P){return y(this.event)(j,W,P)}}function F(B){return new _(B)}m.chain=F;function N(B,j,W=P=>P){const P=(...Q)=>$.fire(W(...Q)),H=()=>B.on(j,P),L=()=>B.removeListener(j,P),$=new c({onFirstListenerAdd:H,onLastListenerRemove:L});return $.event}m.fromNodeEventEmitter=N;function z(B,j,W=P=>P){const P=(...Q)=>$.fire(W(...Q)),H=()=>B.addEventListener(j,P),L=()=>B.removeEventListener(j,P),$=new c({onFirstListenerAdd:H,onLastListenerRemove:L});return $.event}m.fromDOMEventEmitter=z;function ce(B){const j=new c;let W=!1;return B.then(void 0,()=>null).then(()=>{W?j.fire(void 0):setTimeout(()=>j.fire(void 0),0)}),W=!0,j.event}m.fromPromise=ce;function de(B){return new Promise(j=>y(B)(j))}m.toPromise=de})(D=e.Event||(e.Event={}));class S{constructor(y){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${y}_${S._idPool++}`}start(y){this._stopWatch=new E.StopWatch(!0),this._listenerCount=y}stop(){if(this._stopWatch){const y=this._stopWatch.elapsed();this._elapsedOverall+=y,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${y.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let k=-1;function i(m){const y=k;return k=m,{dispose(){k=y}}}e.setGlobalLeakWarningThreshold=i;class A{constructor(y,l=Math.random().toString(18).slice(2,5)){this.customThreshold=y,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(y){let l=k;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),!(l<=0||y<l)){this._stacks||(this._stacks=new Map);const d=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(d)||0;if(this._stacks.set(d,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let t,n=0;for(const[s,o]of this._stacks)(!t||n<o)&&(t=s,n=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(d)||0;this._stacks.set(d,t-1)}}}}class c{constructor(y){var l;this._disposed=!1,this._options=y,this._leakageMon=k>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((l=this._options)===null||l===void 0?void 0:l._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(y,l,d)=>{var f;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(l?[y,l]:y);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,y,l);const s=(f=this._leakageMon)===null||f===void 0?void 0:f.check(this._listeners.size);let o;return o={dispose:()=>{s&&s(),o.dispose=c._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},d instanceof C.DisposableStore?d.add(o):Array.isArray(d)&&d.push(o),o}),this._event}fire(y){var l,d;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,y]);for((l=this._perfMon)===null||l===void 0||l.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,t]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,t):f[0].call(f[1],t)}catch(n){(0,v.onUnexpectedError)(n)}}(d=this._perfMon)===null||d===void 0||d.stop()}}dispose(){var y,l,d,f;(y=this._listeners)===null||y===void 0||y.clear(),(l=this._deliveryQueue)===null||l===void 0||l.clear(),((d=this._options)===null||d===void 0?void 0:d.onLastListenerRemove)&&this._options.onLastListenerRemove(),(f=this._leakageMon)===null||f===void 0||f.dispose(),this._disposed=!0}}e.Emitter=c,c._noop=function(){};class g extends c{constructor(y){super(y);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=y==null?void 0:y.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const y=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(y))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(y){this._listeners&&(this._isPaused!==0?this._eventQueue.push(y):super.fire(y))}}e.PauseableEmitter=g;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(y){const l={event:y,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const d=()=>{this.hasListeners&&this.unhook(l);const f=this.events.indexOf(l);this.events.splice(f,1)};return(0,C.toDisposable)((0,R.once)(d))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(y=>this.hook(y))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(y=>this.unhook(y))}hook(y){y.listener=y.event(l=>this.emitter.fire(l))}unhook(y){y.listener&&y.listener.dispose(),y.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(y){return(l,d,f)=>y(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>l.call(d,t)):l.call(d,t)},void 0,f)}bufferEvents(y){const l=[];this.buffers.push(l);const d=y();return this.buffers.pop(),l.forEach(f=>f()),d}}e.EventBufferer=a;class p{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=C.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(y){this.inputEvent=y,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=y(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(be[20],we([0,1,3]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(D,S){const k=setTimeout(D.bind(S),0);return{dispose(){clearTimeout(k)}}});var C;(function(D){function S(k){return k===D.None||k===D.Cancelled||k instanceof T?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}D.isCancellationToken=S,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(C=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=C.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=E}),define(be[36],we([0,1,3]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(A){const c=this._icons.get(A.id);c?A.description?c.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new R;e.iconRegistry=C;function T(i,A){return new D(i,A)}e.registerCodicon=T;function E(i){return i?i.replace(/\$\((.*?)\)/g,(A,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=E;class D{constructor(A,c,g){this.id=A,this.definition=c,this.description=g,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function S(i,A){const c=["codicon","codicon-"+i];return A&&c.push("codicon-modifier-"+A),c}e.getClassNamesArray=S;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function c(a){if(a instanceof D)return["codicon","codicon-"+a.id];const p=A.exec(a.id);if(!p)return c(D.error);let[,m,y]=p;const l=["codicon","codicon-"+m];return y&&l.push("codicon-modifier-"+y.substr(1)),l}i.asClassNameArray=c;function g(a){return c(a).join(" ")}i.asClassName=g;function r(a){return"."+c(a).join(".")}i.asCSSSelector=r})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(be[110],we([0,1,12,6]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(l){const d=l;return d?[d.on,d.pause,d.resume,d.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=C;function T(l){const d=l;return d?C(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=T;function E(l,d){return new D(l,d)}e.newWriteableStream=E;class D{constructor(d,f){this.reducer=d,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){var f;if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof((f=this.options)===null||f===void 0?void 0:f.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(f=>f(d))}emitError(d){this.listeners.error.length===0?(0,v.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(f=>f(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,f){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(d,f){if(!this.state.destroyed){let t;switch(d){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(f);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(l,d){const f=[];let t;for(;(t=l.read())!==null;)f.push(t);return d(f)}e.consumeReadable=S;function k(l,d,f){const t=[];let n;for(;(n=l.read())!==null&&t.length<f;)t.push(n);return n===null&&t.length>0?d(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return l.read()}}}e.peekReadable=k;function i(l,d){return new Promise((f,t)=>{const n=[];A(l,{onData:s=>{d&&n.push(s)},onError:s=>{d?t(s):f(void 0)},onEnd:()=>{f(d?d(n):void 0)}})})}e.consumeStream=i;function A(l,d){l.on("error",f=>d.onError(f)),l.on("end",()=>d.onEnd()),l.on("data",f=>d.onData(f))}e.listenStream=A;function c(l,d){return new Promise((f,t)=>{const n=new R.DisposableStore,s=[],o=b=>{if(s.push(b),s.length>d)return n.dispose(),l.pause(),f({stream:l,buffer:s,ended:!1})},u=b=>t(b),w=()=>f({stream:l,buffer:s,ended:!0});n.add((0,R.toDisposable)(()=>l.removeListener("error",u))),l.on("error",u),n.add((0,R.toDisposable)(()=>l.removeListener("end",w))),l.on("end",w),n.add((0,R.toDisposable)(()=>l.removeListener("data",o))),l.on("data",o)})}e.peekStream=c;function g(l,d){const f=E(d);return f.end(l),f}e.toStream=g;function r(){const l=E(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=r;function a(l){let d=!1;return{read:()=>d?null:(d=!0,l)}}e.toReadable=a;function p(l,d,f){const t=E(f);return A(l,{onData:n=>t.write(d.data(n)),onError:n=>t.error(d.error?d.error(n):n),onEnd:()=>t.end()}),t}e.transform=p;function m(l,d,f){let t=!1;return{read:()=>{const n=d.read();return t?n:(t=!0,n!==null?f([l,n]):l)}}}e.prefixedReadable=m;function y(l,d,f){let t=!1;const n=E(f);return A(d,{onData:s=>t?n.write(s):(t=!0,n.write(f([l,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(l)),n.end()}}),n}e.prefixedStream=y}),define(be[8],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(O){return!O||typeof O!="string"?!0:O.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function C(O,...Y){return Y.length===0?O:O.replace(R,function(re,Ie){const _e=parseInt(Ie,10);return isNaN(_e)||_e<0||_e>=Y.length?re:Y[_e]})}e.format=C;function T(O){return O.replace(/[<>&]/g,function(Y){switch(Y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Y}})}e.escape=T;function E(O){return O.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function D(O,Y){let re=0;const Ie=Y.charCodeAt(0);for(let _e=O.length-1;_e>=0;_e--)O.charCodeAt(_e)===Ie&&re++;return re}e.count=D;function S(O,Y,re="\u2026"){return O.length<=Y?O:`${O.substr(0,Y)}${re}`}e.truncate=S;function k(O,Y=" "){const re=i(O,Y);return A(re,Y)}e.trim=k;function i(O,Y){if(!O||!Y)return O;const re=Y.length;if(re===0||O.length===0)return O;let Ie=0;for(;O.indexOf(Y,Ie)===Ie;)Ie=Ie+re;return O.substring(Ie)}e.ltrim=i;function A(O,Y){if(!O||!Y)return O;const re=Y.length,Ie=O.length;if(re===0||Ie===0)return O;let _e=Ie,Re=-1;for(;Re=O.lastIndexOf(Y,_e-1),!(Re===-1||Re+re!==_e);){if(Re===0)return"";_e=Re}return O.substring(0,_e)}e.rtrim=A;function c(O){return O.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function g(O){return O.replace(/\*/g,"")}e.stripWildcards=g;function r(O,Y,re={}){if(!O)throw new Error("Cannot create regex from empty string");Y||(O=E(O)),re.wholeWord&&(/\B/.test(O.charAt(0))||(O="\\b"+O),/\B/.test(O.charAt(O.length-1))||(O=O+"\\b"));let Ie="";return re.global&&(Ie+="g"),re.matchCase||(Ie+="i"),re.multiline&&(Ie+="m"),re.unicode&&(Ie+="u"),new RegExp(O,Ie)}e.createRegExp=r;function a(O){return O.source==="^"||O.source==="^$"||O.source==="$"||O.source==="^\\s*$"?!1:!!(O.exec("")&&O.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function p(O){return!!O.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function m(O){return(O.global?"g":"")+(O.ignoreCase?"i":"")+(O.multiline?"m":"")+(O.unicode?"u":"")}e.regExpFlags=m;function y(O){return O.split(/\r\n|\r|\n/)}e.splitLines=y;function l(O){for(let Y=0,re=O.length;Y<re;Y++){const Ie=O.charCodeAt(Y);if(Ie!==32&&Ie!==9)return Y}return-1}e.firstNonWhitespaceIndex=l;function d(O,Y=0,re=O.length){for(let Ie=Y;Ie<re;Ie++){const _e=O.charCodeAt(Ie);if(_e!==32&&_e!==9)return O.substring(Y,Ie)}return O.substring(Y,re)}e.getLeadingWhitespace=d;function f(O,Y=O.length-1){for(let re=Y;re>=0;re--){const Ie=O.charCodeAt(re);if(Ie!==32&&Ie!==9)return re}return-1}e.lastNonWhitespaceIndex=f;function t(O,Y){return O<Y?-1:O>Y?1:0}e.compare=t;function n(O,Y,re=0,Ie=O.length,_e=0,Re=Y.length){for(;re<Ie&&_e<Re;re++,_e++){let st=O.charCodeAt(re),Ye=Y.charCodeAt(_e);if(st<Ye)return-1;if(st>Ye)return 1}const ze=Ie-re,Xe=Re-_e;return ze<Xe?-1:ze>Xe?1:0}e.compareSubstring=n;function s(O,Y){return o(O,Y,0,O.length,0,Y.length)}e.compareIgnoreCase=s;function o(O,Y,re=0,Ie=O.length,_e=0,Re=Y.length){for(;re<Ie&&_e<Re;re++,_e++){let st=O.charCodeAt(re),Ye=Y.charCodeAt(_e);if(st!==Ye){const et=st-Ye;if(!(et===32&&w(Ye))&&!(et===-32&&w(st)))return u(st)&&u(Ye)?et:n(O.toLowerCase(),Y.toLowerCase(),re,Ie,_e,Re)}}const ze=Ie-re,Xe=Re-_e;return ze<Xe?-1:ze>Xe?1:0}e.compareSubstringIgnoreCase=o;function u(O){return O>=97&&O<=122}e.isLowerAsciiLetter=u;function w(O){return O>=65&&O<=90}e.isUpperAsciiLetter=w;function b(O){return u(O)||w(O)}function I(O,Y){return O.length===Y.length&&h(O,Y)}e.equalsIgnoreCase=I;function h(O,Y,re=O.length){for(let Ie=0;Ie<re;Ie++){const _e=O.charCodeAt(Ie),Re=Y.charCodeAt(Ie);if(_e!==Re){if(b(_e)&&b(Re)){const ze=Math.abs(_e-Re);if(ze!==0&&ze!==32)return!1}else if(String.fromCharCode(_e).toLowerCase()!==String.fromCharCode(Re).toLowerCase())return!1}}return!0}function _(O,Y){const re=Y.length;return Y.length>O.length?!1:h(O,Y,re)}e.startsWithIgnoreCase=_;function F(O,Y){let re,Ie=Math.min(O.length,Y.length);for(re=0;re<Ie;re++)if(O.charCodeAt(re)!==Y.charCodeAt(re))return re;return Ie}e.commonPrefixLength=F;function N(O,Y){let re,Ie=Math.min(O.length,Y.length);const _e=O.length-1,Re=Y.length-1;for(re=0;re<Ie;re++)if(O.charCodeAt(_e-re)!==Y.charCodeAt(Re-re))return re;return Ie}e.commonSuffixLength=N;function z(O){return 55296<=O&&O<=56319}e.isHighSurrogate=z;function ce(O){return 56320<=O&&O<=57343}e.isLowSurrogate=ce;function de(O,Y){return(O-55296<<10)+(Y-56320)+65536}e.computeCodePoint=de;function B(O,Y,re){const Ie=O.charCodeAt(re);if(z(Ie)&&re+1<Y){const _e=O.charCodeAt(re+1);if(ce(_e))return de(Ie,_e)}return Ie}e.getNextCodePoint=B;function j(O,Y){const re=O.charCodeAt(Y-1);if(ce(re)&&Y>1){const Ie=O.charCodeAt(Y-2);if(z(Ie))return de(Ie,re)}return re}function W(O,Y){const re=Be.getInstance(),Ie=Y,_e=O.length,Re=B(O,_e,Y);Y+=Re>=65536?2:1;let ze=re.getGraphemeBreakType(Re);for(;Y<_e;){const Xe=B(O,_e,Y),st=re.getGraphemeBreakType(Xe);if(Ne(ze,st))break;Y+=Xe>=65536?2:1,ze=st}return Y-Ie}e.nextCharLength=W;function P(O,Y){const re=Be.getInstance(),Ie=Y,_e=j(O,Y);Y-=_e>=65536?2:1;let Re=re.getGraphemeBreakType(_e);for(;Y>0;){const ze=j(O,Y),Xe=re.getGraphemeBreakType(ze);if(Ne(Xe,Re))break;Y-=ze>=65536?2:1,Re=Xe}return Ie-Y}e.prevCharLength=P;function H(O,Y){const re=Be.getInstance(),Ie=O.length,_e=Y,Re=B(O,Ie,Y),ze=re.getGraphemeBreakType(Re);Y+=Re>=65536?2:1;let Xe=ze;for(;Y<Ie;){const Ye=B(O,Ie,Y),et=re.getGraphemeBreakType(Ye);if(Ne(Xe,et))break;Y+=Ye>=65536?2:1,Xe=et}const st=Y;for(Y=_e,Xe=ze;Y>0;){const Ye=j(O,Y),et=re.getGraphemeBreakType(Ye);if(Ne(et,Xe))break;Y-=Ye>=65536?2:1,Xe=et}return[Y,st]}function L(O,Y){return Y>0&&ce(O.charCodeAt(Y))?H(O,Y-1):H(O,Y)}e.getCharContainingOffset=L;function $(O){const Y=O.length;let re=0,Ie=0;for(;Ie<Y;){const ze=B(O,Y,Ie);Ie+=ze>=65536?2:1,ze<128?re+=1:ze<2048?re+=2:ze<65536?re+=3:re+=4}const _e=new Uint8Array(re);Ie=0;let Re=0;for(;Ie<Y;){const ze=B(O,Y,Ie);Ie+=ze>=65536?2:1,ze<128?_e[Re++]=ze:ze<2048?(_e[Re++]=192|(ze&1984)>>>6,_e[Re++]=128|(ze&63)>>>0):ze<65536?(_e[Re++]=224|(ze&61440)>>>12,_e[Re++]=128|(ze&4032)>>>6,_e[Re++]=128|(ze&63)>>>0):(_e[Re++]=240|(ze&1835008)>>>18,_e[Re++]=128|(ze&258048)>>>12,_e[Re++]=128|(ze&4032)>>>6,_e[Re++]=128|(ze&63)>>>0)}return _e}e.encodeUTF8=$;function Q(O){const Y=O.byteLength,re=[];let Ie=0;for(;Ie<Y;){const _e=O[Ie];let Re;if(_e>=240&&Ie+3<Y?Re=(O[Ie++]&7)<<18>>>0|(O[Ie++]&63)<<12>>>0|(O[Ie++]&63)<<6>>>0|(O[Ie++]&63)<<0>>>0:_e>=224&&Ie+2<Y?Re=(O[Ie++]&15)<<12>>>0|(O[Ie++]&63)<<6>>>0|(O[Ie++]&63)<<0>>>0:_e>=192&&Ie+1<Y?Re=(O[Ie++]&31)<<6>>>0|(O[Ie++]&63)<<0>>>0:Re=O[Ie++],Re>=0&&Re<=55295||Re>=57344&&Re<=65535)re.push(String.fromCharCode(Re));else if(Re>=65536&&Re<=1114111){const ze=Re-65536,Xe=55296+((ze&1047552)>>>10),st=56320+((ze&1023)>>>0);re.push(String.fromCharCode(Xe)),re.push(String.fromCharCode(st))}else re.push(String.fromCharCode(65533))}return re.join("")}e.decodeUTF8=Q;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ae(O){return q.test(O)}e.containsRTL=ae;const fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Le(O){return fe.test(O)}e.containsEmoji=Le;const xe=/^[\t\n\r\x20-\x7E]*$/;function Fe(O){return xe.test(O)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function He(O){return e.UNUSUAL_LINE_TERMINATORS.test(O)}e.containsUnusualLineTerminators=He;function x(O){for(let Y=0,re=O.length;Y<re;Y++)if(G(O.charCodeAt(Y)))return!0;return!1}e.containsFullWidthCharacter=x;function G(O){return O=+O,O>=11904&&O<=55215||O>=63744&&O<=64255||O>=65281&&O<=65374}e.isFullWidthCharacter=G;function ee(O){return O>=127462&&O<=127487||O===8986||O===8987||O===9200||O===9203||O>=9728&&O<=10175||O===11088||O===11093||O>=127744&&O<=128591||O>=128640&&O<=128764||O>=128992&&O<=129003||O>=129280&&O<=129535||O>=129648&&O<=129750}e.isEmojiImprecise=ee;function ie(O,Y){if(O.length<Y)return O;const re=/\b/g;let Ie=0;for(;re.test(O)&&!(O.length-re.lastIndex<Y);)Ie=re.lastIndex,re.lastIndex+=1;return O.substring(Ie).replace(/^\s/,"")}e.lcut=ie;const ue=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,$e=/\x1b\[0?m/g;function he(O){return O&&(O=O.replace(ue,""),O=O.replace(Ee,""),O=O.replace($e,"")),O}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(O){return!!(O&&O.length>0&&O.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Te(O){return Ce(O)?O.substr(1):O}e.stripUTF8BOM=Te;function We(O,Y){if(!O||!Y||O.length<Y.length)return!1;const re=Y.length,Ie=O.toLowerCase();let _e=0,Re=-1;for(;_e<re;){const ze=Ie.indexOf(Y[_e],Re+1);if(ze<0)return!1;Re=ze,_e++}return!0}e.fuzzyContains=We;function ve(O,Y=!1){return O?(Y&&(O=O.replace(/\\./g,"")),O.toLowerCase()!==O):!1}e.containsUppercaseCharacter=ve;function Ge(O){return O.charAt(0).toUpperCase()+O.slice(1)}e.uppercaseFirstLetter=Ge;function V(O,Y=1){if(Y===0)return"";let re=-1;do re=O.indexOf(`
`,re+1),Y--;while(Y>0&&re>=0);return re===-1?O:(O[re-1]==="\r"&&re--,O.substr(0,re))}e.getNLines=V;function Z(O){const Y=90-65+1;return O=O%(2*Y),O<Y?String.fromCharCode(97+O):String.fromCharCode(65+O-Y)}e.singleLetterHash=Z;function ge(O){return Be.getInstance().getGraphemeBreakType(O)}e.getGraphemeBreakType=ge;function Ne(O,Y){return O===0?Y!==5&&Y!==7:O===2&&Y===3?!1:O===4||O===2||O===3||Y===4||Y===2||Y===3?!0:!(O===8&&(Y===8||Y===9||Y===11||Y===12)||(O===11||O===9)&&(Y===9||Y===10)||(O===12||O===10)&&Y===10||Y===5||Y===13||Y===7||O===1||O===13&&Y===14||O===6&&Y===6)}e.breakBetweenGraphemeBreakType=Ne;var Ve;(function(O){O[O.Other=0]="Other",O[O.Prepend=1]="Prepend",O[O.CR=2]="CR",O[O.LF=3]="LF",O[O.Control=4]="Control",O[O.Extend=5]="Extend",O[O.Regional_Indicator=6]="Regional_Indicator",O[O.SpacingMark=7]="SpacingMark",O[O.L=8]="L",O[O.V=9]="V",O[O.T=10]="T",O[O.LV=11]="LV",O[O.LVT=12]="LVT",O[O.ZWJ=13]="ZWJ",O[O.Extended_Pictographic=14]="Extended_Pictographic"})(Ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=Ze()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(Y){if(Y<32)return Y===10?3:Y===13?2:4;if(Y<127)return 0;const re=this._data,Ie=re.length/3;let _e=1;for(;_e<=Ie;)if(Y<re[3*_e])_e=2*_e;else if(Y>re[3*_e+1])_e=2*_e+1;else return re[3*_e+2];return 0}}Be._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(O,Y){if(O===0)return 0;const re=ye(O,Y);if(re!==void 0)return re;const Ie=j(Y,O);return O-=ke(Ie),O}e.getLeftDeleteOffset=Se;function ye(O,Y){let re=j(Y,O);for(O-=ke(re);ne(re)||re===65039||re===8419;){if(O===0)return;re=j(Y,O),O-=ke(re)}if(!!ee(re)){if(O>=0){const Ie=j(Y,O);Ie===8205&&(O-=ke(Ie))}return O}}function ke(O){return O>=65536?2:1}function ne(O){return 127995<=O&&O<=127999}var oe;(function(O){O[O.zwj=8205]="zwj",O[O.emojiVariantSelector=65039]="emojiVariantSelector",O[O.enclosingKeyCap=8419]="enclosingKeyCap"})(oe||(oe={}))}),define(be[24],we([0,1,8,110]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",E=typeof TextDecoder!="undefined";let D,S;class k{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return C?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return C&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,I){return!((I==null?void 0:I.dontUseNodeBuffer)||!1)&&C?new k(Buffer.from(b)):T?(D||(D=new TextEncoder),new k(D.encode(b))):new k(v.encodeUTF8(b))}static concat(b,I){if(typeof I=="undefined"){I=0;for(let F=0,N=b.length;F<N;F++)I+=b[F].byteLength}const h=k.alloc(I);let _=0;for(let F=0,N=b.length;F<N;F++){const z=b[F];h.set(z,_),_+=z.byteLength}return h}toString(){return C?this.buffer.toString():E?(S||(S=new TextDecoder),S.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(b,I){return new k(this.buffer.subarray(b,I))}set(b,I){b instanceof k?this.buffer.set(b.buffer,I):this.buffer.set(b,I)}readUInt32BE(b){return c(this.buffer,b)}writeUInt32BE(b,I){g(this.buffer,b,I)}readUInt32LE(b){return r(this.buffer,b)}writeUInt32LE(b,I){a(this.buffer,b,I)}readUInt8(b){return p(this.buffer,b)}writeUInt8(b,I){m(this.buffer,b,I)}}e.VSBuffer=k;function i(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0}e.readUInt16LE=i;function A(w,b,I){w[I+0]=b&255,b=b>>>8,w[I+1]=b&255}e.writeUInt16LE=A;function c(w,b){return w[b]*2**24+w[b+1]*2**16+w[b+2]*2**8+w[b+3]}e.readUInt32BE=c;function g(w,b,I){w[I+3]=b,b=b>>>8,w[I+2]=b,b=b>>>8,w[I+1]=b,b=b>>>8,w[I]=b}e.writeUInt32BE=g;function r(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0|w[b+2]<<16>>>0|w[b+3]<<24>>>0}e.readUInt32LE=r;function a(w,b,I){w[I+0]=b&255,b=b>>>8,w[I+1]=b&255,b=b>>>8,w[I+2]=b&255,b=b>>>8,w[I+3]=b&255}e.writeUInt32LE=a;function p(w,b){return w[b]}e.readUInt8=p;function m(w,b,I){w[I]=b}e.writeUInt8=m;function y(w){return R.consumeReadable(w,b=>k.concat(b))}e.readableToBuffer=y;function l(w){return R.toReadable(w)}e.bufferToReadable=l;function d(w){return R.consumeStream(w,b=>k.concat(b))}e.streamToBuffer=d;async function f(w){return w.ended?k.concat(w.buffer):k.concat([...w.buffer,await d(w.stream)])}e.bufferedStreamToBuffer=f;function t(w){return R.toStream(w,b=>k.concat(b))}e.bufferToStream=t;function n(w){return R.transform(w,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.streamToBufferReadableStream=n;function s(w){return R.newWriteableStream(b=>k.concat(b),w)}e.newWriteableBufferStream=s;function o(w,b){return R.prefixedReadable(w,b,I=>k.concat(I))}e.prefixedBufferReadable=o;function u(w,b){return R.prefixedStream(w,b,I=>k.concat(I))}e.prefixedBufferStream=u}),define(be[57],we([0,1,8]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(m){return C(m,0)}e.hash=R;function C(m,y){switch(typeof m){case"object":return m===null?T(349,y):Array.isArray(m)?S(m,y):k(m,y);case"string":return D(m,y);case"boolean":return E(m,y);case"number":return T(m,y);case"undefined":return T(937,y);default:return T(617,y)}}e.doHash=C;function T(m,y){return(y<<5)-y+m|0}function E(m,y){return T(m?433:863,y)}function D(m,y){y=T(149417,y);for(let l=0,d=m.length;l<d;l++)y=T(m.charCodeAt(l),y);return y}e.stringHash=D;function S(m,y){return y=T(104579,y),m.reduce((l,d)=>C(d,l),y)}function k(m,y){return y=T(181387,y),Object.keys(m).sort().reduce((l,d)=>(l=D(d,l),C(m[d],l)),y)}class i{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=C(y,this._value),this._value}}e.Hasher=i;var A;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function c(m,y,l=32){const d=l-y,f=~((1<<d)-1);return(m<<y|(f&m)>>>d)>>>0}function g(m,y=0,l=m.byteLength,d=0){for(let f=0;f<l;f++)m[y+f]=d}function r(m,y,l="0"){for(;m.length<y;)m=l+m;return m}function a(m,y=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(l=>l.toString(16).padStart(2,"0")).join(""):r((m>>>0).toString(16),y/4)}e.toHexString=a;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const l=y.length;if(l!==0){const d=this._buff;let f=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=y.charCodeAt(0),s=0);;){let o=n;if(v.isHighSurrogate(n))if(s+1<l){const u=y.charCodeAt(s+1);v.isLowSurrogate(u)?(s++,o=v.computeCodePoint(n,u)):o=65533}else{t=n;break}else v.isLowSurrogate(n)&&(o=65533);if(f=this._push(d,f,o),s++,s<l)n=y.charCodeAt(s);else break}this._buffLen=f,this._leftoverHighSurrogate=t}}_push(y,l,d){return d<128?y[l++]=d:d<2048?(y[l++]=192|(d&1984)>>>6,y[l++]=128|(d&63)>>>0):d<65536?(y[l++]=224|(d&61440)>>>12,y[l++]=128|(d&4032)>>>6,y[l++]=128|(d&63)>>>0):(y[l++]=240|(d&1835008)>>>18,y[l++]=128|(d&258048)>>>12,y[l++]=128|(d&4032)>>>6,y[l++]=128|(d&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=p._bigBlock32,l=this._buffDV;for(let b=0;b<64;b+=4)y.setUint32(b,l.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)y.setUint32(b,c(y.getUint32(b-12,!1)^y.getUint32(b-32,!1)^y.getUint32(b-56,!1)^y.getUint32(b-64,!1),1),!1);let d=this._h0,f=this._h1,t=this._h2,n=this._h3,s=this._h4,o,u,w;for(let b=0;b<80;b++)b<20?(o=f&t|~f&n,u=1518500249):b<40?(o=f^t^n,u=1859775393):b<60?(o=f&t|f&n|t&n,u=2400959708):(o=f^t^n,u=3395469782),w=c(d,5)+o+s+u+y.getUint32(b*4,!1)&4294967295,s=n,n=t,t=c(f,30),f=d,d=w;this._h0=this._h0+d&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[47],we([0,1,8]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(R||(R={})),function(C){const T="error",E="warning",D="warn",S="info",k="ignore";function i(c){return c?v.equalsIgnoreCase(T,c)?C.Error:v.equalsIgnoreCase(E,c)||v.equalsIgnoreCase(D,c)?C.Warning:v.equalsIgnoreCase(S,c)?C.Info:C.Ignore:C.Ignore}C.fromValue=i;function A(c){switch(c){case C.Error:return T;case C.Warning:return E;case C.Info:return S;default:return k}}C.toString=A}(R||(R={})),e.default=R}),define(be[10],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(b){return Array.isArray(b)}e.isArray=v;function R(b){return typeof b=="string"}e.isString=R;function C(b){return Array.isArray(b)&&b.every(I=>R(I))}e.isStringArray=C;function T(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=T;function E(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=E;function D(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=D;function S(b){return b===!0||b===!1}e.isBoolean=S;function k(b){return typeof b=="undefined"}e.isUndefined=k;function i(b){return!A(b)}e.isDefined=i;function A(b){return k(b)||b===null}e.isUndefinedOrNull=A;function c(b,I){if(!b)throw new Error(I?`Unexpected type, expected '${I}'`:"Unexpected type")}e.assertType=c;function g(b){if(A(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=g;function r(...b){const I=[];for(let h=0;h<b.length;h++){const _=b[h];if(A(_))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);I.push(_)}return I}e.assertAllDefined=r;const a=Object.prototype.hasOwnProperty;function p(b){if(!T(b))return!1;for(let I in b)if(a.call(b,I))return!1;return!0}e.isEmptyObject=p;function m(b){return typeof b=="function"}e.isFunction=m;function y(...b){return b.length>0&&b.every(m)}e.areFunctions=y;function l(b,I){const h=Math.min(b.length,I.length);for(let _=0;_<h;_++)d(b[_],I[_])}e.validateConstraints=l;function d(b,I){if(R(I)){if(typeof b!==I)throw new Error(`argument does not match constraint: typeof ${I}`)}else if(m(I)){try{if(b instanceof I)return}catch(h){}if(!A(b)&&b.constructor===I||I.length===1&&I.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function f(b){let I=[],h=Object.getPrototypeOf(b);for(;Object.prototype!==h;)I=I.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return I}e.getAllPropertyNames=f;function t(b){const I=[];for(const h of f(b))typeof b[h]=="function"&&I.push(h);return I}e.getAllMethodNames=t;function n(b,I){const h=F=>function(){const N=Array.prototype.slice.call(arguments,0);return I(F,N)};let _={};for(const F of b)_[F]=h(F);return _}e.createProxyObject=n;function s(b){return b===null?void 0:b}e.withNullAsUndefined=s;function o(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=o;function u(b){return class{constructor(){return new Proxy({},{get(I,h){if(I[h])return I[h];throw new Error(`Not Implemented: ${b}->${String(h)}`)}})}}}e.NotImplementedProxy=u;function w(b){throw new Error("Unreachable")}e.assertNever=w}),define(be[37],we([0,1,21,8,14,10]),function(J,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(s){return s===47||s===92}e.isPathSeparator=E;function D(s){return s.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=D;function S(s){return s.indexOf("/")===-1&&(s=D(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=S;function k(s,o=C.posix.sep){if(!s)return"";const u=s.length,w=s.charCodeAt(0);if(E(w)){if(E(s.charCodeAt(1))&&!E(s.charCodeAt(2))){let I=3;const h=I;for(;I<u&&!E(s.charCodeAt(I));I++);if(h!==I&&!E(s.charCodeAt(I+1))){for(I+=1;I<u;I++)if(E(s.charCodeAt(I)))return s.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(m(w)&&s.charCodeAt(1)===58)return E(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let b=s.indexOf("://");if(b!==-1){for(b+=3;b<u;b++)if(E(s.charCodeAt(b)))return s.slice(0,b+1)}return""}e.getRoot=k;function i(s){if(!v.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let u=2;const w=u;for(;u<s.length&&(o=s.charCodeAt(u),o!==92);u++);return!(w===u||(o=s.charCodeAt(u+1),isNaN(o)||o===92))}e.isUNC=i;const A=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(s,o=v.isWindows){const u=o?A:c;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||o&&g.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=r;function a(s,o,u){const w=s===o;return!u||w?w:!s||!o?!1:(0,R.equalsIgnoreCase)(s,o)}e.isEqual=a;function p(s,o,u,w=C.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(u){if(!(0,R.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let I=o.length;return o.charAt(o.length-1)===w&&I--,s.charAt(I)===w}return o.charAt(o.length-1)!==w&&(o+=w),s.indexOf(o)===0}e.isEqualOrParent=p;function m(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=m;function y(s,o){return v.isWindows&&s.endsWith(":")&&(s+=C.sep),(0,C.isAbsolute)(s)||(s=(0,C.join)(o,s)),s=(0,C.normalize)(s),v.isWindows?(s=(0,R.rtrim)(s,C.sep),s.endsWith(":")&&(s+=C.sep)):(s=(0,R.rtrim)(s,C.sep),s||(s=C.sep)),s}e.sanitizeFilePath=y;function l(s){const o=(0,C.normalize)(s);return v.isWindows?s.length>3?!1:d(o)&&(s.length===2||o.charCodeAt(2)===92):o===C.posix.sep}e.isRootOrDriveLetter=l;function d(s){return v.isWindows?m(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function f(s){return d(s)?s[0]:void 0}e.getDriveLetter=f;function t(s,o,u){return o.length>s.length?-1:s===o?0:(u&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=t;function n(s){const o=s.split(":");let u,w,b;if(o.forEach(I=>{const h=Number(I);(0,T.isNumber)(h)?w===void 0?w=h:b===void 0&&(b=h):u=u?[u,I].join(":"):I}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:w!==void 0?w:void 0,column:b!==void 0?b:w!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(be[23],we([0,1,10]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const p=Array.isArray(a)?[]:{};return Object.keys(a).forEach(m=>{a[m]&&typeof a[m]=="object"?p[m]=R(a[m]):p[m]=a[m]}),p}e.deepClone=R;function C(a){if(!a||typeof a!="object")return a;const p=[a];for(;p.length>0;){const m=p.shift();Object.freeze(m);for(const y in m)if(T.call(m,y)){const l=m[y];typeof l=="object"&&!Object.isFrozen(l)&&p.push(l)}}return a}e.deepFreeze=C;const T=Object.prototype.hasOwnProperty;function E(a,p){return D(a,p,new Set)}e.cloneAndChange=E;function D(a,p,m){if((0,v.isUndefinedOrNull)(a))return a;const y=p(a);if(typeof y!="undefined")return y;if((0,v.isArray)(a)){const l=[];for(const d of a)l.push(D(d,p,m));return l}if((0,v.isObject)(a)){if(m.has(a))throw new Error("Cannot clone recursive data-structure");m.add(a);const l={};for(let d in a)T.call(a,d)&&(l[d]=D(a[d],p,m));return m.delete(a),l}return a}function S(a,p,m=!0){return(0,v.isObject)(a)?((0,v.isObject)(p)&&Object.keys(p).forEach(y=>{y in a?m&&((0,v.isObject)(a[y])&&(0,v.isObject)(p[y])?S(a[y],p[y],m):a[y]=p[y]):a[y]=p[y]}),a):p}e.mixin=S;function k(a,p){if(a===p)return!0;if(a==null||p===null||p===void 0||typeof a!=typeof p||typeof a!="object"||Array.isArray(a)!==Array.isArray(p))return!1;let m,y;if(Array.isArray(a)){if(a.length!==p.length)return!1;for(m=0;m<a.length;m++)if(!k(a[m],p[m]))return!1}else{const l=[];for(y in a)l.push(y);l.sort();const d=[];for(y in p)d.push(y);if(d.sort(),!k(l,d))return!1;for(m=0;m<l.length;m++)if(!k(a[l[m]],p[l[m]]))return!1}return!0}e.equals=k;function i(a){const p=new Set;return JSON.stringify(a,(m,y)=>{if((0,v.isObject)(y)||Array.isArray(y)){if(p.has(y))return"[Circular]";p.add(y)}return y})}e.safeStringify=i;function A(a,p,m){const y=p(a);return typeof y=="undefined"?m:y}e.getOrDefault=A;function c(a,p){const m=Object.create(null);return!a||!p||Object.keys(p).forEach(l=>{const d=a[l],f=p[l];k(d,f)||(m[l]=f)}),m}e.distinct=c;function g(a,p){const m=p.toLowerCase(),y=Object.keys(a).find(l=>l.toLowerCase()===m);return y?a[y]:a[p]}e.getCaseInsensitive=g;function r(a,p){const m=Object.create(null);for(const y of Object.keys(a))p(y,a[y])&&(m[y]=a[y]);return m}e.filter=r}),define(be[83],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var v;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(v=e.Constants||(e.Constants={}));function R(T){return T<0?0:T>255?255:T|0}e.toUint8=R;function C(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=C}),define(be[2],we([0,1,21,14]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,T=/^\//,E=/^\/\//;function D(s,o){if(!s.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!T.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,o){return!s&&!o?"file":s}function k(s,o){switch(s){case"https":case"http":case"file":o?o[0]!==A&&(o=A+o):o=A;break}return o}const i="",A="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(o,u,w,b,I,h=!1){typeof o=="object"?(this.scheme=o.scheme||i,this.authority=o.authority||i,this.path=o.path||i,this.query=o.query||i,this.fragment=o.fragment||i):(this.scheme=S(o,h),this.authority=u||i,this.path=k(this.scheme,w||i),this.query=b||i,this.fragment=I||i,D(this,h))}static isUri(o){return o instanceof g?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return l(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:w,path:b,query:I,fragment:h}=o;return u===void 0?u=this.scheme:u===null&&(u=i),w===void 0?w=this.authority:w===null&&(w=i),b===void 0?b=this.path:b===null&&(b=i),I===void 0?I=this.query:I===null&&(I=i),h===void 0?h=this.fragment:h===null&&(h=i),u===this.scheme&&w===this.authority&&b===this.path&&I===this.query&&h===this.fragment?this:new a(u,w,b,I,h)}static parse(o,u=!1){const w=c.exec(o);return w?new a(w[2]||i,n(w[4]||i),n(w[5]||i),n(w[7]||i),n(w[9]||i),u):new a(i,i,i,i,i)}static file(o){let u=i;if(v.isWindows&&(o=o.replace(/\\/g,A)),o[0]===A&&o[1]===A){const w=o.indexOf(A,2);w===-1?(u=o.substring(2),o=A):(u=o.substring(2,w),o=o.substring(w)||A)}return new a("file",u,o,i,i)}static from(o){const u=new a(o.scheme,o.authority,o.path,o.query,o.fragment);return D(u,!0),u}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return v.isWindows&&o.scheme==="file"?w=g.file(R.win32.join(l(o,!0),...u)).path:w=R.posix.join(o.path,...u),o.with({path:w})}toString(o=!1){return d(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof g)return o;{const u=new a(o);return u._formatted=o.external,u._fsPath=o._sep===r?o.fsPath:null,u}}else return o}}e.URI=g;const r=v.isWindows?1:void 0;class a extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(o=!1){return o?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=r),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(s,o){let u,w=-1;for(let b=0;b<s.length;b++){const I=s.charCodeAt(b);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||o&&I===47)w!==-1&&(u+=encodeURIComponent(s.substring(w,b)),w=-1),u!==void 0&&(u+=s.charAt(b));else{u===void 0&&(u=s.substr(0,b));const h=p[I];h!==void 0?(w!==-1&&(u+=encodeURIComponent(s.substring(w,b)),w=-1),u+=h):w===-1&&(w=b)}}return w!==-1&&(u+=encodeURIComponent(s.substring(w))),u!==void 0?u:s}function y(s){let o;for(let u=0;u<s.length;u++){const w=s.charCodeAt(u);w===35||w===63?(o===void 0&&(o=s.substr(0,u)),o+=p[w]):o!==void 0&&(o+=s[u])}return o!==void 0?o:s}function l(s,o){let u;return s.authority&&s.path.length>1&&s.scheme==="file"?u=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?o?u=s.path.substr(1):u=s.path[1].toLowerCase()+s.path.substr(2):u=s.path,v.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=l;function d(s,o){const u=o?y:m;let w="",{scheme:b,authority:I,path:h,query:_,fragment:F}=s;if(b&&(w+=b,w+=":"),(I||b==="file")&&(w+=A,w+=A),I){let N=I.indexOf("@");if(N!==-1){const z=I.substr(0,N);I=I.substr(N+1),N=z.indexOf(":"),N===-1?w+=u(z,!1):(w+=u(z.substr(0,N),!1),w+=":",w+=u(z.substr(N+1),!1)),w+="@"}I=I.toLowerCase(),N=I.indexOf(":"),N===-1?w+=u(I,!1):(w+=u(I.substr(0,N),!1),w+=I.substr(N))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const N=h.charCodeAt(1);N>=65&&N<=90&&(h=`/${String.fromCharCode(N+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const N=h.charCodeAt(0);N>=65&&N<=90&&(h=`${String.fromCharCode(N+32)}:${h.substr(2)}`)}w+=u(h,!0)}return _&&(w+="?",w+=u(_,!1)),F&&(w+="#",w+=o?F:m(F,!1)),w}function f(s){try{return decodeURIComponent(s)}catch(o){return s.length>3?s.substr(0,3)+f(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,o=>f(o)):s}});var it=this&&this.__classPrivateFieldSet||function(J,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(J,v):C?C.value=v:e.set(J,v),v},Ue=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[22],we([0,1,2,8]),function(J,e,v,R){"use strict";var C,T,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,n,s){let o=t.get(n);return o===void 0&&(o=s,t.set(n,o)),o}e.getOrSet=D;function S(t){const n=[];return t.forEach((s,o)=>{n.push(`${o} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=S;function k(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=i;class A{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,R.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class c{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,R.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class r{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,R.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(n){this._iter=n}static forUris(n=()=>!1){return new p(new r(n))}static forPaths(){return new p(new c)}static forStrings(){return new p(new i)}static forConfigKeys(){return new p(new A)}clear(){this._root=void 0}set(n,s){const o=this._iter.reset(n);let u;for(this._root||(this._root=new a,this._root.segment=o.value()),u=this._root;;){const b=o.cmp(u.segment);if(b>0)u.left||(u.left=new a,u.left.segment=o.value()),u=u.left;else if(b<0)u.right||(u.right=new a,u.right.segment=o.value()),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new a,u.mid.segment=o.value()),u=u.mid;else break}const w=u.value;return u.value=s,u.key=n,w}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let o=this._root;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const o=this._iter.reset(n),u=[];let w=this._root;for(;w;){const b=o.cmp(w.segment);if(b>0)u.push([1,w]),w=w.left;else if(b<0)u.push([-1,w]),w=w.right;else if(o.hasNext())o.next(),u.push([0,w]),w=w.mid;else{for(s?(w.left=void 0,w.mid=void 0,w.right=void 0):w.value=void 0;u.length>0&&w.isEmpty();){let[I,h]=u.pop();switch(I){case 1:h.left=void 0;break;case 0:h.mid=void 0;break;case-1:h.right=void 0;break}w=h}break}}}findSubstr(n){const s=this._iter.reset(n);let o=this._root,u;for(;o;){const w=s.cmp(o.segment);if(w>0)o=o.left;else if(w<0)o=o.right;else if(s.hasNext())s.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(n){const s=this._iter.reset(n);let o=this._root;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(n){for(const[s,o]of this)n(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=p;class m{constructor(n,s){this[C]="ResourceMap",n instanceof m?(this.map=new Map(n.map),this.toKey=s!=null?s:m.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:m.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[o,u]of this.map)n(u,v.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield v.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[v.URI.parse(n[0]),n[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[v.URI.parse(n[0]),n[1]]}}e.ResourceMap=m,m.defaultToKey=t=>t.toString();var y;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const o=this._map.get(n);if(!!o)return s!==0&&this.touch(o,s),o.value}set(n,s,o=0){let u=this._map.get(n);if(u)u.value=s,o!==0&&this.touch(u,o);else{switch(u={key:n,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,s){const o=this._state;let u=this._head;for(;u;){if(s?n.bind(s)(u.value,u.key,this):n(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const w={value:o.key,done:!1};return o=o.next,w}else return{value:void 0,done:!0}}};return u}values(){const n=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const w={value:o.value,done:!1};return o=o.next,w}else return{value:void 0,done:!0}}};return u}entries(){const n=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const w={value:[o.key,o.value],done:!1};return o=o.next,w}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>n;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,o=n.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const o=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const o=n.next,u=n.previous;n===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,o)=>{n.push([o,s])}),n}fromJSON(n){this.clear();for(const[s,o]of n)this.set(s,o)}}e.LinkedMap=l;class d extends l{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d;class f{constructor(n){E.set(this,void 0),it(this,E,n,"f")}get size(){return Ue(this,E,"f").size}forEach(n,s){Ue(this,E,"f").forEach(n,s)}get(n){return Ue(this,E,"f").get(n)}has(n){return Ue(this,E,"f").has(n)}entries(){return Ue(this,E,"f").entries()}keys(){return Ue(this,E,"f").keys()}values(){return Ue(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return Ue(this,E,"f").entries()}}e.ReadonlyMapView=f}),define(be[111],we([0,1,22,8]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...he){return function(Ce,Te){for(let We=0,ve=he.length;We<ve;We++){const Ge=he[We](Ce,Te);if(Ge)return Ge}return null}}e.or=C,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(he,Ce,Te){if(!Te||Te.length<Ce.length)return null;let We;return he?We=R.startsWithIgnoreCase(Te,Ce):We=Te.indexOf(Ce)===0,We?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function E(he,Ce){const Te=Ce.toLowerCase().indexOf(he.toLowerCase());return Te===-1?null:[{start:Te,end:Te+he.length}]}e.matchesContiguousSubString=E;function D(he,Ce){return S(he.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=D;function S(he,Ce,Te,We){if(Te===he.length)return[];if(We===Ce.length)return null;if(he[Te]===Ce[We]){let ve=null;return(ve=S(he,Ce,Te+1,We+1))?m({start:We,end:We+1},ve):null}return S(he,Ce,Te,We+1)}function k(he){return 97<=he&&he<=122}function i(he){return 65<=he&&he<=90}e.isUpper=i;function A(he){return 48<=he&&he<=57}function c(he){return he===32||he===9||he===10||he===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(he=>g.add(he.charCodeAt(0)));function r(he){return c(he)||g.has(he)}function a(he,Ce){return he===Ce||r(he)&&r(Ce)}function p(he){return k(he)||i(he)||A(he)}function m(he,Ce){return Ce.length===0?Ce=[he]:he.end===Ce[0].start?Ce[0].start=he.start:Ce.unshift(he),Ce}function y(he,Ce){for(let Te=Ce;Te<he.length;Te++){const We=he.charCodeAt(Te);if(i(We)||A(We)||Te>0&&!p(he.charCodeAt(Te-1)))return Te}return he.length}function l(he,Ce,Te,We){if(Te===he.length)return[];if(We===Ce.length)return null;if(he[Te]!==Ce[We].toLowerCase())return null;{let ve=null,Ge=We+1;for(ve=l(he,Ce,Te+1,We+1);!ve&&(Ge=y(Ce,Ge))<Ce.length;)ve=l(he,Ce,Te+1,Ge),Ge++;return ve===null?null:m({start:We,end:We+1},ve)}}function d(he){let Ce=0,Te=0,We=0,ve=0,Ge=0;for(let Ve=0;Ve<he.length;Ve++)Ge=he.charCodeAt(Ve),i(Ge)&&Ce++,k(Ge)&&Te++,p(Ge)&&We++,A(Ge)&&ve++;const V=Ce/he.length,Z=Te/he.length,ge=We/he.length,Ne=ve/he.length;return{upperPercent:V,lowerPercent:Z,alphaPercent:ge,numericPercent:Ne}}function f(he){const{upperPercent:Ce,lowerPercent:Te}=he;return Te===0&&Ce>.6}function t(he){const{upperPercent:Ce,lowerPercent:Te,alphaPercent:We,numericPercent:ve}=he;return Te>.2&&Ce<.8&&We>.6&&ve<.2}function n(he){let Ce=0,Te=0,We=0,ve=0;for(let Ge=0;Ge<he.length;Ge++)We=he.charCodeAt(Ge),i(We)&&Ce++,k(We)&&Te++,c(We)&&ve++;return(Ce===0||Te===0)&&ve===0?he.length<=30:Ce<=5}function s(he,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!n(he)||Ce.length>60)return null;const Te=d(Ce);if(!t(Te)){if(!f(Te))return null;Ce=Ce.toLowerCase()}let We=null,ve=0;for(he=he.toLowerCase();ve<Ce.length&&(We=l(he,Ce,0,ve))===null;)ve=y(Ce,ve+1);return We}e.matchesCamelCase=s;function o(he,Ce,Te=!1){if(!Ce||Ce.length===0)return null;let We=null,ve=0;for(he=he.toLowerCase(),Ce=Ce.toLowerCase();ve<Ce.length&&(We=u(he,Ce,0,ve,Te))===null;)ve=w(Ce,ve+1);return We}e.matchesWords=o;function u(he,Ce,Te,We,ve){if(Te===he.length)return[];if(We===Ce.length)return null;if(a(he.charCodeAt(Te),Ce.charCodeAt(We))){let Ge=null,V=We+1;if(Ge=u(he,Ce,Te+1,We+1,ve),!ve)for(;!Ge&&(V=w(Ce,V))<Ce.length;)Ge=u(he,Ce,Te+1,V,ve),V++;return Ge===null?null:m({start:We,end:We+1},Ge)}else return null}function w(he,Ce){for(let Te=Ce;Te<he.length;Te++)if(r(he.charCodeAt(Te))||Te>0&&r(he.charCodeAt(Te-1)))return Te;return he.length}const b=C(e.matchesPrefix,s,E),I=C(e.matchesPrefix,s,D),h=new v.LRUCache(1e4);function _(he,Ce,Te=!1){if(typeof he!="string"||typeof Ce!="string")return null;let We=h.get(he);We||(We=new RegExp(R.convertSimple2RegExpPattern(he),"i"),h.set(he,We));const ve=We.exec(Ce);return ve?[{start:ve.index,end:ve.index+ve[0].length}]:Te?I(he,Ce):b(he,Ce)}e.matchesFuzzy=_;function F(he,Ce){const Te=x(he,he.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Te?z(Te):null}e.matchesFuzzy2=F;function N(he,Ce,Te,We,ve,Ge){const V=Math.min(13,he.length);for(;Te<V;Te++){const Z=x(he,Ce,Te,We,ve,Ge,!1);if(Z)return Z}return[0,Ge]}e.anyScore=N;function z(he){if(typeof he=="undefined")return[];const Ce=[],Te=he[1];for(let We=he.length-1;We>1;We--){const ve=he[We]+Te,Ge=Ce[Ce.length-1];Ge&&Ge.end===ve?Ge.end=ve+1:Ce.push({start:ve,end:ve+1})}return Ce}e.createMatches=z;const ce=128;function de(){const he=[],Ce=[];for(let Te=0;Te<=ce;Te++)Ce[Te]=0;for(let Te=0;Te<=ce;Te++)he.push(Ce.slice(0));return he}function B(he){const Ce=[];for(let Te=0;Te<=he;Te++)Ce[Te]=0;return Ce}const j=B(2*ce),W=B(2*ce),P=de(),H=de(),L=de(),$=!1;function Q(he,Ce,Te,We,ve){function Ge(Z,ge,Ne=" "){for(;Z.length<ge;)Z=Ne+Z;return Z}let V=` |   |${We.split("").map(Z=>Ge(Z,3)).join("|")}
`;for(let Z=0;Z<=Te;Z++)Z===0?V+=" |":V+=`${Ce[Z-1]}|`,V+=he[Z].slice(0,ve+1).map(ge=>Ge(ge.toString(),3)).join("|")+`
`;return V}function q(he,Ce,Te,We){he=he.substr(Ce),Te=Te.substr(We),console.log(Q(H,he,he.length,Te,Te.length)),console.log(Q(L,he,he.length,Te,Te.length)),console.log(Q(P,he,he.length,Te,Te.length))}function ae(he,Ce){if(Ce<0||Ce>=he.length)return!1;const Te=he.codePointAt(Ce);switch(Te){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(Te)}}function fe(he,Ce){if(Ce<0||Ce>=he.length)return!1;switch(he.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Le(he,Ce,Te){return Ce[he]!==Te[he]}function xe(he,Ce,Te,We,ve,Ge,V=!1){for(;Ce<Te&&ve<Ge;)he[Ce]===We[ve]&&(V&&(j[Ce]=ve),Ce+=1),ve+=1;return Ce===Te}e.isPatternInWord=xe;var Fe;(function(he){he[he.Diag=1]="Diag",he[he.Left=2]="Left",he[he.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var He;(function(he){he.Default=[-100,0];function Ce(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}he.isDefault=Ce})(He=e.FuzzyScore||(e.FuzzyScore={}));function x(he,Ce,Te,We,ve,Ge,V){const Z=he.length>ce?ce:he.length,ge=We.length>ce?ce:We.length;if(!(Te>=Z||Ge>=ge||Z-Te>ge-Ge)&&!!xe(Ce,Te,Z,ve,Ge,ge,!0)){G(Z,ge,Te,Ge,Ce,ve);let Ne=1,Ve=1,Be=Te,Ze=Ge;const Se=[!1];for(Ne=1,Be=Te;Be<Z;Ne++,Be++){const O=j[Be],Y=W[Be],re=Be+1<Z?W[Be+1]:ge;for(Ve=O-Ge+1,Ze=O;Ze<re;Ve++,Ze++){let Ie=Number.MIN_SAFE_INTEGER,_e=!1;Ze<=Y&&(Ie=ee(he,Ce,Be,Te,We,ve,Ze,ge,Ge,P[Ne-1][Ve-1]===0,Se));let Re=0;Ie!==Number.MAX_SAFE_INTEGER&&(_e=!0,Re=Ie+H[Ne-1][Ve-1]);const ze=Ze>O,Xe=ze?H[Ne][Ve-1]+(P[Ne][Ve-1]>0?-5:0):0,st=Ze>O+1&&P[Ne][Ve-1]>0,Ye=st?H[Ne][Ve-2]+(P[Ne][Ve-2]>0?-5:0):0;if(st&&(!ze||Ye>=Xe)&&(!_e||Ye>=Re))H[Ne][Ve]=Ye,L[Ne][Ve]=3,P[Ne][Ve]=0;else if(ze&&(!_e||Xe>=Re))H[Ne][Ve]=Xe,L[Ne][Ve]=2,P[Ne][Ve]=0;else if(_e)H[Ne][Ve]=Re,L[Ne][Ve]=1,P[Ne][Ve]=P[Ne-1][Ve-1]+1;else throw new Error("not possible")}}if($&&q(he,Te,We,Ge),!(!Se[0]&&!V)){Ne--,Ve--;const ye=[H[Ne][Ve],Ge];let ke=0,ne=0;for(;Ne>=1;){let O=Ve;do{const Y=L[Ne][O];if(Y===3)O=O-2;else if(Y===2)O=O-1;else break}while(O>=1);ke>1&&Ce[Te+Ne-1]===ve[Ge+Ve-1]&&!Le(O+Ge-1,We,ve)&&ke+1>P[Ne][O]&&(O=Ve),O===Ve?ke++:ke=1,ne||(ne=O),Ne--,Ve=O-1,ye.push(Ve)}ge===Z&&(ye[0]+=2);const oe=ne-Z;return ye[0]-=oe,ye}}}e.fuzzyScore=x;function G(he,Ce,Te,We,ve,Ge){let V=he-1,Z=Ce-1;for(;V>=Te&&Z>=We;)ve[V]===Ge[Z]&&(W[V]=Z,V--),Z--}function ee(he,Ce,Te,We,ve,Ge,V,Z,ge,Ne,Ve){if(Ce[Te]!==Ge[V])return Number.MIN_SAFE_INTEGER;let Be=1,Ze=!1;return V===Te-We?Be=he[Te]===ve[V]?7:5:Le(V,ve,Ge)&&(V===0||!Le(V-1,ve,Ge))?(Be=he[Te]===ve[V]?7:5,Ze=!0):ae(Ge,V)&&(V===0||!ae(Ge,V-1))?Be=5:(ae(Ge,V-1)||fe(Ge,V-1))&&(Be=5,Ze=!0),Be>1&&Te===We&&(Ve[0]=!0),Ze||(Ze=Le(V,ve,Ge)||ae(Ge,V-1)||fe(Ge,V-1)),Te===We?V>ge&&(Be-=Ze?3:5):Ne?Be+=Ze?2:0:Be+=Ze?0:1,V+1===Z&&(Be-=Ze?3:5),Be}function ie(he,Ce,Te,We,ve,Ge,V){return Ee(he,Ce,Te,We,ve,Ge,!0,V)}e.fuzzyScoreGracefulAggressive=ie;function ue(he,Ce,Te,We,ve,Ge,V){return Ee(he,Ce,Te,We,ve,Ge,!1,V)}e.fuzzyScoreGraceful=ue;function Ee(he,Ce,Te,We,ve,Ge,V,Z){let ge=x(he,Ce,Te,We,ve,Ge,Z);if(ge&&!V)return ge;if(he.length>=3){const Ne=Math.min(7,he.length-1);for(let Ve=Te+1;Ve<Ne;Ve++){const Be=$e(he,Ve);if(Be){const Ze=x(Be,Be.toLowerCase(),Te,We,ve,Ge,Z);Ze&&(Ze[0]-=3,(!ge||Ze[0]>ge[0])&&(ge=Ze))}}}return ge}function $e(he,Ce){if(!(Ce+1>=he.length)){const Te=he[Ce],We=he[Ce+1];if(Te!==We)return he.slice(0,Ce)+We+Te+he.slice(Ce+2)}}}),define(be[112],we([0,1,36,111,8]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),E=new RegExp(`(\\\\)?${T.source}`,"g");function D(a){return a.replace(E,(p,m)=>m?p:`\\${p}`)}e.escapeIcons=D;const S=new RegExp(`\\\\${T.source}`,"g");function k(a){return a.replace(S,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=k;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function A(a){return a.indexOf(e.iconStartMarker)===-1?a:a.replace(i,(p,m,y,l)=>y?p:m||l||"")}e.stripIcons=A;function c(a){const p=a.indexOf(e.iconStartMarker);return p===-1?{text:a}:g(a,p)}e.parseLabelWithIcons=c;function g(a,p){const m=[];let y="";function l(w){if(w){y+=w;for(const b of w)m.push(t)}}let d=-1,f="",t=0,n,s,o=p;const u=a.length;for(l(a.substr(0,p));o<u;)n=a[o],s=a[o+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(d=o,l(f),f=e.iconStartMarker,o++):n===")"&&d!==-1?(t+=o-d+1,d=-1,f=""):d!==-1?/^[a-z0-9\-]$/i.test(n)?f+=n:(l(f),d=-1,f=""):l(n),o++;return l(f),{text:y,iconOffsets:m}}function r(a,p,m=!1){const{text:y,iconOffsets:l}=p;if(!l||l.length===0)return(0,R.matchesFuzzy)(a,y,m);const d=(0,C.ltrim)(y," "),f=y.length-d.length,t=(0,R.matchesFuzzy)(a,d,m);if(t)for(const n of t){const s=l[n.start+f]+f;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=r}),define(be[84],we([0,1,13,112,12]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(a="",p=!1){var m,y;if(this.value=a,typeof this.value!="string")throw(0,C.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(m=p.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(y=p.supportThemeIcons)!==null&&y!==void 0?y:!1)}appendText(a,p=0){return this.value+=A(this.supportThemeIcons?(0,R.escapeIcons)(a):a).replace(/([ \t]+)/g,(m,y)=>"&nbsp;".repeat(y.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,p){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=E;function D(r){return S(r)?!r.value:Array.isArray(r)?r.every(D):!0}e.isEmptyMarkdownString=D;function S(r){return r instanceof E?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function k(r,a){return!r&&!a?!0:!r||!a?!1:Array.isArray(r)&&Array.isArray(a)?(0,v.equals)(r,a,i):S(r)&&S(a)?i(r,a):!1}e.markedStringsEquals=k;function i(r,a){return r===a?!0:!r||!a?!1:r.value===a.value&&r.isTrusted===a.isTrusted&&r.supportThemeIcons===a.supportThemeIcons}function A(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function c(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=c;function g(r){const a=[],p=r.split("|").map(y=>y.trim());r=p[0];const m=p[1];if(m){const y=/height=(\d+)/.exec(m),l=/width=(\d+)/.exec(m),d=y?y[1]:"",f=l?l[1]:"",t=isFinite(parseInt(f)),n=isFinite(parseInt(d));t&&a.push(`width="${f}"`),n&&a.push(`height="${d}"`)}return{href:r,dimensions:a}}e.parseHrefAndDimensions=g}),define(be[58],we([0,1,24,8,2]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(k){return JSON.stringify(k,D)}e.stringify=T;function E(k){let i=JSON.parse(k);return i=S(i),i}e.parse=E;function D(k,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,R.regExpFlags)(i)}:i}function S(k,i=0){if(!k||i>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return C.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof v.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let A=0;A<k.length;++A)k[A]=S(k[A],i+1);else for(const A in k)Object.hasOwnProperty.call(k,A)&&(k[A]=S(k[A],i+1))}return k}e.revive=S}),define(be[17],we([0,1,2,21]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,k,i){this._hosts[S]=k,this._ports[S]=i}setConnectionToken(S,k){this._connectionTokens[S]=k}rewrite(S){if(this._delegate)return this._delegate(S);const k=S.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const A=this._ports[k],c=this._connectionTokens[k];let g=`path=${encodeURIComponent(S.path)}`;return typeof c=="string"&&(g+=`&tkn=${encodeURIComponent(c)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${i}:${A}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new T;class E{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,k,i){const A=this.toUri(S,k);return A.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(A):R.isNative&&(i||R.isPreferringBrowserCodeLoad)&&A.scheme===C.file?A.with({scheme:C.vscodeFileResource,authority:A.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):A}asFileUri(S,k){const i=this.toUri(S,k);return i.scheme===C.vscodeFileResource?i.with({scheme:C.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,k){return v.URI.isUri(S)?S:v.URI.parse(k.toUrl(S))}}e.FileAccess=new E}),define(be[25],we([0,1,37,14,2,8,17,21]),function(J,e,v,R,C,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(g){return(0,C.uriToFsPath)(g,!0)}e.originalFSPath=S;class k{constructor(r){this._ignorePathCasing=r}compare(r,a,p=!1){return r===a?0:(0,T.compare)(this.getComparisonKey(r,p),this.getComparisonKey(a,p))}isEqual(r,a,p=!1){return r===a?!0:!r||!a?!1:this.getComparisonKey(r,p)===this.getComparisonKey(a,p)}getComparisonKey(r,a=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,a,p=!1){if(r.scheme===a.scheme){if(r.scheme===E.Schemas.file)return v.isEqualOrParent(S(r),S(a),this._ignorePathCasing(r))&&r.query===a.query&&(p||r.fragment===a.fragment);if((0,e.isEqualAuthority)(r.authority,a.authority))return v.isEqualOrParent(r.path,a.path,this._ignorePathCasing(r),"/")&&r.query===a.query&&(p||r.fragment===a.fragment)}return!1}joinPath(r,...a){return C.URI.joinPath(r,...a)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return R.posix.basename(r.path)}extname(r){return R.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let a;return r.scheme===E.Schemas.file?a=C.URI.file(R.dirname(S(r))).path:(a=R.posix.dirname(r.path),r.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),a="/")),r.with({path:a})}normalizePath(r){if(!r.path.length)return r;let a;return r.scheme===E.Schemas.file?a=C.URI.file(R.normalize(S(r))).path:a=R.posix.normalize(r.path),r.with({path:a})}relativePath(r,a){if(!(r.scheme!==a.scheme||!(0,e.isEqualAuthority)(r.authority,a.authority))){if(r.scheme===E.Schemas.file){const y=R.relative(S(r),S(a));return D.isWindows?v.toSlashes(y):y}let p=r.path||"/",m=a.path||"/";if(this._ignorePathCasing(r)){let y=0;for(const l=Math.min(p.length,m.length);y<l&&!(p.charCodeAt(y)!==m.charCodeAt(y)&&p.charAt(y).toLowerCase()!==m.charAt(y).toLowerCase());y++);p=m.substr(0,y)+p.substr(y)}return R.posix.relative(p,m)}}resolvePath(r,a){if(r.scheme===E.Schemas.file){const p=C.URI.file(R.resolve(S(r),a));return r.with({authority:p.authority,path:p.path})}return a=v.toPosixPath(a),r.with({path:R.posix.resolve(r.path,a)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,a){return r===a||(0,T.equalsIgnoreCase)(r,a)}hasTrailingPathSeparator(r,a=R.sep){if(r.scheme===E.Schemas.file){const p=S(r);return p.length>v.getRoot(p).length&&p[p.length-1]===a}else{const p=r.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,a=R.sep){return(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,a=R.sep){let p=!1;if(r.scheme===E.Schemas.file){const m=S(r);p=m!==void 0&&m.length===v.getRoot(m).length&&m[m.length-1]===a}else{a="/";const m=r.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path+"/"}):r}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(g=>g.scheme===E.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new k(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(g,r){const a=[];for(let p=0;p<g.length;p++){const m=r(g[p]);g.some((y,l)=>l===p?!1:(0,e.isEqualOrParent)(m,r(y)))||a.push(g[p])}return a}e.distinctParents=i;var A;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function r(a){const p=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(l=>{const[d,f]=l.split(":");d&&f&&p.set(d,f)});const y=a.path.substring(0,a.path.indexOf(";"));return y&&p.set(g.META_DATA_MIME,y),p}g.parseMetaData=r})(A=e.DataUri||(e.DataUri={}));function c(g,r,a){if(r){let p=g.path;return p&&p[0]!==R.posix.sep&&(p=R.posix.sep+p),g.with({scheme:a,authority:r,path:p})}return g.with({scheme:a})}e.toLocalResource=c}),define(be[11],we([0,1,20,12,3,6,45,25]),function(J,e,v,R,C,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(H){return!!H&&typeof H.then=="function"}e.isThenable=S;function k(H){const L=new v.CancellationTokenSource,$=H(L.token),Q=new Promise((q,ae)=>{L.token.onCancellationRequested(()=>{ae((0,R.canceled)())}),Promise.resolve($).then(fe=>{L.dispose(),q(fe)},fe=>{L.dispose(),ae(fe)})});return new class{cancel(){L.cancel()}then(q,ae){return Q.then(q,ae)}catch(q){return this.then(void 0,q)}finally(q){return Q.finally(q)}}}e.createCancelablePromise=k;function i(H,L,$){return Promise.race([H,new Promise(Q=>L.onCancellationRequested(()=>Q($)))])}e.raceCancellation=i;async function A(H){let L=-1;const $=H.map((q,ae)=>q.then(fe=>(L=ae,fe))),Q=await Promise.race($);return H.forEach((q,ae)=>{ae!==L&&q.cancel()}),Q}e.raceCancellablePromises=A;function c(H,L,$){let Q;const q=setTimeout(()=>{Q==null||Q(void 0),$==null||$()},L);return Promise.race([H.finally(()=>clearTimeout(q)),new Promise(ae=>Q=ae)])}e.raceTimeout=c;function g(H){return new Promise((L,$)=>{const Q=H();S(Q)?Q.then(L,$):L(Q)})}e.asPromise=g;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const Q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Q};this.queuedPromise=new Promise(Q=>{this.activePromise.then($,$).then(Q)})}return new Promise(($,Q)=>{this.queuedPromise.then($,Q)})}return this.activePromise=L(),new Promise(($,Q)=>{this.activePromise.then(q=>{this.activePromise=null,$(q)},q=>{this.activePromise=null,Q(q)})})}}e.Throttler=r;class a{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=a;class p{constructor(){this.promiseMap=new Map}queue(L,$){var Q;const ae=((Q=this.promiseMap.get(L))!==null&&Q!==void 0?Q:Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(L)===ae&&this.promiseMap.delete(L)});return this.promiseMap.set(L,ae),ae}}e.SequencerByKey=p;class m{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,$=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Q,q)=>{this.doResolve=Q,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Q=this.task;return this.task=null,Q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class y{constructor(L){this.delayer=new m(L),this.throttler=new r}trigger(L,$){return this.delayer.trigger(()=>this.throttler.queue(L),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=y;class l{constructor(){this._isOpen=!1,this._promise=new Promise((L,$)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class d extends l{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function f(H,L){return L?new Promise(($,Q)=>{const q=setTimeout($,H);L.onCancellationRequested(()=>{clearTimeout(q),Q((0,R.canceled)())})}):k($=>f(H,$))}e.timeout=f;function t(H,L=0){const $=setTimeout(H,L);return(0,T.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=t;function n(H){return H.then(void 0,L=>{})}e.ignoreErrors=n;function s(H){const L=[];let $=0;const Q=H.length;function q(){return $<Q?H[$++]():null}function ae(fe){fe!=null&&L.push(fe);const Le=q();return Le?Le.then(ae):Promise.resolve(L)}return Promise.resolve(null).then(ae)}e.sequence=s;function o(H,L=Q=>!!Q,$=null){let Q=0;const q=H.length,ae=()=>{if(Q>=q)return Promise.resolve($);const fe=H[Q++];return Promise.resolve(fe()).then(xe=>L(xe)?Promise.resolve(xe):ae())};return ae()}e.first=o;function u(H,L=Q=>!!Q,$=null){if(H.length===0)return Promise.resolve($);let Q=H.length;const q=()=>{var ae,fe;Q=-1;for(const Le of H)(fe=(ae=Le).cancel)===null||fe===void 0||fe.call(ae)};return new Promise((ae,fe)=>{for(const Le of H)Le.then(xe=>{--Q>=0&&L(xe)?(q(),ae(xe)):Q===0&&ae($)}).catch(xe=>{--Q>=0&&(q(),fe(xe))})})}e.firstParallel=u;class w{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise(($,Q)=>{this.outstandingPromises.push({factory:L,c:$,e:Q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const $=L.factory();$.then(L.c,L.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=w;class b extends w{constructor(){super(1)}}e.Queue=b;class I{constructor(){this.queues=new Map}queueFor(L,$=D.extUri){const Q=$.getComparisonKey(L);let q=this.queues.get(Q);return q||(q=new b,C.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(Q)}),this.queues.set(Q,q)),q}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=I;class h{constructor(L,$){this._token=-1,typeof L=="function"&&typeof $=="number"&&this.setIfNotSet(L,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},$)}setIfNotSet(L,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},$))}}e.TimeoutTimer=h;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,$){this.cancel(),this._token=setInterval(()=>{L()},$)}}e.IntervalTimer=_;class F{constructor(L,$){this.timeoutToken=-1,this.runner=L,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class N extends F{constructor(L,$){super(L,$);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const H=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const $=setTimeout(()=>L(H));let Q=!1;return{dispose(){Q||(Q=!0,clearTimeout($))}}}}else e.runWhenIdle=(H,L)=>{const $=requestIdleCallback(H,typeof L=="number"?{timeout:L}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,cancelIdleCallback($))}}}}();class z{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function ce(H,L,$){let Q;for(let q=0;q<$;q++)try{return await H()}catch(ae){Q=ae,await f(L)}throw Q}e.retry=ce;class de{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var L;(L=this._pending)===null||L===void 0||L.cancel()}setPending(L,$,Q){return this._pending={taskId:L,cancel:()=>Q==null?void 0:Q(),promise:$},$.then(()=>this.donePending(L),()=>this.donePending(L)),$}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let $,Q;const q=new Promise((ae,fe)=>{$=ae,Q=fe});this._next={run:L,promise:q,promiseResolve:$,promiseReject:Q}}return this._next.promise}}e.TaskSequentializer=de;class B{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,$)=>{this.completeCallback=L,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise($=>{this.completeCallback(L),this.resolved=!0,$()})}error(L){return new Promise($=>{this.errorCallback(L),this.rejected=!0,$()})}cancel(){new Promise(L=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=j;class W extends C.Emitter{async fireAsync(L,$,Q){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new E.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,L]);for(;this._asyncDeliveryQueue.size>0&&!$.isCancellationRequested;){const[q,ae]=this._asyncDeliveryQueue.shift(),fe=[],Le=Object.assign(Object.assign({},ae),{waitUntil:xe=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");Q&&(xe=Q(xe,typeof q=="function"?q:q[0])),fe.push(xe)}});try{typeof q=="function"?q.call(void 0,Le):q[0].call(q[1],Le)}catch(xe){(0,R.onUnexpectedError)(xe);continue}Object.freeze(fe),await P.settled(fe).catch(xe=>(0,R.onUnexpectedError)(xe))}}}}e.AsyncEmitter=W;var P;(function(H){async function L(ae){return typeof Promise.allSettled=="function"?$(ae):Q(ae)}H.allSettled=L;async function $(ae){return Promise.allSettled(ae)}async function Q(ae){return Promise.all(ae.map(fe=>fe.then(Le=>({status:"fulfilled",value:Le}),Le=>({status:"rejected",reason:Le}))))}async function q(ae){let fe;const Le=await Promise.all(ae.map(xe=>xe.then(Fe=>Fe,Fe=>{fe||(fe=Fe)})));if(typeof fe!="undefined")throw fe;return Le}H.settled=q})(P=e.Promises||(e.Promises={}))}),define(be[113],we([0,1,14,11]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new R.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),T=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),E=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(h,_,F=!1){const N=h||"",z=_||"",ce=C.value.collator.compare(N,z);return C.value.collatorIsNumeric&&ce===0&&N!==z?N<z?-1:1:ce}e.compareFileNames=D;function S(h,_){const F=T.value.collator;return h=h||"",_=_||"",f(F,h,_)}e.compareFileNamesDefault=S;function k(h,_){const F=T.value.collator;return h=h||"",_=_||"",o(h,_)||f(F,h,_)}e.compareFileNamesUpper=k;function i(h,_){const F=T.value.collator;return h=h||"",_=_||"",s(h,_)||f(F,h,_)}e.compareFileNamesLower=i;function A(h,_){return h=h||"",_=_||"",h===_?0:h<_?-1:1}e.compareFileNamesUnicode=A;function c(h,_,F=!1){F||(h=h&&h.toLowerCase(),_=_&&_.toLowerCase());const[N,z]=l(h),[ce,de]=l(_);return N!==ce?N<ce?-1:1:z===de?0:z<de?-1:1}e.noIntlCompareFileNames=c;function g(h,_){const[F,N]=l(h),[z,ce]=l(_);let de=C.value.collator.compare(N,ce);if(de===0){if(C.value.collatorIsNumeric&&N!==ce)return N<ce?-1:1;if(de=C.value.collator.compare(F,z),C.value.collatorIsNumeric&&de===0&&F!==z)return F<z?-1:1}return de}e.compareFileExtensions=g;function r(h,_){h=h||"",_=_||"";const F=d(h),N=d(_),z=T.value.collator,ce=E.value.collator;return f(ce,F,N)||f(z,h,_)}e.compareFileExtensionsDefault=r;function a(h,_){h=h||"",_=_||"";const F=d(h),N=d(_),z=T.value.collator,ce=E.value.collator;return f(ce,F,N)||o(h,_)||f(z,h,_)}e.compareFileExtensionsUpper=a;function p(h,_){h=h||"",_=_||"";const F=d(h),N=d(_),z=T.value.collator,ce=E.value.collator;return f(ce,F,N)||s(h,_)||f(z,h,_)}e.compareFileExtensionsLower=p;function m(h,_){h=h||"",_=_||"";const F=d(h).toLowerCase(),N=d(_).toLowerCase();return F!==N?F<N?-1:1:h!==_?h<_?-1:1:0}e.compareFileExtensionsUnicode=m;const y=/^(.*?)(\.([^.]*))?$/;function l(h,_=!1){const F=h?y.exec(h):[];let N=[F&&F[1]||"",F&&F[3]||""];return _&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function d(h){const _=h?y.exec(h):[];return _&&_[1]&&_[1].charAt(0)!=="."&&_[3]||""}function f(h,_,F){let N=h.compare(_,F);return N!==0?N:_.length!==F.length?_.length<F.length?-1:1:0}function t(h){const _=h.charAt(0);return _.toLocaleUpperCase()!==_}function n(h){const _=h.charAt(0);return _.toLocaleLowerCase()!==_}function s(h,_){return t(h)&&n(_)?-1:n(h)&&t(_)?1:0}function o(h,_){return n(h)&&t(_)?-1:t(h)&&n(_)?1:0}function u(h,_,F=!1){return F||(h=h&&h.toLowerCase(),_=_&&_.toLowerCase()),h===_?0:h<_?-1:1}function w(h,_,F=!1){const N=h.split(v.sep),z=_.split(v.sep),ce=N.length-1,de=z.length-1;let B,j;for(let W=0;;W++){if(B=ce===W,j=de===W,B&&j)return D(N[W],z[W],F);if(B)return-1;if(j)return 1;const P=u(N[W],z[W],F);if(P!==0)return P}}e.comparePaths=w;function b(h,_,F){const N=h.toLowerCase(),z=_.toLowerCase(),ce=I(h,_,F);if(ce)return ce;const de=N.endsWith(F),B=z.endsWith(F);if(de!==B)return de?-1:1;const j=D(N,z);return j!==0?j:N.localeCompare(z)}e.compareAnything=b;function I(h,_,F){const N=h.toLowerCase(),z=_.toLowerCase(),ce=N.startsWith(F),de=z.startsWith(F);if(ce!==de)return ce?-1:1;if(ce&&de){if(N.length<z.length)return-1;if(N.length>z.length)return 1}return 0}e.compareByPrefix=I}),define(be[28],we([0,1,8,37,14,22,11]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const S="**",k="/",i="[/\\\\]",A="[^/\\\\]",c=/\//g;function g($){switch($){case 0:return"";case 1:return`${A}*?`;default:return`(?:${i}|${A}+${i}|${i}${A}+)*?`}}function r($,Q){if(!$)return[];const q=[];let ae=!1,fe=!1,Le="";for(const xe of $){switch(xe){case Q:if(!ae&&!fe){q.push(Le),Le="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}Le+=xe}return Le&&q.push(Le),q}e.splitGlobAware=r;function a($){if(!$)return"";let Q="";const q=r($,k);if(q.every(ae=>ae===S))Q=".*";else{let ae=!1;q.forEach((fe,Le)=>{if(fe===S){ae||(Q+=g(2),ae=!0);return}let xe=!1,Fe="",He=!1,x="";for(const G of fe){if(G!=="}"&&xe){Fe+=G;continue}if(He&&(G!=="]"||!x)){let ee;G==="-"?ee=G:(G==="^"||G==="!")&&!x?ee="^":G===k?ee="":ee=v.escapeRegExpCharacters(G),x+=ee;continue}switch(G){case"{":xe=!0;continue;case"[":He=!0;continue;case"}":Q+=`(?:${r(Fe,",").map(ue=>a(ue)).join("|")})`,xe=!1,Fe="";break;case"]":Q+="["+x+"]",He=!1,x="";break;case"?":Q+=A;continue;case"*":Q+=g(1);continue;default:Q+=v.escapeRegExpCharacters(G)}}Le<q.length-1&&(q[Le+1]!==S||Le+2<q.length)&&(Q+=i),ae=!1})}return Q}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},s=function(){return null};function o($,Q){if(!$)return s;let q;typeof $!="string"?q=$.pattern:q=$,q=q.trim();const ae=`${q}_${!!Q.trimForExclusions}`;let fe=t.get(ae);if(fe)return u(fe,$);let Le;if(p.test(q)){const xe=q.substr(4);fe=function(Fe,He){return typeof Fe=="string"&&Fe.endsWith(xe)?q:null}}else(Le=m.exec(w(q,Q)))?fe=b(Le[1],q):(Q.trimForExclusions?l:y).test(q)?fe=I(q,Q):(Le=d.exec(w(q,Q)))?fe=h(Le[1].substr(1),q,!0):(Le=f.exec(w(q,Q)))?fe=h(Le[1],q,!1):fe=_(q);return t.set(ae,fe),u(fe,$)}function u($,Q){return typeof Q=="string"?$:function(q,ae){return R.isEqualOrParent(q,Q.base)?$(C.relative(Q.base,q),ae):null}}function w($,Q){return Q.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function b($,Q){const q=`/${$}`,ae=`\\${$}`,fe=function(xe,Fe){return typeof xe!="string"?null:Fe?Fe===$?Q:null:xe===$||xe.endsWith(q)||xe.endsWith(ae)?Q:null},Le=[$];return fe.basenames=Le,fe.patterns=[Q],fe.allBasenames=Le,fe}function I($,Q){const q=L($.slice(1,-1).split(",").map(Fe=>o(Fe,Q)).filter(Fe=>Fe!==s),$),ae=q.length;if(!ae)return s;if(ae===1)return q[0];const fe=function(Fe,He){for(let x=0,G=q.length;x<G;x++)if(q[x](Fe,He))return $;return null},Le=q.find(Fe=>!!Fe.allBasenames);Le&&(fe.allBasenames=Le.allBasenames);const xe=q.reduce((Fe,He)=>He.allPaths?Fe.concat(He.allPaths):Fe,[]);return xe.length&&(fe.allPaths=xe),fe}function h($,Q,q){const ae=C.sep===C.posix.sep,fe=ae?$:$.replace(c,C.sep),Le=C.sep+fe,xe=C.posix.sep+$,Fe=q?function(He,x){return typeof He=="string"&&(He===fe||He.endsWith(Le)||!ae&&(He===$||He.endsWith(xe)))?Q:null}:function(He,x){return typeof He=="string"&&(He===fe||!ae&&He===$)?Q:null};return Fe.allPaths=[(q?"*/":"./")+$],Fe}function _($){try{const Q=new RegExp(`^${a($)}$`);return function(q){return Q.lastIndex=0,typeof q=="string"&&Q.test(q)?$:null}}catch(Q){return s}}function F($,Q,q){return!$||typeof Q!="string"?!1:N($)(Q,void 0,q)}e.match=F;function N($,Q={}){if(!$)return n;if(typeof $=="string"||B($)){const q=o($,Q);if(q===s)return n;const ae=function(fe,Le){return!!q(fe,Le)};return q.allBasenames&&(ae.allBasenames=q.allBasenames),q.allPaths&&(ae.allPaths=q.allPaths),ae}return P($,Q)}e.parse=N;function z($){if(!!$){let Q;return q=>(Q||(Q=($()||Promise.resolve([])).then(ae=>ae?de(ae):{})),Q.then(ae=>!!ae[q]))}}e.hasSiblingPromiseFn=z;function ce($){if(!!$){let Q;return q=>{if(!Q){const ae=$();Q=ae?de(ae):{}}return!!Q[q]}}}e.hasSiblingFn=ce;function de($){const Q={};for(const q of $)Q[q]=!0;return Q}function B($){const Q=$;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=B;function j($){return $.allBasenames||[]}e.getBasenameTerms=j;function W($){return $.allPaths||[]}e.getPathTerms=W;function P($,Q){const q=L(Object.getOwnPropertyNames($).map(Fe=>H(Fe,$[Fe],Q)).filter(Fe=>Fe!==s)),ae=q.length;if(!ae)return s;if(!q.some(Fe=>!!Fe.requiresSiblings)){if(ae===1)return q[0];const Fe=function(G,ee){for(let ie=0,ue=q.length;ie<ue;ie++){const Ee=q[ie](G,ee);if(Ee)return Ee}return null},He=q.find(G=>!!G.allBasenames);He&&(Fe.allBasenames=He.allBasenames);const x=q.reduce((G,ee)=>ee.allPaths?G.concat(ee.allPaths):G,[]);return x.length&&(Fe.allPaths=x),Fe}const fe=function(Fe,He,x){let G;for(let ee=0,ie=q.length;ee<ie;ee++){const ue=q[ee];ue.requiresSiblings&&x&&(He||(He=C.basename(Fe)),G||(G=He.substr(0,He.length-C.extname(Fe).length)));const Ee=ue(Fe,He,G,x);if(Ee)return Ee}return null},Le=q.find(Fe=>!!Fe.allBasenames);Le&&(fe.allBasenames=Le.allBasenames);const xe=q.reduce((Fe,He)=>He.allPaths?Fe.concat(He.allPaths):Fe,[]);return xe.length&&(fe.allPaths=xe),fe}function H($,Q,q){if(Q===!1)return s;const ae=o($,q);if(ae===s)return s;if(typeof Q=="boolean")return ae;if(Q){const fe=Q.when;if(typeof fe=="string"){const Le=(xe,Fe,He,x)=>{if(!x||!ae(xe,Fe))return null;const G=fe.replace("$(basename)",He),ee=x(G);return(0,E.isThenable)(ee)?ee.then(ie=>ie?$:null):ee?$:null};return Le.requiresSiblings=!0,Le}}return ae}function L($,Q){const q=$.filter(Fe=>!!Fe.basenames);if(q.length<2)return $;const ae=q.reduce((Fe,He)=>{const x=He.basenames;return x?Fe.concat(x):Fe},[]);let fe;if(Q){fe=[];for(let Fe=0,He=ae.length;Fe<He;Fe++)fe.push(Q)}else fe=q.reduce((Fe,He)=>{const x=He.patterns;return x?Fe.concat(x):Fe},[]);const Le=function(Fe,He){if(typeof Fe!="string")return null;if(!He){let G;for(G=Fe.length;G>0;G--){const ee=Fe.charCodeAt(G-1);if(ee===47||ee===92)break}He=Fe.substr(G)}const x=ae.indexOf(He);return x!==-1?fe[x]:null};Le.basenames=ae,Le.patterns=fe,Le.allBasenames=ae;const xe=$.filter(Fe=>!Fe.basenames);return xe.push(Le),xe}}),define(be[59],we([0,1,2,14,8,17,21,25,37]),function(J,e,v,R,C,T,E,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(o,u,w){if(typeof o=="string"&&(o=v.URI.file(o)),w){const I=w.getWorkspaceFolder(o);if(I){const h=w.getWorkspace().folders.length>1;let _;if((0,D.isEqual)(I.uri,o)?_="":_=(0,D.relativePath)(I.uri,o),h){const F=I.name?I.name:(0,D.basename)(I.uri);_=_?F+" \u2022 "+_:F}return _}}if(o.scheme!==T.Schemas.file&&o.scheme!==T.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(o.fsPath))return(0,R.normalize)(A(o.fsPath));let b=(0,R.normalize)(o.fsPath);return!E.isWindows&&(u==null?void 0:u.userHome)&&(b=g(b,u.userHome.fsPath)),b}e.getPathLabel=k;function i(o){if(!!o){typeof o=="string"&&(o=v.URI.file(o));const u=(0,D.basename)(o)||(o.scheme===T.Schemas.file?o.fsPath:o.path);return E.isWindows&&(0,S.isRootOrDriveLetter)(u)?A(u):u}}e.getBaseLabel=i;function A(o){return(0,S.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=A;let c=Object.create(null);function g(o,u){if(E.isWindows||!o||!u)return o;let w=c.original===u?c.normalized:void 0;return w||(w=`${(0,C.rtrim)(u,R.posix.sep)}${R.posix.sep}`,c={original:u,normalized:w}),(E.isLinux?o.startsWith(w):(0,C.startsWithIgnoreCase)(o,w))&&(o=`~/${o.substr(w.length)}`),o}e.tildify=g;function r(o,u){return o.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=r;const a="\u2026",p="\\\\",m="~";function y(o,u=R.sep){const w=new Array(o.length);let b=!1;for(let I=0;I<o.length;I++){let h=o[I];if(h===""){w[I]=`.${u}`;continue}if(!h){w[I]=h;continue}b=!0;let _="";h.indexOf(p)===0?(_=h.substr(0,h.indexOf(p)+p.length),h=h.substr(h.indexOf(p)+p.length)):h.indexOf(u)===0?(_=h.substr(0,h.indexOf(u)+u.length),h=h.substr(h.indexOf(u)+u.length)):h.indexOf(m)===0&&(_=h.substr(0,h.indexOf(m)+m.length),h=h.substr(h.indexOf(m)+m.length));const F=h.split(u);for(let N=1;b&&N<=F.length;N++)for(let z=F.length-N;b&&z>=0;z--){b=!1;let ce=F.slice(z,z+N).join(u);for(let de=0;!b&&de<o.length;de++)if(de!==I&&o[de]&&o[de].indexOf(ce)>-1){const B=z+N===F.length,j=z>0&&o[de].indexOf(u)>-1?u+ce:ce,W=o[de].endsWith(j);b=!B||W}if(!b){let de="";(F[0].endsWith(":")||_!=="")&&(z===1&&(z=0,N++,ce=F[0]+u+ce),z>0&&(de=F[0]+u),de=_+de),z>0&&(de=de+a+u),de=de+ce,z+N<F.length&&(de=de+u+a),w[I]=de}}b&&(w[I]=h)}return w}e.shorten=y;var l;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function d(o,u=Object.create(null)){const w=[];let b=!1,I="";for(const h of o)if(h==="$"||b&&h==="{")I&&w.push({value:I,type:l.TEXT}),I="",b=!0;else if(h==="}"&&b){const _=u[I];if(typeof _=="string")_.length&&w.push({value:_,type:l.VARIABLE});else if(_){const F=w[w.length-1];(!F||F.type!==l.SEPARATOR)&&w.push({value:_.label,type:l.SEPARATOR})}I="",b=!1}else I+=h;return I&&!b&&w.push({value:I,type:l.TEXT}),w.filter((h,_)=>{if(h.type===l.SEPARATOR){const F=w[_-1],N=w[_+1];return[F,N].every(z=>z&&(z.type===l.VARIABLE||z.type===l.TEXT)&&z.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=d;function f(o,u){return E.isMacintosh||u?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):o.replace(/&&|&/g,w=>w==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function t(o,u){return E.isMacintosh||u?o.replace(/\(&&\w\)|&&/g,""):E.isWindows?o.replace(/&&|&/g,w=>w==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(o){const u=o.indexOf("/")!==-1?R.posix:R.win32,w=u.basename(o),b=u.dirname(o);return w.length?{name:w,parentPath:b}:{name:b,parentPath:""}}e.splitName=s}),define(be[114],we([0,1,2]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(i){return i.toJSON()}class C{constructor(A){this._uriTransformer=A}transformIncoming(A){const c=this._uriTransformer.transformIncoming(A);return c===A?A:R(v.URI.from(c))}transformOutgoing(A){const c=this._uriTransformer.transformOutgoing(A);return c===A?A:R(v.URI.from(c))}transformOutgoingURI(A){const c=this._uriTransformer.transformOutgoing(A);return c===A?A:v.URI.from(c)}transformOutgoingScheme(A){return this._uriTransformer.transformOutgoingScheme(A)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,A,c){if(!i||c>200)return null;if(typeof i=="object"){if(i instanceof v.URI)return A.transformOutgoing(i);for(let g in i)if(Object.hasOwnProperty.call(i,g)){const r=T(i[g],A,c+1);r!==null&&(i[g]=r)}}return null}function E(i,A){const c=T(i,A,0);return c===null?i:c}e.transformOutgoingURIs=E;function D(i,A,c,g){if(!i||g>200)return null;if(typeof i=="object"){if(i.$mid===1)return c?v.URI.revive(A.transformIncoming(i)):A.transformIncoming(i);for(let r in i)if(Object.hasOwnProperty.call(i,r)){const a=D(i[r],A,c,g+1);a!==null&&(i[r]=a)}}return null}function S(i,A){const c=D(i,A,!1,0);return c===null?i:c}e.transformIncomingURIs=S;function k(i,A){const c=D(i,A,!0,0);return c===null?i:c}e.transformAndReviveIncomingURIs=k}),define(be[31],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(S){return v.test(S)}e.isUUID=R;const C=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(S){for(let k=0;k<S.length;k++)S[k]=Math.floor(Math.random()*256);return S};function D(){E(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let S=0,k="";return k+=T[C[S++]],k+=T[C[S++]],k+=T[C[S++]],k+=T[C[S++]],k+="-",k+=T[C[S++]],k+=T[C[S++]],k+="-",k+=T[C[S++]],k+=T[C[S++]],k+="-",k+=T[C[S++]],k+=T[C[S++]],k+="-",k+=T[C[S++]],k+=T[C[S++]],k+=T[C[S++]],k+=T[C[S++]],k+=T[C[S++]],k+=T[C[S++]],k}e.generateUuid=D}),define(be[85],we([0,1,83]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(D){let S=(0,v.toUint8)(D);this._defaultValue=S,this._asciiMap=R._createAsciiMap(S),this._map=new Map}static _createAsciiMap(D){let S=new Uint8Array(256);for(let k=0;k<256;k++)S[k]=D;return S}set(D,S){let k=(0,v.toUint8)(S);D>=0&&D<256?this._asciiMap[D]=k:this._map.set(D,k)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=R;var C;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(C||(C={}));class T{constructor(){this._actual=new R(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=T}),define(be[115],we([0,1,85]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(E){E[E.Regular=0]="Regular",E[E.Whitespace=1]="Whitespace",E[E.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends v.CharacterClassifier{constructor(D){super(0);for(let S=0,k=D.length;S<k;S++)this.set(D.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function T(E){let D={};return S=>(D.hasOwnProperty(S)||(D[S]=E(S)),D[S])}e.getMapForWordSeparators=T(E=>new C(E))}),define(be[38],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(C,T){this.lineNumber=C,this.column=T}with(C=this.lineNumber,T=this.column){return C===this.lineNumber&&T===this.column?this:new v(C,T)}delta(C=0,T=0){return this.with(this.lineNumber+C,this.column+T)}equals(C){return v.equals(this,C)}static equals(C,T){return!C&&!T?!0:!!C&&!!T&&C.lineNumber===T.lineNumber&&C.column===T.column}isBefore(C){return v.isBefore(this,C)}static isBefore(C,T){return C.lineNumber<T.lineNumber?!0:T.lineNumber<C.lineNumber?!1:C.column<T.column}isBeforeOrEqual(C){return v.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,T){return C.lineNumber<T.lineNumber?!0:T.lineNumber<C.lineNumber?!1:C.column<=T.column}static compare(C,T){let E=C.lineNumber|0,D=T.lineNumber|0;if(E===D){let S=C.column|0,k=T.column|0;return S-k}return E-D}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new v(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=v}),define(be[32],we([0,1,38]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(T,E,D,S){T>D||T===D&&E>S?(this.startLineNumber=D,this.startColumn=S,this.endLineNumber=T,this.endColumn=E):(this.startLineNumber=T,this.startColumn=E,this.endLineNumber=D,this.endColumn=S)}isEmpty(){return R.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return R.containsPosition(this,T)}static containsPosition(T,E){return!(E.lineNumber<T.startLineNumber||E.lineNumber>T.endLineNumber||E.lineNumber===T.startLineNumber&&E.column<T.startColumn||E.lineNumber===T.endLineNumber&&E.column>T.endColumn)}containsRange(T){return R.containsRange(this,T)}static containsRange(T,E){return!(E.startLineNumber<T.startLineNumber||E.endLineNumber<T.startLineNumber||E.startLineNumber>T.endLineNumber||E.endLineNumber>T.endLineNumber||E.startLineNumber===T.startLineNumber&&E.startColumn<T.startColumn||E.endLineNumber===T.endLineNumber&&E.endColumn>T.endColumn)}strictContainsRange(T){return R.strictContainsRange(this,T)}static strictContainsRange(T,E){return!(E.startLineNumber<T.startLineNumber||E.endLineNumber<T.startLineNumber||E.startLineNumber>T.endLineNumber||E.endLineNumber>T.endLineNumber||E.startLineNumber===T.startLineNumber&&E.startColumn<=T.startColumn||E.endLineNumber===T.endLineNumber&&E.endColumn>=T.endColumn)}plusRange(T){return R.plusRange(this,T)}static plusRange(T,E){let D,S,k,i;return E.startLineNumber<T.startLineNumber?(D=E.startLineNumber,S=E.startColumn):E.startLineNumber===T.startLineNumber?(D=E.startLineNumber,S=Math.min(E.startColumn,T.startColumn)):(D=T.startLineNumber,S=T.startColumn),E.endLineNumber>T.endLineNumber?(k=E.endLineNumber,i=E.endColumn):E.endLineNumber===T.endLineNumber?(k=E.endLineNumber,i=Math.max(E.endColumn,T.endColumn)):(k=T.endLineNumber,i=T.endColumn),new R(D,S,k,i)}intersectRanges(T){return R.intersectRanges(this,T)}static intersectRanges(T,E){let D=T.startLineNumber,S=T.startColumn,k=T.endLineNumber,i=T.endColumn,A=E.startLineNumber,c=E.startColumn,g=E.endLineNumber,r=E.endColumn;return D<A?(D=A,S=c):D===A&&(S=Math.max(S,c)),k>g?(k=g,i=r):k===g&&(i=Math.min(i,r)),D>k||D===k&&S>i?null:new R(D,S,k,i)}equalsRange(T){return R.equalsRange(this,T)}static equalsRange(T,E){return!!T&&!!E&&T.startLineNumber===E.startLineNumber&&T.startColumn===E.startColumn&&T.endLineNumber===E.endLineNumber&&T.endColumn===E.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(T){return new v.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(T){return new v.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,E){return new R(this.startLineNumber,this.startColumn,T,E)}setStartPosition(T,E){return new R(T,E,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(T){return new R(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,E=T){return new R(T.lineNumber,T.column,E.lineNumber,E.column)}static lift(T){return T?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,E){return!(T.endLineNumber<E.startLineNumber||T.endLineNumber===E.startLineNumber&&T.endColumn<E.startColumn||E.endLineNumber<T.startLineNumber||E.endLineNumber===T.startLineNumber&&E.endColumn<T.startColumn)}static areIntersecting(T,E){return!(T.endLineNumber<E.startLineNumber||T.endLineNumber===E.startLineNumber&&T.endColumn<=E.startColumn||E.endLineNumber<T.startLineNumber||E.endLineNumber===T.startLineNumber&&E.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,E){if(T&&E){const k=T.startLineNumber|0,i=E.startLineNumber|0;if(k===i){const A=T.startColumn|0,c=E.startColumn|0;if(A===c){const g=T.endLineNumber|0,r=E.endLineNumber|0;if(g===r){const a=T.endColumn|0,p=E.endColumn|0;return a-p}return g-r}return A-c}return k-i}return(T?1:0)-(E?1:0)}static compareRangesUsingEnds(T,E){return T.endLineNumber===E.endLineNumber?T.endColumn===E.endColumn?T.startLineNumber===E.startLineNumber?T.startColumn-E.startColumn:T.startLineNumber-E.startLineNumber:T.endColumn-E.endColumn:T.endLineNumber-E.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=R}),define(be[116],we([0,1,38,32]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class T extends R.Range{constructor(D,S,k,i){super(D,S,k,i);this.selectionStartLineNumber=D,this.selectionStartColumn=S,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return T.selectionsEqual(this,D)}static selectionsEqual(D,S){return D.selectionStartLineNumber===S.selectionStartLineNumber&&D.selectionStartColumn===S.selectionStartColumn&&D.positionLineNumber===S.positionLineNumber&&D.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,S){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,D,S):new T(D,S,this.startLineNumber,this.startColumn)}getPosition(){return new v.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,S){return this.getDirection()===0?new T(D,S,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,D,S)}static fromPositions(D,S=D){return new T(D.lineNumber,D.column,S.lineNumber,S.column)}static liftSelection(D){return new T(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,S){if(D&&!S||!D&&S)return!1;if(!D&&!S)return!0;if(D.length!==S.length)return!1;for(let k=0,i=D.length;k<i;k++)if(!this.selectionsEqual(D[k],S[k]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,S,k,i,A){return A===0?new T(D,S,k,i):new T(k,i,D,S)}}e.Selection=T}),define(be[86],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var v;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(v=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class S{constructor(a,p){this.range=a,this.matches=p}}e.FindMatch=S;var k;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right"})(i=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var A;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A=e.ModelConstants||(e.ModelConstants={}));class c{constructor(a,p,m,y,l,d){this.identifier=a,this.range=p,this.text=m,this.forceMoveMarkers=y,this.isAutoWhitespaceEdit=l,this._isTracked=d}}e.ValidAnnotatedEditOperation=c;class g{constructor(a,p,m){this.reverseEdits=a,this.changes=p,this.trimAutoWhitespaceLineNumbers=m}}e.ApplyEditsResult=g}),define(be[117],we([0,1,8,115,38,32,86]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class S{constructor(l,d,f,t){this.searchString=l,this.isRegex=d,this.matchCase=f,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=k(this.searchString):l=this.searchString.indexOf(`
`)>=0;let d=null;try{d=v.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(t){return null}if(!d)return null;let f=!this.isRegex&&!l;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new i(d,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=S;function k(y){if(!y||y.length===0)return!1;for(let l=0,d=y.length;l<d;l++)if(y.charCodeAt(l)===92){if(l++,l>=d)break;const t=y.charCodeAt(l);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(l,d,f){this.regex=l,this.wordSeparators=d,this.simpleSearch=f}}e.SearchData=i;function A(y,l,d){if(!d)return new E.FindMatch(y,null);let f=[];for(let t=0,n=l.length;t<n;t++)f[t]=l[t];return new E.FindMatch(y,f)}e.createFindMatch=A;class c{constructor(l){let d=[],f=0;for(let t=0,n=l.length;t<n;t++)l.charCodeAt(t)===10&&(d[f++]=t);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(l){const d=this._lineFeedsOffsets;let f=0,t=d.length-1;if(t===-1||l<=d[0])return 0;for(;f<t;){const n=f+((t-f)/2>>0);d[n]>=l?t=n-1:d[n+1]>=l?(f=n,t=n):f=n+1}return f+1}}class g{static findMatches(l,d,f,t,n){const s=d.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(l,f,new m(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(l,f,s,t,n):[]}static _getMultilineMatchRange(l,d,f,t,n,s){let o,u=0;t?(u=t.findLineFeedCountBeforeOffset(n),o=d+n+u):o=d+n;let w;if(t){let _=t.findLineFeedCountBeforeOffset(n+s.length)-u;w=o+s.length+_}else w=o+s.length;const b=l.getPositionAt(o),I=l.getPositionAt(w);return new T.Range(b.lineNumber,b.column,I.lineNumber,I.column)}static _doFindMatchesMultiline(l,d,f,t,n){const s=l.getOffsetAt(d.getStartPosition()),o=l.getValueInRange(d,1),u=l.getEOL()===`\r
`?new c(o):null,w=[];let b=0,I;for(f.reset(0);I=f.next(o);)if(w[b++]=A(this._getMultilineMatchRange(l,s,o,u,I.index,I[0]),I,t),b>=n)return w;return w}static _doFindMatchesLineByLine(l,d,f,t,n){const s=[];let o=0;if(d.startLineNumber===d.endLineNumber){const w=l.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return o=this._findMatchesInLine(f,w,d.startLineNumber,d.startColumn-1,o,s,t,n),s}const u=l.getLineContent(d.startLineNumber).substring(d.startColumn-1);o=this._findMatchesInLine(f,u,d.startLineNumber,d.startColumn-1,o,s,t,n);for(let w=d.startLineNumber+1;w<d.endLineNumber&&o<n;w++)o=this._findMatchesInLine(f,l.getLineContent(w),w,0,o,s,t,n);if(o<n){const w=l.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);o=this._findMatchesInLine(f,w,d.endLineNumber,0,o,s,t,n)}return s}static _findMatchesInLine(l,d,f,t,n,s,o,u){const w=l.wordSeparators;if(!o&&l.simpleSearch){const h=l.simpleSearch,_=h.length,F=d.length;let N=-_;for(;(N=d.indexOf(h,N+_))!==-1;)if((!w||p(w,d,F,N,_))&&(s[n++]=new E.FindMatch(new T.Range(f,N+1+t,f,N+1+_+t),null),n>=u))return n;return n}const b=new m(l.wordSeparators,l.regex);let I;b.reset(0);do if(I=b.next(d),I&&(s[n++]=A(new T.Range(f,I.index+1+t,f,I.index+1+I[0].length+t),I,o),n>=u))return n;while(I);return n}static findNextMatch(l,d,f,t){const n=d.parseSearchRequest();if(!n)return null;const s=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(l,f,s,t):this._doFindNextMatchLineByLine(l,f,s,t)}static _doFindNextMatchMultiline(l,d,f,t){const n=new C.Position(d.lineNumber,1),s=l.getOffsetAt(n),o=l.getLineCount(),u=l.getValueInRange(new T.Range(n.lineNumber,n.column,o,l.getLineMaxColumn(o)),1),w=l.getEOL()===`\r
`?new c(u):null;f.reset(d.column-1);let b=f.next(u);return b?A(this._getMultilineMatchRange(l,s,u,w,b.index,b[0]),b,t):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(l,new C.Position(1,1),f,t):null}static _doFindNextMatchLineByLine(l,d,f,t){const n=l.getLineCount(),s=d.lineNumber,o=l.getLineContent(s),u=this._findFirstMatchInLine(f,o,s,d.column,t);if(u)return u;for(let w=1;w<=n;w++){const b=(s+w-1)%n,I=l.getLineContent(b+1),h=this._findFirstMatchInLine(f,I,b+1,1,t);if(h)return h}return null}static _findFirstMatchInLine(l,d,f,t,n){l.reset(t-1);const s=l.next(d);return s?A(new T.Range(f,s.index+1,f,s.index+1+s[0].length),s,n):null}static findPreviousMatch(l,d,f,t){const n=d.parseSearchRequest();if(!n)return null;const s=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(l,f,s,t):this._doFindPreviousMatchLineByLine(l,f,s,t)}static _doFindPreviousMatchMultiline(l,d,f,t){const n=this._doFindMatchesMultiline(l,new T.Range(1,1,d.lineNumber,d.column),f,t,10*D);if(n.length>0)return n[n.length-1];const s=l.getLineCount();return d.lineNumber!==s||d.column!==l.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(l,new C.Position(s,l.getLineMaxColumn(s)),f,t):null}static _doFindPreviousMatchLineByLine(l,d,f,t){const n=l.getLineCount(),s=d.lineNumber,o=l.getLineContent(s).substring(0,d.column-1),u=this._findLastMatchInLine(f,o,s,t);if(u)return u;for(let w=1;w<=n;w++){const b=(n+s-w-1)%n,I=l.getLineContent(b+1),h=this._findLastMatchInLine(f,I,b+1,t);if(h)return h}return null}static _findLastMatchInLine(l,d,f,t){let n=null,s;for(l.reset(0);s=l.next(d);)n=A(new T.Range(f,s.index+1,f,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=g;function r(y,l,d,f,t){if(f===0)return!0;const n=l.charCodeAt(f-1);if(y.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=l.charCodeAt(f);if(y.get(s)!==0)return!0}return!1}function a(y,l,d,f,t){if(f+t===d)return!0;const n=l.charCodeAt(f+t);if(y.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=l.charCodeAt(f+t-1);if(y.get(s)!==0)return!0}return!1}function p(y,l,d,f,t){return r(y,l,d,f,t)&&a(y,l,d,f,t)}e.isValidMatch=p;class m{constructor(l,d){this._wordSeparators=l,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const d=l.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(f=this._searchRegex.exec(l),!f))return null;const t=f.index,n=f[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){v.getNextCodePoint(l,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||p(this._wordSeparators,l,d,t,n))return f}while(f);return null}}e.Searcher=m}),define(be[87],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function v(D=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)D.indexOf(k)>=0||(S+="\\"+k);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=v();function R(D){let S=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)S=D;else{let k="g";D.ignoreCase&&(k+="i"),D.multiline&&(k+="m"),D.unicode&&(k+="u"),S=new RegExp(D.source,k)}return S.lastIndex=0,S}e.ensureValidWordDefinition=R;const C={maxLen:1e3,windowSize:15,timeBudget:150};function T(D,S,k,i,A=C){if(k.length>A.maxLen){let p=D-A.maxLen/2;return p<0?p=0:i+=p,k=k.substring(p,D+A.maxLen/2),T(D,S,k,i,A)}const c=Date.now(),g=D-1-i;let r=-1,a=null;for(let p=1;!(Date.now()-c>=A.timeBudget);p++){const m=g-A.windowSize*p;S.lastIndex=Math.max(0,m);const y=E(S,k,g,r);if(!y&&a||(a=y,m<=0))break;r=m}if(a){let p={word:a[0],startColumn:i+1+a.index,endColumn:i+1+a.index+a[0].length};return S.lastIndex=0,p}return null}e.getWordAtText=T;function E(D,S,k,i){let A;for(;A=D.exec(S);){const c=A.index||0;if(c<=k&&D.lastIndex>=k)return A;if(i>0&&c>i)return null}return null}}),define(be[118],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var v;(function(E){E[E.None=0]="None",E[E.Indent=1]="Indent",E[E.IndentOutdent=2]="IndentOutdent",E[E.Outdent=3]="Outdent"})(v=e.IndentAction||(e.IndentAction={}));class R{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let S=0,k=D.notIn.length;S<k;S++)switch(D.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=R;class C{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of D)T(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),T(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),T(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),T(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&T(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=C;function T(E,D,S){E.has(D)?E.get(D).push(S):E.set(D,[S])}}),define(be[60],we([0,1,28,14]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(T,E,D,S){if(Array.isArray(T)){let k=0;for(const i of T){const A=C(i,E,D,S);if(A===10)return A;A>k&&(k=A)}return k}else{if(typeof T=="string")return S?T==="*"?5:T===D?10:0:0;if(T){const{language:k,pattern:i,scheme:A,hasAccessToAllModels:c}=T;if(!S&&!c)return 0;let g=0;if(A)if(A===E.scheme)g=10;else if(A==="*")g=5;else return 0;if(k)if(k===D)g=10;else if(k==="*")g=Math.max(g,5);else return 0;if(i){let r;if(typeof i=="string"?r=i:r=Object.assign(Object.assign({},i),{base:(0,R.normalize)(i.base)}),r===E.fsPath||(0,v.match)(r,E.fsPath))g=10;else return 0}return g}else return 0}}e.score=C}),define(be[119],we([0,1,85]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class C{constructor(r,a,p){const m=new Uint8Array(r*a);for(let y=0,l=r*a;y<l;y++)m[y]=p;this._data=m,this.rows=r,this.cols=a}get(r,a){return this._data[r*this.cols+a]}set(r,a,p){this._data[r*this.cols+a]=p}}e.Uint8Matrix=C;class T{constructor(r){let a=0,p=0;for(let y=0,l=r.length;y<l;y++){let[d,f,t]=r[y];f>a&&(a=f),d>p&&(p=d),t>p&&(p=t)}a++,p++;let m=new C(p,a,0);for(let y=0,l=r.length;y<l;y++){let[d,f,t]=r[y];m.set(d,f,t)}this._states=m,this._maxCharCode=a}nextState(r,a){return a<0||a>=this._maxCharCode?0:this._states.get(r,a)}}e.StateMachine=T;let E=null;function D(){return E===null&&(E=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var S;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let k=null;function i(){if(k===null){k=new v.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<g.length;a++)k.set(g.charCodeAt(a),1);const r=".,;";for(let a=0;a<r.length;a++)k.set(r.charCodeAt(a),2)}return k}class A{static _createLink(r,a,p,m,y){let l=y-1;do{const d=a.charCodeAt(l);if(r.get(d)!==2)break;l--}while(l>m);if(m>0){const d=a.charCodeAt(m-1),f=a.charCodeAt(l);(d===40&&f===41||d===91&&f===93||d===123&&f===125)&&l--}return{range:{startLineNumber:p,startColumn:m+1,endLineNumber:p,endColumn:l+2},url:a.substring(m,l+1)}}static computeLinks(r,a=D()){const p=i();let m=[];for(let y=1,l=r.getLineCount();y<=l;y++){const d=r.getLineContent(y),f=d.length;let t=0,n=0,s=0,o=1,u=!1,w=!1,b=!1,I=!1;for(;t<f;){let h=!1;const _=d.charCodeAt(t);if(o===13){let F;switch(_){case 40:u=!0,F=0;break;case 41:F=u?0:1;break;case 91:b=!0,w=!0,F=0;break;case 93:b=!1,F=w?0:1;break;case 123:I=!0,F=0;break;case 125:F=I?0:1;break;case 39:F=s===34||s===96?0:1;break;case 34:F=s===39||s===96?0:1;break;case 96:F=s===39||s===34?0:1;break;case 42:F=s===42?1:0;break;case 124:F=s===124?1:0;break;case 32:F=b?0:1;break;default:F=p.get(_)}F===1&&(m.push(A._createLink(p,d,y,n,t)),h=!0)}else if(o===12){let F;_===91?(w=!0,F=0):F=p.get(_),F===1?h=!0:o=13}else o=a.nextState(o,_),o===0&&(h=!0);h&&(o=1,u=!1,w=!1,I=!1,n=t+1,s=_),t++}o===13&&m.push(A._createLink(p,d,y,n,f))}return m}}e.LinkComputer=A;function c(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:A.computeLinks(g)}e.computeLinks=c}),define(be[120],we([0,1,3,6]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(E){this._onDidChange.fire({changedLanguages:E,changedColorMap:!1})}register(E,D){return this._map.set(E,D),this.fire([E]),(0,R.toDisposable)(()=>{this._map.get(E)===D&&(this._map.delete(E),this.fire([E]))})}registerPromise(E,D){let S=null,k=!1;return this._promises.set(E,D.then(i=>{this._promises.delete(E),!(k||!i)&&(S=this.register(E,i))})),(0,R.toDisposable)(()=>{k=!0,S&&S.dispose()})}getPromise(E){const D=this.get(E);if(D)return Promise.resolve(D);const S=this._promises.get(E);return S?S.then(k=>this.get(E)):null}get(E){return this._map.get(E)||null}setColorMap(E){this._colorMap=E,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(be[88],we([0,1,24,21]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(A){A[A.Full=1]="Full",A[A.Delta=2]="Delta"})(C||(C={}));function T(A){for(let c=0,g=A.length;c<g;c+=4){const r=A[c+0],a=A[c+1],p=A[c+2],m=A[c+3];A[c+0]=m,A[c+1]=p,A[c+2]=a,A[c+3]=r}}function E(A){const c=new Uint8Array(A.buffer,A.byteOffset,A.length*4);return R.isLittleEndian()||T(c),v.VSBuffer.wrap(c)}function D(A){const c=A.buffer;if(R.isLittleEndian()||T(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const g=new Uint8Array(c.byteLength);return g.set(c),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function S(A){const c=new Uint32Array(k(A));let g=0;if(c[g++]=A.id,A.type==="full")c[g++]=1,c[g++]=A.data.length,c.set(A.data,g),g+=A.data.length;else{c[g++]=2,c[g++]=A.deltas.length;for(const r of A.deltas)c[g++]=r.start,c[g++]=r.deleteCount,r.data?(c[g++]=r.data.length,c.set(r.data,g),g+=r.data.length):c[g++]=0}return E(c)}e.encodeSemanticTokensDto=S;function k(A){let c=0;if(c+=1+1,A.type==="full")c+=1+A.data.length;else{c+=1,c+=(1+1+1)*A.deltas.length;for(const g of A.deltas)g.data&&(c+=g.data.length)}return c}function i(A){const c=D(A);let g=0;const r=c[g++];if(c[g++]===1){const y=c[g++],l=c.subarray(g,g+y);return g+=y,{id:r,type:"full",data:l}}const p=c[g++];let m=[];for(let y=0;y<p;y++){const l=c[g++],d=c[g++],f=c[g++];let t;f>0&&(t=c.subarray(g,g+f),g+=f),m[y]={start:l,deleteCount:d,data:t}}return{id:r,type:"delta",deltas:m}}e.decodeSemanticTokensDto=i}),define(be[89],we([0,1,83]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(E,D){this.index=E,this.remainder=D}}e.PrefixSumIndexOfResult=R;class C{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,D){E=(0,v.toUint32)(E);const S=this.values,k=this.prefixSum,i=D.length;return i===0?!1:(this.values=new Uint32Array(S.length+i),this.values.set(S.subarray(0,E),0),this.values.set(S.subarray(E),E+i),this.values.set(D,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(E,D){return E=(0,v.toUint32)(E),D=(0,v.toUint32)(D),this.values[E]===D?!1:(this.values[E]=D,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,D){E=(0,v.toUint32)(E),D=(0,v.toUint32)(D);const S=this.values,k=this.prefixSum;if(E>=S.length)return!1;let i=S.length-E;return D>=i&&(D=i),D===0?!1:(this.values=new Uint32Array(S.length-D),this.values.set(S.subarray(0,E),0),this.values.set(S.subarray(E+D),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(E){return E<0?0:(E=(0,v.toUint32)(E),this._getAccumulatedValue(E))}_getAccumulatedValue(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),E>=this.values.length&&(E=this.values.length-1);for(let S=D;S<=E;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalValue();let D=0,S=this.values.length-1,k=0,i=0,A=0;for(;D<=S;)if(k=D+(S-D)/2|0,i=this.prefixSum[k],A=i-this.values[k],E<A)S=k-1;else if(E>=i)D=k+1;else break;return new R(k,E-A)}}e.PrefixSumComputer=C}),define(be[121],we([0,1,8,38,89]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(D,S,k,i){this._uri=D,this._lines=S,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const S=D.changes;for(const k of S)this._acceptDeleteRange(k.range),this._acceptInsertText(new R.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,S=this._lines.length,k=new Uint32Array(S);for(let i=0;i<S;i++)k[i]=this._lines[i].length+D;this._lineStarts=new C.PrefixSumComputer(k)}}_setLineText(D,S){this._lines[D]=S,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,S){if(S.length!==0){let k=(0,v.splitLines)(S);if(k.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+k[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}k[k.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let A=1;A<k.length;A++)this._lines.splice(D.lineNumber+A-1,0,k[A]),i[A-1]=k[A].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,i)}}}e.MirrorTextModel=T}),define(be[122],we([18,19]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(be[61],we([0,1,122,10,13]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(k,i){return i&&(k.stack||k.stacktrace)?v.localize(0,null,D(k),E(k.stack)||E(k.stacktrace)):D(k)}function E(k){return Array.isArray(k)?k.join(`
`):k}function D(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?v.localize(1,null,k.message):k.message||v.localize(2,null)}function S(k=null,i=!1){if(!k)return v.localize(3,null);if(Array.isArray(k)){const A=C.coalesce(k),c=S(A[0],i);return A.length>1?v.localize(4,null,c,A.length):c}if(R.isString(k))return k;if(k.detail){const A=k.detail;if(A.error)return T(A.error,i);if(A.exception)return T(A.exception,i)}return k.stack?T(k,i):k.message?k.message:v.localize(5,null)}e.toErrorMessage=S}),define(be[123],we([18,19]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(be[124],we([0,1,123,21,87]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=E;class D{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,ge){this._values[Z]=ge}}e.ValidatedEditorOptions=D;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class k{constructor(Z,ge,Ne,Ve){this.id=Z,this.name=ge,this.defaultValue=Ne,this.schema=Ve}compute(Z,ge,Ne){return Ne}}class i{constructor(Z,ge=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(Z){return this.defaultValue}}class A{constructor(Z,ge,Ne,Ve){this.id=Z,this.name=ge,this.defaultValue=Ne,this.schema=Ve}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,ge,Ne){return Ne}}function c(V,Z){return typeof V=="undefined"?Z:V==="false"?!1:Boolean(V)}e.boolean=c;class g extends A{constructor(Z,ge,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Ne),super(Z,ge,Ne,Ve)}validate(Z){return c(Z,this.defaultValue)}}class r extends A{constructor(Z,ge,Ne,Ve,Be,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Ne,Ze.minimum=Ve,Ze.maximum=Be),super(Z,ge,Ne,Ze),this.minimum=Ve,this.maximum=Be}static clampedInt(Z,ge,Ne,Ve){if(typeof Z=="undefined")return ge;let Be=parseInt(Z,10);return isNaN(Be)?ge:(Be=Math.max(Ne,Be),Be=Math.min(Ve,Be),Be|0)}validate(Z){return r.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class a extends A{constructor(Z,ge,Ne,Ve,Be){typeof Be!="undefined"&&(Be.type="number",Be.default=Ne),super(Z,ge,Ne,Be),this.validationFn=Ve}static clamp(Z,ge,Ne){return Z<ge?ge:Z>Ne?Ne:Z}static float(Z,ge){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return ge;const Ne=parseFloat(Z);return isNaN(Ne)?ge:Ne}validate(Z){return this.validationFn(a.float(Z,this.defaultValue))}}class p extends A{static string(Z,ge){return typeof Z!="string"?ge:Z}constructor(Z,ge,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Ne),super(Z,ge,Ne,Ve)}validate(Z){return p.string(Z,this.defaultValue)}}function m(V,Z,ge){return typeof V!="string"||ge.indexOf(V)===-1?Z:V}e.stringSet=m;class y extends A{constructor(Z,ge,Ne,Ve,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.enum=Ve,Be.default=Ne),super(Z,ge,Ne,Be),this._allowedValues=Ve}validate(Z){return m(Z,this.defaultValue,this._allowedValues)}}class l extends k{constructor(Z,ge,Ne,Ve,Be,Ze,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.enum=Be,Se.default=Ve),super(Z,ge,Ne,Se),this._allowedValues=Be,this._convert=Ze}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function d(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",description:v.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,ge,Ne){return Ne===0?Z.accessibilitySupport:Ne}}class t extends k{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:v.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{insertSpace:c(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(V){switch(V){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function w(V){switch(V){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class b extends i{constructor(){super(124,[62,31])}compute(Z,ge,Ne){const Ve=["monaco-editor"];return ge.get(31)&&Ve.push(ge.get(31)),Z.extraEditorClassName&&Ve.push(Z.extraEditorClassName),ge.get(62)==="default"?Ve.push("mouse-default"):ge.get(62)==="copy"&&Ve.push("mouse-copy"),ge.get(97)&&Ve.push("showUnused"),ge.get(122)&&Ve.push("showDeprecated"),Ve.join(" ")}}class I extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(Z,ge,Ne){return Ne&&Z.emptySelectionClipboard}}class h extends k{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Z.seedSearchStringFromSelection,description:v.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[v.localize(9,null),v.localize(10,null),v.localize(11,null)],description:v.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:v.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:v.localize(14,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:v.localize(15,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{cursorMoveOnType:c(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:c(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":m(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(ge.loop,this.defaultValue.loop)}}}class _ extends k{constructor(){super(41,"fontLigatures",_.OFF,{anyOf:[{type:"boolean",description:v.localize(16,null)},{type:"string",description:v.localize(17,null)}],description:v.localize(18,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?_.OFF:Z==="true"?_.ON:Z:Boolean(Z)?_.ON:_.OFF}}e.EditorFontLigatures=_,_.OFF='"liga" off, "calt" off',_.ON='"liga" on, "calt" on';class F extends i{constructor(){super(40)}compute(Z,ge,Ne){return Z.fontInfo}}class N extends A{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(19,null)})}validate(Z){let ge=a.float(Z,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(ge,6,100)}compute(Z,ge,Ne){return Z.fontInfo.fontSize}}class z extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:v.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(21,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(r.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class ce extends k{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[v.localize(22,null),v.localize(23,null),v.localize(24,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:v.localize(26,null)},ge),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:v.localize(27,null)},ge),"editor.gotoLocation.multipleDeclarations":Object.assign({description:v.localize(28,null)},ge),"editor.gotoLocation.multipleImplementations":Object.assign({description:v.localize(29,null)},ge),"editor.gotoLocation.multipleReferences":Object.assign({description:v.localize(30,null)},ge),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Ne,description:v.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Ne,description:v.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Ne,description:v.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Ne,description:v.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Ne,description:v.localize(35,null)}})}validate(Z){var ge,Ne,Ve,Be,Ze;if(!Z||typeof Z!="object")return this.defaultValue;const Se=Z;return{multiple:m(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ge=Se.multipleDefinitions)!==null&&ge!==void 0?ge:m(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=Se.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:m(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ve=Se.multipleDeclarations)!==null&&Ve!==void 0?Ve:m(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Be=Se.multipleImplementations)!==null&&Be!==void 0?Be:m(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ze=Se.multipleReferences)!==null&&Ze!==void 0?Ze:m(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class de extends k{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(50,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:v.localize(36,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:v.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:v.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{enabled:c(ge.enabled,this.defaultValue.enabled),delay:r.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:c(ge.sticky,this.defaultValue.sticky)}}}var B;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class j extends i{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(Z,ge,Ne){return j.computeLayout(ge,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const ge=Z.height/Z.lineHeight,Ne=Z.scrollBeyondLastLine?ge-1:0,Ve=(Z.viewLineCount+Ne)/(Z.pixelRatio*Z.height),Be=Math.floor(Z.viewLineCount/Ve);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:Ne,desiredRatio:Ve,minimapLineCount:Be}}static _computeMinimapLayout(Z,ge){const Ne=Z.outerWidth,Ve=Z.outerHeight,Be=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const Ze=ge.stableMinimapLayoutInput,Se=Ze&&Z.outerHeight===Ze.outerHeight&&Z.lineHeight===Ze.lineHeight&&Z.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&Z.pixelRatio===Ze.pixelRatio&&Z.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&Z.minimap.enabled===Ze.minimap.enabled&&Z.minimap.side===Ze.minimap.side&&Z.minimap.size===Ze.minimap.size&&Z.minimap.showSlider===Ze.minimap.showSlider&&Z.minimap.renderCharacters===Ze.minimap.renderCharacters&&Z.minimap.maxColumn===Ze.minimap.maxColumn&&Z.minimap.scale===Ze.minimap.scale&&Z.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&Z.isViewportWrapping===Ze.isViewportWrapping,ye=Z.lineHeight,ke=Z.typicalHalfwidthCharacterWidth,ne=Z.scrollBeyondLastLine,oe=Z.minimap.renderCharacters;let O=Be>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Y=Z.minimap.maxColumn,re=Z.minimap.size,Ie=Z.minimap.side,_e=Z.verticalScrollbarWidth,Re=Z.viewLineCount,ze=Z.remainingWidth,Xe=Z.isViewportWrapping,st=oe?2:3;let Ye=Math.floor(Be*Ve);const et=Ye/Be;let pt=!1,_t=!1,je=st*O,me=O/Be,pe=1;if(re==="fill"||re==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:at,desiredRatio:Je,minimapLineCount:ft}=j.computeContainedMinimapLineCount({viewLineCount:Re,scrollBeyondLastLine:ne,height:Ve,lineHeight:ye,pixelRatio:Be});if(Re/ft>1)pt=!0,_t=!0,O=1,je=1,me=O/Be;else{let mt=!1,bt=O+1;if(re==="fit"){const kt=Math.ceil((Re+at)*je);Xe&&Se&&ze<=ge.stableFitRemainingWidth?(mt=!0,bt=ge.stableFitMaxMinimapScale):(mt=kt>Ye,Xe&&mt?(ge.stableMinimapLayoutInput=Z,ge.stableFitRemainingWidth=ze):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0))}if(re==="fill"||mt){pt=!0;const kt=O;je=Math.min(ye*Be,Math.max(1,Math.floor(1/Je))),O=Math.min(bt,Math.max(1,Math.floor(je/st))),O>kt&&(pe=Math.min(2,O/kt)),me=O/Be/pe,Ye=Math.ceil(Math.max(ct,Re+at)*je),Xe&&mt&&(ge.stableFitMaxMinimapScale=O)}}}const se=Math.floor(Y*me),K=Math.min(se,Math.max(0,Math.floor((ze-_e-2)*me/(ke+me)))+e.MINIMAP_GUTTER_WIDTH);let Oe=Math.floor(Be*K);const Ae=Oe/Be;Oe=Math.floor(Oe*pe);const rt=oe?1:2,tt=Ie==="left"?0:Ne-K-_e;return{renderMinimap:rt,minimapLeft:tt,minimapWidth:K,minimapHeightIsEditorHeight:pt,minimapIsSampling:_t,minimapScale:O,minimapLineHeight:je,minimapCanvasInnerWidth:Oe,minimapCanvasInnerHeight:Ye,minimapCanvasOuterWidth:Ae,minimapCanvasOuterHeight:et}}static computeLayout(Z,ge){const Ne=ge.outerWidth|0,Ve=ge.outerHeight|0,Be=ge.lineHeight|0,Ze=ge.lineNumbersDigitCount|0,Se=ge.typicalHalfwidthCharacterWidth,ye=ge.maxDigitWidth,ke=ge.pixelRatio,ne=ge.viewLineCount,oe=Z.get(119),O=oe==="inherit"?Z.get(118):oe,Y=O==="inherit"?Z.get(114):O,re=Z.get(117),Ie=Z.get(2),_e=ge.isDominatedByLongLines,Re=Z.get(46),ze=Z.get(56).renderType!==0,Xe=Z.get(57),st=Z.get(91),Ye=Z.get(61),et=Z.get(89),pt=et.verticalScrollbarSize,_t=et.verticalHasArrows,je=et.arrowSize,me=et.horizontalScrollbarSize,pe=Z.get(54),se=Z.get(35);let K;if(typeof pe=="string"&&/^\d+(\.\d+)?ch$/.test(pe)){const Lt=parseFloat(pe.substr(0,pe.length-2));K=r.clampedInt(Lt*Se,0,0,1e3)}else K=r.clampedInt(pe,0,0,1e3);se&&(K+=16);let Oe=0;if(ze){const Lt=Math.max(Ze,Xe);Oe=Math.round(Lt*ye)}let Ae=0;Re&&(Ae=Be);let rt=0,tt=rt+Ae,ct=tt+Oe,at=ct+K;const Je=Ne-Ae-Oe-K;let ft=!1,ut=!1,mt=-1;Ie!==2&&(O==="inherit"&&_e?(ft=!0,ut=!0):Y==="on"||Y==="bounded"?ut=!0:Y==="wordWrapColumn"&&(mt=re));const bt=j._computeMinimapLayout({outerWidth:Ne,outerHeight:Ve,lineHeight:Be,typicalHalfwidthCharacterWidth:Se,pixelRatio:ke,scrollBeyondLastLine:st,minimap:Ye,verticalScrollbarWidth:pt,viewLineCount:ne,remainingWidth:Je,isViewportWrapping:ut},ge.memory||new S);bt.renderMinimap!==0&&bt.minimapLeft===0&&(rt+=bt.minimapWidth,tt+=bt.minimapWidth,ct+=bt.minimapWidth,at+=bt.minimapWidth);const kt=Je-bt.minimapWidth,Ft=Math.max(1,Math.floor((kt-pt-2)/Se)),Et=_t?je:0;return ut&&(mt=Math.max(1,Ft),Y==="bounded"&&(mt=Math.min(mt,re))),{width:Ne,height:Ve,glyphMarginLeft:rt,glyphMarginWidth:Ae,lineNumbersLeft:tt,lineNumbersWidth:Oe,decorationsLeft:ct,decorationsWidth:K,contentLeft:at,contentWidth:kt,minimap:bt,viewportColumn:Ft,isWordWrapMinified:ft,isViewportWrapping:ut,wrappingColumn:mt,verticalScrollbarWidth:pt,horizontalScrollbarHeight:me,overviewRuler:{top:Et,width:pt,height:Ve-2*Et,right:0}}}}e.EditorLayoutInfoComputer=j;class W extends k{constructor(){const Z={enabled:!0};super(53,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:v.localize(39,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:c(Z.enabled,this.defaultValue.enabled)}}}class P extends k{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:v.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,description:v.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,description:v.localize(42,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{enabled:c(ge.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class H extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:v.localize(43,null)})}compute(Z,ge,Ne){return Z.fontInfo.lineHeight}}class L extends k{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:v.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(45,null),v.localize(46,null),v.localize(47,null)],default:Z.size,description:v.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:v.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:v.localize(50,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:v.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:v.localize(53,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{enabled:c(ge.enabled,this.defaultValue.enabled),size:m(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(ge.side,this.defaultValue.side,["right","left"]),showSlider:m(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(ge.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ge.scale,1,1,3),maxColumn:r.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function $(V){return V==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Q extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(55,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{top:r.clampedInt(ge.top,0,0,1e3),bottom:r.clampedInt(ge.bottom,0,0,1e3)}}}class q extends k{constructor(){const Z={enabled:!0,cycle:!1};super(72,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:v.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:v.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{enabled:c(ge.enabled,this.defaultValue.enabled),cycle:c(ge.cycle,this.defaultValue.cycle)}}}class ae extends i{constructor(){super(125)}compute(Z,ge,Ne){return Z.pixelRatio}}class fe extends k{constructor(){const Z={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:v.localize(58,null)},comments:{type:"boolean",default:Z.comments,description:v.localize(59,null)},other:{type:"boolean",default:Z.other,description:v.localize(60,null)}}}],default:Z,description:v.localize(61,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const ge=Z,Ne={other:c(ge.other,this.defaultValue.other),comments:c(ge.comments,this.defaultValue.comments),strings:c(ge.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var Le;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Le=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class xe extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(62,null),v.localize(63,null),v.localize(64,null),v.localize(65,null)],default:"on",description:v.localize(66,null)})}validate(Z){let ge=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(ge=4,Ne=Z):Z==="interval"?ge=3:Z==="relative"?ge=2:Z==="on"?ge=1:ge=0),{renderType:ge,renderFn:Ne}}}function Fe(V){const Z=V.get(84);return Z==="editable"?V.get(77):Z!=="on"}e.filterValidationDecorations=Fe;class He extends k{constructor(){const Z=[],ge={type:"number",description:v.localize(67,null)};super(88,"rulers",Z,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:v.localize(68,null),format:"color-hex"}}}]},default:Z,description:v.localize(69,null)})}validate(Z){if(Array.isArray(Z)){let ge=[];for(let Ne of Z)if(typeof Ne=="number")ge.push({column:r.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ve=Ne;ge.push({column:r.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return ge.sort((Ne,Ve)=>Ne.column-Ve.column),ge}return this.defaultValue}}function x(V,Z){if(typeof V!="string")return Z;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class G extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z,Ne=r.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=r.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:x(ge.vertical,this.defaultValue.vertical),horizontal:x(ge.horizontal,this.defaultValue.horizontal),useShadows:c(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:r.clampedInt(ge.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:r.clampedInt(ge.verticalSliderSize,Ve,0,1e3),scrollByPage:c(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends k{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(70,null),v.localize(71,null)],default:Z.insertMode,description:v.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:v.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:v.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:v.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:v.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:v.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:v.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:v.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(109,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{insertMode:m(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(ge.showIcons,this.defaultValue.showIcons),showStatusBar:c(ge.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:c(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(ge.showMethods,this.defaultValue.showMethods),showFunctions:c(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:c(ge.showConstructors,this.defaultValue.showConstructors),showFields:c(ge.showFields,this.defaultValue.showFields),showVariables:c(ge.showVariables,this.defaultValue.showVariables),showClasses:c(ge.showClasses,this.defaultValue.showClasses),showStructs:c(ge.showStructs,this.defaultValue.showStructs),showInterfaces:c(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:c(ge.showModules,this.defaultValue.showModules),showProperties:c(ge.showProperties,this.defaultValue.showProperties),showEvents:c(ge.showEvents,this.defaultValue.showEvents),showOperators:c(ge.showOperators,this.defaultValue.showOperators),showUnits:c(ge.showUnits,this.defaultValue.showUnits),showValues:c(ge.showValues,this.defaultValue.showValues),showConstants:c(ge.showConstants,this.defaultValue.showConstants),showEnums:c(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:c(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(ge.showKeywords,this.defaultValue.showKeywords),showWords:c(ge.showWords,this.defaultValue.showWords),showColors:c(ge.showColors,this.defaultValue.showColors),showFiles:c(ge.showFiles,this.defaultValue.showFiles),showReferences:c(ge.showReferences,this.defaultValue.showReferences),showFolders:c(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:c(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(ge.showSnippets,this.defaultValue.showSnippets),showUsers:c(ge.showUsers,this.defaultValue.showUsers),showIssues:c(ge.showIssues,this.defaultValue.showIssues)}}}class ie extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(110,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ue extends i{constructor(){super(126,[77])}compute(Z,ge,Ne){return ge.get(77)?!0:Z.tabFocusMode}}var Ee;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(Ee=e.WrappingIndent||(e.WrappingIndent={}));function $e(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class he extends i{constructor(){super(128,[127])}compute(Z,ge,Ne){const Ve=ge.get(127);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Te:R.isLinux?We:Ce,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ve(V){return e.editorOptionsRegistry[V.id]=V,V}var Ge;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.codeLens=12]="codeLens",V[V.codeLensFontFamily=13]="codeLensFontFamily",V[V.codeLensFontSize=14]="codeLensFontSize",V[V.colorDecorators=15]="colorDecorators",V[V.columnSelection=16]="columnSelection",V[V.comments=17]="comments",V[V.contextmenu=18]="contextmenu",V[V.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",V[V.cursorBlinking=20]="cursorBlinking",V[V.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",V[V.cursorStyle=22]="cursorStyle",V[V.cursorSurroundingLines=23]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",V[V.cursorWidth=25]="cursorWidth",V[V.disableLayerHinting=26]="disableLayerHinting",V[V.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",V[V.domReadOnly=28]="domReadOnly",V[V.dragAndDrop=29]="dragAndDrop",V[V.emptySelectionClipboard=30]="emptySelectionClipboard",V[V.extraEditorClassName=31]="extraEditorClassName",V[V.fastScrollSensitivity=32]="fastScrollSensitivity",V[V.find=33]="find",V[V.fixedOverflowWidgets=34]="fixedOverflowWidgets",V[V.folding=35]="folding",V[V.foldingStrategy=36]="foldingStrategy",V[V.foldingHighlight=37]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=39]="fontFamily",V[V.fontInfo=40]="fontInfo",V[V.fontLigatures=41]="fontLigatures",V[V.fontSize=42]="fontSize",V[V.fontWeight=43]="fontWeight",V[V.formatOnPaste=44]="formatOnPaste",V[V.formatOnType=45]="formatOnType",V[V.glyphMargin=46]="glyphMargin",V[V.gotoLocation=47]="gotoLocation",V[V.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",V[V.hover=50]="hover",V[V.inDiffEditor=51]="inDiffEditor",V[V.letterSpacing=52]="letterSpacing",V[V.lightbulb=53]="lightbulb",V[V.lineDecorationsWidth=54]="lineDecorationsWidth",V[V.lineHeight=55]="lineHeight",V[V.lineNumbers=56]="lineNumbers",V[V.lineNumbersMinChars=57]="lineNumbersMinChars",V[V.linkedEditing=58]="linkedEditing",V[V.links=59]="links",V[V.matchBrackets=60]="matchBrackets",V[V.minimap=61]="minimap",V[V.mouseStyle=62]="mouseStyle",V[V.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=64]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",V[V.multiCursorModifier=66]="multiCursorModifier",V[V.multiCursorPaste=67]="multiCursorPaste",V[V.occurrencesHighlight=68]="occurrencesHighlight",V[V.overviewRulerBorder=69]="overviewRulerBorder",V[V.overviewRulerLanes=70]="overviewRulerLanes",V[V.padding=71]="padding",V[V.parameterHints=72]="parameterHints",V[V.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",V[V.quickSuggestions=75]="quickSuggestions",V[V.quickSuggestionsDelay=76]="quickSuggestionsDelay",V[V.readOnly=77]="readOnly",V[V.renameOnType=78]="renameOnType",V[V.renderControlCharacters=79]="renderControlCharacters",V[V.renderIndentGuides=80]="renderIndentGuides",V[V.renderFinalNewline=81]="renderFinalNewline",V[V.renderLineHighlight=82]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=84]="renderValidationDecorations",V[V.renderWhitespace=85]="renderWhitespace",V[V.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",V[V.roundedSelection=87]="roundedSelection",V[V.rulers=88]="rulers",V[V.scrollbar=89]="scrollbar",V[V.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=91]="scrollBeyondLastLine",V[V.scrollPredominantAxis=92]="scrollPredominantAxis",V[V.selectionClipboard=93]="selectionClipboard",V[V.selectionHighlight=94]="selectionHighlight",V[V.selectOnLineNumbers=95]="selectOnLineNumbers",V[V.showFoldingControls=96]="showFoldingControls",V[V.showUnused=97]="showUnused",V[V.snippetSuggestions=98]="snippetSuggestions",V[V.smartSelect=99]="smartSelect",V[V.smoothScrolling=100]="smoothScrolling",V[V.stickyTabStops=101]="stickyTabStops",V[V.stopRenderingLineAfter=102]="stopRenderingLineAfter",V[V.suggest=103]="suggest",V[V.suggestFontSize=104]="suggestFontSize",V[V.suggestLineHeight=105]="suggestLineHeight",V[V.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",V[V.suggestSelection=107]="suggestSelection",V[V.tabCompletion=108]="tabCompletion",V[V.tabIndex=109]="tabIndex",V[V.unusualLineTerminators=110]="unusualLineTerminators",V[V.useShadowDOM=111]="useShadowDOM",V[V.useTabStops=112]="useTabStops",V[V.wordSeparators=113]="wordSeparators",V[V.wordWrap=114]="wordWrap",V[V.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=117]="wordWrapColumn",V[V.wordWrapOverride1=118]="wordWrapOverride1",V[V.wordWrapOverride2=119]="wordWrapOverride2",V[V.wrappingIndent=120]="wrappingIndent",V[V.wrappingStrategy=121]="wrappingStrategy",V[V.showDeprecated=122]="showDeprecated",V[V.inlayHints=123]="inlayHints",V[V.editorClassName=124]="editorClassName",V[V.pixelRatio=125]="pixelRatio",V[V.tabFocusMode=126]="tabFocusMode",V[V.layoutInfo=127]="layoutInfo",V[V.wrappingInfo=128]="wrappingInfo"})(Ge=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(111,null)})),acceptSuggestionOnEnter:ve(new y(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(112,null),""],markdownDescription:v.localize(113,null)})),accessibilitySupport:ve(new f),accessibilityPageSize:ve(new r(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(114,null)})),ariaLabel:ve(new p(4,"ariaLabel",v.localize(115,null))),autoClosingBrackets:ve(new y(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(116,null),v.localize(117,null),""],description:v.localize(118,null)})),autoClosingDelete:ve(new y(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(119,null),""],description:v.localize(120,null)})),autoClosingOvertype:ve(new y(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(121,null),""],description:v.localize(122,null)})),autoClosingQuotes:ve(new y(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(123,null),v.localize(124,null),""],description:v.localize(125,null)})),autoIndent:ve(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[v.localize(126,null),v.localize(127,null),v.localize(128,null),v.localize(129,null),v.localize(130,null)],description:v.localize(131,null)})),automaticLayout:ve(new g(10,"automaticLayout",!1)),autoSurround:ve(new y(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(132,null),v.localize(133,null),v.localize(134,null),""],description:v.localize(135,null)})),stickyTabStops:ve(new g(101,"stickyTabStops",!1,{description:v.localize(136,null)})),codeLens:ve(new g(12,"codeLens",!0,{description:v.localize(137,null)})),codeLensFontFamily:ve(new p(13,"codeLensFontFamily","",{description:v.localize(138,null)})),codeLensFontSize:ve(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:v.localize(139,null)})),colorDecorators:ve(new g(15,"colorDecorators",!0,{description:v.localize(140,null)})),columnSelection:ve(new g(16,"columnSelection",!1,{description:v.localize(141,null)})),comments:ve(new t),contextmenu:ve(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new g(19,"copyWithSyntaxHighlighting",!0,{description:v.localize(142,null)})),cursorBlinking:ve(new l(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:v.localize(143,null)})),cursorSmoothCaretAnimation:ve(new g(21,"cursorSmoothCaretAnimation",!1,{description:v.localize(144,null)})),cursorStyle:ve(new l(22,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:v.localize(145,null)})),cursorSurroundingLines:ve(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(146,null)})),cursorSurroundingLinesStyle:ve(new y(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(147,null),v.localize(148,null)],description:v.localize(149,null)})),cursorWidth:ve(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(150,null)})),disableLayerHinting:ve(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new g(28,"domReadOnly",!1)),dragAndDrop:ve(new g(29,"dragAndDrop",!0,{description:v.localize(151,null)})),emptySelectionClipboard:ve(new I),extraEditorClassName:ve(new p(31,"extraEditorClassName","")),fastScrollSensitivity:ve(new a(32,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:v.localize(152,null)})),find:ve(new h),fixedOverflowWidgets:ve(new g(34,"fixedOverflowWidgets",!1)),folding:ve(new g(35,"folding",!0,{description:v.localize(153,null)})),foldingStrategy:ve(new y(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(154,null),v.localize(155,null)],description:v.localize(156,null)})),foldingHighlight:ve(new g(37,"foldingHighlight",!0,{description:v.localize(157,null)})),unfoldOnClickAfterEndOfLine:ve(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(158,null)})),fontFamily:ve(new p(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(159,null)})),fontInfo:ve(new F),fontLigatures2:ve(new _),fontSize:ve(new N),fontWeight:ve(new z),formatOnPaste:ve(new g(44,"formatOnPaste",!1,{description:v.localize(160,null)})),formatOnType:ve(new g(45,"formatOnType",!1,{description:v.localize(161,null)})),glyphMargin:ve(new g(46,"glyphMargin",!0,{description:v.localize(162,null)})),gotoLocation:ve(new ce),hideCursorInOverviewRuler:ve(new g(48,"hideCursorInOverviewRuler",!1,{description:v.localize(163,null)})),highlightActiveIndentGuide:ve(new g(49,"highlightActiveIndentGuide",!0,{description:v.localize(164,null)})),hover:ve(new de),inDiffEditor:ve(new g(51,"inDiffEditor",!1)),letterSpacing:ve(new a(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>a.clamp(V,-5,20),{description:v.localize(165,null)})),lightbulb:ve(new W),lineDecorationsWidth:ve(new A(54,"lineDecorationsWidth",10)),lineHeight:ve(new H),lineNumbers:ve(new xe),lineNumbersMinChars:ve(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new g(58,"linkedEditing",!1,{description:v.localize(166,null)})),links:ve(new g(59,"links",!0,{description:v.localize(167,null)})),matchBrackets:ve(new y(60,"matchBrackets","always",["always","near","never"],{description:v.localize(168,null)})),minimap:ve(new L),mouseStyle:ve(new y(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new a(63,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:v.localize(169,null)})),mouseWheelZoom:ve(new g(64,"mouseWheelZoom",!1,{markdownDescription:v.localize(170,null)})),multiCursorMergeOverlapping:ve(new g(65,"multiCursorMergeOverlapping",!0,{description:v.localize(171,null)})),multiCursorModifier:ve(new l(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$,{markdownEnumDescriptions:[v.localize(172,null),v.localize(173,null)],markdownDescription:v.localize(174,null)})),multiCursorPaste:ve(new y(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(175,null),v.localize(176,null)],markdownDescription:v.localize(177,null)})),occurrencesHighlight:ve(new g(68,"occurrencesHighlight",!0,{description:v.localize(178,null)})),overviewRulerBorder:ve(new g(69,"overviewRulerBorder",!0,{description:v.localize(179,null)})),overviewRulerLanes:ve(new r(70,"overviewRulerLanes",3,0,3)),padding:ve(new Q),parameterHints:ve(new q),peekWidgetDefaultFocus:ve(new y(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(180,null),v.localize(181,null)],description:v.localize(182,null)})),definitionLinkOpensInPeek:ve(new g(74,"definitionLinkOpensInPeek",!1,{description:v.localize(183,null)})),quickSuggestions:ve(new fe),quickSuggestionsDelay:ve(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(184,null)})),readOnly:ve(new g(77,"readOnly",!1)),renameOnType:ve(new g(78,"renameOnType",!1,{description:v.localize(185,null),markdownDeprecationMessage:v.localize(186,null)})),renderControlCharacters:ve(new g(79,"renderControlCharacters",!1,{description:v.localize(187,null)})),renderIndentGuides:ve(new g(80,"renderIndentGuides",!0,{description:v.localize(188,null)})),renderFinalNewline:ve(new g(81,"renderFinalNewline",!0,{description:v.localize(189,null)})),renderLineHighlight:ve(new y(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(190,null)],description:v.localize(191,null)})),renderLineHighlightOnlyWhenFocus:ve(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(192,null)})),renderValidationDecorations:ve(new y(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new y(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(193,null),v.localize(194,null),v.localize(195,null),""],description:v.localize(196,null)})),revealHorizontalRightPadding:ve(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ve(new g(87,"roundedSelection",!0,{description:v.localize(197,null)})),rulers:ve(new He),scrollbar:ve(new G),scrollBeyondLastColumn:ve(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:v.localize(198,null)})),scrollBeyondLastLine:ve(new g(91,"scrollBeyondLastLine",!0,{description:v.localize(199,null)})),scrollPredominantAxis:ve(new g(92,"scrollPredominantAxis",!0,{description:v.localize(200,null)})),selectionClipboard:ve(new g(93,"selectionClipboard",!0,{description:v.localize(201,null),included:R.isLinux})),selectionHighlight:ve(new g(94,"selectionHighlight",!0,{description:v.localize(202,null)})),selectOnLineNumbers:ve(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:ve(new y(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[v.localize(203,null),v.localize(204,null)],description:v.localize(205,null)})),showUnused:ve(new g(97,"showUnused",!0,{description:v.localize(206,null)})),showDeprecated:ve(new g(122,"showDeprecated",!0,{description:v.localize(207,null)})),inlayHints:ve(new P),snippetSuggestions:ve(new y(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(208,null),v.localize(209,null),v.localize(210,null),v.localize(211,null)],description:v.localize(212,null)})),smartSelect:ve(new ie),smoothScrolling:ve(new g(100,"smoothScrolling",!1,{description:v.localize(213,null)})),stopRenderingLineAfter:ve(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new ee),suggestFontSize:ve(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(214,null)})),suggestLineHeight:ve(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(215,null)})),suggestOnTriggerCharacters:ve(new g(106,"suggestOnTriggerCharacters",!0,{description:v.localize(216,null)})),suggestSelection:ve(new y(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(217,null),v.localize(218,null),v.localize(219,null)],description:v.localize(220,null)})),tabCompletion:ve(new y(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(221,null),v.localize(222,null),v.localize(223,null)],description:v.localize(224,null)})),tabIndex:ve(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ve(new y(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(225,null),v.localize(226,null),v.localize(227,null)],description:v.localize(228,null)})),useShadowDOM:ve(new g(111,"useShadowDOM",!0)),useTabStops:ve(new g(112,"useTabStops",!0,{description:v.localize(229,null)})),wordSeparators:ve(new p(113,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:v.localize(230,null)})),wordWrap:ve(new y(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(231,null),v.localize(232,null),v.localize(233,null),v.localize(234,null)],description:v.localize(235,null)})),wordWrapBreakAfterCharacters:ve(new p(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new p(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new r(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(236,null)})),wordWrapOverride1:ve(new y(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new y(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ve(new l(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],$e,{enumDescriptions:[v.localize(237,null),v.localize(238,null),v.localize(239,null),v.localize(240,null)],description:v.localize(241,null)})),wrappingStrategy:ve(new y(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[v.localize(242,null),v.localize(243,null)],description:v.localize(244,null)})),editorClassName:ve(new b),pixelRatio:ve(new ae),tabFocusMode:ve(new ue),layoutInfo:ve(new j),wrappingInfo:ve(new he)}}),define(be[125],we([18,19]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[126],we([18,19]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[127],we([18,19]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(be[128],we([18,19]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(be[129],we([18,19]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(be[130],we([18,19]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(be[131],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[132],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[133],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(be[134],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[135],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[136],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[137],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[138],we([18,19]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(be[139],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[140],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[141],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[142],we([18,19]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[143],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var v;(function(E){E[E.ACTIVATE=0]="ACTIVATE",E[E.RESTORE=1]="RESTORE",E[E.PRESERVE=2]="PRESERVE"})(v=e.EditorActivation||(e.EditorActivation={}));var R;(function(E){E[E.PICK=1]="PICK",E[E.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var C;(function(E){E[E.API=0]="API",E[E.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(E){E[E.Center=0]="Center",E[E.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",E[E.NearTop=2]="NearTop",E[E.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[144],we([0,1,126]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function T(c){return c=c.trim(),c==="*"||R.test(c)}e.isValidVersionStr=T;function E(c){if(!T(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=c.match(R);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=E;function D(c){if(!c)return null;let g=c.majorBase,r=c.majorMustEqual,a=c.minorBase,p=c.minorMustEqual,m=c.patchBase,y=c.patchMustEqual;c.hasCaret&&(g===0||(p=!1),y=!1);let l=0;if(c.preRelease){const d=C.exec(c.preRelease);if(d){const[,f,t,n]=d;l=Date.UTC(Number(f),Number(t)-1,Number(n))}}return{majorBase:g,majorMustEqual:r,minorBase:a,minorMustEqual:p,patchBase:m,patchMustEqual:y,isMinimum:c.hasGreaterEquals,notBefore:l}}e.normalizeVersion=D;function S(c,g,r){let a;typeof c=="string"?a=D(E(c)):a=c;let p;g instanceof Date?p=g.getTime():typeof g=="string"&&(p=new Date(g).getTime());let m;if(typeof r=="string"?m=D(E(r)):m=r,!a||!m)return!1;let y=a.majorBase,l=a.minorBase,d=a.patchBase,f=m.majorBase,t=m.minorBase,n=m.patchBase,s=m.notBefore,o=m.majorMustEqual,u=m.minorMustEqual,w=m.patchMustEqual;return m.isMinimum?y>f?!0:y<f?!1:l>t?!0:l<t||p&&p<s?!1:d>=n:(y===1&&f===0&&(!o||!u||!w)&&(f=1,t=0,n=0,o=!0,u=!1,w=!1),y<f?!1:y>f?!o:l<t?!1:l>t?!u:d<n?!1:d>n?!w:!(p&&p<s))}e.isValidVersion=S;function k(c,g,r,a){return r.isBuiltin||typeof r.main=="undefined"?!0:A(c,g,r.engines.vscode,a)}e.isValidExtensionVersion=k;function i(c,g,r){return c==="*"||A(g,r,c)}e.isEngineValid=i;function A(c,g,r,a=[]){let p=D(E(r));if(!p)return a.push(v.localize(0,null,r)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return a.push(v.localize(1,null,r)),!1}else if(!p.majorMustEqual)return a.push(v.localize(2,null,r)),!1;return S(c,g,p)?!0:(a.push(v.localize(3,null,c,r)),!1)}}),define(be[90],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(T,E=[],D=!1){this.ctor=T,this.staticArguments=E,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=v;const R=(C,...T)=>new v(C,T);e.createSyncDescriptor=R}),define(be[62],we([0,1,90]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function C(E,D,S){D instanceof v.SyncDescriptor||(D=new v.SyncDescriptor(D,[],S)),R.push([E,D])}e.registerSingleton=C;function T(){return R}e.getSingletonServiceDescriptors=T}),define(be[145],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=v;class R{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let E of this._nodes.values())E.outgoing.size===0&&T.push(E);return T}insertEdge(T,E){const D=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(E);D.outgoing.set(this._hashFn(E),S),S.incoming.set(this._hashFn(T),D)}removeNode(T){const E=this._hashFn(T);this._nodes.delete(E);for(let D of this._nodes.values())D.outgoing.delete(E),D.incoming.delete(E)}lookupOrInsertNode(T){const E=this._hashFn(T);let D=this._nodes.get(E);return D||(D=new v(T),this._nodes.set(E,D)),D}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[E,D]of this._nodes)T.push(`${E}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,E]of this._nodes){const D=new Set([T]),S=this._findCycle(E,D);if(S)return S}}_findCycle(T,E){for(let[D,S]of T.outgoing){if(E.has(D))return[...E,D].join(" -> ");E.add(D);const k=this._findCycle(S,E);if(k)return k;E.delete(D)}}}e.Graph=R}),define(be[4],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(k){return k[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(v=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function R(D,S,k,i){S[v.DI_TARGET]===S?S[v.DI_DEPENDENCIES].push({id:D,index:k,optional:i}):(S[v.DI_DEPENDENCIES]=[{id:D,index:k,optional:i}],S[v.DI_TARGET]=S)}function C(D){if(v.serviceIds.has(D))return v.serviceIds.get(D);const S=function(k,i,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(S,k,A,!1)};return S.toString=()=>D,v.serviceIds.set(D,S),S}e.createDecorator=C;function T(D){return D}e.refineServiceDecorator=T;function E(D){return function(S,k,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(D,S,i,!0)}}e.optional=E}),define(be[146],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,v.createDecorator)("modelService");function R(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(be[147],we([0,1,3,57,6,22,82,60,146]),function(J,e,v,R,C,T,E,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(c){return typeof c=="string"?!1:Array.isArray(c)?c.every(k):!!c.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new v.Emitter}get onDidChange(){return this._onDidChange.event}register(g,r){let a={selector:g,provider:r,_score:-1,_time:this._clock++};return this._entries.push(a),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(a){let p=this._entries.indexOf(a);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),a=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const r=[];for(let a of this._entries)a._score>0&&r.push(a.provider);return r}ordered(g){const r=[];return this._orderedForEach(g,a=>r.push(a.provider)),r}orderedGroups(g){const r=[];let a,p;return this._orderedForEach(g,m=>{a&&p===m._score?a.push(m.provider):(p=m._score,a=[m.provider],r.push(a))}),r}_orderedForEach(g,r){if(!!g){this._updateScores(g);for(const a of this._entries)a._score>0&&r(a)}}_updateScores(g){let r={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let a of this._entries)if(a._score=(0,D.score)(a.selector,g.uri,g.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(g)),k(a.selector)&&a._score>0){for(let p of this._entries)p._score=0;a._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(g,r){return g._score<r._score?1:g._score>r._score?-1:g._time<r._time?1:g._time>r._time?-1:0}}e.LanguageFeatureRegistry=i;class A{constructor(g,r,a=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=r,this.max=a,this._cache=new T.LRUCache(50,.7)}_key(g){return g.id+(0,R.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const r=this._key(g),a=this._cache.get(r);return this._clamp(a==null?void 0:a.value)}update(g,r){const a=this._key(g);let p=this._cache.get(a);return p||(p=new E.MovingAverage,this._cache.set(a,p)),p.update(r),this.get(g)}}e.LanguageFeatureRequestDelays=A}),define(be[63],we([0,1,2,32,147,120,36]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class S{constructor(_,F){this.language=_,this.id=F}}e.LanguageIdentifier=S;var k;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var i;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var A;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&1792)>>>8}static getFontStyle(_){return(_&14336)>>>11}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let F=this.getForeground(_),N="mtk"+F,z=this.getFontStyle(_);return z&1&&(N+=" mtki"),z&2&&(N+=" mtkb"),z&4&&(N+=" mtku"),N}static getInlineStyleFromMetadata(_,F){const N=this.getForeground(_),z=this.getFontStyle(_);let ce=`color: ${F[N]};`;return z&1&&(ce+="font-style: italic;"),z&2&&(ce+="font-weight: bold;"),z&4&&(ce+="text-decoration: underline;"),ce}}e.TokenMetadata=g;var r;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(_){const F=h[_];let N=F&&E.iconRegistry.get(F);return N||(console.info("No codicon found for CompletionItemKind "+_),N=E.Codicon.symbolProperty),N.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(_,F){let N=h[_];return typeof N=="undefined"&&!F&&(N=9),N}}();var a;(function(h){h[h.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(y=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function f(h){return h&&v.URI.isUri(h.uri)&&R.Range.isIRange(h.range)&&(R.Range.isIRange(h.originSelectionRange)||R.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=f;var t;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(h){h[h.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var s;(function(h){const _=new Map;_.set("file",0),_.set("module",1),_.set("namespace",2),_.set("package",3),_.set("class",4),_.set("method",5),_.set("property",6),_.set("field",7),_.set("constructor",8),_.set("enum",9),_.set("interface",10),_.set("function",11),_.set("variable",12),_.set("constant",13),_.set("string",14),_.set("number",15),_.set("boolean",16),_.set("array",17),_.set("object",18),_.set("key",19),_.set("null",20),_.set("enum-member",21),_.set("struct",22),_.set("event",23),_.set("operator",24),_.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function N(de){return _.get(de)}h.fromString=N;function z(de){return F.get(de)}h.toString=z;function ce(de,B){const j=F.get(de);let W=j&&E.iconRegistry.get("symbol-"+j);return W||(console.info("No codicon found for SymbolKind "+de),W=E.Codicon.symbolProperty),`${B?"inline":"block"} ${W.classNames}`}h.toCssClassName=ce})(s=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(_){this.value=_}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var u;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var w;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(w=e.CommentMode||(e.CommentMode={}));var b;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var I;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(I=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[148],we([0,1,6,10,4,3,45,43]),function(J,e,v,R,C,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,C.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(S,k){if(!S)throw new Error("invalid command");if(typeof S=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:S,handler:k})}if(S.description){const r=[];for(let p of S.description.args)r.push(p.constraint);const a=S.handler;S.handler=function(p,...m){return(0,R.validateConstraints)(m,r),a(p,...m)}}const{id:i}=S;let A=this._commands.get(i);A||(A=new E.LinkedList,this._commands.set(i,A));let c=A.unshift(S),g=(0,v.toDisposable)(()=>{c();const r=this._commands.get(i);(r==null?void 0:r.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),g}registerCommandAlias(S,k){return e.CommandsRegistry.registerCommand(S,(i,...A)=>i.get(e.ICommandService).executeCommand(k,...A))}getCommand(S){const k=this._commands.get(S);if(!(!k||k.isEmpty()))return D.Iterable.first(k)}getCommands(){const S=new Map;for(const k of this._commands.keys()){const i=this.getCommand(k);i&&S.set(k,i)}return S}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>v.Disposable.None,onDidExecuteCommand:()=>v.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(be[64],we([0,1,8,4,21]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=C.userAgent||"";const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",C.isMacintosh),E.set("isLinux",C.isLinux),E.set("isWindows",C.isWindows),E.set("isWeb",C.isWeb),E.set("isMacNative",C.isMacintosh&&!C.isWeb),E.set("isEdge",T.indexOf("Edg/")>=0),E.set("isFirefox",T.indexOf("Firefox")>=0),E.set("isChrome",T.indexOf("Chrome")>=0),E.set("isSafari",T.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var S;(function(h){h[h.False=0]="False",h[h.True=1]="True",h[h.Defined=2]="Defined",h[h.Not=3]="Not",h[h.Equals=4]="Equals",h[h.NotEquals=5]="NotEquals",h[h.And=6]="And",h[h.Regex=7]="Regex",h[h.NotRegex=8]="NotRegex",h[h.Or=9]="Or",h[h.In=10]="In",h[h.NotIn=11]="NotIn",h[h.Greater=12]="Greater",h[h.GreaterEquals=13]="GreaterEquals",h[h.Smaller=14]="Smaller",h[h.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return A.INSTANCE}static true(){return c.INSTANCE}static has(_){return g.create(_)}static equals(_,F){return r.create(_,F)}static notEquals(_,F){return m.create(_,F)}static regex(_,F){return n.create(_,F)}static in(_,F){return a.create(_,F)}static not(_){return y.create(_)}static and(..._){return o.create(_)}static or(..._){return u.create(_)}static greater(_,F){return l.create(_,F)}static less(_,F){return f.create(_,F)}static deserialize(_,F=!1){if(!!_)return this._deserializeOrExpression(_,F)}static _deserializeOrExpression(_,F){let N=_.split("||");return u.create(N.map(z=>this._deserializeAndExpression(z,F)))}static _deserializeAndExpression(_,F){let N=_.split("&&");return o.create(N.map(z=>this._deserializeOne(z,F)))}static _deserializeOne(_,F){if(_=_.trim(),_.indexOf("!=")>=0){let N=_.split("!=");return m.create(N[0].trim(),this._deserializeValue(N[1],F))}if(_.indexOf("==")>=0){let N=_.split("==");return r.create(N[0].trim(),this._deserializeValue(N[1],F))}if(_.indexOf("=~")>=0){let N=_.split("=~");return n.create(N[0].trim(),this._deserializeRegexValue(N[1],F))}if(_.indexOf(" in ")>=0){let N=_.split(" in ");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const N=_.split(">=");return d.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const N=_.split(">");return l.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const N=_.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const N=_.split("<");return f.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(_)?y.create(_.substr(1).trim()):g.create(_)}static _deserializeValue(_,F){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let N=/^'([^']*)'$/.exec(_);return N?N[1].trim():_}static _deserializeRegexValue(_,F){if((0,v.isFalsyOrWhitespace)(_)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=_.indexOf("/"),z=_.lastIndexOf("/");if(N===z||N<0){if(F)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let ce=_.slice(N+1,z),de=_[z+1]==="i"?"i":"";try{return new RegExp(ce,de)}catch(B){if(F)throw new Error(`bad regexp-value '${_}', parse error: ${B}`);return console.warn(`bad regexp-value '${_}', parse error: ${B}`),null}}}e.ContextKeyExpr=k;function i(h,_){return h.cmp(_)}class A{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=A,A.INSTANCE=new A;class c{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return A.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class g{constructor(_){this.key=_,this.type=2}static create(_){const F=E.get(_);return typeof F=="boolean"?F?c.INSTANCE:A.INSTANCE:new g(_)}cmp(_){return _.type!==this.type?this.type-_.type:b(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return y.create(this.key)}}e.ContextKeyDefinedExpr=g;class r{constructor(_,F){this.key=_,this.value=F,this.type=4}static create(_,F){if(typeof F=="boolean")return F?g.create(_):y.create(_);const N=E.get(_);return typeof N=="boolean"?F===(N?"true":"false")?c.INSTANCE:A.INSTANCE:new r(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class a{constructor(_,F){this.key=_,this.valueKey=F,this.type=10}static create(_,F){return new a(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}evaluate(_){const F=_.getValue(this.valueKey),N=_.getValue(this.key);return Array.isArray(F)?F.indexOf(N)>=0:typeof N=="string"&&typeof F=="object"&&F!==null?D.call(F,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=a;class p{constructor(_){this._actual=_,this.type=11}static create(_){return new p(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new p(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class m{constructor(_,F){this.key=_,this.value=F,this.type=5}static create(_,F){if(typeof F=="boolean")return F?y.create(_):g.create(_);const N=E.get(_);return typeof N=="boolean"?F===(N?"true":"false")?A.INSTANCE:c.INSTANCE:new m(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class y{constructor(_){this.key=_,this.type=3}static create(_){const F=E.get(_);return typeof F=="boolean"?F?A.INSTANCE:c.INSTANCE:new y(_)}cmp(_){return _.type!==this.type?this.type-_.type:b(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=y;class l{constructor(_,F){this.key=_,this.value=F,this.type=12}static create(_,F){return new l(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=l;class d{constructor(_,F){this.key=_,this.value=F,this.type=13}static create(_,F){return new d(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=d;class f{constructor(_,F){this.key=_,this.value=F,this.type=14}static create(_,F){return new f(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerExpr=f;class t{constructor(_,F){this.key=_,this.value=F,this.type=15}static create(_,F){return new t(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(_,F){this.key=_,this.regexp=F,this.type=7}static create(_,F){return new n(_,F)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const F=this.regexp?this.regexp.source:"",N=_.regexp?_.regexp.source:"";return F<N?-1:F>N?1:0}equals(_){if(_.type===this.type){const F=this.regexp?this.regexp.source:"",N=_.regexp?_.regexp.source:"";return this.key===_.key&&F===N}return!1}evaluate(_){let F=_.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(_){this._actual=_,this.type=8}static create(_){return new s(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new s(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class o{constructor(_){this.expr=_,this.type=6}static create(_){return o._normalizeArr(_)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const z=i(this.expr[F],_.expr[F]);if(z!==0)return z}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(_.expr[F]))return!1;return!0}return!1}evaluate(_){for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].evaluate(_))return!1;return!0}static _normalizeArr(_){const F=[];let N=!1;for(const z of _)if(!!z){if(z.type===1){N=!0;continue}if(z.type===0)return A.INSTANCE;if(z.type===6){F.push(...z.expr);continue}F.push(z)}if(F.length===0&&N)return c.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(i);F.length>1;){const z=F[F.length-1];if(z.type!==9)break;F.pop();const ce=F.pop(),de=u.create(z.expr.map(B=>o.create([B,ce])));de&&(F.push(de),F.sort(i))}return F.length===1?F[0]:new o(F)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let F of this.expr)_.push(...F.keys());return _}map(_){return new o(this.expr.map(F=>F.map(_)))}negate(){let _=[];for(let F of this.expr)_.push(F.negate());return u.create(_)}}e.ContextKeyAndExpr=o;class u{constructor(_){this.expr=_,this.type=9}static create(_){const F=u._normalizeArr(_);if(F.length!==0)return F.length===1?F[0]:new u(F)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const z=i(this.expr[F],_.expr[F]);if(z!==0)return z}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(_.expr[F]))return!1;return!0}return!1}evaluate(_){for(let F=0,N=this.expr.length;F<N;F++)if(this.expr[F].evaluate(_))return!0;return!1}static _normalizeArr(_){let F=[],N=!1;if(_){for(let z=0,ce=_.length;z<ce;z++){const de=_[z];if(!!de){if(de.type===0){N=!0;continue}if(de.type===1)return[c.INSTANCE];if(de.type===9){F=F.concat(de.expr);continue}F.push(de)}}if(F.length===0&&N)return[A.INSTANCE];F.sort(i)}return F}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let F of this.expr)_.push(...F.keys());return _}map(_){return new u(this.expr.map(F=>F.map(_)))}negate(){let _=[];for(let N of this.expr)_.push(N.negate());const F=N=>N.type===9?N.expr:[N];for(;_.length>1;){const N=_.shift(),z=_.shift(),ce=[];for(const de of F(N))for(const B of F(z))ce.push(k.and(de,B));_.unshift(k.or(...ce))}return _[0]}}e.ContextKeyOrExpr=u;class w extends g{constructor(_,F,N){super(_);this._defaultValue=F,typeof N=="object"?w._info.push(Object.assign(Object.assign({},N),{key:_})):N!==!0&&w._info.push({key:_,description:N,type:F!=null?typeof F:void 0})}static all(){return w._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(_){return k.equals(this.key,_)}notEqualsTo(_){return k.notEquals(this.key,_)}}e.RawContextKey=w,w._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(h,_){return h<_?-1:h>_?1:0}function I(h,_,F,N){return h<F?-1:h>F?1:_<N?-1:_>N?1:0}}),define(be[149],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],we([0,1,8,4]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class E{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,A){if(typeof i=="undefined"||i===null)return typeof A=="undefined"||A===null;if(typeof A=="undefined"||A===null)return!1;if(typeof i=="string"||typeof A=="string"){let c=typeof i=="string"?i:i.value,g=typeof A=="string"?A:A.value;return v.equalsIgnoreCase(c,g)}return i._lower===A._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=E;function D(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function S(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[150],we([0,1,8,26]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(g,r){return g.uuid&&r.uuid?g.uuid===r.uuid:g.id===r.id?!0:(0,v.compareIgnoreCase)(g.id,r.id)===0}e.areSameExtensions=C;class T{constructor(r,a){this.version=a,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof T?C(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=T;function E(g,r){return`${g}.${r}`}e.getExtensionId=E;function D(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function S(g,r){return D(E(g,r))}e.getGalleryExtensionId=S;function k(g,r){const a=[],p=m=>{for(const y of a)if(y.some(l=>C(r(l),r(m))))return y;return null};for(const m of g){const y=p(m);y?y.push(m):a.push([m])}return a}e.groupByExtension=k;function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function A(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function c(g){const r=new Set;for(const a of g)a.malicious&&r.add(a.id.id);return r}e.getMaliciousExtensionsSet=c}),define(be[65],we([0,1,127,14,2,4,8,10,22]),function(J,e,v,R,C,T,E,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function k(B){return B.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var A;(function(B){B[B.Readonly=1]="Readonly"})(A=e.FilePermission||(e.FilePermission={}));var c;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=g;function r(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=r;function a(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function p(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=p;var m;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(j,W){super(j);this.code=W}}e.FileSystemProviderError=y;function l(B,j){const W=new y(B.toString(),j);return f(W,j),W}e.createFileSystemProviderError=l;function d(B){return B||l((0,v.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=d;function f(B,j){return B.name=j?`${j} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=f;function t(B){if(!B)return m.Unknown;if(B instanceof y)return B.code;const j=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!j)return m.Unknown;switch(j[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=t;function n(B){if(B instanceof I)return B.fileOperationResult;switch(t(B)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class o{constructor(j,W,P){this.resource=j,this.operation=W,this.target=P}isOperation(j){return this.operation===j}}e.FileOperationEvent=o;var u;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class w{constructor(j,W){this.ignorePathCasing=W,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=j;for(const P of j)switch(P.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(P.resource,P);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(P.resource,P);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(P.resource,P);break}}contains(j,...W){return this.doContains(j,{includeChildren:!1},...W)}affects(j,...W){return this.doContains(j,{includeChildren:!0},...W)}doContains(j,W,...P){var H,L,$,Q,q,ae;if(!j)return!1;const fe=P.length>0;return!!((!fe||P.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get(j))||W.includeChildren&&((L=this.added)===null||L===void 0?void 0:L.findSuperstr(j)))||(!fe||P.includes(0))&&((($=this.updated)===null||$===void 0?void 0:$.get(j))||W.includeChildren&&((Q=this.updated)===null||Q===void 0?void 0:Q.findSuperstr(j)))||(!fe||P.includes(2))&&(((q=this.deleted)===null||q===void 0?void 0:q.findSubstr(j))||W.includeChildren&&((ae=this.deleted)===null||ae===void 0?void 0:ae.findSuperstr(j))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(j){const W=[],P=j===1?this.added:j===0?this.updated:this.deleted;if(P)for(const[,H]of P)W.push(H);return W}filter(j){return new w(this.changes.filter(W=>j(W)),this.ignorePathCasing)}}e.FileChangesEvent=w;function b(B,j,W){return!B||!j||B===j||j.length>B.length?!1:(j.charAt(j.length-1)!==R.sep&&(j+=R.sep),W?(0,E.startsWithIgnoreCase)(B,j):B.indexOf(j)===0)}e.isParent=b;class I extends Error{constructor(j,W,P){super(j);this.fileOperationResult=W,this.options=P}static isFileOperationError(j){return j instanceof Error&&!(0,D.isUndefinedOrNull)(j.fileOperationResult)}}e.FileOperationError=I;var h;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(h=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=F;async function N(B,j){if(!j.canHandleResource(C.URI.from({scheme:B.scheme})))return new Promise(W=>{const P=j.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===B.scheme&&H.added&&(P.dispose(),W())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(j){return(0,D.isNumber)(j)||(j=0),j<z.KB?(0,v.localize)(1,null,j.toFixed(0)):j<z.MB?(0,v.localize)(2,null,(j/z.KB).toFixed(2)):j<z.GB?(0,v.localize)(3,null,(j/z.MB).toFixed(2)):j<z.TB?(0,v.localize)(4,null,(j/z.GB).toFixed(2)):(0,v.localize)(5,null,(j/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var ce;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(ce=e.Arch||(e.Arch={}));function de(B){return{maxFileSize:B===0?300*z.MB:16*z.GB,maxHeapSize:B===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=de}),define(be[66],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...C){this._entries=new Map;for(let[T,E]of C)this.set(T,E)}set(C,T){const E=this._entries.get(C);return this._entries.set(C,T),E}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=v}),define(be[151],we([0,1,12,145,90,4,66,11]),function(J,e,v,R,C,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class k extends Error{constructor(r){var a;super("cyclic dependency between services");this.message=(a=r.findCycleSlow())!==null&&a!==void 0?a:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class i{constructor(r=new E.ServiceCollection,a=!1,p){this._activeInstantiations=new Set,this._services=r,this._strict=a,this._parent=p,this._services.set(T.IInstantiationService,this)}createChild(r){return new i(r,this._strict,this)}invokeFunction(r,...a){let p=c.traceInvocation(r),m=!1;try{return r({get:(l,d)=>{if(m)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(l,p);if(!f&&d!==T.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return f}},...a)}finally{m=!0,p.stop()}}createInstance(r,...a){let p,m;return r instanceof C.SyncDescriptor?(p=c.traceCreation(r.ctor),m=this._createInstance(r.ctor,r.staticArguments.concat(a),p)):(p=c.traceCreation(r),m=this._createInstance(r,a,p)),p.stop(),m}_createInstance(r,a=[],p){let m=T._util.getServiceDependencies(r).sort((d,f)=>d.index-f.index),y=[];for(const d of m){let f=this._getOrCreateServiceInstance(d.id,p);if(!f&&this._strict&&!d.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${d.id}.`);y.push(f)}let l=m.length>0?m[0].index:a.length;if(a.length!==l){console.warn(`[createInstance] First service dependency of ${r.name} at position ${l+1} conflicts with ${a.length} static arguments`);let d=l-a.length;d>0?a=a.concat(new Array(d)):a=a.slice(0,l)}return new r(...[...a,...y])}_setServiceInstance(r,a){if(this._services.get(r)instanceof C.SyncDescriptor)this._services.set(r,a);else if(this._parent)this._parent._setServiceInstance(r,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let a=this._services.get(r);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):a}_getOrCreateServiceInstance(r,a){let p=this._getServiceInstanceOrDescriptor(r);return p instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,p,a.branch(r,!0)):(a.branch(r,!1),p)}_safeCreateAndCacheServiceInstance(r,a,p){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,a,p)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,a,p){const m=new R.Graph(d=>d.id.toString());let y=0;const l=[{id:r,desc:a,_trace:p}];for(;l.length;){const d=l.pop();if(m.lookupOrInsertNode(d),y++>1e3)throw new k(m);for(let f of T._util.getServiceDependencies(d.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(f.id);if(!t&&!f.optional&&console.warn(`[createInstance] ${r} depends on ${f.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const n={id:f.id,desc:t,_trace:d._trace.branch(f.id,!0)};m.insertEdge(d,n),l.push(n)}}}for(;;){const d=m.roots();if(d.length===0){if(!m.isEmpty())throw new k(m);break}for(const{data:f}of d){if(this._getServiceInstanceOrDescriptor(f.id)instanceof C.SyncDescriptor){const n=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,n)}m.removeNode(f)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,a,p=[],m,y){if(this._services.get(r)instanceof C.SyncDescriptor)return this._createServiceInstance(a,p,m,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,a,p,m,y);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(r,a=[],p,m){if(p){const y=new D.IdleValue(()=>this._createInstance(r,a,m));return new Proxy(Object.create(null),{get(l,d){if(d in l)return l[d];let f=y.value,t=f[d];return typeof t!="function"||(t=t.bind(f),l[d]=t),t},set(l,d,f){return y.value[d]=f,!0}})}else return this._createInstance(r,a,m)}}e.InstantiationService=i;var A;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(A||(A={}));class c{constructor(r,a){this.type=r,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return S?new c(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(r){return S?new c(0,r.name):c._None}branch(r,a){let p=new c(2,r.toString());return this._dep.push([r,a,p]),p}stop(){let r=Date.now()-this._start;c._totals+=r;let a=!1;function p(y,l){let d=[],f=new Array(y+1).join("	");for(const[t,n,s]of l._dep)if(n&&s){a=!0,d.push(`${f}CREATES -> ${t}`);let o=p(y+1,s);o&&d.push(o)}else d.push(`${f}uses -> ${t}`);return d.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(r>2||a)&&console.log(m.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(be[16],we([0,1,4,6,21,3,61]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function D(){return new Date().toISOString()}var S;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class k extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class i extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(S.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(S.Error,this.format(s))}else this.log(S.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let o=t[s];if(typeof o=="object")try{o=JSON.stringify(o)}catch(u){}n+=(s>0?" ":"")+o}return n}}e.AbstractMessageLogger=i;class A extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...n){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}debug(t,...n){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}info(t,...n){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}warn(t,...n){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...n):console.warn(`[main ${D()}]`,t,...n))}error(t,...n){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}critical(t,...n){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=A;class c extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=c;class g extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,E.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class r extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class a extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=a;class p extends R.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?S.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class m{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=m;function y(f){if(f.verbose)return S.Trace;if(typeof f.logLevel=="string"){const t=l(f.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function l(f){switch(f){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function d(f){switch(f){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=d}),define(be[91],we([0,1,4,128,47]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var E;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(E=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(r,a){return a-r}S.compare=k;const i=Object.create(null);i[S.Error]=(0,R.localize)(0,null),i[S.Warning]=(0,R.localize)(1,null),i[S.Info]=(0,R.localize)(2,null);function A(r){return i[r]||""}S.toString=A;function c(r){switch(r){case C.default.Error:return S.Error;case C.default.Warning:return S.Warning;case C.default.Info:return S.Info;case C.default.Ignore:return S.Hint}}S.fromSeverity=c;function g(r){switch(r){case S.Error:return C.default.Error;case S.Warning:return C.default.Warning;case S.Info:return C.default.Info;case S.Hint:return C.default.Ignore}}S.toSeverity=g}(E=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(S){const k="";function i(c){return A(c,!0)}S.makeKey=i;function A(c,g){let r=[k];return c.source?r.push(c.source.replace("\xA6","\\\xA6")):r.push(k),c.code?typeof c.code=="string"?r.push(c.code.replace("\xA6","\\\xA6")):r.push(c.code.value.replace("\xA6","\\\xA6")):r.push(k),c.severity!==void 0&&c.severity!==null?r.push(E.toString(c.severity)):r.push(k),c.message&&g?r.push(c.message.replace("\xA6","\\\xA6")):r.push(k),c.startLineNumber!==void 0&&c.startLineNumber!==null?r.push(c.startLineNumber.toString()):r.push(k),c.startColumn!==void 0&&c.startColumn!==null?r.push(c.startColumn.toString()):r.push(k),c.endLineNumber!==void 0&&c.endLineNumber!==null?r.push(c.endLineNumber.toString()):r.push(k),c.endColumn!==void 0&&c.endColumn!==null?r.push(c.endColumn.toString()):r.push(k),r.push(k),r.join("\xA6")}S.makeKeyOptionalMessage=A})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,v.createDecorator)("markerService")}),define(be[152],we([0,1,47,4,3]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=(0,R.createDecorator)("notificationService");var T;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var E;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(E=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new S,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=D;class S{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=S});var qe=this&&this.__decorate||function(J,e,v,R){var C=arguments.length,T=C<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,v,R);else for(var D=J.length-1;D>=0;D--)(E=J[D])&&(T=(C<3?E(T):C>3?E(e,v,T):E(e,v))||T);return C>3&&T&&Object.defineProperty(e,v,T),T},Ke=this&&this.__param||function(J,e){return function(v,R){e(v,R,J)}};define(be[153],we([0,1,4,20,6,11]),function(J,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,v.createDecorator)("progressService");var E;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(E=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(A){this.callback=A}get value(){return this._value}report(A){this._value=A,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let S=class extends C.Disposable{constructor(A,c){super();this.deferred=new T.DeferredPromise,c.withProgress(A,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(A){this.reporter?this.reporter.report(A):this.lastStep=A}};S=qe([Ke(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends C.Disposable{constructor(A){super();this.progressIndicator=A,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(A){this.stop();const c=++this.currentOperationId,g=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},A),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:g.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(A){this.currentOperationId===A&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,v.createDecorator)("editorProgressService")}),define(be[29],we([0,1,10,42]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(E,D){R.ok(v.isString(E)),R.ok(v.isObject(D)),R.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,D)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new C}),define(be[92],we([0,1,29,3]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,k){this.schemasById[C(S)]=k,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new T;v.Registry.add(e.Extensions.JSONContribution,E)}),define(be[67],we([0,1,125,3,29,10,92]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=C.Registry.as(E.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,y=!0){this.registerConfigurations([m],y)}registerConfigurations(m,y=!0){const l=[];m.forEach(d=>{l.push(...this.validateAndRegisterProperties(d,y,d.extensionInfo)),this.configurationContributors.push(d),this.registerJSONConfiguration(d)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(m){const y=[],l=d=>{if(d.properties)for(const f in d.properties)y.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,d.properties[f]);d.allOf&&d.allOf.forEach(f=>l(f))};for(const d of m){l(d);const f=this.configurationContributors.indexOf(d);f!==-1&&this.configurationContributors.splice(f,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}registerDefaultConfigurations(m){const y=[],l=[];for(const d of m)for(const f in d)if(y.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]=Object.assign(Object.assign({},this.defaultValues[f]||{}),d[f]);const t={type:"object",default:this.defaultValues[f],description:v.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};l.push(A(f)),this.configurationProperties[f]=t,this.defaultLanguageConfigurationOverridesNode.properties[f]=t}else{this.defaultValues[f]=d[f];const t=this.configurationProperties[f];t&&(this.updatePropertyDefaultValue(f,t),this.updateSchema(f,t))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}deregisterDefaultConfigurations(m){const y=[];for(const l of m)for(const d in l)if(y.push(d),delete this.defaultValues[d],e.OVERRIDE_PROPERTY_PATTERN.test(d))delete this.configurationProperties[d],delete this.defaultLanguageConfigurationOverridesNode.properties[d];else{const f=this.configurationProperties[d];f&&(this.updatePropertyDefaultValue(d,f),this.updateSchema(d,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const y of m)this.overrideIdentifiers.add(y);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,y=!0,l,d=3){var f;d=T.isUndefinedOrNull(m.scope)?d:m.scope;let t=[],n=m.properties;if(n)for(let o in n){if(y&&r(o)){delete n[o];continue}const u=n[o];if(this.updatePropertyDefaultValue(o,u),e.OVERRIDE_PROPERTY_PATTERN.test(o)?u.scope=void 0:(u.scope=T.isUndefinedOrNull(u.scope)?d:u.scope,u.restricted=T.isUndefinedOrNull(u.restricted)?!!((f=l==null?void 0:l.restrictedConfigurations)===null||f===void 0?void 0:f.includes(o)):u.restricted),n[o].hasOwnProperty("included")&&!n[o].included){this.excludedConfigurationProperties[o]=n[o],delete n[o];continue}else this.configurationProperties[o]=n[o];!n[o].deprecationMessage&&n[o].markdownDeprecationMessage&&(n[o].deprecationMessage=n[o].markdownDeprecationMessage),t.push(o)}let s=m.allOf;if(s)for(let o of s)t.push(...this.validateAndRegisterProperties(o,y,l,d));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const y=l=>{let d=l.properties;if(d)for(const t in d)this.updateSchema(t,d[t]);let f=l.allOf;f&&f.forEach(y)};y(m)}updateSchema(m,y){switch(e.allSettings.properties[m]=y,y.scope){case 1:e.applicationSettings.properties[m]=y;break;case 2:e.machineSettings.properties[m]=y;break;case 6:e.machineOverridableSettings.properties[m]=y;break;case 3:e.windowSettings.properties[m]=y;break;case 4:e.resourceSettings.properties[m]=y;break;case 5:e.resourceSettings.properties[m]=y,this.resourceLanguageSettingsSchema.properties[m]=y;break}}removeFromSchema(m,y){switch(delete e.allSettings.properties[m],y.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const y=`[${m}]`,l={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(y,l),e.allSettings.properties[y]=l,e.applicationSettings.properties[y]=l,e.machineSettings.properties[y]=l,e.machineOverridableSettings.properties[y]=l,e.windowSettings.properties[y]=l,e.resourceSettings.properties[y]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,y){let l=this.defaultValues[m];T.isUndefined(l)&&(l=y.default),T.isUndefined(l)&&(l=c(y.type)),y.default=l}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function A(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=A;function c(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const g=new k;C.Registry.add(e.Extensions.Configuration,g);function r(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?v.localize(5,null,p):g.getConfigurationProperties()[p]!==void 0?v.localize(6,null,p):null:v.localize(4,null)}e.validateProperty=r;function a(){const p=[],m=g.getConfigurationProperties();for(const y of Object.keys(m))p.push([y,m[y].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=a}),define(be[93],we([0,1,23,10,2,29,4,67]),function(J,e,v,R,C,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function S(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof C.URI)}e.isConfigurationOverrides=S;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function A(n,s){const o=s?n?s.keys.filter(F=>n.keys.indexOf(F)===-1):[...s.keys]:[],u=n?s?n.keys.filter(F=>s.keys.indexOf(F)===-1):[...n.keys]:[],w=[];if(s&&n){for(const F of n.keys)if(s.keys.indexOf(F)!==-1){const N=m(n.contents,F),z=m(s.contents,F);v.equals(N,z)||w.push(F)}}const b=[],I=F=>{const N={};for(const z of F)for(const ce of z.identifiers)N[f(ce)]=z;return N},h=s?I(s.overrides):{},_=n?I(n.overrides):{};if(Object.keys(h).length)for(const F of o){const N=h[F];N&&b.push([(0,D.overrideIdentifierFromKey)(F),N.keys])}if(Object.keys(_).length)for(const F of u){const N=_[F];N&&b.push([(0,D.overrideIdentifierFromKey)(F),N.keys])}if(Object.keys(h).length&&Object.keys(_).length)for(const F of w){const N=_[F],z=h[F];if(N&&z){const ce=A({contents:N.contents,keys:N.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});b.push([(0,D.overrideIdentifierFromKey)(F),[...ce.added,...ce.removed,...ce.updated]])}}return{added:o,removed:u,updated:w,overrides:b}}e.compare=A;function c(n,s){const o=[];for(const u of Object.keys(n))if(D.OVERRIDE_PROPERTY_PATTERN.test(u)){const w={};for(const b in n[u])w[b]=n[u][b];o.push({identifiers:[(0,D.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(w),contents:g(w,s)})}return o}e.toOverrides=c;function g(n,s){const o=Object.create(null);for(let u in n)r(o,u,n[u],s);return o}e.toValuesTree=g;function r(n,s,o,u){const w=s.split("."),b=w.pop();let I=n;for(let h=0;h<w.length;h++){let _=w[h],F=I[_];switch(typeof F){case"undefined":F=I[_]=Object.create(null);break;case"object":break;default:u(`Ignoring ${s} as ${w.slice(0,h+1).join(".")} is ${JSON.stringify(F)}`);return}I=F}if(typeof I=="object"&&I!==null)try{I[b]=o}catch(h){u(`Ignoring ${s} as ${w.join(".")} is ${JSON.stringify(I)}`)}else u(`Ignoring ${s} as ${w.join(".")} is ${JSON.stringify(I)}`)}e.addToValueTree=r;function a(n,s){const o=s.split(".");p(n,o)}e.removeFromValueTree=a;function p(n,s){const o=s.shift();if(s.length===0){delete n[o];return}if(Object.keys(n).indexOf(o)!==-1){const u=n[o];typeof u=="object"&&!Array.isArray(u)&&(p(u,s),Object.keys(u).length===0&&delete n[o])}}function m(n,s,o){function u(I,h){let _=I;for(const F of h){if(typeof _!="object"||_===null)return;_=_[F]}return _}const w=s.split("."),b=u(n,w);return typeof b=="undefined"?o:b}e.getConfigurationValue=m;function y(n,s,o){Object.keys(s).forEach(u=>{u!=="__proto__"&&(u in n?R.isObject(n[u])&&R.isObject(s[u])?y(n[u],s[u],o):o&&(n[u]=s[u]):n[u]=s[u])})}e.merge=y;function l(){const n=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=l;function d(){const n=Object.create(null),s=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let o in s){let u=s[o].default;r(n,o,u,w=>console.error(`Conflict in default settings: ${w}`))}return n}e.getDefaultValues=d;function f(n){return`[${n}]`}e.keyFromOverrideIdentifier=f;function t(n,s,o){const u=n.inspect(s),w=n.inspect(o);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:u.defaultValue}e.getMigratedSettingValue=t}),define(be[154],we([0,1,44,22,13,10,23,2,67,93,29,6,3]),function(J,e,v,R,C,T,E,D,S,k,i,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,k.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const o of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[o],w=n[o];w&&(typeof u=="object"&&typeof w=="object"?(u=E.deepClone(u),this.mergeContents(u,w)):u=w),s[o]=u}return new g(s,this.keys,this.overrides)}merge(...t){const n=E.deepClone(this.contents),s=E.deepClone(this.overrides),o=[...this.keys];for(const u of t){this.mergeContents(n,u.contents);for(const w of u.overrides){const[b]=s.filter(I=>C.equals(I.identifiers,w.identifiers));b?this.mergeContents(b.contents,w.contents):s.push(E.deepClone(w))}for(const w of u.keys)o.indexOf(w)===-1&&o.push(w)}return new g(n,o,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&T.isObject(t[s])&&T.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=E.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=g;class r extends g{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),s=[];for(const o of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(o)&&s.push({identifiers:[(0,S.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,k.toValuesTree)(t[o],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,n,s)}}e.DefaultConfigurationModel=r;class a{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:o,overrides:u,restricted:w}=this.doParseRaw(t,n);this._configurationModel=new g(s,o,u),this._restrictedConfigurations=w||[]}doParseContent(t){let n={},s=null,o=[],u=[],w=[];function b(h){Array.isArray(o)?o.push(h):s&&(o[s]=h)}let I={onObjectBegin:()=>{let h={};b(h),u.push(o),o=h,s=null},onObjectProperty:h=>{s=h},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let h=[];b(h),u.push(o),o=h,s=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:b,onError:(h,_,F)=>{w.push({error:h,offset:_,length:F})}};if(t)try{v.visit(t,I),n=o[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return n}doParseRaw(t,n){const s=i.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,s,!0,n);t=o.raw;const u=(0,k.toValuesTree)(t,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),w=Object.keys(t),b=(0,k.toOverrides)(t,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:u,keys:w,overrides:b,restricted:o.restricted}}filter(t,n,s,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.skipRestricted))return{raw:t,restricted:[]};const u={},w=[];for(let b in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(b)&&s){const I=this.filter(t[b],n,!1,o);u[b]=I.raw,w.push(...I.restricted)}else{const I=n[b],h=I?typeof I.scope!="undefined"?I.scope:3:void 0;(I==null?void 0:I.restricted)&&w.push(b),(h===void 0||o.scopes===void 0||o.scopes.includes(h))&&(o.skipRestricted&&(I==null?void 0:I.restricted)||(u[b]=t[b]))}return{raw:u,restricted:w}}}e.ConfigurationModelParser=a;class p extends A.Disposable{constructor(t,n,s,o){super();this.userSettingsResource=t,this.scopes=n,this.fileService=o,this._onDidChange=this._register(new c.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(c.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class m{constructor(t,n,s=new g,o=new g,u=new R.ResourceMap,w=new g,b=new R.ResourceMap,I=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=w,this._memoryConfigurationByResource=b,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new g,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const o=this.getConsolidateConfigurationModel(n,s),u=this.getFolderConfigurationModelForResource(n.resource,s),w=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,b=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),I=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),h=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,z=n.overrideIdentifier?w.override(n.overrideIdentifier).getValue(t):w.getValue(t),ce=o.getValue(t),de=C.distinct(C.flatten(o.overrides.map(B=>B.identifiers))).filter(B=>o.getOverrideValue(t,B)!==void 0);return{defaultValue:b,userValue:I,userLocalValue:h,userRemoteValue:_,workspaceValue:F,workspaceFolderValue:N,memoryValue:z,value:ce,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:n.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:w.getValue(t),override:n.overrideIdentifier?w.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:de.length?de:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(o=>S.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const u=(0,S.overrideIdentifierFromKey)(o),w=this._defaultConfiguration.getKeysForOverrideIdentifier(u),b=t.getKeysForOverrideIdentifier(u),I=[...b.filter(h=>w.indexOf(h)===-1),...w.filter(h=>b.indexOf(h)===-1),...w.filter(h=>!E.equals(this._defaultConfiguration.override(u).getValue(h),t.override(u).getValue(h)))];return[u,I]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:u}=(0,k.compare)(this.localUserConfiguration,t),w=[...n,...s,...o];return w.length&&this.updateLocalUserConfiguration(t),{keys:w,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:u}=(0,k.compare)(this.remoteUserConfiguration,t);let w=[...n,...s,...o];return w.length&&this.updateRemoteUserConfiguration(t),{keys:w,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:u}=(0,k.compare)(this.workspaceConfiguration,t);let w=[...n,...s,...o];return w.length&&this.updateWorkspaceConfiguration(t),{keys:w,overrides:u}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:u,removed:w,overrides:b}=(0,k.compare)(s,n);let I=[...o,...u,...w];return(I.length||!s)&&this.updateFolderConfiguration(t,n),{keys:I,overrides:b}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:u,overrides:w}=(0,k.compare)(n,void 0);return{keys:[...s,...o,...u],overrides:w}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const o=n.getFolder(t);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const u=this._memoryConfigurationByResource.get(t);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(n=s.merge(o),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:u}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:o,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((w,b)=>(w.set(D.URI.revive(b[0]),this.parseConfigurationModel(b[1])),w),new R.ResourceMap);return new m(n,s,new g,o,u,new g,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function y(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const t=new Set,n=new Map;for(const o of f)o.keys.forEach(u=>t.add(u)),o.overrides.forEach(([u,w])=>{const b=(0,R.getOrSet)(n,u,new Set);w.forEach(I=>b.add(I))});const s=[];return n.forEach((o,u)=>s.push([u,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=y;class l{constructor(t,n,s,o){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(b=>u.add(b)),t.overrides.forEach(([,b])=>b.forEach(I=>u.add(I))),this.affectedKeys=[...u.values()];const w=new g;this.affectedKeys.forEach(b=>w.setValue(b,{})),this.affectedKeysTree=w.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,u=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!E.equals(o,u)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,k.toValuesTree)({[n]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(t=t[o],!t)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=l;class d extends l{constructor(t,n,s,o){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=d}),define(be[68],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var R;(function(E){E[E.Unknown=0]="Unknown",E[E.DisableTrust=1]="DisableTrust",E[E.MachineTrusted=2]="MachineTrusted"})(R=e.RemoteTrustOption||(e.RemoteTrustOption={}));var C;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(D,S=C.Unknown,k){super(D);this._message=D,this._code=S,this._detail=k,this.isHandled=S===C.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(D){return D instanceof T&&D._code===C.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof T&&D._code===C.NoResolverFound}static isHandled(D){return D instanceof T&&D.isHandled}}e.RemoteAuthorityResolverError=T}),define(be[94],we([0,1,17]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function R(k){return k.scheme===v.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=R;function C(k){if(!!k){const i=k.indexOf("+");return i<0?k:k.substr(0,i)}}e.getRemoteName=C;function T(k){return k.scheme!==v.Schemas.file&&k.scheme!==v.Schemas.vscodeRemote}function E(k){if(k.folders.length)return k.folders.every(i=>T(i.uri))?k.folders[0].uri:void 0;if(k.configuration&&T(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=E;function D(k){var i;return(i=E(k))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=D;function S(k){return E(k)!==void 0}e.isVirtualWorkspace=S}),define(be[155],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,T,E=5){let D;return D=T(S=>{const k=typeof S=="string"?S:S.data;let i=this._terminalBufferMap.get(C);if(i){i.data.push(k);return}const A=setTimeout(()=>this.flushBuffer(C),E);i={data:[k],timeoutId:A,dispose:()=>{clearTimeout(A),this.flushBuffer(C),D.dispose()}},this._terminalBufferMap.set(C,i)}),D}stopBuffering(C){const T=this._terminalBufferMap.get(C);T&&T.dispose()}flushBuffer(C){const T=this._terminalBufferMap.get(C);T&&(this._terminalBufferMap.delete(C),this._callback(C,T.data.join("")))}}e.TerminalDataBufferer=v}),define(be[156],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(be[157],we([0,1,4,6,29,3,156,36]),function(J,e,v,R,C,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,v.createDecorator)("themeService");var S;(function(p){function m(y){return y&&typeof y=="object"&&typeof y.id=="string"}p.isThemeColor=m})(S=e.ThemeColor||(e.ThemeColor={}));function k(p){return{id:p}}e.themeColorFromId=k;var i;(function(p){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}p.isThemeIcon=m;const y=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function l(t){const n=y.exec(t);if(!!n){let[,s]=n;return{id:s}}}p.fromString=l;function d(t,n){let s=t.id;const o=s.lastIndexOf("~");return o!==-1&&(s=s.substring(0,o)),n&&(s=`${s}~${n}`),{id:s}}p.modify=d;function f(t,n){var s,o;return t.id===n.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((o=n.color)===null||o===void 0?void 0:o.id)}p.isEqual=f,p.asClassNameArray=D.CSSIcon.asClassNameArray,p.asClassName=D.CSSIcon.asClassName,p.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function A(p){switch(p){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=A,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,R.toDisposable)(()=>{const y=this.themingParticipants.indexOf(m);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new c;C.Registry.add(e.Extensions.ThemingContribution,g);function r(p){return g.onColorThemeChange(p)}e.registerThemingParticipant=r;class a extends R.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,y){let l=this.theme.getColor(m);return l&&y&&(l=y(l,this.theme)),l?l.toString():null}}e.Themable=a}),define(be[158],we([0,1,29,157,3,129,92,11,36]),function(J,e,v,R,C,T,E,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${S.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,y,l,d){const f=this.iconsById[m];if(f){if(l&&!f.description){f.description=l,this.iconSchema.properties[m].markdownDescription=`${l} $(${m})`;const s=this.iconReferenceSchema.enum.indexOf(m);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=l),this._onDidChange.fire()}return f}let t={id:m,description:l,defaults:y,deprecationMessage:d};this.iconsById[m]=t;let n={$ref:"#/definitions/icons"};return d&&(n.deprecationMessage=d),l&&(n.markdownDescription=`${l}: $(${m})`),this.iconSchema.properties[m]=n,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const y=this.iconReferenceSchema.enum.indexOf(m);y!==-1&&(this.iconReferenceSchema.enum.splice(y,1),this.iconReferenceSchema.enumDescriptions.splice(y,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,y){const l=this.iconFontsById[m];if(l)return l;let d={id:m,definition:y};return this.iconFontsById[m]=d,this._onDidChange.fire(),d}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(f,t)=>f.id.localeCompare(t.id),y=f=>{for(;R.ThemeIcon.isThemeIcon(f.defaults);)f=this.iconsById[f.defaults.id];return`codicon codicon-${f?f.id:""}`};let l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.iconsById).map(f=>this.iconsById[f]);for(const f of d.filter(t=>!!t.description).sort(m))l.push(`|<i class="${y(f)}"></i>|${f.id}|${R.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const f of d.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(m))l.push(`|<i class="${y(f)}"></i>|${f.id}|`);return l.join(`
`)}}const i=new k;v.Registry.add(e.Extensions.IconContribution,i);function A(p,m,y,l){return i.registerIcon(p,m,y,l)}e.registerIcon=A;function c(){return i}e.getIconRegistry=c;function g(){for(const p of S.iconRegistry.all)i.registerIcon(p.id,p.definition,p.description);S.iconRegistry.onDidRegister(p=>i.registerIcon(p.id,p.definition,p.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let r=v.Registry.as(E.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,i.getIconSchema());const a=new D.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=A("widget-close",S.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=A("goto-previous-location",S.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=A("goto-next-location",S.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=R.ThemeIcon.modify(S.Codicon.sync,"spin")}),define(be[48],we([0,1,2,25,4,22]),function(J,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var E;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function D(c){const g=c;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=D;function S(c){const g=c;return!!(g&&typeof g=="object"&&v.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=S;class k{constructor(g,r,a,p){this._id=g,this._configuration=a,this._ignorePathCasing=p,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class i{constructor(g,r){this.raw=r,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,R.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function A(c){return new i({uri:c,index:0,name:(0,R.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=A}),define(be[159],we([0,1,4,130,48,2,21,14,25,108,44,17,59,37,94]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const a=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(j){return(typeof j=="string"?(0,D.extname)(j):(0,S.extname)(j))===a}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function m(j){return j.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function y(j){return j.hasOwnProperty("folderUri")}e.isRecentFolder=y;function l(j){return j.hasOwnProperty("fileUri")}e.isRecentFile=l;function d(j){const W=j;return typeof(W==null?void 0:W.id)=="string"&&T.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=d;function f(j){if(j.configuration)return{id:j.id,configPath:j.configuration};if(j.folders.length===1)return{id:j.id,uri:j.folders[0].uri}}e.toWorkspaceIdentifier=f;function t(j){const W=j;return typeof(W==null?void 0:W.id)=="string"&&T.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=t;function n(j){const W=j;if(W==null?void 0:W.uri)return{id:W.id,uri:T.URI.revive(W.uri)};const P=j;if(P==null?void 0:P.configPath)return{id:P.id,configPath:T.URI.revive(P.configPath)};if(j==null?void 0:j.id)return{id:j.id}}e.reviveIdentifier=n;function s(j,W){return S.extUriBiasedIgnorePathCase.isEqualOrParent(j,W.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function o(j){return u(j)||w(j)}e.isStoredWorkspaceFolder=o;function u(j){const W=j;return typeof(W==null?void 0:W.path)=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=u;function w(j){const W=j;return typeof(W==null?void 0:W.uri)=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=w;function b(j,W,P,H,L=!E.isWindows,$){if(j.scheme!==H.scheme)return{name:P,uri:j.toString(!0)};let Q=W?void 0:$.relativePath(H,j);if(Q!==void 0)Q.length===0?Q=".":E.isWindows&&j.scheme===A.Schemas.file&&!L&&(Q=Q.replace(/\//g,"\\"));else if(j.scheme===A.Schemas.file)Q=j.fsPath,E.isWindows&&(Q=(0,c.normalizeDriveLetter)(Q),L&&(Q=(0,g.toSlashes)(Q)));else{if(!$.isEqualAuthority(j.authority,H.authority))return{name:P,uri:j.toString(!0)};Q=j.path}return{name:P,path:Q}}e.getStoredWorkspaceFolder=b;function I(j,W,P){let H=[],L=new Set;const $=P.dirname(W);for(let Q of j){let q;if(u(Q))Q.path&&(q=P.resolvePath($,Q.path));else if(w(Q))try{q=T.URI.parse(Q.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(ae){console.warn(ae)}if(q){let ae=P.getComparisonKey(q);if(!L.has(ae)){L.add(ae);const fe=Q.name||P.basenameOrAuthority(q);H.push(new C.WorkspaceFolder({uri:q,name:fe,index:H.length},Q))}}}return H}e.toWorkspaceFolders=I;function h(j,W,P,H,L){let $=_(W,j);const Q=L.dirname(W),q=L.dirname(H),ae=[],fe=F($.folders);for(const He of $.folders){const x=u(He)?L.resolvePath(Q,He.path):T.URI.parse(He.uri);let G;P?G=!1:G=!u(He)||(0,D.isAbsolute)(He.path),ae.push(b(x,G,He.name,q,fe,L))}const Le={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},xe=k.setProperty(j,["folders"],ae,Le);let Fe=k.applyEdits(j,xe);return $.remoteAuthority===(0,r.getRemoteAuthority)(H)&&(Fe=k.applyEdits(Fe,k.removeProperty(Fe,["remoteAuthority"],Le))),Fe}e.rewriteWorkspaceFileForNewLocation=h;function _(j,W){let P=i.parse(W);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(H=>o(H));else throw new Error(`${j} looks like an invalid workspace file.`);return P}function F(j){return E.isWindows?j.some(W=>u(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function N(j){return j.workspace&&typeof j.workspace=="object"&&typeof j.workspace.id=="string"&&typeof j.workspace.configPath=="string"}function z(j){return typeof j.folderUri=="string"}function ce(j){return typeof j.fileUri=="string"}function de(j,W){const P={workspaces:[],files:[]};if(j){const H=function($,Q){for(let q=0;q<$.length;q++)try{Q($[q],q)}catch(ae){W.warn(`Error restoring recent entry ${JSON.stringify($[q])}: ${ae.toString()}. Skip entry.`)}},L=j;if(Array.isArray(L.entries))H(L.entries,$=>{const Q=$.label,q=$.remoteAuthority;N($)?P.workspaces.push({label:Q,remoteAuthority:q,workspace:{id:$.workspace.id,configPath:T.URI.parse($.workspace.configPath)}}):z($)?P.workspaces.push({label:Q,remoteAuthority:q,folderUri:T.URI.parse($.folderUri)}):ce($)&&P.files.push({label:Q,remoteAuthority:q,fileUri:T.URI.parse($.fileUri)})});else{const $=j;Array.isArray($.workspaces3)&&H($.workspaces3,(Q,q)=>{const ae=Array.isArray($.workspaceLabels)&&$.workspaceLabels[q]||void 0;typeof Q=="object"&&typeof Q.id=="string"&&typeof Q.configURIPath=="string"?P.workspaces.push({label:ae,workspace:{id:Q.id,configPath:T.URI.parse(Q.configURIPath)}}):typeof Q=="string"&&P.workspaces.push({label:ae,folderUri:T.URI.parse(Q)})}),Array.isArray($.files2)&&H($.files2,(Q,q)=>{const ae=Array.isArray($.fileLabels)&&$.fileLabels[q]||void 0;typeof Q=="string"&&P.files.push({label:ae,fileUri:T.URI.parse(Q)})})}}return P}e.restoreRecentlyOpened=de;function B(j){const W={entries:[]};for(const P of j.workspaces)y(P)?W.entries.push({folderUri:P.folderUri.toString(),label:P.label,remoteAuthority:P.remoteAuthority}):W.entries.push({workspace:{id:P.workspace.id,configPath:P.workspace.configPath.toString()},label:P.label,remoteAuthority:P.remoteAuthority});for(const P of j.files)W.entries.push({fileUri:P.fileUri.toString(),label:P.label,remoteAuthority:P.remoteAuthority});return W}e.toStoreData=B}),define(be[69],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class v{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const T=this._idPool++;return this._data.set(T,C),this.logDebugInfo(),T}get(C,T){return this._data.has(C)?this._data.get(C)[T]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!v.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=v,v.enableDebugLogging=!1}),define(be[70],we([0,1,2,3,4]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class T{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(S=>({name:S.name,group:S.group,resource:v.URI.revive(S.resource),isActive:S.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(be[49],we([0,1,17,4]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(v.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(E,D){D===null?this._providerInfo.delete(E):this._providerInfo.set(E,D)}isFreeScheme(E){return!this._providerInfo.has(E)&&!this._systemSchemes.has(E)}getCapabilities(E){return this._providerInfo.get(E)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,v.createDecorator)("IExtHostInitDataService")}),define(be[160],we([0,1,11]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(E,D,S){this._deferredPromises=new Map,this._id=E,this._shared=D,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new v.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const A of k.values())A.error(i)}})()},0)}get keys(){var E;return Object.entries((E=this._value)!==null&&E!==void 0?E:{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(E,D){let S=this._value[E];return typeof S=="undefined"&&(S=D),S}update(E,D){this._value[E]=D;let S=this._deferredPromises.get(E);if(S!==void 0)return S.p;const k=new v.DeferredPromise;return this._deferredPromises.set(E,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class C extends R{constructor(E,D){super(E.identifier.value,!0,D);this._extension=E}setKeysForSync(E){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},E)}}e.ExtensionGlobalMemento=C}),define(be[15],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,v.createDecorator)("IExtHostRpcService");class R{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(J,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(J,v):C?C.value=v:e.set(J,v),v},Ue=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[161],we([0,1,26,3]),function(J,e,v,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(D,S){C.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=v.ExtensionIdentifier.toKey(D.identifier),it(this,C,S,"f"),Ue(this,C,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(D){return Ue(this,C,"f").get(this._id,D)}store(D,S){return Ue(this,C,"f").store(this._id,D,S)}delete(D){return Ue(this,C,"f").delete(this._id,D)}}e.ExtensionSecrets=T,C=new WeakMap}),define(be[95],we([0,1,4,3]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(E){this._enabled=E}$onDidChangeTelemetryEnabled(E){this._enabled=E,this._onDidChangeTelemetryEnabled.fire(E)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,v.createDecorator)("IExtHostTelemetry")}),define(be[71],we([0,1,3]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(E){E[E.NewChild=0]="NewChild",E[E.Disposed=1]="Disposed",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const C=new WeakMap,T=E=>{let D=C.get(E);return D||(D={children:new Map,bus:new v.Emitter},C.set(E,D)),D};e.getPrivateApiFor=T}),define(be[72],we([0,1,4,3,15]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(D){function S(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}D.fromApiTunnel=S;function k(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}D.fromServiceTunnel=k})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,v.createDecorator)("IExtHostTunnelService");let E=class{constructor(S){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,k){return{dispose:()=>{}}}async $providePortAttributes(S,k,i,A,c){return[]}async $forwardPort(S,k){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};E=qe([Ke(0,C.IExtHostRpcService)],E),e.ExtHostTunnelService=E});var it=this&&this.__classPrivateFieldSet||function(J,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(J,v):C?C.value=v:e.set(J,v),v},Ue=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)},qt=this&&this.__rest||function(J,e){var v={};for(var R in J)Object.prototype.hasOwnProperty.call(J,R)&&e.indexOf(R)<0&&(v[R]=J[R]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(J);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(J,R[C])&&(v[R[C]]=J[R[C]]);return v};define(be[7],we([0,1,13,12,84,22,8,10,2,31,65,68,71]),function(J,e,v,R,C,T,E,D,S,k,i,A,c){"use strict";var g,r,a,p,m,y,l,d,f,t,n,s,o,u,w,b;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(U){function M(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(M,U),Object.setPrototypeOf(M.prototype,U.prototype),M}let h=a=class{constructor(M){g.set(this,void 0),it(this,g,M,"f")}static from(...M){let te=M;return new a(function(){if(te){for(const De of te)De&&typeof De.dispose=="function"&&De.dispose();te=void 0}})}dispose(){typeof Ue(this,g,"f")=="function"&&(Ue(this,g,"f").call(this),it(this,g,void 0,"f"))}};g=new WeakMap,h=a=qe([I],h),e.Disposable=h;let _=p=class{constructor(M,te){if(M<0)throw(0,R.illegalArgument)("line must be non-negative");if(te<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=M,this._character=te}static Min(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let De=1;De<M.length;De++){const Qe=M[De];Qe.isBefore(te)&&(te=Qe)}return te}static Max(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let De=1;De<M.length;De++){const Qe=M[De];Qe.isAfter(te)&&(te=Qe)}return te}static isPosition(M){if(!M)return!1;if(M instanceof p)return!0;let{line:te,character:De}=M;return typeof te=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,te=0){if(M===null||te===null)throw(0,R.illegalArgument)();let De;return typeof M=="undefined"?De=0:typeof M=="number"?De=M:(De=typeof M.lineDelta=="number"?M.lineDelta:0,te=typeof M.characterDelta=="number"?M.characterDelta:0),De===0&&te===0?this:new p(this.line+De,this.character+te)}with(M,te=this.character){if(M===null||te===null)throw(0,R.illegalArgument)();let De;return typeof M=="undefined"?De=this.line:typeof M=="number"?De=M:(De=typeof M.line=="number"?M.line:this.line,te=typeof M.character=="number"?M.character:this.character),De===this.line&&te===this.character?this:new p(De,te)}toJSON(){return{line:this.line,character:this.character}}};_=p=qe([I],_),e.Position=_;let F=m=class{constructor(M,te,De,Qe){let nt,lt;if(typeof M=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Qe=="number"?(nt=new _(M,te),lt=new _(De,Qe)):M instanceof _&&te instanceof _&&(nt=M,lt=te),!nt||!lt)throw new Error("Invalid arguments");nt.isBefore(lt)?(this._start=nt,this._end=lt):(this._start=lt,this._end=nt)}static isRange(M){return M instanceof m?!0:M?_.isPosition(M.start)&&_.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof m?this.contains(M._start)&&this.contains(M._end):M instanceof _?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const te=_.Max(M.start,this._start),De=_.Min(M.end,this._end);if(!te.isAfter(De))return new m(te,De)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const te=_.Min(M.start,this._start),De=_.Max(M.end,this.end);return new m(te,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,te=this.end){if(M===null||te===null)throw(0,R.illegalArgument)();let De;return M?_.isPosition(M)?De=M:(De=M.start||this.start,te=M.end||this.end):De=this.start,De.isEqual(this._start)&&te.isEqual(this.end)?this:new m(De,te)}toJSON(){return[this.start,this.end]}};F=m=qe([I],F),e.Range=F;let N=y=class extends F{constructor(M,te,De,Qe){let nt,lt;if(typeof M=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Qe=="number"?(nt=new _(M,te),lt=new _(De,Qe)):M instanceof _&&te instanceof _&&(nt=M,lt=te),!nt||!lt)throw new Error("Invalid arguments");super(nt,lt);this._anchor=nt,this._active=lt}static isSelection(M){return M instanceof y?!0:M?F.isRange(M)&&_.isPosition(M.anchor)&&_.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};N=y=qe([I],N),e.Selection=N;class z{constructor(M,te,De){if(typeof M!="string"||M.length===0)throw(0,R.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,R.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,R.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(te),this.connectionToken=De}}e.ResolvedAuthority=z;class ce extends Error{constructor(M,te=A.RemoteAuthorityResolverErrorCode.Unknown,De){super(M);this._message=M,this._code=te,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ce.prototype)}static NotAvailable(M,te){return new ce(M,A.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(M){return new ce(M,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ce;var de;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(de=e.EndOfLine||(e.EndOfLine={}));var B;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=l=class{constructor(M,te){this._range=M,this._newText=te}static isTextEdit(M){return M instanceof l?!0:M?F.isRange(M)&&typeof M.newText=="string":!1}static replace(M,te){return new l(M,te)}static insert(M,te){return l.replace(new F(M,M),te)}static delete(M){return l.replace(M,"")}static setEndOfLine(M){const te=new l(new F(new _(0,0),new _(0,0)),"");return te.newEol=M,te}get range(){return this._range}set range(M){if(M&&!F.isRange(M))throw(0,R.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,R.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,R.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=l=qe([I],j),e.TextEdit=j;var W;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellOutput=4]="CellOutput",U[U.CellReplace=5]="CellReplace",U[U.CellOutputItem=6]="CellOutputItem"})(W=e.FileEditType||(e.FileEditType={}));let P=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,te,De,Qe){this._edits.push({_type:1,from:M,to:te,options:De,metadata:Qe})}createFile(M,te,De){this._edits.push({_type:1,from:void 0,to:M,options:te,metadata:De})}deleteFile(M,te,De){this._edits.push({_type:1,from:M,to:void 0,options:te,metadata:De})}replaceNotebookMetadata(M,te,De){this._edits.push({_type:3,metadata:De,uri:M,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(M,te,De,Qe,nt){let lt,ht,yt=[],Ct;if(Bt.isNotebookRange(te)&&Tt.isNotebookCellDataArray(De)&&!Tt.isNotebookCellDataArray(Qe)?(lt=te.start,ht=te.end,yt=De,Ct=Qe):typeof te=="number"&&typeof De=="number"&&Tt.isNotebookCellDataArray(Qe)&&(lt=te,ht=De,yt=Qe,Ct=nt),lt===void 0||ht===void 0)throw new Error("Invalid arguments");(lt!==ht||yt.length>0)&&this._edits.push({_type:5,uri:M,index:lt,count:ht-lt,cells:yt,metadata:Ct})}replaceNotebookCellMetadata(M,te,De,Qe){this._edits.push({_type:3,metadata:Qe,uri:M,edit:{editType:8,index:te,metadata:De}})}replace(M,te,De,Qe){this._edits.push({_type:2,uri:M,edit:new j(te,De),metadata:Qe})}insert(M,te,De,Qe){this.replace(M,new F(te,te),De,Qe)}delete(M,te,De){this.replace(M,te,"",De)}has(M){return this._edits.some(te=>te._type===2&&te.uri.toString()===M.toString())}set(M,te){if(te)for(const De of te)De&&this._edits.push({_type:2,uri:M,edit:De});else{for(let De=0;De<this._edits.length;De++){const Qe=this._edits[De];Qe._type===2&&Qe.uri.toString()===M.toString()&&(this._edits[De]=void 0)}(0,v.coalesceInPlace)(this._edits)}}get(M){const te=[];for(let De of this._edits)De._type===2&&De.uri.toString()===M.toString()&&te.push(De.edit);return te}entries(){const M=new T.ResourceMap;for(let te of this._edits)if(te._type===2){let De=M.get(te.uri);De||(De=[te.uri,[]],M.set(te.uri,De)),De[1].push(te.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};P=qe([I],P),e.WorkspaceEdit=P;let H=d=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof d?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=d._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,te=this._tabstop++){if(typeof M=="function"){const De=new d;De._tabstop=this._tabstop,M(De),this._tabstop=De._tabstop,M=De.value}else M=d._escape(M);return this.value+="${",this.value+=te,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,te=this._tabstop++){const De=M.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(M,te){if(typeof te=="function"){const De=new d;De._tabstop=this._tabstop,te(De),this._tabstop=De._tabstop,te=De.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,te&&(this.value+=":",this.value+=te),this.value+="}",this}};H=d=qe([I],H),e.SnippetString=H;var L;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(L=e.DiagnosticTag||(e.DiagnosticTag={}));var $;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})($=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Q=f=class{constructor(M,te){if(this.uri=M,te)if(te instanceof F)this.range=te;else if(te instanceof _)this.range=new F(te,te);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof f?!0:M?F.isRange(M.range)&&S.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Q=f=qe([I],Q),e.Location=Q;let q=class{constructor(M,te){this.location=M,this.message=te}static is(M){return M?typeof M.message=="string"&&M.location&&F.isRange(M.location.range)&&S.URI.isUri(M.location.uri):!1}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.location.range.isEqual(te.location.range)&&M.location.uri.toString()===te.location.uri.toString()}};q=qe([I],q),e.DiagnosticRelatedInformation=q;let ae=class{constructor(M,te,De=$.Error){if(!F.isRange(M))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=M,this.message=te,this.severity=De}toJSON(){return{severity:$[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.severity===te.severity&&M.code===te.code&&M.severity===te.severity&&M.source===te.source&&M.range.isEqual(te.range)&&(0,v.equals)(M.tags,te.tags)&&(0,v.equals)(M.relatedInformation,te.relatedInformation,q.isEqual)}};ae=qe([I],ae),e.Diagnostic=ae;let fe=class{constructor(M,te){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:(0,C.isMarkdownString)(M)?this.contents=[M]:this.contents=[M],this.range=te}};fe=qe([I],fe),e.Hover=fe;var Le;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let xe=class{constructor(M,te=Le.Text){this.range=M,this.kind=te}toJSON(){return{range:this.range,kind:Le[this.kind]}}};xe=qe([I],xe),e.DocumentHighlight=xe;var Fe;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Fe=e.SymbolKind||(e.SymbolKind={}));var He;(function(U){U[U.Deprecated=1]="Deprecated"})(He=e.SymbolTag||(e.SymbolTag={}));let x=t=class{constructor(M,te,De,Qe,nt){this.name=M,this.kind=te,this.containerName=nt,typeof De=="string"&&(this.containerName=De),Qe instanceof Q?this.location=Qe:De instanceof F&&(this.location=new Q(Qe,De)),t.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};x=t=qe([I],x),e.SymbolInformation=x;let G=n=class{constructor(M,te,De,Qe,nt){this.name=M,this.detail=te,this.kind=De,this.range=Qe,this.selectionRange=nt,this.children=[],n.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(n.validate)}};G=n=qe([I],G),e.DocumentSymbol=G;var ee;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ie=class{constructor(M,te){this.title=M,this.kind=te}};ie=qe([I],ie),e.CodeAction=ie;let ue=s=class{constructor(M){this.value=M}append(M){return new s(this.value?this.value+s.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+s.sep)}};ue.sep=".",ue=s=qe([I],ue),e.CodeActionKind=ue,ue.Empty=new ue(""),ue.QuickFix=ue.Empty.append("quickfix"),ue.Refactor=ue.Empty.append("refactor"),ue.RefactorExtract=ue.Refactor.append("extract"),ue.RefactorInline=ue.Refactor.append("inline"),ue.RefactorRewrite=ue.Refactor.append("rewrite"),ue.Source=ue.Empty.append("source"),ue.SourceOrganizeImports=ue.Source.append("organizeImports"),ue.SourceFixAll=ue.Source.append("fixAll");let Ee=class{constructor(M,te){if(this.range=M,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([I],Ee),e.SelectionRange=Ee;class $e{constructor(M,te,De,Qe,nt,lt){this.kind=M,this.name=te,this.detail=De,this.uri=Qe,this.range=nt,this.selectionRange=lt}}e.CallHierarchyItem=$e;class he{constructor(M,te){this.fromRanges=te,this.from=M}}e.CallHierarchyIncomingCall=he;class Ce{constructor(M,te){this.fromRanges=te,this.to=M}}e.CallHierarchyOutgoingCall=Ce;let Te=class{constructor(M,te){this.range=M,this.command=te}get isResolved(){return!!this.command}};Te=qe([I],Te),e.CodeLens=Te;let We=o=class{constructor(M,te=!1){r.set(this,void 0),it(this,r,new C.MarkdownString(M,{supportThemeIcons:te}),"f")}static isMarkdownString(M){return M instanceof o?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Ue(this,r,"f").value}set value(M){Ue(this,r,"f").value=M}get isTrusted(){return Ue(this,r,"f").isTrusted}set isTrusted(M){Ue(this,r,"f").isTrusted=M}get supportThemeIcons(){return Ue(this,r,"f").supportThemeIcons}appendText(M){return Ue(this,r,"f").appendText(M),this}appendMarkdown(M){return Ue(this,r,"f").appendMarkdown(M),this}appendCodeblock(M,te){return Ue(this,r,"f").appendCodeblock(te!=null?te:"",M),this}};r=new WeakMap,We=o=qe([I],We),e.MarkdownString=We;let ve=class{constructor(M,te){this.label=M,this.documentation=te}};ve=qe([I],ve),e.ParameterInformation=ve;let Ge=class{constructor(M,te){this.label=M,this.documentation=te,this.parameters=[]}};Ge=qe([I],Ge),e.SignatureInformation=Ge;let V=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};V=qe([I],V),e.SignatureHelp=V;var Z;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(Z=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ge;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(ge=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor(M,te,De){this.text=M,this.position=te,this.kind=De}};Ne=qe([I],Ne),e.InlayHint=Ne;var Ve;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(U){U[U.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let Se=class{constructor(M,te){this.label=M,this.kind=te}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Se=qe([I],Se),e.CompletionItem=Se;let ye=class{constructor(M=[],te=!1){this.items=M,this.isIncomplete=te}};ye=qe([I],ye),e.CompletionList=ye;var ke;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(ke=e.ViewColumn||(e.ViewColumn={}));var ne;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(ne=e.StatusBarAlignment||(e.StatusBarAlignment={}));var oe;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(oe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var O;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(O=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Y;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var re;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(re=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ie;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Ie=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function M(te){switch(te){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=M}(re=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let _e=class{constructor(M,te){if(te&&!S.URI.isUri(te))throw(0,R.illegalArgument)("target");if(!F.isRange(M)||M.isEmpty)throw(0,R.illegalArgument)("range");this.range=M,this.target=te}};_e=qe([I],_e),e.DocumentLink=_e;let Re=class{constructor(M,te,De,Qe){this.red=M,this.green=te,this.blue=De,this.alpha=Qe}};Re=qe([I],Re),e.Color=Re;let ze=class{constructor(M,te){if(te&&!(te instanceof Re))throw(0,R.illegalArgument)("color");if(!F.isRange(M)||M.isEmpty)throw(0,R.illegalArgument)("range");this.range=M,this.color=te}};ze=qe([I],ze),e.ColorInformation=ze;let Xe=class{constructor(M){if(!M||typeof M!="string")throw(0,R.illegalArgument)("label");this.label=M}};Xe=qe([I],Xe),e.ColorPresentation=Xe;var st;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(st=e.ColorFormat||(e.ColorFormat={}));var Ye;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var et;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(et=e.TaskRevealKind||(e.TaskRevealKind={}));var pt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(pt=e.TaskPanelKind||(e.TaskPanelKind={}));let _t=u=class{constructor(M,te){if(typeof M!="string"||typeof te!="string")throw(0,R.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}get id(){return this._id}};_t.Clean=new u("clean","Clean"),_t.Build=new u("build","Build"),_t.Rebuild=new u("rebuild","Rebuild"),_t.Test=new u("test","Test"),_t=u=qe([I],_t),e.TaskGroup=_t;function je(U){let M="";for(let te=0;te<U.length;te++)M+=U[te].replace(/,/g,",,")+",";return M}let me=class{constructor(M,te,De){if(typeof M!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=M,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=De):this._options=te)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,R.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let te of this._args)M.push(te);return je(M)}};me=qe([I],me),e.ProcessExecution=me;let pe=class{constructor(M,te,De){if(this._args=[],Array.isArray(te)){if(!M)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,R.illegalArgument)("command");this._command=M,this._args=te,this._options=De}else{if(typeof M!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=M,this._options=te}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,R.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)M.push(typeof te=="string"?te:te.value);return je(M)}};pe=qe([I],pe),e.ShellExecution=pe;var se;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(se=e.ShellQuoting||(e.ShellQuoting={}));var K;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(K=e.TaskScope||(e.TaskScope={}));class Oe{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Oe;let Ae=w=class{constructor(M,te,De,Qe,nt,lt){this.__deprecated=!1,this._definition=this.definition=M;let ht;typeof te=="string"?(this._name=this.name=te,this._source=this.source=De,this.execution=Qe,ht=nt,this.__deprecated=!0):te===K.Global||te===K.Workspace?(this.target=te,this._name=this.name=De,this._source=this.source=Qe,this.execution=nt,ht=lt):(this.target=te,this._name=this.name=De,this._source=this.source=Qe,this.execution=nt,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof me?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof pe?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof Oe?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const te=this._definition.type;(w.EmptyType===te||w.ProcessType===te||w.ShellType===te||w.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};Ae.ExtensionCallbackType="customExecution",Ae.ProcessType="process",Ae.ShellType="shell",Ae.EmptyType="$empty",Ae=w=qe([I],Ae),e.Task=Ae;var rt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(rt=e.ProgressLocation||(e.ProgressLocation={}));let tt=class{constructor(M,te=ct.None){this.collapsibleState=te,S.URI.isUri(M)?this.resourceUri=M:this.label=M}};tt=qe([I],tt),e.TreeItem=tt;var ct;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let at=class{constructor(M,te){this.id=M,this.color=te}};at=qe([I],at),e.ThemeIcon=at,at.File=new at("file"),at.Folder=new at("folder");let Je=class{constructor(M){this.id=M}};Je=qe([I],Je),e.ThemeColor=Je;var ft;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ut=class{constructor(M,te){if(typeof M!="string"&&(!M||!S.URI.isUri(M)&&!S.URI.isUri(M.uri)))throw(0,R.illegalArgument)("base");if(typeof te!="string")throw(0,R.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=S.URI.file(M),this.base=M):S.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=te}};ut=qe([I],ut),e.RelativePattern=ut;let mt=class{constructor(M,te,De,Qe){this.enabled=typeof M=="boolean"?M:!0,typeof te=="string"&&(this.condition=te),typeof De=="string"&&(this.hitCondition=De),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};mt=qe([I],mt),e.Breakpoint=mt;let bt=class extends mt{constructor(M,te,De,Qe,nt){super(te,De,Qe,nt);if(M===null)throw(0,R.illegalArgument)("location");this.location=M}};bt=qe([I],bt),e.SourceBreakpoint=bt;let kt=class extends mt{constructor(M,te,De,Qe,nt){super(te,De,Qe,nt);this.functionName=M}};kt=qe([I],kt),e.FunctionBreakpoint=kt;let Ft=class extends mt{constructor(M,te,De,Qe,nt,lt,ht){super(Qe,nt,lt,ht);if(!te)throw(0,R.illegalArgument)("dataId");this.label=M,this.dataId=te,this.canPersist=De}};Ft=qe([I],Ft),e.DataBreakpoint=Ft;let Et=class{constructor(M,te,De){this.command=M,this.args=te||[],this.options=De}};Et=qe([I],Et),e.DebugAdapterExecutable=Et;let Lt=class{constructor(M,te){this.port=M,this.host=te}};Lt=qe([I],Lt),e.DebugAdapterServer=Lt;let Kt=class{constructor(M){this.path=M}};Kt=qe([I],Kt),e.DebugAdapterNamedPipeServer=Kt;let gt=class{constructor(M){this.implementation=M}};gt=qe([I],gt),e.DebugAdapterInlineImplementation=gt;let Gt=class{constructor(M,te){this.range=M,this.expression=te}};Gt=qe([I],Gt),e.EvaluatableExpression=Gt;let St=class{constructor(M,te){this.range=M,this.text=te}};St=qe([I],St),e.InlineValueText=St;let zt=class{constructor(M,te,De=!0){this.range=M,this.variableName=te,this.caseSensitiveLookup=De}};zt=qe([I],zt),e.InlineValueVariableLookup=zt;let Qt=class{constructor(M,te){this.range=M,this.expression=te}};Qt=qe([I],Qt),e.InlineValueEvaluatableExpression=Qt;let Ut=class{constructor(M,te){this.frameId=M,this.stoppedLocation=te}};Ut=qe([I],Ut),e.InlineValueContext=Ut;var dt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(dt=e.FileChangeType||(e.FileChangeType={}));let Yt=b=class extends Error{constructor(M,te=i.FileSystemProviderErrorCode.Unknown,De){var Qe;super(S.URI.isUri(M)?M.toString(!0):M);this.code=(Qe=De==null?void 0:De.name)!==null&&Qe!==void 0?Qe:"Unknown",(0,i.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(M){return new b(M,i.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(M){return new b(M,i.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(M){return new b(M,i.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(M){return new b(M,i.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(M){return new b(M,i.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(M){return new b(M,i.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Yt=b=qe([I],Yt),e.FileSystemError=Yt;let It=class{constructor(M,te,De){this.start=M,this.end=te,this.kind=De}};It=qe([I],It),e.FoldingRange=It;var $t;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})($t=e.FoldingRangeKind||(e.FoldingRangeKind={}));var an;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(an=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var pn;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(pn=e.CommentMode||(e.CommentMode={}));class ln{constructor(M,te=[]){this.tokenTypes=M,this.tokenModifiers=te}}e.SemanticTokensLegend=ln;function vn(U){return typeof U=="undefined"||(0,D.isStringArray)(U)}class Vt{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let te=0,De=M.tokenTypes.length;te<De;te++)this._tokenTypeStrToInt.set(M.tokenTypes[te],te);for(let te=0,De=M.tokenModifiers.length;te<De;te++)this._tokenModifierStrToInt.set(M.tokenModifiers[te],te)}}push(M,te,De,Qe,nt){if(typeof M=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Qe=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(M,te,De,Qe,nt);if(F.isRange(M)&&typeof te=="string"&&vn(De))return this._push(M,te,De);throw(0,R.illegalArgument)()}_push(M,te,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Qe=M.start.line,nt=M.start.character,lt=M.end.character-M.start.character,ht=this._tokenTypeStrToInt.get(te);let yt=0;if(De)for(const Ct of De){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const Pt=this._tokenModifierStrToInt.get(Ct);yt|=1<<Pt>>>0}this._pushEncoded(Qe,nt,lt,ht,yt)}_pushEncoded(M,te,De,Qe,nt){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Ct=0,Pt=0;for(let Rt=0;Rt<yt;Rt++){let Ot=this._data[5*Rt],sn=this._data[5*Rt+1];Ot===0?(Ot=Ct,sn+=Pt):Ot+=Ct,this._data[5*Rt]=Ot,this._data[5*Rt+1]=sn,Ct=Ot,Pt=sn}}let lt=M,ht=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=nt,this._prevLine=M,this._prevChar=te}static _sortAndDeltaEncode(M){let te=[];const De=M.length/5|0;for(let ht=0;ht<De;ht++)te[ht]=ht;te.sort((ht,yt)=>{const Ct=M[5*ht],Pt=M[5*yt];if(Ct===Pt){const Rt=M[5*ht+1],Ot=M[5*yt+1];return Rt-Ot}return Ct-Pt});const Qe=new Uint32Array(M.length);let nt=0,lt=0;for(let ht=0;ht<De;ht++){const yt=5*te[ht],Ct=M[yt+0],Pt=M[yt+1],Rt=M[yt+2],Ot=M[yt+3],sn=M[yt+4],An=Ct-nt,On=An===0?Pt-lt:Pt,on=5*ht;Qe[on+0]=An,Qe[on+1]=On,Qe[on+2]=Rt,Qe[on+3]=Ot,Qe[on+4]=sn,nt=Ct,lt=Pt}return Qe}build(M){return this._dataIsSortedAndDeltaEncoded?new At(new Uint32Array(this._data),M):new At(Vt._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Vt;class At{constructor(M,te){this.resultId=te,this.data=M}}e.SemanticTokens=At;class bn{constructor(M,te,De){this.start=M,this.deleteCount=te,this.data=De}}e.SemanticTokensEdit=bn;class Jt{constructor(M,te){this.resultId=te,this.edits=M}}e.SemanticTokensEdits=Jt;var Xt;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Xt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var wn;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(wn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let jt=class{constructor(){}};jt.Back={iconPath:new at("arrow-left")},jt=qe([I],jt),e.QuickInputButtons=jt;var Mt;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Mt=e.ExtensionKind||(e.ExtensionKind={}));class _n{constructor(M,te,De){this.badge=M,this.tooltip=te,this.color=De}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=_n;let Zt=class{constructor(M){this.kind=M}};Zt=qe([I],Zt),e.ColorTheme=Zt;var En;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(En=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(M,te){if(M<0)throw(0,R.illegalArgument)("start must be positive");if(te<0)throw(0,R.illegalArgument)("end must be positive");M<=te?(this._start=M,this._end=te):(this._start=te,this._end=M)}static isNotebookRange(M){return M instanceof Bt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let te=this._start,De=this._end;return M.start!==void 0&&(te=M.start),M.end!==void 0&&(De=M.end),te===this._start&&De===this._end?this:new Bt(te,De)}}e.NotebookRange=Bt;class xt{constructor(M,te){typeof M=="object"?Object.assign(this,M):(this.inputCollapsed=M,this.outputCollapsed=te)}with(M){let{inputCollapsed:te,outputCollapsed:De}=M,Qe=qt(M,["inputCollapsed","outputCollapsed"]);return te===void 0?te=this.inputCollapsed:te===null&&(te=void 0),De===void 0?De=this.outputCollapsed:De===null&&(De=void 0),te===this.inputCollapsed&&De===this.outputCollapsed&&Object.keys(Qe).length===0?this:new xt(Object.assign({inputCollapsed:te,outputCollapsed:De},Qe))}}e.NotebookCellMetadata=xt;class Wt{constructor(M={}){Object.assign(this,M)}with(M){return new Wt(M)}}e.NotebookDocumentMetadata=Wt;class Tt{constructor(M,te,De,Qe,nt,lt){this.kind=M,this.value=te,this.languageId=De,this.outputs=Qe!=null?Qe:[],this.metadata=nt,this.executionSummary=lt,Tt.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(te=>Tt.isNotebookCellData(te))}static isNotebookCellData(M){return!0}}e.NotebookCellData=Tt;class en{constructor(M,te){this.cells=M,this.metadata=te!=null?te:new Wt}}e.NotebookData=en;class Me{constructor(M,te,De){if(this.mime=M,this.value=te,this.metadata=De,(0,E.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(M){return M instanceof Me?!0:M?typeof M.mime=="string":!1}static error(M){return new Me("application/x.notebook.error",JSON.stringify({name:M.name,message:M.message,stack:M.stack}))}}e.NotebookCellOutputItem=Me;class tn{constructor(M,te,De){this.outputs=M,typeof te=="string"?(this.id=te,this.metadata=De):(this.id=(0,k.generateUuid)(),this.metadata=te!=null?te:De)}}e.NotebookCellOutput=tn;var un;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(un=e.NotebookCellKind||(e.NotebookCellKind={}));var vt;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(vt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var yn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(yn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Sn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Sn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class cn{constructor(M,te,De,Qe,nt,lt){this.text=M,this.alignment=te,this.command=De,this.tooltip=Qe,this.priority=nt,this.accessibilityInformation=lt}}e.NotebookCellStatusBarItem=cn;var dn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(dn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class nn{constructor(M,te=[]){this.uri=M,this.provides=typeof te=="string"?[te]:te}}e.NotebookKernelPreload=nn;let rn=class{constructor(M,te){this.label=M,this.timestamp=te}};rn=qe([I],rn),e.TimelineItem=rn;var Dn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Dn=e.ExtensionMode||(e.ExtensionMode={}));var Cn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Cn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class kn{constructor(M,te){this.ranges=M,this.wordPattern=te}}e.LinkedEditingRanges=kn;class In{constructor(M,te){this._port=M,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=In;var Pn;(function(U){U[U.Unset=0]="Unset",U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Pn=e.TestResultState||(e.TestResultState={}));var fn;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information",U[U.Hint=3]="Hint"})(fn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var mn;(function(U){U[U.Pending=0]="Pending",U[U.Resolved=1]="Resolved"})(mn=e.TestItemStatus||(e.TestItemStatus={}));const X=(U,M,te,De)=>{let Qe=te;return{enumerable:!0,configurable:!1,get(){return Qe},set(nt){De(Qe,nt)||(Qe=nt,U.bus.fire([3,M,nt]))}}},le=(U,M)=>U===M,Pe=(U,M)=>U===M?!0:!U||!M?!1:U.isEqual(M);class ot{constructor(M,te,De,Qe){this.label=te,this.data=Qe;const nt=(0,c.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:M,enumerable:!0,writable:!1},uri:{value:De,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>nt.parent},children:{value:new T.ReadonlyMapView(nt.children),enumerable:!0,writable:!1},range:X(nt,"range",void 0,Pe),description:X(nt,"description",void 0,le),runnable:X(nt,"runnable",!0,le),debuggable:X(nt,"debuggable",!1,le),status:X(nt,"status",mn.Resolved,le),error:X(nt,"error",void 0,le)})}invalidate(){(0,c.getPrivateApiFor)(this).bus.fire([2])}dispose(){const M=(0,c.getPrivateApiFor)(this);M.parent&&(0,c.getPrivateApiFor)(M.parent).children.delete(this.id),M.bus.fire([1])}addChild(M){if(!(M instanceof ot))throw new Error("Test child must be created through vscode.test.createTestItem()");const te=(0,c.getPrivateApiFor)(this);if(te.children.has(M.id))throw new Error(`Attempted to insert a duplicate test item ID ${M.id}`);te.children.set(M.id,M),te.bus.fire([0,M])}}e.TestItemImpl=ot;class wt{constructor(M){this.message=M,this.severity=fn.Error}static diff(M,te,De){const Qe=new wt(M);return Qe.expectedOutput=te,Qe.actualOutput=De,Qe}}e.TestMessage=wt;var Dt;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Dt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ln;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Ln=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Mn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore"})(Mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(be[96],we([0,1,42,17,8,121,87,7,13]),function(J,e,v,R,C,T,E,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(r,a){a?k.set(r,a):k.delete(r)}e.setWordDefinitionFor=i;function A(r){return k.get(r)}e.getWordDefinitionFor=A;class c extends T.MirrorTextModel{constructor(a,p,m,y,l,d,f,t){super(p,m,y,l);this._proxy=a,this._languageId=d,this._isDirty=f,this._notebook=t,this._isDisposed=!1}dispose(){(0,v.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,S.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===R.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(p){return p?a._getTextInRange(p):a.getText()},get eol(){return a._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(p){return a._lineAt(p)},offsetAt(p){return a._offsetAt(p)},positionAt(p){return a._positionAt(p)},validateRange(p){return a._validateRange(p)},validatePosition(p){return a._validatePosition(p)},getWordRangeAtPosition(p,m){return a._getWordRangeAtPosition(p,m)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,v.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,v.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const p=this._validateRange(a);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const m=this._eol,y=p.start.line,l=p.end.line,d=[];d.push(this._lines[y].substring(p.start.character));for(let f=y+1;f<l;f++)d.push(this._lines[f]);return d.push(this._lines[l].substring(0,p.end.character)),d.join(m)}_lineAt(a){let p;if(a instanceof D.Position?p=a.line:typeof a=="number"&&(p=a),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new g(p,this._lines[p],p===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(a),m=this._lines[p.index].length;return new D.Position(p.index,Math.min(p.remainder,m))}_validateRange(a){if(!(a instanceof D.Range))throw new Error("Invalid argument");const p=this._validatePosition(a.start),m=this._validatePosition(a.end);return p===a.start&&m===a.end?a:new D.Range(p.line,p.character,m.line,m.character)}_validatePosition(a){if(!(a instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:p,character:m}=a,y=!1;if(p<0)p=0,m=0,y=!0;else if(p>=this._lines.length)p=this._lines.length-1,m=this._lines[p].length,y=!0;else{const l=this._lines[p].length;m<0?(m=0,y=!0):m>l&&(m=l,y=!0)}return y?new D.Position(p,m):a}_getWordRangeAtPosition(a,p){const m=this._validatePosition(a);if(!p)p=A(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const y=(0,E.getWordAtText)(m.character+1,(0,E.ensureValidWordDefinition)(p),this._lines[m.line],0);if(y)return new D.Range(m.line,y.startColumn-1,m.line,y.endColumn-1)}}e.ExtHostDocumentData=c;class g{constructor(a,p,m){this._line=a,this._text=p,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(be[162],we([0,1,7,3,89,6,60,22,2,31]),function(J,e,v,R,C,T,E,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(c,g,r,a){this._notebook=r,this._selector=a,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(m=>{const y=this._cellUris.get(m.document.uri);y!==void 0&&(this._cellLengths.changeValue(y,this._cells[y].document.getText().length+1),this._cellLines.changeValue(y,this._cells[y].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(m=>p(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const c=[],g=[];for(const r of this._notebook.getCells())r.kind===v.NotebookCellKind.Code&&(!this._selector||(0,E.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),c.push(r.document.getText().length+1),g.push(r.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(c){var g,r;if(!c){let l="";for(const d of this._cells)l+=d.document.getText()+`
`;return l=l.slice(0,-1),l}if(c.isEmpty)return"";const a=this.locationAt(c.start),p=this.locationAt(c.end),m=this._cells[(g=this._cellUris.get(a.uri))!==null&&g!==void 0?g:-1],y=this._cells[(r=this._cellUris.get(p.uri))!==null&&r!==void 0?r:-1];if(!m||!y)return"";if(m===y)return m.document.getText(new v.Range(a.range.start,p.range.end));{const l=m.document.getText(new v.Range(a.range.start,new v.Position(m.document.lineCount,0))),d=y.document.getText(new v.Range(new v.Position(0,0),p.range.end));return l+`
`+d}}offsetAt(c){const g=this._cellLines.getIndexOf(c.line),r=this._cellLengths.getAccumulatedValue(g.index-1),a=this._cells[g.index].document.offsetAt(c.with(g.remainder));return r+a}positionAt(c){if(typeof c=="number"){const r=this._cellLengths.getIndexOf(c),a=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(a)}const g=this._cellUris.get(c.uri);if(g!==void 0){const r=this._cellLines.getAccumulatedValue(g-1);return new v.Position(r+c.range.start.line,c.range.start.character)}return new v.Position(0,0)}locationAt(c){v.Range.isRange(c)||(c=new v.Range(c,c));const g=this._cellLines.getIndexOf(c.start.line);let r=g;c.isEmpty||(r=this._cellLines.getIndexOf(c.end.line));const a=new v.Position(g.remainder,c.start.character),p=new v.Position(r.remainder,c.end.character),m=new v.Range(a,p),y=this._cells[g.index];return new v.Location(y.document.uri,y.document.validateRange(m))}contains(c){return this._cellUris.has(c)}validateRange(c){const g=this.validatePosition(c.start),r=this.validatePosition(c.end);return c.with(g,r)}validatePosition(c){const g=this._cellLines.getIndexOf(c.line),r=new v.Position(g.remainder,c.character),a=this._cells[g.index].document.validatePosition(r),p=this._cellLines.getAccumulatedValue(g.index-1);return new v.Position(p+a.line,a.character)}}e.ExtHostNotebookConcatDocument=i}),define(be[163],we([0,1,7,15,3]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(D){this._actual=new v.ColorTheme(v.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let S=D==="light"?v.ColorThemeKind.Light:D==="dark"?v.ColorThemeKind.Dark:v.ColorThemeKind.HighContrast;this._actual=new v.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=qe([Ke(0,R.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(be[73],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,v.createDecorator)("IURITransformerService");class R{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=E=>E,this.transformOutgoing=E=>E,this.transformOutgoingURI=E=>E,this.transformOutgoingScheme=E=>E)}}e.URITransformerService=R}),define(be[164],we([0,1,24]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function C(D,S){if(S.serializeBuffersForPostMessage){const k=new R,i=(g,r)=>{if(r instanceof ArrayBuffer){const a=k.add(r);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(r)){const a=T(r);if(a){const p=k.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:a,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},A=JSON.stringify(D,i),c=k.buffers.map(g=>{const r=new Uint8Array(g);return v.VSBuffer.wrap(r)});return{message:A,buffers:c}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=C;function T(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function E(D,S){const k=S.map(c=>{const g=new ArrayBuffer(c.byteLength);return new Uint8Array(g).set(c.buffer),g}),i=S.length?(c,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const r=g,{index:a}=r,p=k[a];if(r.view)switch(r.view.type){case 1:return new Int8Array(p,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return g}:void 0;return{message:JSON.parse(D,i),arrayBuffers:k}}e.deserializeWebviewMessage=E}),define(be[74],we([0,1,17,2]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewResourceRoot=e.webviewResourceOrigin=void 0;const C=D=>`https://${D}.vscode-webview-test.com`;e.webviewResourceOrigin=C;const T=D=>`${(0,e.webviewResourceOrigin)(D)}/vscode-resource/{{resource}}`;e.webviewResourceRoot=T,e.webviewGenericCspSource="https://*.vscode-webview-test.com";function E(D,S,k){if(S.scheme===v.Schemas.http||S.scheme===v.Schemas.https)return S;k&&S.scheme===v.Schemas.file&&(S=R.URI.from({scheme:v.Schemas.vscodeRemote,authority:k,path:S.path}));const i=(0,e.webviewResourceRoot)(D).replace("{{resource}}",S.scheme+"/"+encodeURIComponent(S.authority)+S.path).replace("{{uuid}}",D);return R.URI.parse(i).with({fragment:S.fragment,query:S.query})}e.asWebviewUri=E}),define(be[165],we([0,1,3,6,74,31]),function(J,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class E{constructor(S,k,i){this._proxy=S,this._editors=k,this._initData=i,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const A=k.getVisibleTextEditors();for(const c of this._insets.values())A.indexOf(c.editor)<0&&c.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,k,i,A,c){let g;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===S){g=d;break}if(!g)throw new Error("not a visible editor");const r=this,a=this._handlePool++,p=new v.Emitter,m=new v.Emitter,y=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(d){return(0,C.asWebviewUri)(this._uuid,d,r._initData.remote.authority)}get cspSource(){return C.webviewGenericCspSource}set options(d){this._options=d,r._proxy.$setOptions(a,d)}get options(){return this._options}set html(d){this._html=d,r._proxy.$setHtml(a,d)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(d){return r._proxy.$postMessage(a,d)}},l=new class{constructor(){this.editor=S,this.line=k,this.height=i,this.webview=y,this.onDidDispose=m.event}dispose(){r._insets.has(a)&&(r._insets.delete(a),r._proxy.$disposeEditorInset(a),m.fire(),m.dispose(),p.dispose())}};return this._proxy.$createEditorInset(a,g.id,g.value.document.uri,k+1,i,A||{},c.identifier,c.extensionLocation),this._insets.set(a,{editor:S,inset:l,onDidReceiveMessage:p}),l}$onDidDispose(S){const k=this._insets.get(S);k&&k.inset.dispose()}$onDidReceiveMessage(S,k){const i=this._insets.get(S);i&&i.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=E}),define(be[166],we([0,1,3,64,138,4,6,22,29,13,52,23,36,158]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",c.Codicon.window,(0,C.localize)(0,null));var r;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var a;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel"})(a=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(u){switch(u){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function m(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=m;class y extends E.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new v.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new v.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(w,b,I){var h;const _=this.get(w.id);if(_)return _;const F=w;return F.openCommandActionDescriptor=(I==null?void 0:I.donotRegisterOpenCommand)?void 0:(h=F.openCommandActionDescriptor)!==null&&h!==void 0?h:{id:F.id},(0,D.getOrSet)(this.viewContainers,b,[]).push(F),(I==null?void 0:I.isDefault)&&this.defaultViewContainers.push(F),this._onDidRegister.fire({viewContainer:F,viewContainerLocation:b}),F}deregisterViewContainer(w){for(const b of this.viewContainers.keys()){const I=this.viewContainers.get(b),h=I==null?void 0:I.indexOf(w);if(h!==-1){I==null||I.splice(h,1),I.length===0&&this.viewContainers.delete(b),this._onDidDeregister.fire({viewContainer:w,viewContainerLocation:b});return}}}get(w){return this.all.filter(b=>b.id===w)[0]}getViewContainers(w){return[...this.viewContainers.get(w)||[]]}getViewContainerLocation(w){return[...this.viewContainers.keys()].filter(b=>this.getViewContainers(b).filter(I=>(I==null?void 0:I.id)===w.id).length>0)[0]}getDefaultViewContainer(w){return this.defaultViewContainers.find(b=>this.getViewContainerLocation(b)===w)}}S.Registry.add(r.ViewContainersRegistry,new y);var l;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function d(u,w){var b,I,h,_;const F=(b=u.group)!==null&&b!==void 0?b:l.More,N=(I=w.group)!==null&&I!==void 0?I:l.More;return F!==N?F.localeCompare(N):((h=u.order)!==null&&h!==void 0?h:5)-((_=w.order)!==null&&_!==void 0?_:5)}class f extends E.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new v.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new v.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new v.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new v.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(w,b){this.registerViews2([{views:w,viewContainer:b}])}registerViews2(w){w.forEach(({views:b,viewContainer:I})=>this.addViews(b,I)),this._onViewsRegistered.fire(w)}deregisterViews(w,b){const I=this.removeViews(w,b);I.length&&this._onViewsDeregistered.fire({views:I,viewContainer:b})}moveViews(w,b){for(const I of this._views.keys())if(I!==b){const h=this.removeViews(w,I);h.length&&(this.addViews(h,b),this._onDidChangeContainer.fire({views:h,from:I,to:b}))}}getViews(w){return this._views.get(w)||[]}getView(w){for(const b of this._viewContainers){const I=(this._views.get(b)||[]).filter(h=>h.id===w)[0];if(I)return I}return null}getViewContainer(w){for(const b of this._viewContainers)if((this._views.get(b)||[]).filter(h=>h.id===w)[0])return b;return null}registerViewWelcomeContent(w,b){return this._viewWelcomeContents.add(w,b),this._onDidChangeViewWelcomeContent.fire(w),(0,E.toDisposable)(()=>{this._viewWelcomeContents.delete(w,b),this._onDidChangeViewWelcomeContent.fire(w)})}registerViewWelcomeContent2(w,b){const I=new Map;for(const[h,_]of b)this._viewWelcomeContents.add(w,_),I.set(h,(0,E.toDisposable)(()=>{this._viewWelcomeContents.delete(w,_),this._onDidChangeViewWelcomeContent.fire(w)}));return this._onDidChangeViewWelcomeContent.fire(w),I}getViewWelcomeContent(w){const b=[];return this._viewWelcomeContents.forEach(w,I=>b.push(I)),b.sort(d)}addViews(w,b){let I=this._views.get(b);I||(I=[],this._views.set(b,I),this._viewContainers.push(b));for(const h of w){if(this.getView(h.id)!==null)throw new Error((0,C.localize)(1,null,h.id));I.push(h)}}removeViews(w,b){const I=this._views.get(b);if(!I)return[];const h=[],_=[];for(const F of I)w.includes(F)?h.push(F):_.push(F);return h.length&&(_.length?this._views.set(b,_):(this._views.delete(b),this._viewContainers.splice(this._viewContainers.indexOf(b),1))),h}}S.Registry.add(r.ViewsRegistry,new f),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,C.localize)(2,null));function t(u){return`view.${u}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(w,b){this.resolved=!1,this._hasResolve=!1,(0,A.mixin)(this,w),this._hasResolve=!!b,this.resolve=async I=>{var h,_;if(b&&!this.resolved){const F=await b(I);F&&(this.tooltip=(h=this.tooltip)!==null&&h!==void 0?h:F.tooltip,this.command=(_=this.command)!==null&&_!==void 0?_:F.command)}I.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o}),define(be[167],we([0,1,2,148,159,16,149,166]),function(J,e,v,R,C,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function S(r){return(a,...p)=>r(a.get(R.ICommandService),...p)}class k{static execute(a,p){const m={forceReuseWindow:p&&p.reuseWindow,remoteAuthority:p&&p.remoteAuthority};return a.executeCommand("_files.newWindow",m)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",R.CommandsRegistry.registerCommand({id:k.ID,handler:S(k.execute),description:{description:"Opens an new window",args:[]}}),R.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(r,a){return r.get(C.IWorkspacesService).removeRecentlyOpened([a])});class i{static execute(a,p){return typeof p=="string"?p=p.match(/^[^:/?#]+:\/\//)?v.URI.parse(p):v.URI.file(p):p=v.URI.revive(p),a.executeCommand("_workbench.removeFromRecentlyOpened",p)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",R.CommandsRegistry.registerCommand(i.ID,S(i.execute)),R.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(r,a){const p=r.get(C.IWorkspacesService);let m;const y=a.uri,l=a.label,d=a.remoteAuthority;return a.type==="workspace"?m={workspace:await p.getWorkspaceIdentifier(y),label:l,remoteAuthority:d}:a.type==="folder"?m={folderUri:y,label:l,remoteAuthority:d}:m={fileUri:y,label:l,remoteAuthority:d},p.addRecentlyOpened([m])}),R.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(r){return r.get(C.IWorkspacesService).getRecentlyOpened()}),R.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(r,a){const p=r.get(T.ILogService),m=r.get(E.IEnvironmentService);m.isExtensionDevelopment&&!!m.extensionTestsLocationURI&&p.setLevel(a)}),R.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(r){return r.get(T.ILogService).getLevel()}),R.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(r,a){const p=r.get(D.IViewDescriptorService),m=p.getViewContainerById(a.destinationId);if(!!m){for(const y of a.viewIds){const l=p.getViewDescriptorById(y);(l==null?void 0:l.canMoveView)&&p.moveViewsToContainer([l],m,D.ViewVisibilityState.Default)}await r.get(D.IViewsService).openViewContainer(m.id,!0)}});class A{static execute(a,p){return!Array.isArray(p==null?void 0:p.viewIds)||typeof(p==null?void 0:p.destinationId)!="string"?Promise.reject("Invalid arguments"):a.executeCommand("_workbench.action.moveViews",p)}}e.MoveViewsAPICommand=A,A.ID="vscode.moveViews",R.CommandsRegistry.registerCommand({id:A.ID,handler:S(A.execute),description:{description:"Move Views",args:[]}});class c{static execute(a,p){return a.executeCommand("_workbench.open",p)}}c.ID="vscode.open",R.CommandsRegistry.registerCommand(c.ID,S(c.execute));class g{static execute(a,p,m,y,l){return a.executeCommand("_workbench.diff",[p,m,y])}}g.ID="vscode.diff",R.CommandsRegistry.registerCommand(g.ID,S(g.execute))}),define(be[168],we([0,1,3,11,139]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new v.Emitter,this._onExit=new v.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,S,k,i){const A={command:D};if(S&&Object.keys(S).length>0&&(A.arguments=S),this.internalSend("request",A),typeof i=="number"){const c=setTimeout(()=>{clearTimeout(c);const g=this.pendingRequests.get(A.seq);if(g){this.pendingRequests.delete(A.seq);const r={type:"response",seq:0,request_seq:A.seq,success:!1,command:D,message:(0,C.localize)(0,null,i,D)};g(r)}},i)}return k&&this.pendingRequests.set(A.seq,k),A.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,S){return D.type!=="event"||S.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,R.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const S=D,k=this.pendingRequests.get(S.request_seq);k&&(this.pendingRequests.delete(S.request_seq),k(S));break}}}internalSend(D,S){S.type=D,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((S,k)=>D.set(k,S)),await(0,R.timeout)(500),D.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(be[169],we([0,1,8,2,14,23,17]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function S(n,s,o){return n.replace(D,function(u,w){return s&&w.length>0&&w[0]!=="_"?u:o&&o.hasOwnProperty(w)?o[w]:u})}e.formatPII=S;function k(n){const s={};for(const o of Object.keys(n))o.startsWith("!")||(s[o]=n[o]);return s}e.filterExceptionsFromTelemetry=k;function i(n){return n.configuration.request==="attach"&&!A(n)}e.isSessionAttach=i;function A(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,v.equalsIgnoreCase)(s,"extensionhost")||(0,v.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?A(n.parentSession):void 0}e.getExtensionHostDebugSession=A;function c(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=c;function g(n,s,o){let u,w=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,I=null;for(;I=b.exec(n);){let h=I.index+1,_=h+I[0].length;if(h<=s&&_>=o){u=I[0],w=h;break}}if(u){let h=/\w+/g,_=null;for(;(_=h.exec(u))&&!(_.index+1+w+_[0].length>=o););_&&(u=u.substring(0,h.lastIndex))}return u?{start:w,end:w+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(n){return!!(n&&n.match(r))}e.isUri=a;function p(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(a(n.path))return R.URI.parse(n.path);if((0,C.isAbsolute)(n.path))return R.URI.file(n.path)}return n.path}function m(n){if(typeof n.path=="object"){const s=R.URI.revive(n.path);if(s)return s.scheme===E.Schemas.file?s.fsPath:s.toString()}return n.path}function y(n,s){const o=s?p:m,u=(0,T.deepClone)(n);return d(u,(w,b)=>{w&&b&&(b.path=o(b))}),u}e.convertToDAPaths=y;function l(n,s){const o=s?p:m,u=(0,T.deepClone)(n);return d(u,(w,b)=>{!w&&b&&(b.path=o(b))}),u}e.convertToVSCPaths=l;function d(n,s){switch(n.type){case"event":const o=n;switch(o.event){case"output":s(!1,o.body.source);break;case"loadedSource":s(!1,o.body.source);break;case"breakpoint":s(!1,o.body.breakpoint.source);break;default:break}break;case"request":const u=n;switch(u.command){case"setBreakpoints":s(!0,u.arguments.source);break;case"breakpointLocations":s(!0,u.arguments.source);break;case"source":s(!0,u.arguments.source);break;case"gotoTargets":s(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(b=>s(!1,b));break;default:break}break;case"response":const w=n;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(b=>s(!1,b.source));break;case"loadedSources":w.body.sources.forEach(b=>s(!1,b));break;case"scopes":w.body.scopes.forEach(b=>s(!1,b.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(b=>s(!1,b.source));break;case"setBreakpoints":w.body.breakpoints.forEach(b=>s(!1,b.source));break;default:break}break}}function f(n){return n.filter(s=>{var o;return!((o=s.presentation)===null||o===void 0?void 0:o.hidden)}).sort((s,o)=>s.presentation?o.presentation?s.presentation.group?o.presentation.group?s.presentation.group!==o.presentation.group?s.presentation.group.localeCompare(o.presentation.group):t(s.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(s.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=f;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(be[50],we([0,1,28,17,14,21,64]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ExperimentalUndoRedoPerCell=e.ExperimentalGlobalToolbar=e.ExperimentalInsertToolbarPosition=e.ExperimentalFocusIndicator=e.ExperimentalCompactView=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(h){h[h.Markup=1]="Markup",h[h.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(h){h[h.Running=1]="Running",h[h.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var k;(function(h){h[h.Pending=2]="Pending",h[h.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(h){h[h.WithHardKernelDependency=0]="WithHardKernelDependency",h[h.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",h[h.Pure=2]="Pure",h[h.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var A;(function(h){h[h.ModelChange=1]="ModelChange",h[h.Move=2]="Move",h[h.CellClearOutput=3]="CellClearOutput",h[h.CellsClearOutput=4]="CellsClearOutput",h[h.ChangeLanguage=5]="ChangeLanguage",h[h.Initialize=6]="Initialize",h[h.ChangeCellMetadata=7]="ChangeCellMetadata",h[h.Output=8]="Output",h[h.OutputItem=9]="OutputItem",h[h.ChangeCellContent=10]="ChangeCellContent",h[h.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",h[h.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",h[h.Unknown=100]="Unknown"})(A=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(h){h[h.Handle=0]="Handle",h[h.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(h){h[h.Replace=1]="Replace",h[h.Output=2]="Output",h[h.Metadata=3]="Metadata",h[h.CellLanguage=4]="CellLanguage",h[h.DocumentMetadata=5]="DocumentMetadata",h[h.Move=6]="Move",h[h.OutputItems=7]="OutputItems",h[h.PartialMetadata=8]="PartialMetadata",h[h.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));function r(h,_){if(_)return h.toString();const F=a.parse(h);return F?F.notebook.toString():h.toString()}e.getCellUndoRedoComparisonKey=r;var a;(function(h){h.scheme=R.Schemas.vscodeNotebookCell;const _=/^ch(\d{7,})/;function F(B,j){return B.with({scheme:h.scheme,fragment:`ch${j.toString().padStart(7,"0")}${B.scheme!==R.Schemas.file?B.scheme:""}`})}h.generate=F;function N(B){if(B.scheme===h.scheme){const j=_.exec(B.fragment);if(!!j)return{handle:Number(j[1]),notebook:B.with({scheme:B.fragment.substr(j[0].length)||R.Schemas.file,fragment:null})}}}h.parse=N;function z(B){if(B.scheme===R.Schemas.vscodeNotebookCellMetadata){const j=_.exec(B.fragment);if(!!j)return{handle:Number(j[1]),notebook:B.with({scheme:B.fragment.substr(j[0].length)||R.Schemas.file,fragment:null})}}}h.parseCellMetadataUri=z;function ce(B,j,W){return B.with({scheme:W,fragment:`ch${j.toString().padStart(7,"0")}${B.scheme!==R.Schemas.file?B.scheme:""}`})}h.generateCellUri=ce;function de(B,j){if(B.scheme===j){const W=_.exec(B.fragment);if(!!W)return{handle:Number(W[1]),notebook:B.with({scheme:B.fragment.substr(W[0].length)||R.Schemas.file,fragment:null})}}}h.parseCellUri=de})(a=e.CellUri||(e.CellUri={}));const p=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(h){var _,F;return(F=(_=p.get(h))===null||_===void 0?void 0:_.alwaysSecure)!==null&&F!==void 0?F:!1}e.mimeTypeIsAlwaysSecure=m;function y(h){var _,F;return(F=(_=p.get(h))===null||_===void 0?void 0:_.supportedByCore)!==null&&F!==void 0?F:!1}e.mimeTypeSupportedByCore=y;function l(h){var _,F;return(F=(_=p.get(h))===null||_===void 0?void 0:_.mergeable)!==null&&F!==void 0?F:!1}e.mimeTypeIsMergeable=l;function d(h,_){return T.isWindows&&(h=h.replace(/\//g,"\\"),_=_.replace(/\//g,"\\")),v.match(h,_)}function f(h,_,F){let N=0;for(let z=0;z<_.length;z++){if(d(_[z],h))return N;N++}for(let z=0;z<F.length;z++){if(d(F[z],h))return N;N++}return N}function t(h,_,F){return h.sort((N,z)=>f(N,_,F)-f(z,_,F))}e.sortMimeTypes=t;function n(h,_,F,N=(z,ce)=>z===ce){const z=[];function ce(j,W,P){if(!(W===0&&P.length===0)){const H=z[z.length-1];H&&H.start+H.deleteCount===j?(H.deleteCount+=W,H.toInsert.push(...P)):z.push({start:j,deleteCount:W,toInsert:P})}}let de=0,B=0;for(;;){if(de===h.length){ce(de,0,_.slice(B));break}if(B===_.length){ce(de,h.length-de,[]);break}const j=h[de],W=_[B];if(N(j,W)){de+=1,B+=1;continue}F(W)?(ce(de,1,[]),de+=1):(ce(de,0,[W]),B+=1)}return z}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(h){h.default="default",h.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(h){const _=h;return!!((typeof _.include=="string"||v.isRelativePattern(_.include))&&(typeof _.exclude=="string"||v.isRelativePattern(_.exclude)))}e.isDocumentExcludePattern=o;function u(h,_,F){if(Array.isArray(h.viewType)&&h.viewType.indexOf(_)>=0||h.viewType===_)return!0;if(h.filenamePattern){let N=o(h.filenamePattern)?h.filenamePattern.include:h.filenamePattern,z=o(h.filenamePattern)?h.filenamePattern.exclude:void 0;if(v.match(N,(0,C.basename)(F.fsPath).toLowerCase()))return!(z&&v.match(z,(0,C.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class w{constructor(_){this.textModel=_}getElements(){const _=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)_[F]=this.textModel.cells[F].getHashValue();return _}}e.CellSequence=w,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalCompactView="notebook.experimental.compactView",e.ExperimentalFocusIndicator="notebook.experimental.cellFocusIndicator",e.ExperimentalInsertToolbarPosition="notebook.experimental.insertToolbarPosition",e.ExperimentalGlobalToolbar="notebook.experimental.globalToolbar",e.ExperimentalUndoRedoPerCell="notebook.experimental.undoRedoPerCell";var b;(function(h){h[h.Left=1]="Left",h[h.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class I{static create(_){return`${I._prefix}/${_}`}static parse(_){if(_.startsWith(I._prefix))return _.substr(I._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=I,I._prefix="notebook/"}),define(be[170],we([0,1,141,4,64]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,v.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,v.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,v.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[171],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=v;function R(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=R}),define(be[97],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var v;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(S,k)=>{k.expand!==void 0&&(S.expand=k.expand),k.item!==void 0&&(S.item=S.item?Object.assign(S.item,k.item):k.item)};e.applyTestItemUpdate=R;var C;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.Remove=2]="Remove",S[S.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",S[S.Retire=4]="Retire"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(S,k)=>`${S}:${k.toString()}`;e.getTestSubscriptionKey=T;class E{add(k){}update(k){}remove(k,i){}complete(){}}e.IncrementalChangeCollector=E;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const i=this.createChangeCollector();for(const A of k)switch(A[0]){case 0:{const c=A[1];if(c.parent){if(this.items.has(c.parent)){const g=this.items.get(c.parent);g.children.add(c.item.extId);const r=this.createItem(c,g);this.items.set(c.item.extId,r),i.add(r)}}else{this.roots.add(c.item.extId);const g=this.createItem(c);this.items.set(c.item.extId,g),i.add(g)}c.expand===2&&this.busyControllerCount++;break}case 1:{const c=A[1],g=this.items.get(c.extId);if(!g)break;c.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,c.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,c),i.update(g);break}case 2:{const c=this.items.get(A[1]);if(!c)break;c.parent?this.items.get(c.parent).children.delete(c.item.extId):this.roots.delete(c.item.extId);const g=[[A[1]]];for(;g.length;)for(const r of g.pop()){const a=this.items.get(r);a&&(g.push(a.children),this.items.delete(r),i.remove(a,a!==c),a.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(A[1]);break;case 3:this.updatePendingRoots(A[1]);break}i.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new E}}e.AbstractIncrementalTestCollection=D}),define(be[172],we([0,1,14,46,10,23,21,59,142]),function(J,e,v,R,C,T,E,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(A,c,g){this._contributedVariables=new Map,this._context=A,this._labelService=c,g&&(this._envVariablesPromise=g.then(r=>this.prepareEnv(r)))}prepareEnv(A){if(E.isWindows){const c=Object.create(null);return Object.keys(A).forEach(g=>{c[g.toLowerCase()]=A[g]}),c}return A}resolveWithEnvironment(A,c,g){return this.recursiveResolve(this.prepareEnv(A),c?c.uri:void 0,g)}async resolveAsync(A,c){return this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,c)}async resolveAnyBase(A,c,g,r){const a=T.deepClone(c);return E.isWindows&&a.windows?Object.keys(a.windows).forEach(p=>a[p]=a.windows[p]):E.isMacintosh&&a.osx?Object.keys(a.osx).forEach(p=>a[p]=a.osx[p]):E.isLinux&&a.linux&&Object.keys(a.linux).forEach(p=>a[p]=a.linux[p]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,a,g,r)}async resolveAnyAsync(A,c,g){return this.resolveAnyBase(A,c,g)}async resolveAnyMap(A,c,g){const r=new Map;return{newConfig:await this.resolveAnyBase(A,c,g,r),resolvedVariables:r}}resolveWithInteractionReplace(A,c,g,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(A,c,g,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(A,c){if(this._contributedVariables.has(A))throw new Error("Variable "+A+" is contributed twice.");this._contributedVariables.set(A,c)}recursiveResolve(A,c,g,r,a){if(C.isString(g))return this.resolveString(A,c,g,r,a);if(C.isArray(g))return g.map(p=>this.recursiveResolve(A,c,p,r,a));if(C.isObject(g)){let p=Object.create(null);return Object.keys(g).forEach(m=>{const y=this.resolveString(A,c,m,r,a);p[y]=this.recursiveResolve(A,c,g[m],r,a)}),p}return g}resolveString(A,c,g,r,a){return g.replace(k.VARIABLE_REGEXP,(m,y)=>{if(y.includes(k.VARIABLE_LHS))return m;let l=this.evaluateSingleVariable(A,m,y,c,r);return a&&a.set(y,l),l})}fsPath(A){return this._labelService?this._labelService.getUriLabel(A,{noPrefix:!0}):A.fsPath}evaluateSingleVariable(A,c,g,r,a){let p;const m=g.split(":");m.length>1&&(g=m[0],p=m[1]);const y=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error((0,S.localize)(0,null,c))},l=()=>{const f=y();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,c,v.basename(f)))},d=()=>{if(p){const f=this._context.getFolderUri(p);if(f)return f;throw new Error((0,S.localize)(2,null,c,p))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,c)):new Error((0,S.localize)(4,null,c))};switch(g){case"env":if(p){if(A){const f=A[E.isWindows?p.toLowerCase():p];if(C.isString(f))return f}return""}throw new Error((0,S.localize)(5,null,c));case"config":if(p){const f=this._context.getConfigurationValue(r,p);if(C.isUndefinedOrNull(f))throw new Error((0,S.localize)(6,null,c,p));if(C.isObject(f))throw new Error((0,S.localize)(7,null,c,p));return f}throw new Error((0,S.localize)(8,null,c));case"command":return this.resolveFromMap(c,p,a,"command");case"input":return this.resolveFromMap(c,p,a,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return r||p?(0,D.normalizeDriveLetter)(this.fsPath(d())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(d()));case"lineNumber":const f=this._context.getLineNumber();if(f)return f;throw new Error((0,S.localize)(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,c));case"file":return y();case"fileWorkspaceFolder":return l();case"relativeFile":return r||p?v.relative(this.fsPath(d()),y()):y();case"relativeFileDirname":const n=v.dirname(y());if(r||p){const w=v.relative(this.fsPath(d()),n);return w.length===0?".":w}return n;case"fileDirname":return v.dirname(y());case"fileExtname":return v.extname(y());case"fileBasename":return v.basename(y());case"fileBasenameNoExtension":const s=v.basename(y());return s.slice(0,s.length-v.extname(s).length);case"fileDirnameBasename":return v.basename(v.dirname(y()));case"execPath":const o=this._context.getExecPath();return o||c;case"execInstallFolder":const u=this._context.getAppRoot();return u||c;case"pathSeparator":return v.sep;default:try{const w=p?`${g}:${p}`:g;return this.resolveFromMap(c,w,a,void 0)}catch(w){return c}}}}resolveFromMap(A,c,g,r){if(c&&g){const a=r===void 0?g[c]:g[r+":"+c];if(typeof a=="string")return a;throw new Error((0,S.localize)(11,null,A))}return A}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[173],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,v.createDecorator)("editorGroupsService");var R;(function(c){c[c.UP=0]="UP",c[c.DOWN=1]="DOWN",c[c.LEFT=2]="LEFT",c[c.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var C;(function(c){c[c.HORIZONTAL=0]="HORIZONTAL",c[c.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(c){c[c.FIRST=0]="FIRST",c[c.LAST=1]="LAST",c[c.NEXT=2]="NEXT",c[c.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var E;(function(c){c[c.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",c[c.EVEN=1]="EVEN",c[c.TOGGLE=2]="TOGGLE"})(E=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(c){c[c.COPY_EDITORS=0]="COPY_EDITORS",c[c.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var S;(function(c){c[c.CREATION_TIME=0]="CREATION_TIME",c[c.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",c[c.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(S=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(c){c[c.GROUP_ACTIVE=0]="GROUP_ACTIVE",c[c.GROUP_INDEX=1]="GROUP_INDEX",c[c.EDITOR_OPEN=2]="EDITOR_OPEN",c[c.EDITOR_CLOSE=3]="EDITOR_CLOSE",c[c.EDITOR_MOVE=4]="EDITOR_MOVE",c[c.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",c[c.EDITOR_LABEL=6]="EDITOR_LABEL",c[c.EDITOR_PIN=7]="EDITOR_PIN",c[c.EDITOR_STICKY=8]="EDITOR_STICKY",c[c.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(c){c[c.NEW_EDITOR=1]="NEW_EDITOR",c[c.MOVE_EDITOR=2]="MOVE_EDITOR",c[c.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function A(c){return c.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=A}),define(be[174],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,v.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(be[9],we([0,1,13,84,228,58,23,10,2,32,63,143,91,50,174,7]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(me){function pe(K){const{selectionStartLineNumber:Oe,selectionStartColumn:Ae,positionLineNumber:rt,positionColumn:tt}=K,ct=new a.Position(Oe-1,Ae-1),at=new a.Position(rt-1,tt-1);return new a.Selection(ct,at)}me.to=pe;function se(K){const{anchor:Oe,active:Ae}=K;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Ae.line+1,positionColumn:Ae.character+1}}me.from=se})(p=e.Selection||(e.Selection={}));var m;(function(me){function pe(K){if(!!K){const{start:Oe,end:Ae}=K;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Ae.line+1,endColumn:Ae.character+1}}}me.from=pe;function se(K){if(!!K){const{startLineNumber:Oe,startColumn:Ae,endLineNumber:rt,endColumn:tt}=K;return new a.Range(Oe-1,Ae-1,rt-1,tt-1)}}me.to=se})(m=e.Range||(e.Range={}));var y;(function(me){function pe(se){switch(se){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 4:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}me.to=pe})(y=e.TokenType||(e.TokenType={}));var l;(function(me){function pe(K){return new a.Position(K.lineNumber-1,K.column-1)}me.to=pe;function se(K){return{lineNumber:K.line+1,column:K.character+1}}me.from=se})(l=e.Position||(e.Position={}));var d;(function(me){function pe(K){switch(K){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}me.from=pe;function se(K){switch(K){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}me.to=se})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(me){function pe(K){let Oe;return K.code&&((0,D.isString)(K.code)||(0,D.isNumber)(K.code)?Oe=String(K.code):Oe={value:String(K.code.value),target:K.code.target}),Object.assign(Object.assign({},m.from(K.range)),{message:K.message,source:K.source,code:Oe,severity:n.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?(0,v.coalesce)(K.tags.map(d.from)):void 0})}me.from=pe;function se(K){var Oe;const Ae=new a.Diagnostic(m.to(K),K.message,n.to(K.severity));return Ae.source=K.source,Ae.code=(0,D.isString)(K.code)?K.code:(Oe=K.code)===null||Oe===void 0?void 0:Oe.value,Ae.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),Ae.tags=K.tags&&(0,v.coalesce)(K.tags.map(d.to)),Ae}me.to=se})(f=e.Diagnostic||(e.Diagnostic={}));var t;(function(me){function pe(K){return Object.assign(Object.assign({},m.from(K.location.range)),{message:K.message,resource:K.location.uri})}me.from=pe;function se(K){return new a.DiagnosticRelatedInformation(new a.Location(K.resource,m.to(K)),K.message)}me.to=se})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(me){function pe(K){switch(K){case a.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}me.from=pe;function se(K){switch(K){case c.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}me.to=se})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(me){function pe(K){return typeof K=="number"&&K>=a.ViewColumn.One?K-1:K===a.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}me.from=pe;function se(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=se})(s=e.ViewColumn||(e.ViewColumn={}));function o(me){return typeof me.range!="undefined"}function u(me){return me.length===0?!0:!!o(me[0])}e.isDecorationOptionsArr=u;var w;(function(me){function pe(tt){return tt.map(me.from)}me.fromMany=pe;function se(tt){return tt&&typeof tt=="object"&&typeof tt.language=="string"&&typeof tt.value=="string"}function K(tt){let ct;if(se(tt)){const{language:ut,value:mt}=tt;ct={value:"```"+ut+`
`+mt+"\n```\n"}}else a.MarkdownString.isMarkdownString(tt)?ct={value:tt.value,isTrusted:tt.isTrusted,supportThemeIcons:tt.supportThemeIcons}:typeof tt=="string"?ct={value:tt}:ct={value:""};const at=Object.create(null);ct.uris=at;const Je=ut=>{try{let mt=S.URI.parse(ut,!0);mt=mt.with({query:Oe(mt.query,at)}),at[ut]=mt}catch(mt){}return""},ft=new C.Renderer;return ft.link=Je,ft.image=ut=>Je(R.parseHrefAndDimensions(ut).href),C(ct.value,{renderer:ft}),ct}me.from=K;function Oe(tt,ct){if(!tt)return tt;let at;try{at=(0,T.parse)(tt)}catch(ft){}if(!at)return tt;let Je=!1;return at=(0,E.cloneAndChange)(at,ft=>{if(S.URI.isUri(ft)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ut]=ft,Je=!0,ut}else return}),Je?JSON.stringify(at):tt}function Ae(tt){const ct=new a.MarkdownString(tt.value,tt.supportThemeIcons);return ct.isTrusted=tt.isTrusted,ct}me.to=Ae;function rt(tt){if(!!tt)return typeof tt=="string"?tt:me.from(tt)}me.fromStrict=rt})(w=e.MarkdownString||(e.MarkdownString={}));function b(me){return u(me)?me.map(pe=>({range:m.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?w.fromMany(pe.hoverMessage):pe.hoverMessage?w.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):me.map(pe=>({range:m.from(pe)}))}e.fromRangeOrRangeWithMessage=b;function I(me){return typeof me=="undefined"?me:typeof me=="string"?S.URI.file(me):me}e.pathOrURIToURI=I;var h;(function(me){function pe(se){return typeof se=="undefined"?se:{contentText:se.contentText,contentIconPath:se.contentIconPath?I(se.contentIconPath):void 0,border:se.border,borderColor:se.borderColor,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,color:se.color,backgroundColor:se.backgroundColor,margin:se.margin,width:se.width,height:se.height}}me.from=pe})(h=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var _;(function(me){function pe(se){return typeof se=="undefined"?se:{backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?I(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?h.from(se.before):void 0,after:se.after?h.from(se.after):void 0}}me.from=pe})(_=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(me){function pe(se){if(typeof se=="undefined")return se;switch(se){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}me.from=pe})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(me){function pe(se){return{isWholeLine:se.isWholeLine,rangeBehavior:se.rangeBehavior?F.from(se.rangeBehavior):void 0,overviewRulerLane:se.overviewRulerLane,light:se.light?_.from(se.light):void 0,dark:se.dark?_.from(se.dark):void 0,backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?I(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?h.from(se.before):void 0,after:se.after?h.from(se.after):void 0}}me.from=pe})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(me){function pe(K){return{text:K.newText,eol:K.newEol&&Z.from(K.newEol),range:m.from(K.range)}}me.from=pe;function se(K){const Oe=new a.TextEdit(m.to(K.range),K.text);return Oe.newEol=typeof K.eol=="undefined"?void 0:Z.to(K.eol),Oe}me.to=se})(z=e.TextEdit||(e.TextEdit={}));var ce;(function(me){function pe(K,Oe,Ae){var rt,tt,ct;const at={edits:[]};if(K instanceof a.WorkspaceEdit)for(let Je of K._allEntries())if(Je._type===1)at.edits.push({_type:1,oldUri:Je.from,newUri:Je.to,options:Je.options,metadata:Je.metadata});else if(Je._type===2){const ft=Oe==null?void 0:Oe.getDocument(Je.uri);at.edits.push({_type:2,resource:Je.uri,edit:z.from(Je.edit),modelVersionId:ft==null?void 0:ft.version,metadata:Je.metadata})}else Je._type===3?at.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:(rt=Ae==null?void 0:Ae.getNotebookDocument(Je.uri,!0))===null||rt===void 0?void 0:rt.apiNotebook.version}):Je._type===4?(Je.newOutputs&&at.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:2,index:Je.index,append:Je.append,outputs:Je.newOutputs.map(_e.from)}}),Je.newMetadata&&at.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:8,index:Je.index,metadata:Je.newMetadata}})):Je._type===5?at.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,notebookVersionId:(tt=Ae==null?void 0:Ae.getNotebookDocument(Je.uri,!0))===null||tt===void 0?void 0:tt.apiNotebook.version,edit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(re.from)}}):Je._type===6&&at.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:7,outputId:Je.outputId,items:((ct=Je.newOutputItems)===null||ct===void 0?void 0:ct.map(Ie.from))||[],append:Je.append}});return at}me.from=pe;function se(K){const Oe=new a.WorkspaceEdit;for(const Ae of K.edits)Ae.edit?Oe.replace(S.URI.revive(Ae.resource),m.to(Ae.edit.range),Ae.edit.text):Oe.renameFile(S.URI.revive(Ae.oldUri),S.URI.revive(Ae.newUri),Ae.options);return Oe}me.to=se})(ce=e.WorkspaceEdit||(e.WorkspaceEdit={}));var de;(function(me){const pe=Object.create(null);pe[a.SymbolKind.File]=0,pe[a.SymbolKind.Module]=1,pe[a.SymbolKind.Namespace]=2,pe[a.SymbolKind.Package]=3,pe[a.SymbolKind.Class]=4,pe[a.SymbolKind.Method]=5,pe[a.SymbolKind.Property]=6,pe[a.SymbolKind.Field]=7,pe[a.SymbolKind.Constructor]=8,pe[a.SymbolKind.Enum]=9,pe[a.SymbolKind.Interface]=10,pe[a.SymbolKind.Function]=11,pe[a.SymbolKind.Variable]=12,pe[a.SymbolKind.Constant]=13,pe[a.SymbolKind.String]=14,pe[a.SymbolKind.Number]=15,pe[a.SymbolKind.Boolean]=16,pe[a.SymbolKind.Array]=17,pe[a.SymbolKind.Object]=18,pe[a.SymbolKind.Key]=19,pe[a.SymbolKind.Null]=20,pe[a.SymbolKind.EnumMember]=21,pe[a.SymbolKind.Struct]=22,pe[a.SymbolKind.Event]=23,pe[a.SymbolKind.Operator]=24,pe[a.SymbolKind.TypeParameter]=25;function se(Oe){return typeof pe[Oe]=="number"?pe[Oe]:6}me.from=se;function K(Oe){for(const Ae in pe)if(pe[Ae]===Oe)return Number(Ae);return a.SymbolKind.Property}me.to=K})(de=e.SymbolKind||(e.SymbolKind={}));var B;(function(me){function pe(K){switch(K){case a.SymbolTag.Deprecated:return 1}}me.from=pe;function se(K){switch(K){case 1:return a.SymbolTag.Deprecated}}me.to=se})(B=e.SymbolTag||(e.SymbolTag={}));var j;(function(me){function pe(K){return{name:K.name,kind:de.from(K.kind),tags:K.tags&&K.tags.map(B.from),containerName:K.containerName,location:$.from(K.location)}}me.from=pe;function se(K){const Oe=new a.SymbolInformation(K.name,de.to(K.kind),K.containerName,$.to(K.location));return Oe.tags=K.tags&&K.tags.map(B.to),Oe}me.to=se})(j=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var W;(function(me){function pe(K){var Oe,Ae;const rt={name:K.name||"!!MISSING: name!!",detail:K.detail,range:m.from(K.range),selectionRange:m.from(K.selectionRange),kind:de.from(K.kind),tags:(Ae=(Oe=K.tags)===null||Oe===void 0?void 0:Oe.map(B.from))!==null&&Ae!==void 0?Ae:[]};return K.children&&(rt.children=K.children.map(pe)),rt}me.from=pe;function se(K){const Oe=new a.DocumentSymbol(K.name,K.detail,de.to(K.kind),m.to(K.range),m.to(K.selectionRange));return(0,v.isNonEmptyArray)(K.tags)&&(Oe.tags=K.tags.map(B.to)),K.children&&(Oe.children=K.children.map(se)),Oe}me.to=se})(W=e.DocumentSymbol||(e.DocumentSymbol={}));var P;(function(me){function pe(se){const K=new a.CallHierarchyItem(de.to(se.kind),se.name,se.detail||"",S.URI.revive(se.uri),m.to(se.range),m.to(se.selectionRange));return K._sessionId=se._sessionId,K._itemId=se._itemId,K}me.to=pe})(P=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(me){function pe(se){return new a.CallHierarchyIncomingCall(P.to(se.from),se.fromRanges.map(K=>m.to(K)))}me.to=pe})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var L;(function(me){function pe(se){return new a.CallHierarchyOutgoingCall(P.to(se.to),se.fromRanges.map(K=>m.to(K)))}me.to=pe})(L=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(me){function pe(K){return{range:K.range&&m.from(K.range),uri:K.uri}}me.from=pe;function se(K){return new a.Location(S.URI.revive(K.uri),m.to(K.range))}me.to=se})($=e.location||(e.location={}));var Q;(function(me){function pe(K){const Oe=K,Ae=K;return{originSelectionRange:Oe.originSelectionRange?m.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Ae.uri,range:m.from(Oe.targetRange?Oe.targetRange:Ae.range),targetSelectionRange:Oe.targetSelectionRange?m.from(Oe.targetSelectionRange):void 0}}me.from=pe;function se(K){return{targetUri:S.URI.revive(K.uri),targetRange:m.to(K.range),targetSelectionRange:K.targetSelectionRange?m.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?m.to(K.originSelectionRange):void 0}}me.to=se})(Q=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(me){function pe(K){return{range:m.from(K.range),contents:w.fromMany(K.contents)}}me.from=pe;function se(K){return new a.Hover(K.contents.map(w.to),m.to(K.range))}me.to=se})(q=e.Hover||(e.Hover={}));var ae;(function(me){function pe(K){return{range:m.from(K.range),expression:K.expression}}me.from=pe;function se(K){return new a.EvaluatableExpression(m.to(K.range),K.expression)}me.to=se})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var fe;(function(me){function pe(K){if(K instanceof a.InlineValueText)return{type:"text",range:m.from(K.range),text:K.text};if(K instanceof a.InlineValueVariableLookup)return{type:"variable",range:m.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}me.from=pe;function se(K){switch(K.type){case"text":return{range:m.to(K.range),text:K.text};case"variable":return{range:m.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:m.to(K.range),expression:K.expression}}}me.to=se})(fe=e.InlineValue||(e.InlineValue={}));var Le;(function(me){function pe(K){return{frameId:K.frameId,stoppedLocation:m.from(K.stoppedLocation)}}me.from=pe;function se(K){return new a.InlineValueContext(K.frameId,m.to(K.stoppedLocation))}me.to=se})(Le=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(me){function pe(K){return{range:m.from(K.range),kind:K.kind}}me.from=pe;function se(K){return new a.DocumentHighlight(m.to(K.range),K.kind)}me.to=se})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(me){function pe(se){switch(se){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}me.to=pe})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var He;(function(me){function pe(se){return{triggerKind:Fe.to(se.triggerKind),triggerCharacter:se.triggerCharacter}}me.to=pe})(He=e.CompletionContext||(e.CompletionContext={}));var x;(function(me){function pe(K){switch(K){case a.CompletionItemTag.Deprecated:return 1}}me.from=pe;function se(K){switch(K){case 1:return a.CompletionItemTag.Deprecated}}me.to=se})(x=e.CompletionItemTag||(e.CompletionItemTag={}));var G;(function(me){const pe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function se(Ae){var rt;return(rt=pe.get(Ae))!==null&&rt!==void 0?rt:9}me.from=se;const K=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Oe(Ae){var rt;return(rt=K.get(Ae))!==null&&rt!==void 0?rt:a.CompletionItemKind.Property}me.to=Oe})(G=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(me){function pe(se,K){var Oe;const Ae=new a.CompletionItem(typeof se.label=="string"?se.label:se.label.name);return typeof se.label!="string"&&(Ae.label2=se.label),Ae.insertText=se.insertText,Ae.kind=G.to(se.kind),Ae.tags=(Oe=se.tags)===null||Oe===void 0?void 0:Oe.map(x.to),Ae.detail=se.detail,Ae.documentation=R.isMarkdownString(se.documentation)?w.to(se.documentation):se.documentation,Ae.sortText=se.sortText,Ae.filterText=se.filterText,Ae.preselect=se.preselect,Ae.commitCharacters=se.commitCharacters,k.Range.isIRange(se.range)?Ae.range=m.to(se.range):typeof se.range=="object"&&(Ae.range={inserting:m.to(se.range.insert),replacing:m.to(se.range.replace)}),Ae.keepWhitespace=typeof se.insertTextRules=="undefined"?!1:Boolean(se.insertTextRules&1),typeof se.insertTextRules!="undefined"&&se.insertTextRules&4?Ae.insertText=new a.SnippetString(se.insertText):(Ae.insertText=se.insertText,Ae.textEdit=Ae.range instanceof a.Range?new a.TextEdit(Ae.range,Ae.insertText):void 0),se.additionalTextEdits&&se.additionalTextEdits.length>0&&(Ae.additionalTextEdits=se.additionalTextEdits.map(rt=>z.to(rt))),Ae.command=K&&se.command?K.fromInternal(se.command):void 0,Ae}me.to=pe})(ee=e.CompletionItem||(e.CompletionItem={}));var ie;(function(me){function pe(K){return{label:K.label,documentation:K.documentation?w.fromStrict(K.documentation):void 0}}me.from=pe;function se(K){return{label:K.label,documentation:R.isMarkdownString(K.documentation)?w.to(K.documentation):K.documentation}}me.to=se})(ie=e.ParameterInformation||(e.ParameterInformation={}));var ue;(function(me){function pe(K){return{label:K.label,documentation:K.documentation?w.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(ie.from):[],activeParameter:K.activeParameter}}me.from=pe;function se(K){return{label:K.label,documentation:R.isMarkdownString(K.documentation)?w.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(ie.to):[],activeParameter:K.activeParameter}}me.to=se})(ue=e.SignatureInformation||(e.SignatureInformation={}));var Ee;(function(me){function pe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ue.from):[]}}me.from=pe;function se(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ue.to):[]}}me.to=se})(Ee=e.SignatureHelp||(e.SignatureHelp={}));var $e;(function(me){function pe(K){var Oe;return{text:K.text,position:l.from(K.position),kind:he.from((Oe=K.kind)!==null&&Oe!==void 0?Oe:a.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}me.from=pe;function se(K){const Oe=new a.InlayHint(K.text,l.to(K.position),he.to(K.kind));return Oe.whitespaceAfter=K.whitespaceAfter,Oe.whitespaceBefore=K.whitespaceBefore,Oe}me.to=se})($e=e.InlayHint||(e.InlayHint={}));var he;(function(me){function pe(K){return K}me.from=pe;function se(K){return K}me.to=se})(he=e.InlayHintKind||(e.InlayHintKind={}));var Ce;(function(me){function pe(K){return{range:m.from(K.range),url:K.target,tooltip:K.tooltip}}me.from=pe;function se(K){let Oe;if(K.url)try{Oe=typeof K.url=="string"?S.URI.parse(K.url,!0):S.URI.revive(K.url)}catch(Ae){}return new a.DocumentLink(m.to(K.range),Oe)}me.to=se})(Ce=e.DocumentLink||(e.DocumentLink={}));var Te;(function(me){function pe(K){const Oe=new a.ColorPresentation(K.label);return K.textEdit&&(Oe.textEdit=z.to(K.textEdit)),K.additionalTextEdits&&(Oe.additionalTextEdits=K.additionalTextEdits.map(Ae=>z.to(Ae))),Oe}me.to=pe;function se(K){return{label:K.label,textEdit:K.textEdit?z.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Oe=>z.from(Oe)):void 0}}me.from=se})(Te=e.ColorPresentation||(e.ColorPresentation={}));var We;(function(me){function pe(K){return new a.Color(K[0],K[1],K[2],K[3])}me.to=pe;function se(K){return[K.red,K.green,K.blue,K.alpha]}me.from=se})(We=e.Color||(e.Color={}));var ve;(function(me){function pe(K){return{range:m.from(K.range)}}me.from=pe;function se(K){return new a.SelectionRange(m.to(K.range))}me.to=se})(ve=e.SelectionRange||(e.SelectionRange={}));var Ge;(function(me){function pe(se){switch(se){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}me.to=pe})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(me){function pe(K){switch(K){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}me.from=pe;function se(K){switch(K){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}me.to=se})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Z;(function(me){function pe(K){if(K===a.EndOfLine.CRLF)return 1;if(K===a.EndOfLine.LF)return 0}me.from=pe;function se(K){if(K===1)return a.EndOfLine.CRLF;if(K===0)return a.EndOfLine.LF}me.to=se})(Z=e.EndOfLine||(e.EndOfLine={}));var ge;(function(me){function pe(se){if(typeof se=="object")return se.viewId;switch(se){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}me.from=pe})(ge=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(me){function pe(se){const K={start:se.start+1,end:se.end+1};return se.kind&&(K.kind=Ve.from(se.kind)),K}me.from=pe})(Ne=e.FoldingRange||(e.FoldingRange={}));var Ve;(function(me){function pe(se){if(se)switch(se){case a.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}me.from=pe})(Ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Be;(function(me){function pe(se){if(se)return{pinned:typeof se.preview=="boolean"?!se.preview:void 0,inactive:se.background,preserveFocus:se.preserveFocus,selection:typeof se.selection=="object"?m.from(se.selection):void 0,override:typeof se.override=="boolean"?A.EditorOverride.DISABLED:void 0}}me.from=pe})(Be=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(me){function pe(K){return K instanceof a.RelativePattern||typeof K=="string"?K:se(K)?new a.RelativePattern(K.base,K.pattern):K}me.from=pe;function se(K){const Oe=K;return Oe&&typeof Oe.base=="string"&&typeof Oe.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var Se;(function(me){function pe(se){if(se){if(Array.isArray(se))return se.map(pe);if(typeof se=="string")return se;{const K=se;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:Ze.from(K.pattern),exclusive:K.exclusive}}}else return}me.from=pe})(Se=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(me){function pe(K){return{start:K.start,end:K.end}}me.from=pe;function se(K){return new a.NotebookRange(K.start,K.end)}me.to=se})(ye=e.NotebookRange||(e.NotebookRange={}));var ke;(function(me){function pe(se){return new a.NotebookCellMetadata().with(Object.assign(Object.assign({},se),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}me.to=pe})(ke=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var ne;(function(me){function pe(K){return K}me.from=pe;function se(K){return new a.NotebookDocumentMetadata().with(K)}me.to=se})(ne=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var oe;(function(me){function pe(K){return{startTime:K.runStartTime,endTime:K.runEndTime,executionOrder:K.executionOrder,success:K.lastRunSuccess}}me.to=pe;function se(K){return{lastRunSuccess:K.success,runStartTime:K.startTime,runEndTime:K.endTime,executionOrder:K.executionOrder}}me.from=se})(oe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var O;(function(me){function pe(K){switch(K){case a.NotebookCellKind.Markup:return g.CellKind.Markup;case a.NotebookCellKind.Code:default:return g.CellKind.Code}}me.from=pe;function se(K){switch(K){case g.CellKind.Markup:return a.NotebookCellKind.Markup;case g.CellKind.Code:default:return a.NotebookCellKind.Code}}me.to=se})(O=e.NotebookCellKind||(e.NotebookCellKind={}));var Y;(function(me){function pe(K){const Oe={metadata:ne.from(K.metadata),cells:[]};for(let Ae of K.cells)a.NotebookCellData.validate(Ae),Oe.cells.push(re.from(Ae));return Oe}me.from=pe;function se(K){return{metadata:ne.to(K.metadata),cells:K.cells.map(re.to)}}me.to=se})(Y=e.NotebookData||(e.NotebookData={}));var re;(function(me){function pe(K){var Oe;return{cellKind:O.from(K.kind),language:K.languageId,source:K.value,metadata:K.metadata,internalMetadata:oe.from((Oe=K.executionSummary)!==null&&Oe!==void 0?Oe:{}),outputs:K.outputs?K.outputs.map(_e.from):[]}}me.from=pe;function se(K){return new a.NotebookCellData(O.to(K.cellKind),K.source,K.language,K.outputs?K.outputs.map(_e.to):void 0,K.metadata?ke.to(K.metadata):void 0)}me.to=se})(re=e.NotebookCellData||(e.NotebookCellData={}));var Ie;(function(me){function pe(K){return{mime:K.mime,value:K.value,metadata:K.metadata}}me.from=pe;function se(K){return new a.NotebookCellOutputItem(K.mime,K.value,K.metadata)}me.to=se})(Ie=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var _e;(function(me){function pe(K){return{outputId:K.id,outputs:K.outputs.map(Ie.from),metadata:K.metadata}}me.from=pe;function se(K){const Oe=K.outputs.map(Ie.to);return new a.NotebookCellOutput(Oe,K.outputId,K.metadata)}me.to=se})(_e=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Re;(function(me){function pe(Ae){if(Ae!=null){if(Ae instanceof a.RelativePattern||typeof Ae=="string")return Ae;if(Oe(Ae))return new a.RelativePattern(Ae.base,Ae.pattern);if(K(Ae))return{include:Ze.from(Ae.include)||void 0,exclude:Ze.from(Ae.exclude)||void 0}}}me.from=pe;function se(Ae){return typeof Ae=="string"?Ae:Oe(Ae)?{base:Ae.base,pattern:Ae.pattern}:{include:Ae.include,exclude:Ae.exclude}}me.to=se;function K(Ae){const rt=Ae,tt=Ze.from(rt.include);if(!(tt&&tt instanceof a.RelativePattern||typeof tt=="string"))return!1;const ct=Ze.from(rt.exclude);return!!(ct&&ct instanceof a.RelativePattern||typeof ct=="string")}function Oe(Ae){const rt=Ae;return rt&&typeof rt.base=="string"&&typeof rt.pattern=="string"}})(Re=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ze;(function(me){function pe(se){return{backgroundColor:se.backgroundColor,borderColor:se.borderColor,top:se.top?h.from(se.top):void 0}}me.from=pe})(ze=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Xe;(function(me){function pe(se,K,Oe){const Ae=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{alignment:se.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ae,Oe),text:se.text,tooltip:se.tooltip,accessibilityInformation:se.accessibilityInformation,priority:se.priority}}me.from=pe})(Xe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var st;(function(me){function pe(se){var K,Oe,Ae;return{transientOutputs:(K=se==null?void 0:se.transientOutputs)!==null&&K!==void 0?K:!1,transientCellMetadata:(Oe=se==null?void 0:se.transientCellMetadata)!==null&&Oe!==void 0?Oe:{},transientDocumentMetadata:(Ae=se==null?void 0:se.transientDocumentMetadata)!==null&&Ae!==void 0?Ae:{}}}me.from=pe})(st=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ye;(function(me){function pe(K){var Oe;return{uri:K.uri,provides:typeof K.provides=="string"?[K.provides]:(Oe=K.provides)!==null&&Oe!==void 0?Oe:[]}}me.from=pe;function se(K){return new a.NotebookKernelPreload(S.URI.revive(K.uri),K.provides)}me.to=se})(Ye=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var et;(function(me){function pe(K){return{message:w.fromStrict(K.message)||"",severity:K.severity,expectedOutput:K.expectedOutput,actualOutput:K.actualOutput,location:K.location?$.from(K.location):void 0}}me.from=pe;function se(K){const Oe=new a.TestMessage(typeof K.message=="string"?K.message:w.to(K.message));return Oe.severity=K.severity,Oe.actualOutput=K.actualOutput,Oe.expectedOutput=K.expectedOutput,Oe}me.to=se})(et=e.TestMessage||(e.TestMessage={}));var pt;(function(me){function pe(Ae){var rt,tt;return{extId:Ae.id,label:Ae.label,uri:Ae.uri,range:m.from(Ae.range)||null,debuggable:(rt=Ae.debuggable)!==null&&rt!==void 0?rt:!1,description:Ae.description||null,runnable:(tt=Ae.runnable)!==null&&tt!==void 0?tt:!0,error:Ae.error&&w.fromStrict(Ae.error)||null}}me.from=pe;function se(Ae){return{extId:Ae.id,label:Ae.label,uri:Ae.uri,range:m.from(Ae.range)||null,debuggable:!1,description:Ae.description||null,error:null,runnable:!0}}me.fromResultSnapshot=se;function K(Ae){return{id:Ae.extId,label:Ae.label,uri:S.URI.revive(Ae.uri),range:m.to(Ae.range||void 0),addChild:()=>{},dispose:()=>{},status:a.TestItemStatus.Pending,data:void 0,debuggable:Ae.debuggable,description:Ae.description||void 0,runnable:Ae.runnable}}me.toPlain=K;function Oe(Ae){const rt=new a.TestItemImpl(Ae.extId,Ae.label,S.URI.revive(Ae.uri),void 0);return rt.range=m.to(Ae.range||void 0),rt.debuggable=Ae.debuggable,rt.description=Ae.description||void 0,rt.runnable=Ae.runnable,rt}me.to=Oe})(pt=e.TestItem||(e.TestItem={}));var _t;(function(me){const pe=(K,Oe)=>Object.assign(Object.assign({},pt.toPlain(K.item)),{taskStates:K.tasks.map(Ae=>({state:Ae.state,duration:Ae.duration,messages:Ae.messages.map(et.to)})),children:K.children.map(Ae=>Oe.get(Ae)).filter(D.isDefined).map(Ae=>pe(Ae,Oe))});function se(K){const Oe=[],Ae=new Map;for(const rt of K.items)Ae.set(rt.item.extId,rt),rt.direct&&Oe.push(rt);return{completedAt:K.completedAt,results:Oe.map(rt=>pe(rt,Ae))}}me.to=se})(_t=e.TestResults||(e.TestResults={}));var je;(function(me){function pe(se){switch(se){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}me.to=pe})(je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(be[175],we([0,1,2,12,7,9,45]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(k,i,A,c={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=A,this._thresholds=c,this._callbacks=new E.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,A,c)=>{const r={dispose:this._callbacks.push([i,A,k])};return Array.isArray(c)&&c.push(r),r}}async $participateInSave(k,i){const A=v.URI.revive(k);let c=!1;const g=setTimeout(()=>c=!0,this._thresholds.timeout),r=[];try{for(let a of[...this._callbacks]){if(c)break;const p=this._documents.getDocument(A),m=await this._deliverEventAsyncAndBlameBadListeners(a,{document:p,reason:T.TextDocumentSaveReason.to(i)});r.push(m)}}finally{clearTimeout(g)}return r}_deliverEventAsyncAndBlameBadListeners([k,i,A],c){const g=this._badListeners.get(k);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(A,k,i,c).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const a=this._badListeners.get(k);this._badListeners.set(k,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,A,c){const g=[],r=Date.now(),{document:a,reason:p}=c,{version:m}=a,y=Object.freeze({document:a,reason:p,waitUntil(l){if(Object.isFrozen(g))throw(0,R.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(l))}});try{i.apply(A,[y])}catch(l){return Promise.reject(l)}return Object.freeze(g),new Promise((l,d)=>{const f=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(f),l(t)}).catch(t=>{clearTimeout(f),d(t)})}).then(l=>{const d={edits:[]};for(const f of l)if(Array.isArray(f)&&f.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:n,range:s}of f)d.edits.push({_type:2,resource:a.uri,edit:{range:s&&T.Range.from(s),text:t,eol:n&&T.EndOfLine.from(n)}});if(d.edits.length!==0)return m===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(be[176],we([0,1,3,11,28,2,9,7]),function(J,e,v,R,C,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(A,c,g,r,a){this._onDidCreate=new v.Emitter,this._onDidChange=new v.Emitter,this._onDidDelete=new v.Emitter,this._config=0,g&&(this._config+=1),r&&(this._config+=2),a&&(this._config+=4);const p=(0,C.parse)(c),m=A(y=>{if(!g)for(let l of y.created){const d=T.URI.revive(l);p(d.fsPath)&&this._onDidCreate.fire(d)}if(!r)for(let l of y.changed){const d=T.URI.revive(l);p(d.fsPath)&&this._onDidChange.fire(d)}if(!a)for(let l of y.deleted){const d=T.URI.revive(l);p(d.fsPath)&&this._onDidDelete.fire(d)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(A,c,g){this._logService=c,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new v.Emitter,this._onDidRenameFile=new v.Emitter,this._onDidCreateFile=new v.Emitter,this._onDidDeleteFile=new v.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(A,c,g,r){return new S(this._onFileSystemEvent.event,A,c,g,r)}$onFileEvent(A){this._onFileSystemEvent.fire(A)}$onDidRunFileOperation(A,c){switch(A){case 2:this._onDidRenameFile.fire(Object.freeze({files:c.map(g=>({oldUri:T.URI.revive(g.source),newUri:T.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:c.map(g=>T.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:c.map(g=>T.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(A){return this._createWillExecuteEvent(A,this._onWillRenameFile)}getOnWillCreateFileEvent(A){return this._createWillExecuteEvent(A,this._onWillCreateFile)}getOnWillDeleteFileEvent(A){return this._createWillExecuteEvent(A,this._onWillDeleteFile)}_createWillExecuteEvent(A,c){return(g,r,a)=>{const p=function(y){g.call(r,y)};return p.extension=A,c.event(p,void 0,a)}}async $onWillRunFileOperation(A,c,g,r){switch(A){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:c.map(a=>({oldUri:T.URI.revive(a.source),newUri:T.URI.revive(a.target)}))},g,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:c.map(a=>T.URI.revive(a.target))},g,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:c.map(a=>T.URI.revive(a.target))},g,r)}}async _fireWillEvent(A,c,g,r){const a=new Set,p=[];if(await A.fireAsync(c,r,async(y,l)=>{var d;const f=Date.now(),t=await Promise.resolve(y);t instanceof D.WorkspaceEdit&&(p.push(t),a.add((d=l.extension.displayName)!==null&&d!==void 0?d:l.extension.identifier.value)),Date.now()-f>g&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),!r.isCancellationRequested&&p.length!==0){const m={edits:[]};for(let y of p){let{edits:l}=E.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(l)}return{edit:m,extensionNames:Array.from(a)}}}}e.ExtHostFileSystemEventService=k}),define(be[177],we([0,1,17,23,2,9,7,50]),function(J,e,v,R,C,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(c,g,r,a){this.start=c,this.deletedCount=g,this.deletedItems=r,this.items=a}static asApiEvents(c){return c.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(r=>r.apiCell)}))}}class k{constructor(c,g,r){var a,p,m;this.notebook=c,this._extHostDocument=g,this._cellData=r,this.handle=r.handle,this.uri=C.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(a=r.internalMetadata)!==null&&a!==void 0?a:{},this._metadata=T.NotebookCellMetadata.to((p=r.metadata)!==null&&p!==void 0?p:{}),this._previousResult=T.NotebookCellExecutionSummary.to((m=r.internalMetadata)!==null&&m!==void 0?m:{})}static asModelAddData(c,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(T.NotebookCellOutput.to)}setOutputItems(c,g,r){const a=r.map(T.NotebookCellOutputItem.to),p=this._outputs.find(m=>m.id===c);p&&(g||(p.outputs.length=0),p.outputs.push(...a))}setMetadata(c){this._metadata=T.NotebookCellMetadata.to(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=T.NotebookCellExecutionSummary.to(c)}}e.ExtHostCell=k;class i{constructor(c,g,r,a,p,m,y){this._proxy=c,this._textDocumentsAndEditors=g,this._textDocuments=r,this._emitter=a,this._viewType=p,this._metadata=m,this.uri=y,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get viewType(){return c._viewType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===v.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(g){return g=c._validateIndex(g),c._cells[g].apiCell},getCells(g){return(g?c._getCells(g):c._cells).map(a=>a.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=c}disposeBackup(){var c;(c=this._backup)===null||c===void 0||c.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=this._metadata.with(c.metadata))}acceptModelChanged(c,g){this._versionId=c.versionId,this._isDirty=g;for(const r of c.rawEvents)r.kind===D.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===D.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(r.index,r.metadata):r.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(r.index,r.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let g=c.start|0,r=c.end|0;return g<0&&(g=0),r>this._cells.length&&(r=this._cells.length),c.with({start:g,end:r})}_getCells(c){c=this._validateRange(c);const g=[];for(let r=c.start;r<c.end;r++)g.push(this._cells[r]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,g){if(!this._disposed){const r=[],a=[],p=[];c.reverse().forEach(m=>{const l=m[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return g||a.push(k.asModelAddData(this.apiNotebook,t)),n}),d=new S(m[0],m[1],[],l),f=this._cells.splice(m[0],m[1],...l);for(const t of f)p.push(t.uri),d.deletedItems.push(t.apiCell);r.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:p}),g||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(r)}))}}_moveCell(c,g){const r=this._cells.splice(c,1);this._cells.splice(g,0,...r);const a=[new S(c,1,r.map(p=>p.apiCell),[]),new S(g,0,[],r)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(a)}))}_setCellOutputs(c,g){const r=this._cells[c];r.setOutputs(g),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(c,g,r,a){const p=this._cells[c];p.setOutputItems(g,r,a),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(c,g){const r=this._cells[c];r.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(r.uri,g)}_changeCellMetadata(c,g){const r=this._cells[c],a=r.apiCell.metadata;r.setMetadata(g);const p=r.apiCell.metadata;(0,R.equals)(a,p)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:r.apiCell}))}_changeCellInternalMetadata(c,g){var r;const a=this._cells[c],p=a.internalMetadata;if(a.setInternalMetadata(g),p.runState!==g.runState){const m=(r=g.runState)!==null&&r!==void 0?r:E.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,executionState:m}))}}getCellFromApiCell(c){return this._cells.find(g=>g.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(g=>g.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(be[178],we([0,1,7,9]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,S){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:D,metadata:S})}replaceCells(D,S,k){this._throwIfFinalized(),!(D===S&&k.length===0)&&this._collectedEdits.push({editType:1,index:D,count:S-D,cells:k.map(R.NotebookCellData.from)})}}class T{constructor(D,S,k,i,A,c){this.id=D,this._proxy=S,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=A,this._visibleRanges=i,this._viewColumn=c}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},get visibleRanges(){return D._visibleRanges},revealRange(S,k){D._proxy.$tryRevealRange(D.id,R.NotebookRange.from(S),k!=null?k:v.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(S){const k=new C(this.document.version);return S(k),D._applyEdit(k.finalize())},setDecorations(S,k){return D.setDecorations(S,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const S=[];let k=-1;for(let i=0;i<D.cellEdits.length;i++){if(k<0){S.push(D.cellEdits[i]),k++;continue}const c=S[k],g=D.cellEdits[i];if(c.editType===1&&g.editType===1&&c.index===g.index){c.cells.push(...D.cellEdits[i].cells),c.count+=D.cellEdits[i].count;continue}S.push(D.cellEdits[i]),k++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,S)}setDecorations(D,S){if(!(S.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return S.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(S),D.key)}}e.ExtHostNotebookEditor=T}),define(be[179],we([0,1,9,153,133,20,53]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(A){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=A}withProgress(A,c,g){const r=this._handles++,{title:a,location:p,cancellable:m}=c,y={label:(0,C.localize)(0,null,A.displayName||A.name),id:A.identifier.value};return this._proxy.$startProgress(r,{location:v.ProgressLocation.from(p),title:a,source:y,cancellable:m},A),this._withProgress(r,g,!!m)}_withProgress(A,c,g){let r;g&&(r=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(A,r));const a=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),r&&r.dispose()};let p;try{p=c(new k(this._proxy,A),g&&r?r.token:T.CancellationToken.None)}catch(m){throw a(A),m}return p.then(m=>a(A),m=>a(A)),p}$acceptProgressCanceled(A){const c=this._mapHandleToCancellationSource.get(A);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(A))}}e.ExtHostProgress=D;function S(i,A){return i.message=A.message,typeof A.increment=="number"&&(typeof i.increment=="number"?i.increment+=A.increment:i.increment=A.increment),i}class k extends R.Progress{constructor(A,c){super(g=>this.throttledReport(g));this._proxy=A,this._handle=c}throttledReport(A){this._proxy.$progressReport(this._handle,A)}}qe([(0,E.throttle)(100,(i,A)=>S(i,A),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(be[98],we([0,1,42,12,55,9,7]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(c,g){const r=D._Keys.nextId();c.$registerTextEditorDecorationType(r,T.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:r,dispose(){c.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=D,D._Keys=new C.IdGenerator("TextEditorDecorationType");class S{constructor(c,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,g){this._throwIfFinalized();let r=null;if(c instanceof E.Position)r=new E.Range(c,c);else if(c instanceof E.Range)r=c;else throw new Error("Unrecognized location");this._pushEdit(r,g,!1)}insert(c,g){this._throwIfFinalized(),this._pushEdit(new E.Range(c,c),g,!0)}delete(c){this._throwIfFinalized();let g=null;if(c instanceof E.Range)g=c;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(c,g,r){const a=this._document.validateRange(c);this._collectedEdits.push({range:a,text:g,forceMoveMarkers:r})}setEndOfLine(c){if(this._throwIfFinalized(),c!==E.EndOfLine.LF&&c!==E.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=S;class k{constructor(c,g,r,a){this._proxy=c,this._id=g,this._accept(r),this._logService=a;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(m){p._setTabSize(m)},get insertSpaces(){return p._insertSpaces},set insertSpaces(m){p._setInsertSpaces(m)},get cursorStyle(){return p._cursorStyle},set cursorStyle(m){p._setCursorStyle(m)},get lineNumbers(){return p._lineNumbers},set lineNumbers(m){p._setLineNumbers(m)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const g=Math.floor(c);return g>0?g:null}if(typeof c=="string"){const g=parseInt(c,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(c){const g=this._validateTabSize(c);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const g=this._validateInsertSpaces(c);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(c)})))}assign(c){const g={};let r=!1;if(typeof c.tabSize!="undefined"){const a=this._validateTabSize(c.tabSize);a==="auto"?(r=!0,g.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,r=!0,g.tabSize=a)}if(typeof c.insertSpaces!="undefined"){const a=this._validateInsertSpaces(c.insertSpaces);a==="auto"?(r=!0,g.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,r=!0,g.insertSpaces=a)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,r=!0,g.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,r=!0,g.lineNumbers=T.TextEditorLineNumbersStyle.from(c.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(c){c.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=k;class i{constructor(c,g,r,a,p,m,y,l){this.id=c,this._proxy=g,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new k(this._proxy,this.id,m,r),this._visibleRanges=y,this._viewColumn=l;const d=this;this.value=Object.freeze({get document(){return a.getValue()},set document(f){throw(0,R.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(f){if(!(f instanceof E.Selection))throw(0,R.illegalArgument)("selection");d._selections=[f],d._trySetSelection()},get selections(){return d._selections},set selections(f){if(!Array.isArray(f)||f.some(t=>!(t instanceof E.Selection)))throw(0,R.illegalArgument)("selections");d._selections=f,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(f){throw(0,R.readonly)("visibleRanges")},get options(){return d._options.value},set options(f){d._disposed||d._options.assign(f)},get viewColumn(){return d._viewColumn},set viewColumn(f){throw(0,R.readonly)("viewColumn")},edit(f,t={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new S(a.getValue(),t);return f(n),d._applyEdit(n)},insertSnippet(f,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=d._selections.map(o=>T.Range.from(o));else if(t instanceof E.Position){const{lineNumber:o,column:u}=T.Position.from(t);s=[{startLineNumber:o,startColumn:u,endLineNumber:o,endColumn:u}]}else if(t instanceof E.Range)s=[T.Range.from(t)];else{s=[];for(const o of t)if(o instanceof E.Range)s.push(T.Range.from(o));else{const{lineNumber:u,column:w}=T.Position.from(o);s.push({startLineNumber:u,startColumn:w,endLineNumber:u,endColumn:w})}}return g.$tryInsertSnippet(c,f.value,s,n)},setDecorations(f,t){const n=t.length===0;n&&!d._hasDecorationsForKey.has(f.key)||(n?d._hasDecorationsForKey.delete(f.key):d._hasDecorationsForKey.add(f.key),d._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return g.$trySetDecorations(c,f.key,T.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let o=0,u=t.length;o<u;o++){const w=t[o];s[4*o]=w.start.line+1,s[4*o+1]=w.start.character+1,s[4*o+2]=w.end.line+1,s[4*o+3]=w.end.character+1}return g.$trySetDecorationsFast(c,f.key,s)}}))},revealRange(f,t){d._runOnProxy(()=>g.$tryRevealRange(c,T.Range.from(f),t||E.TextEditorRevealType.Default))},show(f){g.$tryShowEditor(c,T.ViewColumn.from(f))},hide(){g.$tryHideEditor(c)}})}dispose(){(0,v.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,v.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,v.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,v.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,v.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const g=c.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const r=g.edits.map(p=>p.range);r.sort((p,m)=>p.end.line===m.end.line?p.end.character===m.end.character?p.start.line===m.start.line?p.start.character-m.start.character:p.start.line-m.start.line:p.end.character-m.end.character:p.end.line-m.end.line);for(let p=0,m=r.length-1;p<m;p++){const y=r[p].end;if(r[p+1].start.isBefore(y))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=g.edits.map(p=>({range:T.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,a,{setEndOfLine:typeof g.setEndOfLine=="number"?T.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=i}),define(be[180],we([0,1,136,25,2,3,6,11,7,10,13,9,20]),function(J,e,v,R,C,T,E,D,S,k,i,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(p,m){if((0,k.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let y;return Array.isArray(p.highlights)&&(y=p.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),y=y.length?y:void 0),{label:p.label,highlights:y}}}class r{constructor(m,y,l){this._proxy=m,this.commands=y,this.logService=l,this.treeViews=new Map;function d(f){return f&&f.$treeViewId&&f.$treeItemHandle}y.registerArgumentProcessor({processArgument:f=>d(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(t=>d(t)?this.convertArgument(t):t):f})}registerTreeDataProvider(m,y,l){const d=this.createTreeView(m,{treeDataProvider:y},l);return{dispose:()=>d.dispose()}}createTreeView(m,y,l){if(!y||!y.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=y.dragAndDropController!==void 0,f=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!y.showCollapseAll,canSelectMany:!!y.canSelectMany,canDragAndDrop:d}),t=this.createExtHostTreeView(m,y,l);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(n){t.message=n},get title(){return t.title},set title(n){t.title=n},get description(){return t.description},set description(n){t.description=n},reveal:(n,s)=>t.reveal(n,s),dispose:async()=>{await f,this.treeViews.delete(m),t.dispose()}}}$getChildren(m,y){const l=this.treeViews.get(m);return l?l.getChildren(y):Promise.reject(new Error((0,v.localize)(0,null,m)))}$onDrop(m,y,l){const d=this.treeViews.get(m);return d?d.onDrop(y,l):Promise.reject(new Error((0,v.localize)(1,null,m)))}async $hasResolve(m){const y=this.treeViews.get(m);if(!y)throw new Error((0,v.localize)(2,null,m));return y.hasResolve}$resolve(m,y,l){const d=this.treeViews.get(m);if(!d)throw new Error((0,v.localize)(3,null,m));return d.resolveTreeItem(y,l)}$setExpanded(m,y,l){const d=this.treeViews.get(m);if(!d)throw new Error((0,v.localize)(4,null,m));d.setExpanded(y,l)}$setSelection(m,y){const l=this.treeViews.get(m);if(!l)throw new Error((0,v.localize)(5,null,m));l.setSelection(y)}$setVisible(m,y){const l=this.treeViews.get(m);if(!l)throw new Error((0,v.localize)(6,null,m));l.setVisible(y)}createExtHostTreeView(m,y,l){const d=new a(m,y,this._proxy,this.commands.converter,this.logService,l);return this.treeViews.set(m,d),d}convertArgument(m){const y=this.treeViews.get(m.$treeViewId);return y?y.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=r;class a extends E.Disposable{constructor(m,y,l,d,f,t){super();if(this.viewId=m,this.proxy=l,this.commands=d,this.logService=f,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,t.contributes&&t.contributes.views)for(const o in t.contributes.views)for(const u of t.contributes.views[o])u.id===m&&(this._title=u.name);this.dataProvider=y.treeDataProvider,this.dndController=y.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let n,s;this._register(T.Event.debounce(this._onDidChangeData.event,(o,u)=>(o||(o={message:!1,elements:[]}),u.element!==!1&&(n||(n=new Promise(w=>s=w),this.refreshPromise=this.refreshPromise.then(()=>n)),o.elements.push(u.element)),u.message&&(o.message=!0),o),200,!0)(({message:o,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=s;return n=null,this.refresh(u).then(()=>w())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,k.isUndefinedOrNull)(m))}getChildren(m){const y=m?this.getExtensionElement(m):void 0;if(m&&!y)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const l=this.getChildrenNodes(m);return(l?Promise.resolve(l):this.fetchChildrenNodes(y)).then(d=>d.map(f=>f.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,y){y=y||{select:!0,focus:!1};const l=(0,k.isUndefinedOrNull)(y.select)?!0:y.select,d=(0,k.isUndefinedOrNull)(y.focus)?!1:y.focus,f=(0,k.isUndefinedOrNull)(y.expand)?!1:y.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:l,focus:d,expand:f})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:l,focus:d,expand:f})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,y){const l=this.getExtensionElement(m);l&&(y?this._onDidExpandElement.fire(Object.freeze({element:l})):this._onDidCollapseElement.fire(Object.freeze({element:l})))}setSelection(m){(0,i.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(m,y){const l=m.map(f=>this.getExtensionElement(f)).filter(f=>!(0,k.isUndefinedOrNull)(f)),d=this.getExtensionElement(y);return l&&d?(0,D.asPromise)(()=>{var f;return(f=this.dndController)===null||f===void 0?void 0:f.onDrop(l,d)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,y){var l;if(!!this.dataProvider.resolveTreeItem){const d=this.elements.get(m);if(d){const f=this.nodes.get(d);if(f){const t=(l=await this.dataProvider.resolveTreeItem(f.extensionItem,d,y))!==null&&l!==void 0?l:f.extensionItem;return f.item.tooltip=this.getTooltip(t.tooltip),f.item.command=this.getCommand(f.disposableStore,t.command),f.item}}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(y=>y?this.resolveUnknownParentChain(y).then(l=>this.resolveTreeNode(y,l[l.length-1]).then(d=>(l.push(d),l))):Promise.resolve([]))}resolveParent(m){const y=this.nodes.get(m);return y?Promise.resolve(y.parent?this.elements.get(y.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,y){const l=this.nodes.get(m);return l?Promise.resolve(l):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(d=>this.createHandle(m,d,y,!0)).then(d=>this.getChildren(y?y.item.handle:void 0).then(()=>{const f=this.getExtensionElement(d);if(f){const t=this.nodes.get(f);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(m){if(m){let y;if(typeof m=="string"){const l=this.getExtensionElement(m);y=l?this.nodes.get(l):void 0}else y=m;return y&&y.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const y=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const l=m?this.nodes.get(m):void 0,d=await this.dataProvider.getChildren(m);if(y.token.isCancellationRequested)return[];const f=await Promise.all((0,i.coalesce)(d||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!y.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,l):null}));return y.token.isCancellationRequested?[]:(0,i.coalesce)(f)}finally{y.dispose()}}refresh(m){if(m.some(l=>!l))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const l=this.getHandlesToRefresh(m);if(l.length)return this.refreshHandles(l)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const y=new Set,l=m.map(f=>this.nodes.get(f));for(const f of l)if(f&&!y.has(f.item.handle)){let t=f;for(;t&&t.parent&&l.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&y.add(f.item.handle)}const d=[];return y.forEach(f=>{const t=this.elements.get(f);if(t){const n=this.nodes.get(t);n&&(!n.parent||!y.has(n.parent.item.handle))&&d.push(f)}}),d}refreshHandles(m){const y={};return Promise.all(m.map(l=>this.refreshNode(l).then(d=>{d&&(y[l]=d.item)}))).then(()=>Object.keys(y).length?this.proxy.$refresh(this.viewId,y):void 0)}refreshNode(m){const y=this.getExtensionElement(m);if(y){const l=this.nodes.get(y);if(l)return this.clearChildren(y),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(y)).then(d=>{if(d){const f=this.createTreeNode(y,d,l.parent);return this.updateNodeCache(y,f,l,l.parent),l.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,y,l){const d=this.createTreeNode(m,y,l);if(y.id&&this.elements.has(d.item.handle))throw new Error((0,v.localize)(7,null,y.id));return this.addNodeToCache(m,d),this.addNodeToParentCache(d,l),d}getTooltip(m){return S.MarkdownString.isMarkdownString(m)?A.MarkdownString.from(m):m}getCommand(m,y){return y?this.commands.toInternal(y,m):void 0}createTreeNode(m,y,l){const d=new E.DisposableStore,f=this.createHandle(m,y,l),t=this.getLightIconPath(y);return{item:{handle:f,parentHandle:l?l.item.handle:void 0,label:g(y.label,this.extension),description:y.description,resourceUri:y.resourceUri,tooltip:this.getTooltip(y.tooltip),command:this.getCommand(d,y.command),contextValue:y.contextValue,icon:t,iconDark:this.getDarkIconPath(y)||t,themeIcon:this.getThemeIcon(y),collapsibleState:(0,k.isUndefinedOrNull)(y.collapsibleState)?S.TreeItemCollapsibleState.None:y.collapsibleState,accessibilityInformation:y.accessibilityInformation},extensionItem:y,parent:l,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(m){return m.iconPath instanceof S.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:y,label:l,resourceUri:d},f,t){if(y)return`${a.ID_HANDLE_PREFIX}/${y}`;const n=g(l,this.extension),s=f?f.item.handle:a.LABEL_HANDLE_PREFIX;let o=n?n.label:d?(0,R.basename)(d):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const u=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,w=this.getChildrenNodes(f)||[];let b,I=0;do{if(b=`${s}/${I}:${o}`,t||!this.elements.has(b)||u===b)break;I++}while(I<=w.length);return b}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof S.ThemeIcon))return typeof m.iconPath=="string"||C.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof S.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return C.URI.isUri(m)?m:C.URI.file(m)}addNodeToCache(m,y){this.elements.set(y.item.handle,m),this.nodes.set(m,y)}updateNodeCache(m,y,l,d){this.elements.delete(y.item.handle),this.nodes.delete(m),y.item.handle!==l.item.handle&&this.elements.delete(l.item.handle),this.addNodeToCache(m,y);const f=this.getChildrenNodes(d)||[],t=f.filter(n=>n.item.handle===l.item.handle)[0];t&&f.splice(f.indexOf(t),1,y)}addNodeToParentCache(m,y){y?(y.children||(y.children=[]),y.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const y=this.nodes.get(m);if(y){if(y.children)for(const l of y.children){const d=this.elements.get(l.item.handle);d&&this.clear(d)}y.children=void 0}}else this.clearAll()}clear(m){const y=this.nodes.get(m);if(y){if(y.children)for(const l of y.children){const d=this.elements.get(l.item.handle);d&&this.clear(d)}this.nodes.delete(m),this.elements.delete(y.item.handle),y.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}a.LABEL_HANDLE_PREFIX="0",a.ID_HANDLE_PREFIX="1"}),define(be[181],we([0,1,13,11,20,10,71,9,7,97]),function(J,e,v,R,C,T,E,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(p,m){if(m!==void 0){const y=this.testIdsToInternal.get(m),l=y==null?void 0:y.get(p);if(l)return[y,l]}return(0,v.mapFind)(this.testIdsToInternal.values(),y=>{const l=y.get(p);return l&&[y,l]})}createForHierarchy(p=()=>{}){return new r(this.createIdMap(c++),p)}createIdMap(p){const m=new g(p);return this.testIdsToInternal.set(m.id,m),{object:m,dispose:()=>this.testIdsToInternal.delete(m.id)}}}e.OwnedTestCollection=i;var A;(function(a){a[a.Disconnected=0]="Disconnected",a[a.IsChild=1]="IsChild",a[a.IsParent=2]="IsParent",a[a.IsSame=3]="IsSame"})(A=e.TestPosition||(e.TestPosition={}));let c=0;class g{constructor(p){this.id=p,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(p){if(this.map.has(p.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${p.item.extId}`);this.map.set(p.item.extId,p),p.parent||this._roots.add(p)}has(p){return this.map.has(p)}delete(p){const m=this.map.get(p);return m?(this.map.delete(p),this._roots.delete(m),!0):!1}get(p){return this.map.get(p)}comparePositions(p,m){const y=typeof p=="string"?this.map.get(p):p,l=typeof m=="string"?this.map.get(m):m;if(!y||!l)return 0;if(y===l)return 3;for(let d=this.map.get(l.parent);d;d=this.map.get(d.parent))if(d===y)return 1;for(let d=this.map.get(y.parent);d;d=this.map.get(d.parent))if(d===l)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=g;class r{constructor(p,m){this.testIdToInternal=p,this.publishDiff=m,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(p,m){this.addItem(p,m,null)}getTestByReference(p){return this.testItemToInternal.get(p)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const m=this.diff[this.diff.length-1];if(m&&p[0]===1){if(m[0]===1&&m[1].extId===p[1].extId){(0,k.applyTestItemUpdate)(m[1],p[1]);return}if(m[0]===0&&m[1].item.extId===p[1].extId){(0,k.applyTestItemUpdate)(m[1],p[1]);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,m){var y;const l=this.testIdToInternal.object.get(p);if(!!l){if((l.expandLevels===void 0||m>l.expandLevels)&&(l.expandLevels=m),l.expand===1){const d=this.refreshChildren(l);return d.isSettled?this.expandChildren(l,m-1):d.p.then(()=>this.expandChildren(l,m-1))}else if(l.expand===3)return((y=l.initialExpand)===null||y===void 0?void 0:y.isSettled)===!1?l.initialExpand.p.then(()=>this.expandChildren(l,m-1)):this.expandChildren(l,m-1)}}dispose(){var p;for(const m of this.testItemToInternal.values())(p=m.discoverCts)===null||p===void 0||p.dispose(!0),(0,E.getPrivateApiFor)(m.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(p,m){const y=p==null?void 0:p.actual.id;switch(m[0]){case 2:this.pushDiff([4,y]);break;case 1:this.removeItem(p);break;case 0:this.addItem(m[1],p.src.controller,p);break;case 3:const[l,d,f]=m;switch(d){case"status":this.updateExpandability(p);break;case"range":this.pushDiff([1,{extId:y,item:{range:D.Range.from(f)}}]);break;case"error":this.pushDiff([1,{extId:y,item:{error:D.MarkdownString.fromStrict(f)||null}}]);break;default:this.pushDiff([1,{extId:y,item:{[d]:f!=null?f:null}}]);break}break;default:(0,T.assertNever)(m[0])}}addItem(p,m,y){if(!(p instanceof S.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${p.id} did not`);if(this.testItemToInternal.has(p))throw new Error(`Attempted to add a single TestItem ${p.id} multiple times to the tree`);if(this.testIdToInternal.object.has(p.id))throw new Error(`Attempted to insert a duplicate test item ID ${p.id}`);const l=y?y.item.extId:null,d=p.resolveHandler?1:0,f=y?y.expandLevels:1,t={controller:m,tree:this.testIdToInternal.object.id},n={actual:p,parent:l,item:D.TestItem.from(p),expandLevels:f?f-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(p,n),this.pushDiff([0,{parent:l,src:t,expand:d,item:n.item}]);const s=(0,E.getPrivateApiFor)(p);s.parent=y==null?void 0:y.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const o of s.children.values())this.testItemToInternal.has(o)||this.addItem(o,m,n)}updateExpandability(p){var m;let y;p.actual.resolveHandler?p.actual.status===S.TestItemStatus.Pending?y=p.discoverCts?2:1:((m=p.initialExpand)===null||m===void 0||m.complete(),y=3):y=0,y!==p.expand&&(p.expand=y,this.pushDiff([1,{extId:p.actual.id,expand:y}]),y===1&&p.expandLevels!==void 0&&this.refreshChildren(p))}expandChildren(p,m){if(!(m<0)){const y=[...p.actual.children.values()].map(l=>this.expand(l.id,m)).filter(R.isThenable);if(y.length)return Promise.all(y).then(()=>{})}}refreshChildren(p){if(p.discoverCts&&p.discoverCts.dispose(!0),!p.actual.resolveHandler){const m=new R.DeferredPromise;return m.complete(),m}return p.expand=2,p.discoverCts=new C.CancellationTokenSource,this.pushExpandStateUpdate(p),p.initialExpand=new R.DeferredPromise,p.actual.resolveHandler(p.discoverCts.token),p.initialExpand}pushExpandStateUpdate(p){this.pushDiff([1,{extId:p.actual.id,expand:p.expand}])}removeItem(p){var m;this.pushDiff([2,p.actual.id]);const y=[p];for(;y.length;){const l=y.pop();if(!!l){(m=l.discoverCts)===null||m===void 0||m.dispose(!0),this.testIdToInternal.object.delete(l.item.extId),this.testItemToInternal.delete(l.actual);for(const d of l.actual.children.values())y.push(this.testIdToInternal.object.get(d.id))}}}flushDiff(){const p=this.collectDiff();p.length&&this.publishDiff(p)}}e.SingleUseTestCollection=r}),define(be[182],we([0,1,26,3,14]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class E{constructor(i){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(v.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(v.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let A of i.activationEvents)A==="onUri"&&(A=`onUri:${v.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(A)||this._activationMap.set(A,[]),this._activationMap.get(A).push(i)}}keepOnly(i){const A=new Set;i.forEach(c=>A.add(v.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>A.has(v.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,A){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const c=E._findLoopingExtensions(this._extensionDescriptions);if(A=A.concat(c.map(g=>g.identifier)),A.length>0){const g=new Set;A.forEach(r=>g.add(v.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!g.has(v.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(c)}static _findLoopingExtensions(i){const A=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,m){this.addNode(p),this.addNode(m),this._arcs.has(p)?this._arcs.get(p).push(m):this._arcs.set(p,[m])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,m){const y=A.getArcs(p);for(let l=0;l<y.length;l++)if(!m.has(y[l]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let p of i){const m=v.ExtensionIdentifier.toKey(p.identifier);if(c.set(m,p),p.extensionDependencies)for(let y of p.extensionDependencies){const l=v.ExtensionIdentifier.toKey(y);A.addArc(m,l)}}let g=new Set;A.getNodes().filter(p=>A.getArcs(p).length===0).forEach(p=>g.add(p));let r=A.getNodes().filter(p=>!g.has(p)),a;do{a=!1;for(let p=0;p<r.length;p++){const m=r[p];A.hasOnlyGoodArcs(m,g)&&(r.splice(p,1),p--,g.add(m),a=!0)}}while(a);return r.map(p=>c.get(p))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(v.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const A=this._activationMap.get(i);return A?A.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const A=this._extensionsMap.get(v.ExtensionIdentifier.toKey(i));return A||void 0}}e.ExtensionDescriptionRegistry=E;var D;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(D||(D={}));function S(k,i){const A=k.isBuiltin?0:k.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(A!==c)return A-c;const g=C.posix.basename(k.extensionLocation.path),r=C.posix.basename(i.extensionLocation.path);return g<r?-1:g>r?1:0}}),define(be[183],we([0,1,24]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function T(D){const S=v.VSBuffer.alloc(1);switch(D){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=T;function E(D,S){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=E}),define(be[33],we([0,1,3,2,4,26,150]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class D{constructor(y){this.dependency=y}}e.MissingExtensionDependency=D;var S;(function(m){m[m.LocalProcess=0]="LocalProcess",m[m.LocalWebWorker=1]="LocalWebWorker",m[m.Remote=2]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(y,l,d,f){this.codeLoadingTime=y,this.activateCallTime=l,this.activateResolvedTime=d,this.activationReason=f}}e.ActivationTimes=k;class i{constructor(y,l){this.description=y,this.value=l}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var A;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(A=e.ActivationKind||(e.ActivationKind={}));function c(m){m.enableProposedApi||g(m)}e.checkProposedApiEnabled=c;function g(m){throw new Error(`[${m.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.throwProposedApiError=g;function r(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,E.getGalleryExtensionId)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation}}e.toExtension=r;function a(m){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(m.identifier.id),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!1,extensionLocation:m.location},m.manifest),{uuid:m.identifier.uuid})}e.toExtensionDescription=a;class p{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None}activateByEvent(y){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(y){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(y){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(y){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(y,l){return Promise.resolve()}_onWillActivateExtension(y){}_onDidActivateExtension(y,l,d,f,t){}_onDidActivateExtensionError(y,l){}_onExtensionRuntimeError(y,l){}_onExtensionHostExit(y){}}e.NullExtensionService=p}),define(be[184],we([0,1,26,33,16]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class E{constructor(r,a,p,m){this.startup=r,this.codeLoadingTime=a,this.activateCallTime=p,this.activateResolvedTime=m}}e.ExtensionActivationTimes=E,E.NONE=new E(!1,-1,-1,-1);class D{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,a){return r===-1||a===-1?-1:a-r}build(){return new E(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class S{constructor(r,a,p,m,y,l){this.activationFailed=r,this.activationFailedError=a,this.activationTimes=p,this.module=m,this.exports=y,this.subscriptions=l}}e.ActivatedExtension=S;class k extends S{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class i extends S{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class A extends S{constructor(r){super(!0,r,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=A;let c=class{constructor(r,a,p,m,y){this._logService=y,this._registry=r,this._resolvedExtensionsSet=new Set,a.forEach(l=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,p.forEach(l=>this._hostExtensionsMap.set(v.ExtensionIdentifier.toKey(l),l)),this._host=m,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(r){const a=v.ExtensionIdentifier.toKey(r);return this._activatedExtensions.has(a)}getActivatedExtension(r){const a=v.ExtensionIdentifier.toKey(r),p=this._activatedExtensions.get(a);if(!p)throw new Error("Extension `"+r.value+"` is not known or not activated");return p}activateByEvent(r,a){if(this._alreadyActivatedEvents[r])return T;const p=this._registry.getExtensionDescriptionsForActivationEvent(r);return this._activateExtensions(p.map(m=>({id:m.identifier,reason:{startup:a,extensionId:m.identifier,activationEvent:r}}))).then(()=>{this._alreadyActivatedEvents[r]=!0})}activateById(r,a){const p=this._registry.getExtensionDescription(r);if(!p)throw new Error("Extension `"+r+"` is not known");return this._activateExtensions([{id:p.identifier,reason:a}])}_handleActivateRequest(r,a,p){if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(r.id))){a[v.ExtensionIdentifier.toKey(r.id)]=r;return}const m=this._registry.getExtensionDescription(r.id);if(!m){const d=new Error(`Cannot activate unknown extension '${r.id.value}'`);this._host.onExtensionActivationError(r.id,d,new R.MissingExtensionDependency(r.id.value)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(r.id),new A(d));return}const y=typeof m.extensionDependencies=="undefined"?[]:m.extensionDependencies;let l=!0;for(let d=0,f=y.length;d<f;d++){const t=y[d];if(!this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(v.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const w=m.displayName||m.identifier.value,b=this._registry.getExtensionDescription(t),I=b&&b.displayName||t,h=new Error(`Cannot activate the '${w}' extension because its dependency '${I}' failed to activate`);h.detail=n.activationFailedError,this._host.onExtensionActivationError(m.identifier,h,null),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(m.identifier),new A(h));return}if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(t))){l=!1,a[v.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(v.ExtensionIdentifier.toKey(t)),reason:r.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){l=!1,a[v.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:r.reason};continue}const o=m.displayName||m.identifier.value,u=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(m.identifier,u,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(m.identifier),new A(u));return}}}l?a[v.ExtensionIdentifier.toKey(m.identifier)]=r:p.push(r)}_activateExtensions(r){if(r.length===0||(r=r.filter(y=>!this._activatedExtensions.has(v.ExtensionIdentifier.toKey(y.id))),r.length===0))return Promise.resolve(void 0);const a=Object.create(null),p=[];for(let y=0,l=r.length;y<l;y++)this._handleActivateRequest(r[y],a,p);for(let y=0,l=p.length;y<l;y++){const d=v.ExtensionIdentifier.toKey(p[y].id);a[d]&&delete a[d]}const m=Object.keys(a).map(y=>a[y]);return p.length===0?Promise.all(m.map(y=>this._activateExtension(y.id,y.reason))).then(y=>{}):this._activateExtensions(m).then(y=>this._activateExtensions(p))}_activateExtension(r,a){const p=v.ExtensionIdentifier.toKey(r);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const m=this._activatingExtensions.get(p);if(m)return m;const y=this._host.actualActivateExtension(r,a).then(void 0,l=>{const d=new Error;return l&&l.name&&(d.name=l.name),l&&l.message?d.message=`Activating extension '${r.value}' failed: ${l.message}.`:d.message=`Activating extension '${r.value}' failed: ${l}.`,l&&l.stack&&(d.stack=l.stack),this._host.onExtensionActivationError(r,d,null),this._logService.error(`Activating extension ${r.value} failed due to an error:`),this._logService.error(l),new A(l)}).then(l=>{this._activatedExtensions.set(p,l),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,y),y}};c=qe([Ke(4,C.ILogService)],c),e.ExtensionsActivator=c}),define(be[185],we([0,1,12]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,E)=>{this._actualOk=T,this._actualErr=E,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,v.onUnexpectedError)(T))}then(T,E){return this._ensureActual().then(T,E)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=R}),define(be[99],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(S,k){this.isMain=S,this.sid=k,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const R=[];function C(D){const S=new v(!0,D);return R[S.nid]=S,S}e.createMainContextProxyIdentifier=C;function T(D){const S=new v(!1,D);return R[S.nid]=S,S}e.createExtHostContextProxyIdentifier=T;function E(D){return R[D].sid}e.getStringIdentifierForProxy=E}),define(be[5],we([0,1,58,2,99]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var E;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(E=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(l){l.name="$ident";function d(t,n){return Object.defineProperty(t,l.name,{value:n,enumerable:!0}),t}l.mixin=d;function f(t){return t[l.name]}l.of=f})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(d){return d._id=g._n++,d}}e.IdObject=g,g._n=0;var r;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(r=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var a;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(a=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function m(l){if(l&&l.edits)for(const d of l.edits)typeof d.resource=="object"?d.resource=R.URI.revive(d.resource):(d.newUri=R.URI.revive(d.newUri),d.oldUri=R.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,v.revive)(d.metadata));return l}e.reviveWorkspaceEditDto=m;var y;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[75],we([0,1,5,3,4]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(D){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(v.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,S){return this._proxy.$getPassword(D,S)}store(D,S,k){return this._proxy.$setPassword(D,S,k)}delete(D,S){return this._proxy.$deletePassword(D,S)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(be[76],we([0,1,4,16,5,15]),function(J,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,v.createDecorator)("IExtHostApiDeprecationService");let E=class{constructor(S,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(C.MainContext.MainThreadTelemetry)}report(S,k,i){const A=this.getUsageKey(S,k);this._reportedUsages.has(A)||(this._reportedUsages.add(A),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}getUsageKey(S,k){return`${S}-${k.identifier.value}`}};E=qe([Ke(0,T.IExtHostRpcService),Ke(1,R.ILogService)],E),e.ExtHostApiDeprecationService=E,e.NullApiDeprecationService=Object.freeze(new class{report(D,S,k){}})}),define(be[186],we([0,1,3,5,7,26]),function(J,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class E{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new v.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new v.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(S,k,i,A={}){const c=T.ExtensionIdentifier.toKey(S.identifier),g=this._inFlightRequests.get(c)||[],r=i.sort().join(" ");let a=g.find(p=>p.scopes===r);if(a)return a.result;{const p=this._getSession(S,c,k,i,A);a={scopes:r,result:p},g.push(a),this._inFlightRequests.set(c,g);try{await p}finally{const m=g.findIndex(y=>y.scopes===r);m>-1&&(g.splice(m),this._inFlightRequests.set(c,g))}return p}}async _getSession(S,k,i,A,c={}){await this._proxy.$ensureProvider(i);const g=S.displayName||S.name;return this._proxy.$getSession(i,A,k,g,c)}async removeSession(S,k){const i=this._authenticationProviders.get(S);return i?i.provider.removeSession(k):this._proxy.$removeSession(S,k)}registerAuthenticationProvider(S,k,i,A){var c;if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:k,provider:i,options:A!=null?A:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===S)||this._providers.push({id:S,label:k});const g=i.onDidChangeSessions(r=>{var a,p,m;this._proxy.$sendDidChangeSessions(S,{added:(a=r.added)!==null&&a!==void 0?a:[],changed:(p=r.changed)!==null&&p!==void 0?p:[],removed:(m=r.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(S,k,(c=A==null?void 0:A.supportsMultipleAccounts)!==null&&c!==void 0?c:!1),new C.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(S);const r=this._providers.findIndex(a=>a.id===S);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this._onDidChangeSessions.fire({provider:{id:S,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(S,k){return S.forEach(i=>{this._providers.some(A=>A.id===i.id)||this._providers.push(i)}),k.forEach(i=>{const A=this._providers.findIndex(c=>c.id===i.id);A>-1&&this._providers.splice(A)}),this._onDidChangeAuthenticationProviders.fire({added:S,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=E}),define(be[187],we([0,1,5,15,9]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(D,S){this._extHostDocumentsAndEditors=S,this._proxy=D.getProxy(v.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const S=C.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};T=qe([Ke(0,R.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(be[188],we([0,1,5]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(T){const E=T.getProxy(v.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return E.$readText()},writeText(D){return E.$writeText(D)}})}}e.ExtHostClipboard=R}),define(be[77],we([0,1,10,7,9,23,5,13,16,58,32,38,2,6,4,15]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadCommands),this._logService=n,this.converter=new m(this,s=>{const o=this._apiCommands.get(s);return(o==null?void 0:o.result)===l.Void?o:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(o){if(i.Range.isIRange(o))return C.Range.to(o);if(A.Position.isIPosition(o))return C.Position.to(o);if(i.Range.isIRange(o.range)&&c.URI.isUri(o.uri))return C.location.to(o);if(!Array.isArray(o))return o})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const o=t.args.map((w,b)=>{if(!w.validate(s[b]))throw new Error(`Invalid argument '${w.name}' when running '${t.id}', received: ${s[b]}`);return w.convert(s[b])}),u=await this.executeCommand(t.internalId,...o);return t.result.convert(u,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,o,u){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:o,description:u}),t&&this._proxy.$registerCommand(n),new R.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const o=(0,T.cloneAndChange)(n,function(u){if(u instanceof R.Position)return C.Position.from(u);if(u instanceof R.Range)return C.Range.from(u);if(u instanceof R.Location)return C.location.from(u);if(R.NotebookRange.isNotebookRange(u))return C.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,o,s);return(0,k.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw u}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:o,thisArg:u,description:w}=s;if(w)for(let b=0;b<w.args.length;b++)try{(0,v.validateConstraint)(n[b],w.args[b].constraint)}catch(I){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${w.args[b].name}' - ${w.args[b].description}`)}try{return await o.apply(u,n)}catch(b){if(t===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...n);I&&(t=I.command)}throw this._logService.error(b,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((o,u)=>u.processArgument(o),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:o}=s;o&&(t[n]=o)}return Promise.resolve(t)}};p=qe([Ke(0,a.IExtHostRpcService),Ke(1,S.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class m{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const o=this._lookupApiCommand(t.command);if(o)s.id=o.internalId,s.arguments=o.args.map((u,w)=>u.convert(t.arguments&&t.arguments[w]));else if((0,D.isNonEmptyArray)(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),n.add((0,g.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),s.$ident=u,s.id=this.delegatingCommandId,s.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return s}}fromInternal(t){const n=E.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class y{constructor(t,n,s,o){this.name=t,this.description=n,this.validate=s,this.convert=o}optional(){return new y(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new y(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=y,y.Uri=new y("uri","Uri of a text document",f=>c.URI.isUri(f),f=>f),y.Position=new y("position","A position in a text document",f=>R.Position.isPosition(f),C.Position.from),y.Range=new y("range","A range in a text document",f=>R.Range.isRange(f),C.Range.from),y.Selection=new y("selection","A selection in a text document",f=>R.Selection.isSelection(f),C.Selection.from),y.Number=new y("number","",f=>typeof f=="number",f=>f),y.String=new y("string","",f=>typeof f=="string",f=>f),y.CallHierarchyItem=new y("item","A call hierarchy item",f=>f instanceof R.CallHierarchyItem,C.CallHierarchyItem.to);class l{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=l,l.Void=new l("no result",f=>f);class d{constructor(t,n,s,o,u){this.id=t,this.internalId=n,this.description=s,this.args=o,this.result=u}}e.ApiCommand=d}),define(be[189],we([0,1,6,9,7,63,77,167,13,88]),function(J,e,v,R,C,T,E,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",c(R.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,a)=>{if(!(0,S.isFalsyOrEmpty)(r)){class p extends C.SymbolInformation{static to(y){const l=new p(y.name,R.SymbolKind.to(y.kind),y.containerName||"",new C.Location(a[0],R.Range.to(y.range)));return l.detail=y.detail,l.range=l.location.range,l.selectionRange=R.Range.to(y.selectionRange),l.children=y.children?y.children.map(p.to):[],l}}return r.map(p.to)}})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",c(R.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",c(R.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new E.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",c(R.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",c(R.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",c(R.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>C.Position.isPosition(a)),r=>r.map(R.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(a=>{let p;for(const m of a.reverse())p=new C.SelectionRange(R.Range.to(m),p);return p}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const a=[];if(Array.isArray(r))for(let p of r)a.push(...p[1].map(R.WorkspaceSymbol.to));return a})),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(R.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(R.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(R.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return R.WorkspaceEdit.to(r)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(R.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new C.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const a=(0,k.decodeSemanticTokensDto)(r);if(a.type==="full")return new C.SemanticTokens(a.data,void 0)}})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new C.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const a=(0,k.decodeSemanticTokensDto)(r);if(a.type==="full")return new C.SemanticTokens(a.data,void 0)}})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,a,p)=>{if(!r)return new C.CompletionList([]);const m=r.suggestions.map(y=>R.CompletionItem.to(y,p));return new C.CompletionList(m,r.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return R.SignatureHelp.to(r)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,a,p)=>c(m=>new C.CodeLens(R.Range.to(m.range),m.command&&p.fromInternal(m.command)))(r))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>C.Range.isRange(r),r=>C.Selection.isSelection(r)?R.Selection.from(r):R.Range.from(r)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,a,p)=>c(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(m.command)}else{const y=new C.CodeAction(m.title,m.kind?new C.CodeActionKind(m.kind):void 0);return m.edit&&(y.edit=R.WorkspaceEdit.to(m.edit)),m.command&&(y.command=p.fromInternal(m.command)),y.isPreferred=m.isPreferred,y}})(r))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new C.ColorInformation(R.Range.to(a.range),R.Color.to(a.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",r=>r instanceof C.Color,R.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:R.Range.from(r.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(R.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(R.InlayHint.to))),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",c(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>R.NotebookExclusiveDocumentPattern.to(a))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(R.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)]).optional()],E.ApiCommandResult.Void)];class A{constructor(a){this._disposables=new v.DisposableStore,this._commands=a}static register(a){return i.forEach(a.registerApiCommand,a),new A(a).registerCommands()}registerCommands(){const a=p=>(...m)=>p(this._commands,...m);this._register(D.RemoveFromRecentlyOpenedAPICommand.ID,a(D.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:p=>typeof p=="string"}]})}_register(a,p,m){const y=this._commands.registerCommand(!1,a,p,this,m);this._disposables.add(y)}}e.ExtHostApiCommands=A;function c(r){return a=>{if(Array.isArray(a))return a.map(r)}}function g(r){if(!!Array.isArray(r)){const a=[];for(const p of r)T.isLocationLink(p)?a.push(R.DefinitionLink.to(p)):a.push(R.location.to(p));return a}}}),define(be[190],we([0,1,11,53,3,6,2,63,26,9,7,5]),function(J,e,v,R,C,T,E,D,S,k,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class c{constructor(d,f,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=d.getProxy(A.MainContext.MainThreadComments),f.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const o=s.getCommentThread(n.commentThreadHandle);return o||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const o=s.getCommentThread(n.thread.commentThreadHandle);return o?{thread:o,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const o=s.getCommentThread(n.thread.commentThreadHandle);if(!o)return n;let u=n.commentUniqueId,w=o.getCommentByUniqueId(u);return w||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const o=s.getCommentThread(n.thread.commentThreadHandle);if(!o)return n;let u=n.text,w=n.commentUniqueId,b=o.getCommentByUniqueId(w);return b?(b.body=u,b):n}return n}})}createCommentController(d,f,t){const n=c.handlePool++,s=new r(d,n,this._proxy,f,t);this._commentControllers.set(s.handle,s);const o=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(d.identifier))||[];return o.push(s),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(d.identifier),o),s}$createCommentThreadTemplate(d,f,t){const n=this._commentControllers.get(d);!n||n.$createCommentThreadTemplate(f,t)}async $updateCommentThreadTemplate(d,f,t){const n=this._commentControllers.get(d);!n||n.$updateCommentThreadTemplate(f,t)}$deleteCommentThread(d,f){const t=this._commentControllers.get(d);t&&t.$deleteCommentThread(f)}$provideCommentingRanges(d,f,t){const n=this._commentControllers.get(d);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(E.URI.revive(f));return(0,v.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(o=>o?o.map(u=>k.Range.from(u)):void 0)}$toggleReaction(d,f,t,n,s){const o=this._commentControllers.get(d);return!o||!o.reactionHandler?Promise.resolve(void 0):(0,v.asPromise)(()=>{const u=o.getCommentThread(f);if(u){const w=u.getCommentByUniqueId(n.uniqueIdInThread);if(o!==void 0&&w&&o.reactionHandler)return o.reactionHandler(w,m(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=c,c.handlePool=0;class g{constructor(d,f,t,n,s,o,u){this._proxy=d,this._commentController=f,this._id=t,this._uri=n,this._range=s,this._comments=o,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${f.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=o}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const d=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),f={};d("range")&&(f.range=k.Range.from(this._range)),d("label")&&(f.label=this.label),d("contextValue")&&(f.contextValue=this.contextValue),d("comments")&&(f.comments=this._comments.map(t=>a(this,this._commentController,t,this._commentsMap))),d("collapsibleState")&&(f.collapseState=y(this._collapseState)),d("canReply")&&(f.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,f)}}getCommentByUniqueId(d){for(let f of this._commentsMap){let t=f[0],n=f[1];if(d===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,qe([(0,R.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class r{constructor(d,f,t,n,s){this._extension=d,this._handle=f,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(d,f,t,n){if(typeof d=="string"){const s=new g(this._proxy,this,d,f,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new g(this._proxy,this,void 0,d,f,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(d,f){const t=new g(this._proxy,this,void 0,E.URI.revive(d),k.Range.to(f),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(d,f){let t=this._threads.get(d);t&&(t.range=k.Range.to(f))}$deleteCommentThread(d){let f=this._threads.get(d);f&&f.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function a(l,d,f,t){let n=t.get(f);n||(n=++l.commentHandle,t.set(f,n));const s=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(f.body),userName:f.author.name,userIconPath:s,label:f.label,commentReactions:f.reactions?f.reactions.map(o=>p(o)):void 0}}function p(l){return{label:l.label,iconPath:l.iconPath?k.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function m(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?E.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function y(l){if(l!==void 0)switch(l){case i.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(be[100],we([0,1,2,5,7,4,15,16,13,8,14]),function(J,e,v,R,C,T,E,D,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let A=class gn{constructor(g,r){this._logService=r,this._provider=new Map,this._proxy=g.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,r){const a=gn._handlePool++;this._provider.set(a,{provider:g,extensionId:r}),this._proxy.$registerDecorationProvider(a,r.value);const p=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(a,null);return}let y=(0,S.asArray)(m);if(y.length<=gn._maxEventSize){this._proxy.$onDidChange(a,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,y.length);const l=y.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),d=(0,S.groupBy)(l,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let f=[];e:for(let t of d){let n;for(let s of t){let o=(0,i.dirname)(s.uri.path);if(n!==o&&(n=o,f.push(s.uri)>=gn._maxEventSize))break e}}this._proxy.$onDidChange(a,f)});return new C.Disposable(()=>{p==null||p.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(g,r,a){if(!this._provider.has(g))return Object.create(null);const p=Object.create(null),{provider:m,extensionId:y}=this._provider.get(g);return await Promise.all(r.map(async l=>{try{const{uri:d,id:f}=l,t=await Promise.resolve(m.provideFileDecoration(v.URI.revive(d),a));if(!t)return;try{C.FileDecoration.validate(t),p[f]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${y.value}': ${n}`)}}catch(d){this._logService.error(d)}})),p}};A._handlePool=0,A._maxEventSize=250,A=qe([Ke(0,E.IExtHostRpcService),Ke(1,D.ILogService)],A),e.ExtHostDecorations=A,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(be[191],we([0,1,131,91,2,5,7,9,3,16,22]),function(J,e,v,R,C,T,E,D,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class A{constructor(r,a,p,m,y){this._name=r,this._owner=a,this._maxDiagnosticsPerFile=p,this._proxy=m,this._onDidChangeDiagnostics=y,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,a){if(!r){this.clear();return}this._checkDisposed();let p=[];if(C.URI.isUri(r)){if(!a){this.delete(r);return}this._data.set(r,a.slice()),p=[r]}else if(Array.isArray(r)){p=[];let y;r=[...r].sort(A._compareIndexedTuplesByUri);for(const l of r){const[d,f]=l;if((!y||d.toString()!==y.toString())&&(y&&this._data.get(y).length===0&&this._data.delete(y),y=d,p.push(d),this._data.set(d,[])),f){const t=this._data.get(d);t&&t.push(...f)}else{const t=this._data.get(d);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!!this._proxy){const m=[];for(let y of p){let l=[];const d=this._data.get(y);if(d)if(d.length>this._maxDiagnosticsPerFile){l=[];const f=[E.DiagnosticSeverity.Error,E.DiagnosticSeverity.Warning,E.DiagnosticSeverity.Information,E.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of d)if(n.severity===f[t]&&l.push(D.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;l.push({severity:R.MarkerSeverity.Info,message:(0,v.localize)(0,null,d.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=d.map(f=>D.Diagnostic.from(f));m.push([y,l])}this._proxy.$changeMany(this._owner,m)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,a){this._checkDisposed();for(let p of this._data.keys())r.apply(a,[p,this.get(p),this])}get(r){this._checkDisposed();const a=this._data.get(r);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,a){return r[0].toString()<a[0].toString()?-1:r[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=A;let c=class Ht{constructor(r,a){this._logService=a,this._collections=new Map,this._onDidChangeDiagnostics=new S.Emitter,this.onDidChangeDiagnostics=S.Event.map(S.Event.debounce(this._onDidChangeDiagnostics.event,Ht._debouncer,50),Ht._mapper),this._proxy=r.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(r,a){return r?r.concat(a):a}static _mapper(r){const a=new i.ResourceMap;for(const p of r)a.set(p,p);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(r,a){const{_collections:p,_proxy:m,_onDidChangeDiagnostics:y,_logService:l}=this,d=new class{$changeMany(n,s){m.$changeMany(n,s),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,n,s.length===0?"CLEARING":s)}$clear(n){m.$clear(n),l.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,n)}dispose(){m.dispose()}};let f;if(!a)a="_generated_diagnostic_collection_name_#"+Ht._idPool++,f=a;else if(!p.has(a))f=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do f=a+Ht._idPool++;while(p.has(f))}return new class extends A{constructor(){super(a,f,Ht._maxDiagnosticsPerFile,d,y);p.set(f,this)}dispose(){super.dispose(),p.delete(f)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const a=new Map,p=[];for(const m of this._collections.values())m.forEach((y,l)=>{let d=a.get(y.toString());typeof d=="undefined"&&(d=p.length,a.set(y.toString(),d),p.push([y,[]])),p[d][1]=p[d][1].concat(...l)});return p}}_getDiagnostics(r){let a=[];for(let p of this._collections.values())p.has(r)&&(a=a.concat(p.get(r)));return a}$acceptMarkersChange(r){if(!this._mirrorCollection){const a="_generated_mirror",p=new A(a,a,Ht._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(a,p),this._mirrorCollection=p}for(const[a,p]of r)this._mirrorCollection.set(C.URI.revive(a),p.map(D.Diagnostic.to))}};c._idPool=0,c._maxDiagnosticsPerFile=1e3,c=qe([Ke(1,k.ILogService)],c),e.ExtHostDiagnostics=c}),define(be[192],we([0,1,2,5]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(E){this._proxy=E.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(E){return this._proxy.$showOpenDialog(E).then(D=>D?D.map(S=>v.URI.revive(S)):void 0)}showSaveDialog(E){return this._proxy.$showSaveDialog(E).then(D=>D?v.URI.revive(D):void 0)}}e.ExtHostDialogs=C}),define(be[193],we([0,1,12,2,7,5,17,20,8]),function(J,e,v,R,C,T,E,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(A,c,g){this._documentsAndEditors=c,this._logService=g,this._documentContentProviders=new Map,this._proxy=A.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(A,c){if(Object.keys(E.Schemas).indexOf(A)>=0)throw new Error(`scheme '${A}' already registered`);const g=k._handlePool++;this._documentContentProviders.set(g,c),this._proxy.$registerTextContentProvider(g,A);let r;return typeof c.onDidChange=="function"&&(r=c.onDidChange(a=>{if(a.scheme!==A){this._logService.warn(`Provider for scheme '${A}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(g,a).then(p=>{if(!(!p&&typeof p!="string")){const m=this._documentsAndEditors.getDocument(a);if(!!m){const y=(0,S.splitLines)(p);if(!m.equalLines(y))return this._proxy.$onVirtualDocumentChange(a,p)}}},v.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(A,c){const g=this._documentContentProviders.get(A);return g?Promise.resolve(g.provideTextDocumentContent(R.URI.revive(c),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(be[194],we([0,1,3,6,2,5,96,9,10,23]),function(J,e,v,R,C,T,E,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(c,g){this._onDidAddDocument=new v.Emitter,this._onDidRemoveDocument=new v.Emitter,this._onDidChangeDocument=new v.Emitter,this._onDidSaveDocument=new v.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=c.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const a of r)this._onDidRemoveDocument.fire(a.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const a of r)this._onDidAddDocument.fire(a.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(c){if(!!c){const g=this._documentsAndEditors.getDocument(c);if(g)return g}}getDocument(c){const g=this.getDocumentData(c);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${c}'`);return g.document}ensureDocumentData(c){const g=this._documentsAndEditors.getDocument(c);if(g)return Promise.resolve(g);let r=this._documentLoader.get(c.toString());return r||(r=this._proxy.$tryOpenDocument(c).then(a=>{this._documentLoader.delete(c.toString());const p=C.URI.revive(a);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(p))},a=>(this._documentLoader.delete(c.toString()),Promise.reject(a))),this._documentLoader.set(c.toString(),r)),r}createDocumentData(c){return this._proxy.$tryCreateDocument(c).then(g=>C.URI.revive(g))}$acceptModelModeChanged(c,g){const r=C.URI.revive(c),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");this._onDidRemoveDocument.fire(a.document),a._acceptLanguageId(g),this._onDidAddDocument.fire(a.document)}$acceptModelSaved(c){const g=C.URI.revive(c),r=this._documentsAndEditors.getDocument(g);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(c,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(c,g){const r=C.URI.revive(c),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty(g),this._onDidChangeDocument.fire({document:a.document,contentChanges:[]})}$acceptModelChanged(c,g,r){const a=C.URI.revive(c),p=this._documentsAndEditors.getDocument(a);if(!p)throw new Error("unknown document");p._acceptIsDirty(r),p.onEvents(g),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:p.document,contentChanges:g.changes.map(m=>({range:D.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(c,g){(0,E.setWordDefinitionFor)(c,g)}}e.ExtHostDocuments=i}),define(be[39],we([0,1,42,3,6,2,4,5,96,15,98,9,16,22,17,43,109]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let y=class{constructor(d,f){this._extHostRpc=d,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const f=[],t=[],n=[];if(d.removedDocuments)for(const s of d.removedDocuments){const o=T.URI.revive(s),u=this._documents.get(o);(u==null?void 0:u.unref())&&(this._documents.delete(o),f.push(u.value))}if(d.addedDocuments)for(const s of d.addedDocuments){const o=T.URI.revive(s.uri);let u=this._documents.get(o);if(u&&o.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${o} already exists!'`);u||(u=new m(new S.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(o,u),t.push(u.value)),u.ref()}if(d.removedEditors)for(const s of d.removedEditors){const o=this._editors.get(s);this._editors.delete(s),o&&n.push(o)}if(d.addedEditors)for(const s of d.addedEditors){const o=T.URI.revive(s.documentUri);v.ok(this._documents.has(o),`document '${o}' does not exist`),v.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const u=this._documents.get(o).value,w=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>u.document),s.selections.map(A.Selection.to),s.options,s.visibleRanges.map(b=>A.Range.to(b)),typeof s.editorPosition=="number"?A.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,w)}d.newActiveEditor!==void 0&&(v.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,C.dispose)(f),(0,C.dispose)(n),d.removedDocuments&&this._onDidRemoveDocuments.fire(f),d.addedDocuments&&this._onDidAddDocuments.fire(t),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){var f;return(f=this._documents.get(d))===null||f===void 0?void 0:f.value}allDocuments(){return a.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!!this._activeEditorId){const f=this._editors.get(this._activeEditorId);return d?f:f==null?void 0:f.value}}allEditors(){return[...this._editors.values()]}};y=qe([Ke(0,k.IExtHostRpcService),Ke(1,c.ILogService)],y),e.ExtHostDocumentsAndEditors=y,e.IExtHostDocumentsAndEditors=(0,E.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[195],we([0,1,2,5,6,7,9,119,8,24]),function(J,e,v,R,C,T,E,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const r=this._schemes.indexOf(g);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),r=[];let a,p,m=14,y=14;for(const l of g){let d=a?(0,S.commonPrefixLength)(a,l):0;for(d===0?p=1:p=y;d<l.length;d++)d+1===l.length?(m=y,y=9):y+=1,r.push([p,l.toUpperCase().charCodeAt(d),y]),r.push([p,l.toLowerCase().charCodeAt(d),y]),p=y;a=l,y=m}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new D.StateMachine(r)}}provideDocumentLinks(g){this._initStateMachine();const r=[],a=D.LinkComputer.computeLinks({getLineContent(p){return g.lineAt(p-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const p of a){const m=E.DocumentLink.to(p);m.target&&r.push(m)}return r}}class A{constructor(g,r){this._extHostLanguageFeatures=r,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=g.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,r,a,p={},m){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const y=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(y,a),this._enableProposedApi.set(y,m!=null?m:!1);let l=2;p.isCaseSensitive&&(l+=1024),p.isReadonly&&(l+=2048),typeof a.copy=="function"&&(l+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&(l+=4),this._proxy.$registerFileSystemProvider(y,r,l).catch(f=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${r}`),console.error(f)});const d=a.onDidChangeFile(f=>{const t=[];for(const n of f){let{uri:s,type:o}=n;if(s.scheme===r){let u;switch(o){case T.FileChangeType.Changed:u=0;break;case T.FileChangeType.Created:u=1;break;case T.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:u})}}this._proxy.$onFileSystemChange(y,t)});return(0,C.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(y),this._enableProposedApi.delete(y),this._proxy.$unregisterProvider(y)})}static _asIStat(g,r){const{type:a,ctime:p,mtime:m,size:y,permissions:l}=g;return r?{type:a,ctime:p,mtime:m,size:y,permissions:l}:{type:a,ctime:p,mtime:m,size:y}}$stat(g,r){return Promise.resolve(this._getFsProvider(g).stat(v.URI.revive(r))).then(a=>{var p;return A._asIStat(a,(p=this._enableProposedApi.get(g))!==null&&p!==void 0?p:!1)})}$readdir(g,r){return Promise.resolve(this._getFsProvider(g).readDirectory(v.URI.revive(r)))}$readFile(g,r){return Promise.resolve(this._getFsProvider(g).readFile(v.URI.revive(r))).then(a=>k.VSBuffer.wrap(a))}$writeFile(g,r,a,p){return Promise.resolve(this._getFsProvider(g).writeFile(v.URI.revive(r),a.buffer,p))}$delete(g,r,a){return Promise.resolve(this._getFsProvider(g).delete(v.URI.revive(r),a))}$rename(g,r,a,p){return Promise.resolve(this._getFsProvider(g).rename(v.URI.revive(r),v.URI.revive(a),p))}$copy(g,r,a,p){const m=this._getFsProvider(g);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(v.URI.revive(r),v.URI.revive(a),p))}$mkdir(g,r){return Promise.resolve(this._getFsProvider(g).createDirectory(v.URI.revive(r)))}$watch(g,r,a,p){const m=this._getFsProvider(g).watch(v.URI.revive(a),p);this._watches.set(r,m)}$unwatch(g,r){const a=this._watches.get(r);a&&(a.dispose(),this._watches.delete(r))}$open(g,r,a){const p=this._getFsProvider(g);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(v.URI.revive(r),a))}$close(g,r){const a=this._getFsProvider(g);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(r))}$read(g,r,a,p){const m=this._getFsProvider(g);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const y=k.VSBuffer.alloc(p);return Promise.resolve(m.read(r,a,y.buffer,0,p)).then(l=>y.slice(0,l))}$write(g,r,a,p){const m=this._getFsProvider(g);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(r,a,p.buffer,0,p.byteLength))}_getFsProvider(g){const r=this._fsProvider.get(g);if(!r){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return r}}e.ExtHostFileSystem=A}),define(be[78],we([0,1,5,65,7,24,4,15,49]),function(J,e,v,R,C,T,E,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Nt{constructor(A,c){const g=A.getProxy(v.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return g.$stat(r).catch(Nt._handleError)},readDirectory(r){return g.$readdir(r).catch(Nt._handleError)},createDirectory(r){return g.$mkdir(r).catch(Nt._handleError)},async readFile(r){return g.$readFile(r).then(a=>a.buffer).catch(Nt._handleError)},writeFile(r,a){return g.$writeFile(r,T.VSBuffer.wrap(a)).catch(Nt._handleError)},delete(r,a){return g.$delete(r,Object.assign({recursive:!1,useTrash:!1},a)).catch(Nt._handleError)},rename(r,a,p){return g.$rename(r,a,Object.assign({overwrite:!1},p)).catch(Nt._handleError)},copy(r,a,p){return g.$copy(r,a,Object.assign({overwrite:!1},p)).catch(Nt._handleError)},isWritableFileSystem(r){const a=c.getCapabilities(r);if(typeof a=="number")return!(a&2048)}})}static _handleError(A){if(!(A instanceof Error))throw new C.FileSystemError(String(A));if(A.name==="ENOPRO")throw C.FileSystemError.Unavailable(A.message);switch(A.name){case R.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(A.message);case R.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(A.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(A.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(A.message);case R.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(A.message);case R.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(A.message);default:throw new C.FileSystemError(A.message,A.name)}}};k=qe([Ke(0,D.IExtHostRpcService),Ke(1,S.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,E.createDecorator)("IExtHostConsumerFileSystem")}),define(be[196],we([0,1,6,5]),function(J,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(E){this._handlePool=0,this._proxy=E.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(E){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,E),(0,v.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=C}),define(be[197],we([0,1,2,23,9,7,11,5,8,32,13,10,116,6,88,55,69,56,12]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(x,G){this._documents=x,this._provider=G}provideDocumentSymbols(x,G){const ee=this._documents.getDocument(x);return(0,E.asPromise)(()=>this._provider.provideDocumentSymbols(ee,G)).then(ie=>{if(!(0,i.isFalsyOrEmpty)(ie))return ie[0]instanceof T.DocumentSymbol?ie.map(C.DocumentSymbol.from):l._asDocumentSymbolTree(ie)})}static _asDocumentSymbolTree(x){var G;x=x.slice(0).sort((ue,Ee)=>{let $e=ue.location.range.start.compareTo(Ee.location.range.start);return $e===0&&($e=Ee.location.range.end.compareTo(ue.location.range.end)),$e});const ee=[],ie=[];for(const ue of x){const Ee={name:ue.name||"!!MISSING: name!!",kind:C.SymbolKind.from(ue.kind),tags:((G=ue.tags)===null||G===void 0?void 0:G.map(C.SymbolTag.from))||[],detail:"",containerName:ue.containerName,range:C.Range.from(ue.location.range),selectionRange:C.Range.from(ue.location.range),children:[]};for(;;){if(ie.length===0){ie.push(Ee),ee.push(Ee);break}const $e=ie[ie.length-1];if(k.Range.containsRange($e.range,Ee.range)&&!k.Range.equalsRange($e.range,Ee.range)){$e.children&&$e.children.push(Ee),ie.push(Ee);break}ie.pop()}}return ee}}class d{constructor(x,G,ee){this._documents=x,this._commands=G,this._provider=ee,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,G){const ee=this._documents.getDocument(x),ie=await this._provider.provideCodeLenses(ee,G);if(!(!ie||G.isCancellationRequested)){const ue=this._cache.add(ie),Ee=new g.DisposableStore;this._disposables.set(ue,Ee);const $e={cacheId:ue,lenses:[]};for(let he=0;he<ie.length;he++)$e.lenses.push({cacheId:[ue,he],range:C.Range.from(ie[he].range),command:this._commands.toInternal(ie[he].command,Ee)});return $e}}async resolveCodeLens(x,G){var ee;const ie=x.cacheId&&this._cache.get(...x.cacheId);if(!!ie){let ue;if(typeof this._provider.resolveCodeLens!="function"||ie.isResolved?ue=ie:ue=await this._provider.resolveCodeLens(ie,G),ue||(ue=ie),!G.isCancellationRequested){const Ee=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!Ee)return x.command=this._commands.toInternal((ee=ue.command)!==null&&ee!==void 0?ee:d._badCmd,Ee),x}}}releaseCodeLenses(x){var G;(G=this._disposables.get(x))===null||G===void 0||G.dispose(),this._disposables.delete(x),this._cache.delete(x)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function f(He){return Array.isArray(He)?He.map(C.DefinitionLink.from):He?[C.DefinitionLink.from(He)]:[]}class t{constructor(x,G){this._documents=x,this._provider=G}provideDefinition(x,G,ee){const ie=this._documents.getDocument(x),ue=C.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideDefinition(ie,ue,ee)).then(f)}}class n{constructor(x,G){this._documents=x,this._provider=G}provideDeclaration(x,G,ee){const ie=this._documents.getDocument(x),ue=C.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideDeclaration(ie,ue,ee)).then(f)}}class s{constructor(x,G){this._documents=x,this._provider=G}provideImplementation(x,G,ee){const ie=this._documents.getDocument(x),ue=C.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideImplementation(ie,ue,ee)).then(f)}}class o{constructor(x,G){this._documents=x,this._provider=G}provideTypeDefinition(x,G,ee){const ie=this._documents.getDocument(x),ue=C.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideTypeDefinition(ie,ue,ee)).then(f)}}class u{constructor(x,G){this._documents=x,this._provider=G}provideHover(x,G,ee){const ie=this._documents.getDocument(x),ue=C.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideHover(ie,ue,ee)).then(Ee=>{if(!(!Ee||(0,i.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=ie.getWordRangeAtPosition(ue)),Ee.range||(Ee.range=new T.Range(ue,ue)),C.Hover.from(Ee)})}}class w{constructor(x,G){this._documents=x,this._provider=G}provideEvaluatableExpression(x,G,ee){const ie=this._documents.getDocument(x),ue=C.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideEvaluatableExpression(ie,ue,ee)).then(Ee=>{if(Ee)return C.EvaluatableExpression.from(Ee)})}}class b{constructor(x,G){this._documents=x,this._provider=G}provideInlineValues(x,G,ee,ie){const ue=this._documents.getDocument(x);return(0,E.asPromise)(()=>this._provider.provideInlineValues(ue,C.Range.to(G),C.InlineValueContext.to(ee),ie)).then(Ee=>{if(Array.isArray(Ee))return Ee.map($e=>C.InlineValue.from($e))})}}class I{constructor(x,G){this._documents=x,this._provider=G}provideDocumentHighlights(x,G,ee){const ie=this._documents.getDocument(x),ue=C.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideDocumentHighlights(ie,ue,ee)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(C.DocumentHighlight.from)})}}class h{constructor(x,G){this._documents=x,this._provider=G}provideLinkedEditingRanges(x,G,ee){const ie=this._documents.getDocument(x),ue=C.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideLinkedEditingRanges(ie,ue,ee)).then(Ee=>{if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,i.coalesce)(Ee.ranges.map(C.Range.from)),wordPattern:Ee.wordPattern}})}}class _{constructor(x,G){this._documents=x,this._provider=G}provideReferences(x,G,ee,ie){const ue=this._documents.getDocument(x),Ee=C.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideReferences(ue,Ee,ee,ie)).then($e=>{if(Array.isArray($e))return $e.map(C.location.from)})}}class F{constructor(x,G,ee,ie,ue,Ee,$e){this._documents=x,this._commands=G,this._diagnostics=ee,this._provider=ie,this._logService=ue,this._extension=Ee,this._apiDeprecation=$e,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(x,G,ee,ie){const ue=this._documents.getDocument(x),Ee=c.Selection.isISelection(G)?C.Selection.to(G):C.Range.to(G),$e=[];for(const Ce of this._diagnostics.getDiagnostics(x))if(Ee.intersection(Ce.range)&&$e.push(Ce)>F._maxCodeActionsPerFile)break;const he={diagnostics:$e,only:ee.only?new T.CodeActionKind(ee.only):void 0,triggerKind:C.CodeActionTriggerKind.to(ee.trigger)};return(0,E.asPromise)(()=>this._provider.provideCodeActions(ue,Ee,he,ie)).then(Ce=>{var Te;if(!(!(0,i.isNonEmptyArray)(Ce)||ie.isCancellationRequested)){const We=this._cache.add(Ce),ve=new g.DisposableStore;this._disposables.set(We,ve);const Ge=[];for(let V=0;V<Ce.length;V++){const Z=Ce[V];!Z||(F._isCommand(Z)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:Z.title,command:this._commands.toInternal(Z,ve)})):(he.only&&(Z.kind?he.only.contains(Z.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${he.only.value} 'requested but returned code action is of kind '${Z.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${he.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[We,V],title:Z.title,command:Z.command&&this._commands.toInternal(Z.command,ve),diagnostics:Z.diagnostics&&Z.diagnostics.map(C.Diagnostic.from),edit:Z.edit&&C.WorkspaceEdit.from(Z.edit),kind:Z.kind&&Z.kind.value,isPreferred:Z.isPreferred,disabled:(Te=Z.disabled)===null||Te===void 0?void 0:Te.reason})))}return{cacheId:We,actions:Ge}}})}async resolveCodeAction(x,G){var ee;const[ie,ue]=x,Ee=this._cache.get(ie,ue);if(!(!Ee||F._isCommand(Ee))&&!!this._provider.resolveCodeAction){const $e=(ee=await this._provider.resolveCodeAction(Ee,G))!==null&&ee!==void 0?ee:Ee;return($e==null?void 0:$e.edit)?C.WorkspaceEdit.from($e.edit):void 0}}releaseCodeActions(x){var G;(G=this._disposables.get(x))===null||G===void 0||G.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}F._maxCodeActionsPerFile=1e3;class N{constructor(x,G){this._documents=x,this._provider=G}provideDocumentFormattingEdits(x,G,ee){const ie=this._documents.getDocument(x);return(0,E.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ie,G,ee)).then(ue=>{if(Array.isArray(ue))return ue.map(C.TextEdit.from)})}}class z{constructor(x,G){this._documents=x,this._provider=G}provideDocumentRangeFormattingEdits(x,G,ee,ie){const ue=this._documents.getDocument(x),Ee=C.Range.to(G);return(0,E.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(ue,Ee,ee,ie)).then($e=>{if(Array.isArray($e))return $e.map(C.TextEdit.from)})}}class ce{constructor(x,G){this._documents=x,this._provider=G,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(x,G,ee,ie,ue){const Ee=this._documents.getDocument(x),$e=C.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Ee,$e,ee,ie,ue)).then(he=>{if(Array.isArray(he))return he.map(C.TextEdit.from)})}}class de{constructor(x,G){this._provider=x,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(x,G){const ee=D.IdObject.mixin({symbols:[]});return(0,E.asPromise)(()=>this._provider.provideWorkspaceSymbols(x,G)).then(ie=>{if((0,i.isNonEmptyArray)(ie)){for(const ue of ie)if(!!ue){if(!ue.name){this._logService.warn("INVALID SymbolInformation, lacks name",ue);continue}const Ee=D.IdObject.mixin(C.WorkspaceSymbol.from(ue));this._symbolCache.set(Ee._id,ue),ee.symbols.push(Ee)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(x,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const ee=this._symbolCache.get(x._id);if(ee){const ie=await(0,E.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,G));return ie&&(0,R.mixin)(x,C.WorkspaceSymbol.from(ie),!0)}}releaseWorkspaceSymbols(x){const G=this._resultCache.get(x);if(G){for(let[ee,ie]=G;ee<=ie;ee++)this._symbolCache.delete(ee);this._resultCache.delete(x)}}}class B{constructor(x,G,ee){this._documents=x,this._provider=G,this._logService=ee}static supportsResolving(x){return typeof x.prepareRename=="function"}provideRenameEdits(x,G,ee,ie){const ue=this._documents.getDocument(x),Ee=C.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideRenameEdits(ue,Ee,ee,ie)).then($e=>{if(!!$e)return C.WorkspaceEdit.from($e)},$e=>{const he=B._asMessage($e);return he?{rejectReason:he,edits:void 0}:Promise.reject($e)})}resolveRenameLocation(x,G,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ie=this._documents.getDocument(x),ue=C.Position.to(G);return(0,E.asPromise)(()=>this._provider.prepareRename(ie,ue,ee)).then(Ee=>{let $e,he;if(T.Range.isRange(Ee)?($e=Ee,he=ie.getText(Ee)):(0,A.isObject)(Ee)&&($e=Ee.range,he=Ee.placeholder),!!$e){if($e.start.line>ue.line||$e.end.line<ue.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from($e),text:he}}},Ee=>{const $e=B._asMessage(Ee);return $e?{rejectReason:$e,range:void 0,text:void 0}:Promise.reject(Ee)})}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class j{constructor(x,G){this.resultId=x,this.tokens=G}}class W{constructor(x,G){this._documents=x,this._provider=G,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(x,G,ee){const ie=this._documents.getDocument(x),ue=G!==0?this._previousResults.get(G):null;return(0,E.asPromise)(()=>ue&&typeof ue.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ie,ue.resultId,ee):this._provider.provideDocumentSemanticTokens(ie,ee)).then(Ee=>(ue&&this._previousResults.delete(G),Ee?(Ee=W._fixProvidedSemanticTokens(Ee),this._send(W._convertToEdits(ue,Ee),Ee)):null))}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return W._isSemanticTokens(x)?W._isCorrectSemanticTokens(x)?x:new T.SemanticTokens(new Uint32Array(x.data),x.resultId):W._isSemanticTokensEdits(x)?W._isCorrectSemanticTokensEdits(x)?x:new T.SemanticTokensEdits(x.edits.map(G=>new T.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const G of x.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,G){if(!W._isSemanticTokens(G)||!x||!x.tokens)return G;const ee=x.tokens,ie=ee.length,ue=G.data,Ee=ue.length;let $e=0;const he=Math.min(ie,Ee);for(;$e<he&&ee[$e]===ue[$e];)$e++;if($e===ie&&$e===Ee)return new T.SemanticTokensEdits([],G.resultId);let Ce=0;const Te=he-$e;for(;Ce<Te&&ee[ie-Ce-1]===ue[Ee-Ce-1];)Ce++;return new T.SemanticTokensEdits([{start:$e,deleteCount:ie-$e-Ce,data:ue.subarray($e,Ee-Ce)}],G.resultId)}_send(x,G){if(W._isSemanticTokens(x)){const ee=this._nextResultId++;return this._previousResults.set(ee,new j(x.resultId,x.data)),(0,r.encodeSemanticTokensDto)({id:ee,type:"full",data:x.data})}if(W._isSemanticTokensEdits(x)){const ee=this._nextResultId++;return W._isSemanticTokens(G)?this._previousResults.set(ee,new j(G.resultId,G.data)):this._previousResults.set(ee,new j(x.resultId)),(0,r.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(x.edits||[]).map(ie=>({start:ie.start,deleteCount:ie.deleteCount,data:ie.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class P{constructor(x,G){this._documents=x,this._provider=G}provideDocumentRangeSemanticTokens(x,G,ee){const ie=this._documents.getDocument(x);return(0,E.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ie,C.Range.to(G),ee)).then(ue=>ue?this._send(ue):null)}_send(x){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=P;class H{constructor(x,G,ee,ie,ue){this._documents=x,this._commands=G,this._provider=ee,this._apiDeprecation=ie,this._extension=ue,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,G,ee,ie){const ue=this._documents.getDocument(x),Ee=C.Position.to(G),$e=ue.getWordRangeAtPosition(Ee)||new T.Range(Ee,Ee),he=$e.with({end:Ee}),Ce=new m.StopWatch(!0),Te=await(0,E.asPromise)(()=>this._provider.provideCompletionItems(ue,Ee,ie,C.CompletionContext.to(ee)));if(!!Te&&!ie.isCancellationRequested){const We=Array.isArray(Te)?new T.CompletionList(Te):Te,ve=H.supportsResolving(this._provider)?this._cache.add(We.items):this._cache.add([]),Ge=new g.DisposableStore;this._disposables.set(ve,Ge);const V=[],Z={x:ve,b:V,a:{replace:C.Range.from($e),insert:C.Range.from(he)},c:We.isIncomplete||void 0,d:Ce.elapsed()};for(let ge=0;ge<We.items.length;ge++){const Ne=We.items[ge],Ve=this._convertCompletionItem(Ne,[ve,ge],he,$e);V.push(Ve)}return Z}}async resolveCompletionItem(x,G){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...x);if(!!ee){const ie=await(0,E.asPromise)(()=>this._provider.resolveCompletionItem(ee,G));if(!!ie)return this._convertCompletionItem(ie,x)}}}releaseCompletionItems(x){var G;(G=this._disposables.get(x))===null||G===void 0||G.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,G,ee,ie){var ue;const Ee=this._disposables.get(G[0]);if(!Ee)throw Error("DisposableStore is missing...");const $e={x:G,a:(ue=x.label)!==null&&ue!==void 0?ue:"",o:x.label2,b:x.kind!==void 0?C.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(C.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(x.command,Ee)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),$e.h=x.textEdit.newText):typeof x.insertText=="string"?$e.h=x.insertText:x.insertText instanceof T.SnippetString&&($e.h=x.insertText.value,$e.i|=4);let he;return x.textEdit?he=x.textEdit.range:x.range&&(he=x.range),T.Range.isRange(he)?$e.j=C.Range.from(he):he&&(!(ee==null?void 0:ee.isEqual(he.inserting))||!(ie==null?void 0:ie.isEqual(he.replacing)))&&($e.j={insert:C.Range.from(he.inserting),replace:C.Range.from(he.replacing)}),$e}}class L{constructor(x,G){this._documents=x,this._provider=G,this._cache=new p.Cache("SignatureHelp")}provideSignatureHelp(x,G,ee,ie){const ue=this._documents.getDocument(x),Ee=C.Position.to(G),$e=this.reviveContext(ee);return(0,E.asPromise)(()=>this._provider.provideSignatureHelp(ue,Ee,ie,$e)).then(he=>{if(he){const Ce=this._cache.add([he]);return Object.assign(Object.assign({},C.SignatureHelp.from(he)),{id:Ce})}})}reviveContext(x){let G;if(x.activeSignatureHelp){const ee=C.SignatureHelp.to(x.activeSignatureHelp),ie=this._cache.get(x.activeSignatureHelp.id,0);ie?(G=ie,G.activeSignature=ee.activeSignature,G.activeParameter=ee.activeParameter):G=ee}return Object.assign(Object.assign({},x),{activeSignatureHelp:G})}releaseSignatureHelp(x){this._cache.delete(x)}}class ${constructor(x,G){this._documents=x,this._provider=G}provideInlayHints(x,G,ee){const ie=this._documents.getDocument(x);return(0,E.asPromise)(()=>this._provider.provideInlayHints(ie,C.Range.to(G),ee)).then(ue=>ue?{hints:ue.map(C.InlayHint.from)}:void 0)}}class Q{constructor(x,G){this._documents=x,this._provider=G,this._cache=new p.Cache("DocumentLink")}provideLinks(x,G){const ee=this._documents.getDocument(x);return(0,E.asPromise)(()=>this._provider.provideDocumentLinks(ee,G)).then(ie=>{if(!(!Array.isArray(ie)||ie.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ie.map(C.DocumentLink.from)};{const ue=this._cache.add(ie),Ee={links:[],id:ue};for(let $e=0;$e<ie.length;$e++){const he=C.DocumentLink.from(ie[$e]);he.cacheId=[ue,$e],Ee.links.push(he)}return Ee}}})}resolveLink(x,G){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...x);return ee?(0,E.asPromise)(()=>this._provider.resolveDocumentLink(ee,G)).then(ie=>ie&&C.DocumentLink.from(ie)||void 0):Promise.resolve(void 0)}releaseLinks(x){this._cache.delete(x)}}class q{constructor(x,G){this._documents=x,this._provider=G}provideColors(x,G){const ee=this._documents.getDocument(x);return(0,E.asPromise)(()=>this._provider.provideDocumentColors(ee,G)).then(ie=>Array.isArray(ie)?ie.map(Ee=>({color:C.Color.from(Ee.color),range:C.Range.from(Ee.range)})):[])}provideColorPresentations(x,G,ee){const ie=this._documents.getDocument(x),ue=C.Range.to(G.range),Ee=C.Color.to(G.color);return(0,E.asPromise)(()=>this._provider.provideColorPresentations(Ee,{document:ie,range:ue},ee)).then($e=>{if(!!Array.isArray($e))return $e.map(C.ColorPresentation.from)})}}class ae{constructor(x,G){this._documents=x,this._provider=G}provideFoldingRanges(x,G,ee){const ie=this._documents.getDocument(x);return(0,E.asPromise)(()=>this._provider.provideFoldingRanges(ie,G,ee)).then(ue=>{if(!!Array.isArray(ue))return ue.map(C.FoldingRange.from)})}}class fe{constructor(x,G,ee){this._documents=x,this._provider=G,this._logService=ee}provideSelectionRanges(x,G,ee){const ie=this._documents.getDocument(x),ue=G.map(C.Position.to);return(0,E.asPromise)(()=>this._provider.provideSelectionRanges(ie,ue,ee)).then(Ee=>{if(!(0,i.isNonEmptyArray)(Ee))return[];if(Ee.length!==ue.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const $e=[];for(let he=0;he<ue.length;he++){const Ce=[];$e.push(Ce);let Te=ue[he],We=Ee[he];for(;;){if(!We.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(C.SelectionRange.from(We)),!We.parent)break;Te=We.range,We=We.parent}}return $e})}}class Le{constructor(x,G){this._documents=x,this._provider=G,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(x,G,ee){const ie=this._documents.getDocument(x),ue=C.Position.to(G),Ee=await this._provider.prepareCallHierarchy(ie,ue,ee);if(!!Ee){const $e=this._idPool.nextId();return this._cache.set($e,new Map),Array.isArray(Ee)?Ee.map(he=>this._cacheAndConvertItem($e,he)):[this._cacheAndConvertItem($e,Ee)]}}async provideCallsTo(x,G,ee){const ie=this._itemFromCache(x,G);if(!ie)throw new Error("missing call hierarchy item");const ue=await this._provider.provideCallHierarchyIncomingCalls(ie,ee);if(!!ue)return ue.map(Ee=>({from:this._cacheAndConvertItem(x,Ee.from),fromRanges:Ee.fromRanges.map($e=>C.Range.from($e))}))}async provideCallsFrom(x,G,ee){const ie=this._itemFromCache(x,G);if(!ie)throw new Error("missing call hierarchy item");const ue=await this._provider.provideCallHierarchyOutgoingCalls(ie,ee);if(!!ue)return ue.map(Ee=>({to:this._cacheAndConvertItem(x,Ee.to),fromRanges:Ee.fromRanges.map($e=>C.Range.from($e))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,G){var ee;const ie=this._cache.get(x),ue={_sessionId:x,_itemId:ie.size.toString(36),name:G.name,detail:G.detail,kind:C.SymbolKind.from(G.kind),uri:G.uri,range:C.Range.from(G.range),selectionRange:C.Range.from(G.selectionRange),tags:(ee=G.tags)===null||ee===void 0?void 0:ee.map(C.SymbolTag.from)};return ie.set(ue._itemId,G),ue}_itemFromCache(x,G){const ee=this._cache.get(x);return ee==null?void 0:ee.get(G)}}class xe{constructor(x,G){this.adapter=x,this.extension=G}}class Fe{constructor(x,G,ee,ie,ue,Ee,$e){this._adapter=new Map,this._uriTransformer=G,this._proxy=x.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ie,this._diagnostics=ue,this._logService=Ee,this._apiDeprecation=$e}_transformDocumentSelector(x){return(0,i.coalesce)((0,i.asArray)(x).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:C.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new T.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return Fe._handlePool++}_withAdapter(x,G,ee,ie,ue=!1){const Ee=this._adapter.get(x);if(!Ee)return Promise.resolve(ie);if(Ee.adapter instanceof G){let $e;Ee.extension&&($e=Date.now(),this._logService.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${G.name}'`));const he=ee(Ee.adapter,Ee.extension),Ce=Ee.extension;return Ce&&Promise.resolve(he).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-$e}ms`),Te=>{ue&&Te instanceof y.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Te))}),he}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,G){const ee=this._nextHandle();return this._adapter.set(ee,new xe(x,G)),ee}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,G,ee,ie){const ue=this._addNewAdapter(new l(this._documents,ee),x),Ee=ie&&ie.label||Fe._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(ue,this._transformDocumentSelector(G),Ee),this._createDisposable(ue)}$provideDocumentSymbols(x,G,ee){return this._withAdapter(x,l,ie=>ie.provideDocumentSymbols(v.URI.revive(G),ee),void 0)}registerCodeLensProvider(x,G,ee){const ie=this._nextHandle(),ue=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ie,new xe(new d(this._documents,this._commands.converter,ee),x)),this._proxy.$registerCodeLensSupport(ie,this._transformDocumentSelector(G),ue);let Ee=this._createDisposable(ie);if(ue!==void 0){const $e=ee.onDidChangeCodeLenses(he=>this._proxy.$emitCodeLensEvent(ue));Ee=T.Disposable.from(Ee,$e)}return Ee}$provideCodeLenses(x,G,ee){return this._withAdapter(x,d,ie=>ie.provideCodeLenses(v.URI.revive(G),ee),void 0)}$resolveCodeLens(x,G,ee){return this._withAdapter(x,d,ie=>ie.resolveCodeLens(G,ee),void 0)}$releaseCodeLenses(x,G){this._withAdapter(x,d,ee=>Promise.resolve(ee.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(x,G,ee){const ie=this._addNewAdapter(new t(this._documents,ee),x);return this._proxy.$registerDefinitionSupport(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideDefinition(x,G,ee,ie){return this._withAdapter(x,t,ue=>ue.provideDefinition(v.URI.revive(G),ee,ie),[])}registerDeclarationProvider(x,G,ee){const ie=this._addNewAdapter(new n(this._documents,ee),x);return this._proxy.$registerDeclarationSupport(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideDeclaration(x,G,ee,ie){return this._withAdapter(x,n,ue=>ue.provideDeclaration(v.URI.revive(G),ee,ie),[])}registerImplementationProvider(x,G,ee){const ie=this._addNewAdapter(new s(this._documents,ee),x);return this._proxy.$registerImplementationSupport(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideImplementation(x,G,ee,ie){return this._withAdapter(x,s,ue=>ue.provideImplementation(v.URI.revive(G),ee,ie),[])}registerTypeDefinitionProvider(x,G,ee){const ie=this._addNewAdapter(new o(this._documents,ee),x);return this._proxy.$registerTypeDefinitionSupport(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideTypeDefinition(x,G,ee,ie){return this._withAdapter(x,o,ue=>ue.provideTypeDefinition(v.URI.revive(G),ee,ie),[])}registerHoverProvider(x,G,ee,ie){const ue=this._addNewAdapter(new u(this._documents,ee),x);return this._proxy.$registerHoverProvider(ue,this._transformDocumentSelector(G)),this._createDisposable(ue)}$provideHover(x,G,ee,ie){return this._withAdapter(x,u,ue=>ue.provideHover(v.URI.revive(G),ee,ie),void 0)}registerEvaluatableExpressionProvider(x,G,ee,ie){const ue=this._addNewAdapter(new w(this._documents,ee),x);return this._proxy.$registerEvaluatableExpressionProvider(ue,this._transformDocumentSelector(G)),this._createDisposable(ue)}$provideEvaluatableExpression(x,G,ee,ie){return this._withAdapter(x,w,ue=>ue.provideEvaluatableExpression(v.URI.revive(G),ee,ie),void 0)}registerInlineValuesProvider(x,G,ee,ie){const ue=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new b(this._documents,ee),x);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector(G),ue);let $e=this._createDisposable(Ee);if(ue!==void 0){const he=ee.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(ue));$e=T.Disposable.from($e,he)}return $e}$provideInlineValues(x,G,ee,ie,ue){return this._withAdapter(x,b,Ee=>Ee.provideInlineValues(v.URI.revive(G),ee,ie,ue),void 0)}registerDocumentHighlightProvider(x,G,ee){const ie=this._addNewAdapter(new I(this._documents,ee),x);return this._proxy.$registerDocumentHighlightProvider(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideDocumentHighlights(x,G,ee,ie){return this._withAdapter(x,I,ue=>ue.provideDocumentHighlights(v.URI.revive(G),ee,ie),void 0)}registerLinkedEditingRangeProvider(x,G,ee){const ie=this._addNewAdapter(new h(this._documents,ee),x);return this._proxy.$registerLinkedEditingRangeProvider(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideLinkedEditingRanges(x,G,ee,ie){return this._withAdapter(x,h,async ue=>{const Ee=await ue.provideLinkedEditingRanges(v.URI.revive(G),ee,ie);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?Fe._serializeRegExp(Ee.wordPattern):void 0}},void 0)}registerReferenceProvider(x,G,ee){const ie=this._addNewAdapter(new _(this._documents,ee),x);return this._proxy.$registerReferenceSupport(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideReferences(x,G,ee,ie,ue){return this._withAdapter(x,_,Ee=>Ee.provideReferences(v.URI.revive(G),ee,ie,ue),void 0)}registerCodeActionProvider(x,G,ee,ie){var ue,Ee;const $e=new g.DisposableStore,he=this._addNewAdapter(new F(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(he,this._transformDocumentSelector(G),{providedKinds:(ue=ie==null?void 0:ie.providedCodeActionKinds)===null||ue===void 0?void 0:ue.map(Ce=>Ce.value),documentation:(Ee=ie==null?void 0:ie.documentation)===null||Ee===void 0?void 0:Ee.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,$e)}))},Fe._extLabel(x),Boolean(ee.resolveCodeAction)),$e.add(this._createDisposable(he)),$e}$provideCodeActions(x,G,ee,ie,ue){return this._withAdapter(x,F,Ee=>Ee.provideCodeActions(v.URI.revive(G),ee,ie,ue),void 0)}$resolveCodeAction(x,G,ee){return this._withAdapter(x,F,ie=>ie.resolveCodeAction(G,ee),void 0)}$releaseCodeActions(x,G){this._withAdapter(x,F,ee=>Promise.resolve(ee.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(x,G,ee){const ie=this._addNewAdapter(new N(this._documents,ee),x);return this._proxy.$registerDocumentFormattingSupport(ie,this._transformDocumentSelector(G),x.identifier,x.displayName||x.name),this._createDisposable(ie)}$provideDocumentFormattingEdits(x,G,ee,ie){return this._withAdapter(x,N,ue=>ue.provideDocumentFormattingEdits(v.URI.revive(G),ee,ie),void 0)}registerDocumentRangeFormattingEditProvider(x,G,ee){const ie=this._addNewAdapter(new z(this._documents,ee),x);return this._proxy.$registerRangeFormattingSupport(ie,this._transformDocumentSelector(G),x.identifier,x.displayName||x.name),this._createDisposable(ie)}$provideDocumentRangeFormattingEdits(x,G,ee,ie,ue){return this._withAdapter(x,z,Ee=>Ee.provideDocumentRangeFormattingEdits(v.URI.revive(G),ee,ie,ue),void 0)}registerOnTypeFormattingEditProvider(x,G,ee,ie){const ue=this._addNewAdapter(new ce(this._documents,ee),x);return this._proxy.$registerOnTypeFormattingSupport(ue,this._transformDocumentSelector(G),ie,x.identifier),this._createDisposable(ue)}$provideOnTypeFormattingEdits(x,G,ee,ie,ue,Ee){return this._withAdapter(x,ce,$e=>$e.provideOnTypeFormattingEdits(v.URI.revive(G),ee,ie,ue,Ee),void 0)}registerWorkspaceSymbolProvider(x,G){const ee=this._addNewAdapter(new de(G,this._logService),x);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(x,G,ee){return this._withAdapter(x,de,ie=>ie.provideWorkspaceSymbols(G,ee),{symbols:[]})}$resolveWorkspaceSymbol(x,G,ee){return this._withAdapter(x,de,ie=>ie.resolveWorkspaceSymbol(G,ee),void 0)}$releaseWorkspaceSymbols(x,G){this._withAdapter(x,de,ee=>ee.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(x,G,ee){const ie=this._addNewAdapter(new B(this._documents,ee,this._logService),x);return this._proxy.$registerRenameSupport(ie,this._transformDocumentSelector(G),B.supportsResolving(ee)),this._createDisposable(ie)}$provideRenameEdits(x,G,ee,ie,ue){return this._withAdapter(x,B,Ee=>Ee.provideRenameEdits(v.URI.revive(G),ee,ie,ue),void 0)}$resolveRenameLocation(x,G,ee,ie){return this._withAdapter(x,B,ue=>ue.resolveRenameLocation(v.URI.revive(G),ee,ie),void 0)}registerDocumentSemanticTokensProvider(x,G,ee,ie){const ue=this._nextHandle(),Ee=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ue,new xe(new W(this._documents,ee),x)),this._proxy.$registerDocumentSemanticTokensProvider(ue,this._transformDocumentSelector(G),ie,Ee);let $e=this._createDisposable(ue);if(Ee){const he=ee.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));$e=T.Disposable.from($e,he)}return $e}$provideDocumentSemanticTokens(x,G,ee,ie){return this._withAdapter(x,W,ue=>ue.provideDocumentSemanticTokens(v.URI.revive(G),ee,ie),null,!0)}$releaseDocumentSemanticTokens(x,G){this._withAdapter(x,W,ee=>ee.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(x,G,ee,ie){const ue=this._addNewAdapter(new P(this._documents,ee),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ue,this._transformDocumentSelector(G),ie),this._createDisposable(ue)}$provideDocumentRangeSemanticTokens(x,G,ee,ie){return this._withAdapter(x,P,ue=>ue.provideDocumentRangeSemanticTokens(v.URI.revive(G),ee,ie),null,!0)}registerCompletionItemProvider(x,G,ee,ie){const ue=this._addNewAdapter(new H(this._documents,this._commands.converter,ee,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(ue,this._transformDocumentSelector(G),ie,H.supportsResolving(ee),`${x.identifier.value}(${ie.join("")})`),this._createDisposable(ue)}$provideCompletionItems(x,G,ee,ie,ue){return this._withAdapter(x,H,Ee=>Ee.provideCompletionItems(v.URI.revive(G),ee,ie,ue),void 0)}$resolveCompletionItem(x,G,ee){return this._withAdapter(x,H,ie=>ie.resolveCompletionItem(G,ee),void 0)}$releaseCompletionItems(x,G){this._withAdapter(x,H,ee=>ee.releaseCompletionItems(G),void 0)}registerSignatureHelpProvider(x,G,ee,ie){const ue=Array.isArray(ie)?{triggerCharacters:ie,retriggerCharacters:[]}:ie,Ee=this._addNewAdapter(new L(this._documents,ee),x);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector(G),ue),this._createDisposable(Ee)}$provideSignatureHelp(x,G,ee,ie,ue){return this._withAdapter(x,L,Ee=>Ee.provideSignatureHelp(v.URI.revive(G),ee,ie,ue),void 0)}$releaseSignatureHelp(x,G){this._withAdapter(x,L,ee=>ee.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider(x,G,ee){const ie=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ue=this._addNewAdapter(new $(this._documents,ee),x);this._proxy.$registerInlayHintsProvider(ue,this._transformDocumentSelector(G),ie);let Ee=this._createDisposable(ue);if(ie!==void 0){const $e=ee.onDidChangeInlayHints(he=>this._proxy.$emitInlayHintsEvent(ie));Ee=T.Disposable.from(Ee,$e)}return Ee}$provideInlayHints(x,G,ee,ie){return this._withAdapter(x,$,ue=>ue.provideInlayHints(v.URI.revive(G),ee,ie),void 0)}registerDocumentLinkProvider(x,G,ee){const ie=this._addNewAdapter(new Q(this._documents,ee),x);return this._proxy.$registerDocumentLinkProvider(ie,this._transformDocumentSelector(G),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ie)}$provideDocumentLinks(x,G,ee){return this._withAdapter(x,Q,ie=>ie.provideLinks(v.URI.revive(G),ee),void 0)}$resolveDocumentLink(x,G,ee){return this._withAdapter(x,Q,ie=>ie.resolveLink(G,ee),void 0)}$releaseDocumentLinks(x,G){this._withAdapter(x,Q,ee=>ee.releaseLinks(G),void 0)}registerColorProvider(x,G,ee){const ie=this._addNewAdapter(new q(this._documents,ee),x);return this._proxy.$registerDocumentColorProvider(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideDocumentColors(x,G,ee){return this._withAdapter(x,q,ie=>ie.provideColors(v.URI.revive(G),ee),[])}$provideColorPresentations(x,G,ee,ie){return this._withAdapter(x,q,ue=>ue.provideColorPresentations(v.URI.revive(G),ee,ie),void 0)}registerFoldingRangeProvider(x,G,ee){const ie=this._nextHandle(),ue=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ie,new xe(new ae(this._documents,ee),x)),this._proxy.$registerFoldingRangeProvider(ie,this._transformDocumentSelector(G),ue);let Ee=this._createDisposable(ie);if(ue!==void 0){const $e=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ue));Ee=T.Disposable.from(Ee,$e)}return Ee}$provideFoldingRanges(x,G,ee,ie){return this._withAdapter(x,ae,ue=>ue.provideFoldingRanges(v.URI.revive(G),ee,ie),void 0)}registerSelectionRangeProvider(x,G,ee){const ie=this._addNewAdapter(new fe(this._documents,ee,this._logService),x);return this._proxy.$registerSelectionRangeProvider(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideSelectionRanges(x,G,ee,ie){return this._withAdapter(x,fe,ue=>ue.provideSelectionRanges(v.URI.revive(G),ee,ie),[])}registerCallHierarchyProvider(x,G,ee){const ie=this._addNewAdapter(new Le(this._documents,ee),x);return this._proxy.$registerCallHierarchyProvider(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$prepareCallHierarchy(x,G,ee,ie){return this._withAdapter(x,Le,ue=>Promise.resolve(ue.prepareSession(v.URI.revive(G),ee,ie)),void 0)}$provideCallHierarchyIncomingCalls(x,G,ee,ie){return this._withAdapter(x,Le,ue=>ue.provideCallsTo(G,ee,ie),void 0)}$provideCallHierarchyOutgoingCalls(x,G,ee,ie){return this._withAdapter(x,Le,ue=>ue.provideCallsFrom(G,ee,ie),void 0)}$releaseCallHierarchy(x,G){this._withAdapter(x,Le,ee=>Promise.resolve(ee.releaseSession(G)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,S.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:Fe._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:Fe._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?Fe._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?Fe._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:Fe._serializeRegExp(x.beforeText),afterText:x.afterText?Fe._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?Fe._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(Fe._serializeOnEnterRule)}setLanguageConfiguration(x,G,ee){let{wordPattern:ie}=ee;if(ie&&(0,S.regExpLeadsToEndlessLoop)(ie))throw new Error(`Invalid language configuration: wordPattern '${ie}' is not allowed to match the empty string.`);ie?this._documents.setWordDefinitionFor(G,ie):this._documents.setWordDefinitionFor(G,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const ue=this._nextHandle(),Ee={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Fe._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Fe._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Fe._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ue,G,Ee),this._createDisposable(ue)}$setWordDefinitions(x){for(const G of x)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Fe,Fe._handlePool=0}),define(be[198],we([0,1,5,9,7]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(D,S){this._proxy=D.getProxy(v.MainContext.MainThreadLanguages),this._documents=S}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,S){await this._proxy.$changeLanguage(D,S);const k=this._documents.getDocumentData(D);if(!k)throw new Error(`document '${D.toString}' NOT found`);return k.document}async tokenAtPosition(D,S){var k;const i=D.version,A=R.Position.from(S),c=await this._proxy.$tokensAtPosition(D.uri,A),g={type:C.StandardTokenType.Other,range:(k=D.getWordRangeAtPosition(S))!==null&&k!==void 0?k:new C.Range(S.line,S.character,S.line,S.character)};if(!c)return g;const r={range:R.Range.to(c.range),type:R.TokenType.to(c.type)};return!r.range.contains(S)||i!==D.version?g:r}}e.ExtHostLanguages=T}),define(be[199],we([0,1,5,16,33]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(D){return D&&D.title}let E=class{constructor(S,k){this._logService=k,this._proxy=S.getProxy(v.MainContext.MainThreadMessageService)}showMessage(S,k,i,A,c){const g={extension:S};let r;typeof A=="string"||T(A)?r=[A,...c]:(g.modal=A&&A.modal,g.useCustom=A&&A.useCustom,r=c),g.useCustom&&(0,C.checkProposedApiEnabled)(S);const a=[];for(let p=0;p<r.length;p++){const m=r[p];if(typeof m=="string")a.push({title:m,handle:p,isCloseAffordance:!1});else if(typeof m=="object"){let{title:y,isCloseAffordance:l}=m;a.push({title:y,isCloseAffordance:!!l,handle:p})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(k,i,g,a).then(p=>{if(typeof p=="number")return r[p]})}};E=qe([Ke(1,R.ILogService)],E),e.ExtHostMessageService=E}),define(be[200],we([0,1,24,3,57,55,6,22,8,10,2,69,5,9,7,50,177,178]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class y{constructor(f,t){const n=y._Keys.nextId();f.$registerNotebookEditorDecorationType(n,g.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){f.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=y,y._Keys=new T.IdGenerator("NotebookEditorDecorationType");class l{constructor(f,t,n,s,o,u){this._textDocumentsAndEditors=n,this._textDocuments=s,this.logService=o,this._extensionStoragePaths=u,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new D.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new A.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(c.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(c.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(c.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:w=>{var b;if(w&&w.$mid===12){const I=(b=w.notebookEditor)===null||b===void 0?void 0:b.notebookUri,h=w.cell.handle,_=this._documents.get(I),F=_==null?void 0:_.getCell(h);if(F)return F.apiCell}return w}})}get activeNotebookEditor(){var f;return(f=this._activeNotebookEditor)===null||f===void 0?void 0:f.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){return this._editors.get(f)}getIdByEditor(f){for(const[t,n]of this._editors)if(n.apiEditor===f)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,t){const n=this._documents.get(f);if(!n&&!t)throw new Error(`NO notebook document for '${f}'`);return n}_getProviderData(f){const t=this._notebookContentProviders.get(f);if(!t)throw new Error(`NO provider for '${f}'`);return t}registerNotebookContentProvider(f,t,n,s,o){if((0,S.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:f,provider:n});let u;return n.onDidChangeNotebookContentOptions&&(u=n.onDidChangeNotebookContentOptions(()=>{const w=g.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,w)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},t,g.NotebookDocumentContentOptions.from(s),l._convertNotebookRegistrationData(f,o)),new r.Disposable(()=>{u==null||u.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(f,t){if(!!t){const n=t.filenamePattern.map(s=>g.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}}registerNotebookCellStatusBarItemProvider(f,t,n){const s=l._notebookStatusBarItemProviderHandlePool++,o=typeof n.onDidChangeCellStatusBarItems=="function"?l._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,o,t);let u;return o!==void 0&&(u=n.onDidChangeCellStatusBarItems(w=>this._notebookProxy.$emitCellStatusBarEvent(o))),new r.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,o),u&&u.dispose()})}createNotebookEditorDecorationType(f){return new y(this._notebookEditorsProxy,f).value}async createNotebookDocument(f){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&g.NotebookData.from(f.content)});return i.URI.revive(t)}async openNotebookDocument(f){const t=this._documents.get(f);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenNotebook(f),s=this._documents.get(i.URI.revive(n));return(0,k.assertIsDefined)(s==null?void 0:s.apiNotebook)}async showNotebookDocument(f,t){var n;i.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let s;typeof t=="object"?s={position:g.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(g.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:s={preserveFocus:!1};const o=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.viewType,s),u=o&&((n=this._editors.get(o))===null||n===void 0?void 0:n.apiEditor);if(u)return u;throw o?new Error(`Could NOT open editor for "${f.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.toString()}".`)}async $provideNotebookCellStatusBarItems(f,t,n,s){var o;const u=this._notebookStatusBarItemProviders.get(f),w=i.URI.revive(t),b=this._documents.get(w);if(!(!b||!u)){const I=b.getCellFromIndex(n);if(!!I){const h=await u.provideCellStatusBarItems(I.apiCell,s);if(!!h){const _=new E.DisposableStore,F=this._statusBarCache.add([_]),N=(o=h&&h.map(z=>g.NotebookStatusBarItem.from(z,this._commandsConverter,_)))!==null&&o!==void 0?o:void 0;return{cacheId:F,items:N}}}}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,t,n,s,o){if((0,S.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const u=this._handlePool++;return this._notebookSerializer.set(u,n),this._notebookProxy.$registerNotebookSerializer(u,{id:f.identifier,location:f.extensionLocation},t,g.NotebookDocumentContentOptions.from(s),l._convertNotebookRegistrationData(f,o)),(0,E.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(u)})}async $dataToNotebook(f,t,n){const s=this._notebookSerializer.get(f);if(!s)throw new Error("NO serializer found");const o=await s.deserializeNotebook(t.buffer,n);return g.NotebookData.from(o)}async $notebookToData(f,t,n){const s=this._notebookSerializer.get(f);if(!s)throw new Error("NO serializer found");const o=await s.serializeNotebook(g.NotebookData.to(t),n);return v.VSBuffer.wrap(o)}async $openNotebook(f,t,n,s,o){const{provider:u}=this._getProviderData(f),w=await u.openNotebook(i.URI.revive(t),{backupId:n,untitledDocumentData:s==null?void 0:s.buffer},o);return{metadata:g.NotebookDocumentMetadata.from(w.metadata),cells:w.cells.map(g.NotebookCellData.from)}}async $saveNotebook(f,t,n){const s=this.getNotebookDocument(i.URI.revive(t)),{provider:o}=this._getProviderData(f);return await o.saveNotebook(s.apiNotebook,n),!0}async $saveNotebookAs(f,t,n,s){const o=this.getNotebookDocument(i.URI.revive(t)),{provider:u}=this._getProviderData(f);return await u.saveNotebookAs(i.URI.revive(n),o.apiNotebook,s),!0}async $backupNotebook(f,t,n){var s;const o=this.getNotebookDocument(i.URI.revive(t)),u=this._getProviderData(f),w=(s=this._extensionStoragePaths.workspaceValue(u.extension))!==null&&s!==void 0?s:this._extensionStoragePaths.globalValue(u.extension),b=String((0,C.hash)([o.uri.toString(),this._backupIdPool++])),I=i.URI.joinPath(w,b),h=await u.provider.backupNotebook(o.apiNotebook,{destination:I},n);return o.updateBackup(h),h.id}$acceptModelChanged(f,t,n){this.getNotebookDocument(i.URI.revive(f)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(f,t){const n=this.getNotebookDocument(i.URI.revive(f));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(f){const t=this.getNotebookDocument(i.URI.revive(f));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",f,t);const n=this._editors.get(f);if(!n)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(g.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(g.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(f){for(const t in f){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(g.ViewColumn.to(f[t]))}}$acceptDocumentPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",f.path,t);const n=this.getNotebookDocument(i.URI.revive(f));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(f,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const s=new m.ExtHostNotebookEditor(t,this._notebookEditorsProxy,f,n.visibleRanges.map(g.NotebookRange.to),n.selections.map(g.NotebookRange.to),typeof n.viewColumn=="number"?g.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,s)}$acceptDocumentAndEditorsDelta(f){var t,n,s;if(f.removedDocuments)for(const u of f.removedDocuments){const w=i.URI.revive(u),b=this._documents.get(w);b&&(b.dispose(),this._documents.delete(w),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(I=>I.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const I of this._editors.values())I.notebookData.uri.toString()===w.toString()&&this._editors.delete(I.id)}if(f.addedDocuments){const u=[];for(const w of f.addedDocuments){const b=i.URI.revive(w.uri),I=w.viewType;if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const h=this,_=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(F){h._onDidChangeNotebookCells.fire(F)},emitCellOutputsChange(F){h._onDidChangeCellOutputs.fire(F)},emitCellMetadataChange(F){h._onDidChangeCellMetadata.fire(F)},emitCellExecutionStateChange(F){h._onDidChangeCellExecutionState.fire(F)}},I,w.metadata?g.NotebookDocumentMetadata.to(w.metadata):new r.NotebookDocumentMetadata,b);_.acceptModelChanged({versionId:w.versionId,rawEvents:[{kind:a.NotebookCellsChangeType.Initialize,changes:[[0,0,w.cells]]}]},!1),u.push(...w.cells.map(F=>p.ExtHostCell.asModelAddData(_.apiNotebook,F))),(t=this._documents.get(b))===null||t===void 0||t.dispose(),this._documents.set(b,_),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(_.apiNotebook)}}if(f.addedEditors)for(const u of f.addedEditors){if(this._editors.has(u.id))return;const w=i.URI.revive(u.documentUri),b=this._documents.get(w);b&&this._createExtHostEditor(b,u.id,u)}const o=[];if(f.removedEditors)for(const u of f.removedEditors){const w=this._editors.get(u);w&&(this._editors.delete(u),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===w.id&&(this._activeNotebookEditor=void 0),o.push(w))}if(f.visibleEditors){this._visibleNotebookEditors=f.visibleEditors.map(w=>this._editors.get(w)).filter(w=>!!w);const u=new Set;this._visibleNotebookEditors.forEach(w=>u.add(w.id));for(const w of this._editors.values()){const b=u.has(w.id);w._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(w=>w).filter(w=>w.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.newActiveEditor===null?this._activeNotebookEditor=void 0:f.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.newActiveEditor)),f.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor)}}e.ExtHostNotebookController=l,l._notebookStatusBarItemProviderHandlePool=0}),define(be[201],we([0,1,3,6,5,26,2,9,74,22,11,50,20,13,16]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(d,f,t,n){this._mainContext=d,this._initData=f,this._extHostNotebook=t,this._logService=n,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=d.getProxy(C.MainContext.MainThreadNotebookKernels)}createNotebookController(d,f,t,n,s,o){for(let P of this._kernelData.values())if(P.controller.id===f&&T.ExtensionIdentifier.equals(d.identifier,P.extensionId))throw new Error(`notebook controller with id '${f}' ALREADY exist`);const u=this._handlePool++,w=this;this._logService.trace(`NotebookController[${u}], CREATED by ${d.identifier.value}, ${f}`);const b=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${d.identifier}'`);let I=!1;const h=new R.DisposableStore,_=new v.Emitter,F=new v.Emitter,N={id:`${d.identifier.value}/${f}`,viewType:t,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:n||d.identifier.value,preloads:o?o.map(D.NotebookKernelPreload.from):[]};let z=s!=null?s:b,ce;this._proxy.$addKernel(u,N).catch(P=>{console.log(P),I=!0});let de=0;const B=()=>{if(!I){const P=++de;Promise.resolve().then(()=>{P===de&&this._proxy.$updateKernel(u,N)})}},j=new k.ResourceMap,W={get id(){return f},get viewType(){return N.viewType},onDidChangeNotebookAssociation:_.event,get label(){return N.label},set label(P){var H;N.label=(H=P!=null?P:d.displayName)!==null&&H!==void 0?H:d.name,B()},get detail(){var P;return(P=N.detail)!==null&&P!==void 0?P:""},set detail(P){N.detail=P,B()},get description(){var P;return(P=N.description)!==null&&P!==void 0?P:""},set description(P){N.description=P,B()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(P){N.supportedLanguages=P,B()},get hasExecutionOrder(){var P;return(P=N.hasExecutionOrder)!==null&&P!==void 0?P:!1},set hasExecutionOrder(P){N.hasExecutionOrder=P,B()},get preloads(){return N.preloads?N.preloads.map(D.NotebookKernelPreload.to):[]},get executeHandler(){return z},set executeHandler(P){z=P!=null?P:b},get interruptHandler(){return ce},set interruptHandler(P){ce=P,N.supportsInterrupt=Boolean(P),B()},createNotebookCellExecutionTask(P){if(I)throw new Error("notebook controller is DISPOSED");if(!j.has(P.notebook.uri))throw w._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(j.keys()).map(H=>H.toString())),new Error(`notebook controller is NOT associated to notebook: ${P.notebook.uri.toString()}`);return w._createNotebookCellExecution(P)},dispose:()=>{I||(this._logService.trace(`NotebookController[${u}], DISPOSED`),I=!0,this._kernelData.delete(u),h.dispose(),_.dispose(),F.dispose(),this._proxy.$removeKernel(u))},onDidReceiveMessage:F.event,postMessage(P,H){return w._proxy.$postMessage(u,H&&w._extHostNotebook.getIdByEditor(H),P)},asWebviewUri(P){return(0,S.asWebviewUri)(String(u),P,w._initData.remote.authority)},updateNotebookAffinity(P,H){w._proxy.$updateNotebookPriority(u,P.uri,H)}};return this._kernelData.set(u,{extensionId:d.identifier,controller:W,onDidReceiveMessage:F,onDidChangeSelection:_,associatedNotebooks:j}),W}$acceptNotebookAssociation(d,f,t){const n=this._kernelData.get(d);if(n){const s=this._extHostNotebook.getNotebookDocument(E.URI.revive(f));t?n.associatedNotebooks.set(s.uri,!0):n.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${d}] ASSOCIATE notebook`,s.uri.toString(),t),n.onDidChangeSelection.fire({selected:t,notebook:s.apiNotebook})}}async $executeCells(d,f,t){const n=this._kernelData.get(d);if(!!n){const s=this._extHostNotebook.getNotebookDocument(E.URI.revive(f)),o=[];for(let u of t){const w=s.getCell(u);w&&o.push(w.apiCell)}try{this._logService.trace(`NotebookController[${d}] EXECUTE cells`,s.uri.toString(),o.length),await n.controller.executeHandler.call(n.controller,o,s.apiNotebook,n.controller)}catch(u){this._logService.error(`NotebookController[${d}] execute cells FAILED`,u),console.error(u)}}}async $cancelCells(d,f,t){var n;const s=this._kernelData.get(d);if(!!s){const o=this._extHostNotebook.getNotebookDocument(E.URI.revive(f));s.controller.interruptHandler&&await s.controller.interruptHandler.call(s.controller,o.apiNotebook);for(let u of t){const w=o.getCell(u);w&&((n=this._activeExecutions.get(w.uri))===null||n===void 0||n.cancel())}}}$acceptKernelMessageFromRenderer(d,f,t){const n=this._kernelData.get(d);if(!!n){const s=this._extHostNotebook.getEditorById(f);if(!s)throw new Error(`send message for UNKNOWN editor: ${f}`);n.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:t}))}}_createNotebookCellExecution(d){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const n=new m(t.notebook,t,this._mainContext.getProxy(C.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(t.uri,n);const s=n.onDidChangeState(()=>{n.state===p.Resolved&&(n.dispose(),s.dispose(),this._activeExecutions.delete(t.uri))});return n.asApiObject()}};a=qe([Ke(3,r.ILogService)],a),e.ExtHostNotebookKernels=a;var p;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(p||(p={}));class m extends R.Disposable{constructor(d,f,t){super();this._document=d,this._cell=f,this._proxy=t,this._onDidChangeState=new v.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new c.CancellationTokenSource),this._collector=new y(10,n=>this.applyEdits(n)),this._executionOrder=f.internalMetadata.executionOrder,this.mixinMetadata({runState:A.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(d){await this._collector.addItem(d)}async applyEdits(d){return this._proxy.$applyEdits(this._document.uri,d,!1)}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(d){const f={editType:9,handle:this._cell.handle,internalMetadata:d};this.applyEdits([f])}cellIndexToHandle(d){if(typeof d!="number")return this._cell.handle;const f=this._document.getCellFromIndex(d);if(!f)throw new Error("INVALID cell index");return f.handle}asApiObject(){const d=this;return Object.freeze({get document(){return d._document.apiNotebook},get cell(){return d._cell.apiCell},get executionOrder(){return d._executionOrder},set executionOrder(f){d._executionOrder=f,d.mixinMetadata({executionOrder:f})},start(f){var t;if(d._state===p.Resolved||d._state===p.Started)throw new Error("Cannot call start again");d._state=p.Started,d._onDidChangeState.fire(),d.mixinMetadata({runState:A.NotebookCellExecutionState.Executing,runStartTime:(t=f==null?void 0:f.startTime)!==null&&t!==void 0?t:null})},end(f){var t,n;if(d._state===p.Resolved)throw new Error("Cannot call resolve twice");d._state=p.Resolved,d._onDidChangeState.fire(),d.mixinMetadata({runState:null,lastRunSuccess:(t=f==null?void 0:f.success)!==null&&t!==void 0?t:null,runEndTime:(n=f==null?void 0:f.endTime)!==null&&n!==void 0?n:null})},clearOutput(f){return d.verifyStateForOutput(),this.replaceOutput([],f)},async appendOutput(f,t){d.verifyStateForOutput();const n=d.cellIndexToHandle(t);return f=(0,g.asArray)(f),d.applyEditSoon({editType:2,handle:n,append:!0,outputs:f.map(D.NotebookCellOutput.from)})},async replaceOutput(f,t){d.verifyStateForOutput();const n=d.cellIndexToHandle(t);return f=(0,g.asArray)(f),d.applyEditSoon({editType:2,handle:n,outputs:f.map(D.NotebookCellOutput.from)})},async appendOutputItems(f,t){return d.verifyStateForOutput(),f=(0,g.asArray)(f),d.applyEditSoon({editType:7,append:!0,items:f.map(D.NotebookCellOutputItem.from),outputId:t})},async replaceOutputItems(f,t){return d.verifyStateForOutput(),f=(0,g.asArray)(f),d.applyEditSoon({editType:7,items:f.map(D.NotebookCellOutputItem.from),outputId:t})},token:d._tokenSource.token})}}class y{constructor(d,f){this.delay=d,this.callback=f,this.batch=[]}addItem(d){return this.batch.push(d),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const f=this.batch;return this.batch=[],this.callback(f)})),this.waitPromise}}}),define(be[101],we([0,1,5,3,6,24,4,15]),function(J,e,v,R,C,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends C.Disposable{constructor(r,a,p,m){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=m,this._id=m.$register(this.name,a,p),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?T.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(a=>this._proxy.$clear(a,r))}show(r,a){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof r=="boolean"?r:a)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class k extends S{constructor(r,a){super(r,!1,void 0,a)}append(r){super.append(r),this._id.then(a=>this._proxy.$append(a,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class i extends S{constructor(r,a,p){super(r,!0,a,p)}append(r){throw new Error("Not supported")}}class A{constructor(r,a){this.name=r,this._channel=a}append(r){this._channel.then(a=>a.append(r))}appendLine(r){this._channel.then(a=>a.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,a){this._channel.then(p=>p.show(r,a))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=A;let c=class{constructor(r){this._proxy=r.getProxy(v.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new k(r,this._proxy)}createOutputChannelFromLogFile(r,a){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!a)throw new Error("illegal argument `file`. must not be falsy");return new i(r,a,this._proxy)}};c=qe([Ke(0,D.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,E.createDecorator)("IExtHostOutputService")}),define(be[202],we([0,1,11,20,3,6,5,2,7,12,13,47]),function(J,e,v,R,C,T,E,D,S,k,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function c(g,r,a){const p=g.getProxy(E.MainContext.MainThreadQuickOpen);class m{constructor(o,u){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=u}showQuickPick(o,u,w,b=R.CancellationToken.None){this._onDidSelectItem=void 0;const I=Promise.resolve(o),h=++this._instances,_=p.$show(h,{title:w==null?void 0:w.title,placeHolder:w==null?void 0:w.placeHolder,matchOnDescription:w==null?void 0:w.matchOnDescription,matchOnDetail:w==null?void 0:w.matchOnDetail,ignoreFocusLost:w==null?void 0:w.ignoreFocusOut,canPickMany:w==null?void 0:w.canPickMany},b),F={},N=_.then(()=>F);return Promise.race([N,I]).then(z=>{if(z!==F)return I.then(ce=>{const de=[];for(let B=0;B<ce.length;B++){const j=ce[B];let W,P,H,L,$;typeof j=="string"?W=j:(W=j.label,P=j.description,H=j.detail,L=j.picked,$=j.alwaysShow),de.push({label:W,description:P,handle:B,detail:H,picked:L,alwaysShow:$})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{w.onDidSelectItem(ce[B])}),p.$setItems(h,de),_.then(B=>{if(typeof B=="number")return ce[B];if(Array.isArray(B))return B.map(j=>ce[j])})})}).then(void 0,z=>{if(!(0,k.isPromiseCanceledError)(z))return p.$setError(h,z),Promise.reject(z)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,u=R.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,p.$input(o,typeof this._validateInput=="function",u).then(void 0,w=>{if(!(0,k.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(o){return this._validateInput?(0,v.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,u=R.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!!w){const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(I=>I.uri.toString()===w.uri.toString())}}createQuickPick(o,u){const w=new t(o,u,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(o){const u=new n(o,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(o,u){const w=this._sessions.get(o);w&&w._fireDidChangeValue(u)}$onDidAccept(o){const u=this._sessions.get(o);u&&u._fireDidAccept()}$onDidChangeActive(o,u){const w=this._sessions.get(o);w instanceof t&&w._fireDidChangeActive(u)}$onDidChangeSelection(o,u){const w=this._sessions.get(o);w instanceof t&&w._fireDidChangeSelection(u)}$onDidTriggerButton(o,u){const w=this._sessions.get(o);w&&w._fireDidTriggerButton(u)}$onDidHide(o){const u=this._sessions.get(o);u&&u._fireDidHide()}}class y{constructor(o,u){this._extensionId=o,this._onDidDispose=u,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((u,w)=>{const b=u===S.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(b,u)}),this.update({buttons:o.map((u,w)=>({iconPath:l(u.iconPath),tooltip:u.tooltip,handle:u===S.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const u=this._handlesToButtons.get(o);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(o){if(!this._disposed){for(const u of Object.keys(o)){const w=o[u];this._pendingUpdate[u]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}y._nextId=1;function l(s){if(s instanceof S.ThemeIcon)return{id:s.id};const o=f(s),u=d(s);return{dark:typeof o=="string"?D.URI.file(o):o,light:typeof u=="string"?D.URI.file(u):u}}function d(s){return typeof s=="object"&&"light"in s?s.light:s}function f(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends y{constructor(o,u,w){super(o,w);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((u,w)=>{this._handlesToItems.set(w,u),this._itemsToHandles.set(u,w)}),this.update({items:o.map((u,w)=>({label:u.label,description:u.description,handle:w,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(o){const u=(0,i.coalesce)(o.map(w=>this._handlesToItems.get(w)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(o){const u=(0,i.coalesce)(o.map(w=>this._handlesToItems.get(w)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}}class n extends y{constructor(o,u){super(o,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?A.default.Error:A.default.Ignore})}}return new m(r,a)}e.createExtHostQuickOpen=c}),define(be[203],we([0,1,2,3,53,6,11,5,13,113,16,26,33]),function(J,e,v,R,C,T,E,D,S,k,i,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(o){if(o)return typeof o.iconPath=="string"?v.URI.file(o.iconPath):o.iconPath}function r(o,u){if(!o.iconPath&&!u.iconPath)return 0;if(o.iconPath){if(!u.iconPath)return 1}else return-1;const w=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath,b=typeof u.iconPath=="string"?u.iconPath:u.iconPath.fsPath;return(0,k.comparePaths)(w,b)}function a(o,u){let w=0;if(o.strikeThrough!==u.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==u.faded)return o.faded?1:-1;if(o.tooltip!==u.tooltip)return(o.tooltip||"").localeCompare(u.tooltip||"");if(w=r(o,u),w!==0)return w;if(o.light&&u.light)w=r(o.light,u.light);else{if(o.light)return 1;if(u.light)return-1}if(w!==0)return w;if(o.dark&&u.dark)w=r(o.dark,u.dark);else{if(o.dark)return 1;if(u.dark)return-1}return w}function p(o,u){if(o.command!==u.command)return o.command<u.command?-1:1;if(o.title!==u.title)return o.title<u.title?-1:1;if(o.tooltip!==u.tooltip){if(o.tooltip!==void 0&&u.tooltip!==void 0)return o.tooltip<u.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(o.arguments===u.arguments)return 0;if(o.arguments)if(u.arguments){if(o.arguments.length!==u.arguments.length)return o.arguments.length-u.arguments.length}else return 1;else return-1;for(let w=0;w<o.arguments.length;w++){const b=o.arguments[w],I=u.arguments[w];if(b!==I)return b<I?-1:1}return 0}function m(o,u){let w=(0,k.comparePaths)(o.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(w!==0)return w;if(o.command&&u.command)w=p(o.command,u.command);else{if(o.command)return 1;if(u.command)return-1}if(w!==0)return w;if(o.decorations&&u.decorations)w=a(o.decorations,u.decorations);else{if(o.decorations)return 1;if(u.decorations)return-1}return w}function y(o,u){for(let w=0;w<o.length;w++)if(o[w]!==u[w])return!1;return!0}function l(o,u){return o.command===u.command&&o.title===u.title&&o.tooltip===u.tooltip&&(o.arguments&&u.arguments?y(o.arguments,u.arguments):o.arguments===u.arguments)}function d(o,u){return(0,S.equals)(o,u,l)}class f{constructor(u,w,b){this._extension=u,this._proxy=w,this._sourceControlHandle=b,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,c.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(u){if((0,c.checkProposedApiEnabled)(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}focus(){(0,c.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(u,w){(0,c.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,u,w)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=f;class t{constructor(u,w,b,I,h){this._proxy=u,this._commands=w,this._sourceControlHandle=b,this._id=I,this._label=h,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,w){const b=this._resourceStatesCommandsMap.get(u);return b?(0,E.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var u;const w=[...this._resourceStates].sort(m),I=(0,S.sortedDiff)(this._resourceSnapshot,w,m).map(F=>{const N=F.toInsert.map(z=>{const ce=this._resourceHandlePool++;this._resourceStatesMap.set(ce,z);const de=z.resourceUri,B=g(z.decorations),j=z.decorations&&g(z.decorations.light)||B,W=z.decorations&&g(z.decorations.dark)||B,P=[];let H;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const fe=new T.DisposableStore;H=this._commands.converter.toInternal(z.command,fe),this._resourceStatesDisposablesMap.set(ce,fe)}else this._resourceStatesCommandsMap.set(ce,z.command);j&&P.push(j),W&&W.toString()!==(j==null?void 0:j.toString())&&P.push(W);const L=z.decorations&&z.decorations.tooltip||"",$=z.decorations&&!!z.decorations.strikeThrough,Q=z.decorations&&!!z.decorations.faded,q=z.contextValue||"";return{rawResource:[ce,de,P,L,$,Q,q,H],handle:ce}});return{start:F.start,deleteCount:F.deleteCount,toInsert:N}}),h=I.map(({start:F,deleteCount:N,toInsert:z})=>[F,N,z.map(ce=>ce.rawResource)]),_=I.reverse();for(const{start:F,deleteCount:N,toInsert:z}of _){const ce=z.map(B=>B.handle),de=this._handlesSnapshot.splice(F,N,...ce);for(const B of de)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),(u=this._resourceStatesDisposablesMap.get(B))===null||u===void 0||u.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=w,h}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(u,w,b,I,h,_){this._proxy=w,this._commands=b,this._id=I,this._label=h,this._rootUri=_,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,I,h,_)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=u;const w=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(!(this._statusBarCommands&&u&&d(this._statusBarCommands,u))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=u;const w=(u||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}}get selected(){return this._selected}createResourceGroup(u,w){const b=new t(this._proxy,this._commands,this.handle,u,w),I=R.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,I),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const u=[],w=[];for(const[b,I]of this.createdResourceGroups){I.dispose();const h=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});R.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),h.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),u.push([b.handle,b.id,b.label,b.features]);const _=b._takeResourceStateSnapshot();_.length>0&&w.push([b.handle,_]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,u,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(w=>{const b=w._takeResourceStateSnapshot();b.length!==0&&u.push([w.handle,b])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,qe([(0,C.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),qe([(0,C.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Tn{constructor(u,w,b){this._commands=w,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=u.getProxy(D.MainContext.MainThreadSCM),this._telemetry=u.getProxy(D.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===3){const h=this._sourceControls.get(I.sourceControlHandle);if(!h)return I;const _=h.getResourceGroup(I.groupHandle);return _?_.getResourceState(I.handle):I}else if(I&&I.$mid===4){const h=this._sourceControls.get(I.sourceControlHandle);return h?h.getResourceGroup(I.groupHandle):I}else if(I&&I.$mid===5){const h=this._sourceControls.get(I.handle);return h||I}return I}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,w,b,I){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,w,b,I),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const h=Tn._handlePool++,_=new n(u,this._proxy,this._commands,w,b,I);this._sourceControls.set(h,_);const F=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(u.identifier))||[];return F.push(_),this._sourceControlsByExtension.set(A.ExtensionIdentifier.toKey(u.identifier),F),_}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const w=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(u.identifier)),b=w&&w[w.length-1];return b&&b.inputBox}$provideOriginalResource(u,w,b){const I=v.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,I.toString());const h=this._sourceControls.get(u);return!h||!h.quickDiffProvider||!h.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,E.asPromise)(()=>h.quickDiffProvider.provideOriginalResource(I,b)).then(_=>_||null)}$onInputBoxValueChange(u,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const b=this._sourceControls.get(u);return b&&b.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(u,w,b,I){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,w,b);const h=this._sourceControls.get(u);if(!h)return Promise.resolve(void 0);const _=h.getResourceGroup(w);return _?_.$executeResourceCommand(b,I):Promise.resolve(void 0)}$validateInput(u,w,b){this.logService.trace("ExtHostSCM#$validateInput",u);const I=this._sourceControls.get(u);return!I||!I.inputBox.validateInput?Promise.resolve(void 0):(0,E.asPromise)(()=>I.inputBox.validateInput(w,b)).then(h=>h?Promise.resolve([h.message,h.type]):Promise.resolve(void 0))}$setSelectedSourceControl(u){var w,b;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&((w=this._sourceControls.get(u))===null||w===void 0||w.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((b=this._sourceControls.get(this._selectedSourceControlHandle))===null||b===void 0||b.setSelectionState(!1)),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};s._handlePool=0,s=qe([Ke(2,i.ILogService)],s),e.ExtHostSCM=s});var it=this&&this.__classPrivateFieldSet||function(J,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(J,v):C?C.value=v:e.set(J,v),v},Ue=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[204],we([0,1,7,5,134,6]),function(J,e,v,R,C,T){"use strict";var E,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class S{constructor(c,g,r,a,p=v.StatusBarAlignment.Left,m){E.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,it(this,E,c,"f"),it(this,D,g,"f"),this._entryId=S.ID_GEN++,this._extension=r,this._id=a,this._alignment=p,this._priority=m}get id(){var c;return(c=this._id)!==null&&c!==void 0?c:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var c;return(c=this._command)===null||c===void 0?void 0:c.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(c){this._text=c,this.update()}set name(c){this._name=c,this.update()}set tooltip(c){this._tooltip=c,this.update()}set color(c){this._color=c,this.update()}set backgroundColor(c){c&&!S.ALLOWED_BACKGROUND_COLORS.has(c.id)&&(c=void 0),this._backgroundColor=c,this.update()}set command(c){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==c&&(this._internalCommandRegistration.clear(),typeof c=="string"?this._command={fromApi:c,internal:Ue(this,D,"f").toInternal({title:"",command:c},this._internalCommandRegistration)}:c?this._command={fromApi:c,internal:Ue(this,D,"f").toInternal(c,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(c){this._accessibilityInformation=c,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var c;this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let r;this._name?r=this._name:r=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let a=this._color;this._backgroundColor&&(a=S.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,E,"f").$setEntry(this._entryId,g,r,this._text,this._tooltip,(c=this._command)===null||c===void 0?void 0:c.internal,a,this._backgroundColor,this._alignment===v.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=S,E=new WeakMap,D=new WeakMap,S.ID_GEN=0,S.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new v.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(c){this._messages=[],this._item=c.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(c){const g={message:c};return this._messages.unshift(g),this._update(),new v.Disposable(()=>{const r=this._messages.indexOf(g);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(c,g){this._proxy=c.getProxy(R.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new k(this)}createStatusBarEntry(c,g,r,a){return new S(this._proxy,this._commands,c,g,r,a)}setStatusBarMessage(c,g){const r=this._statusMessage.setMessage(c);let a;return typeof g=="number"?a=setTimeout(()=>r.dispose(),g):typeof g!="undefined"&&g.then(()=>r.dispose(),()=>r.dispose()),new v.Disposable(()=>{r.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=i}),define(be[79],we([0,1,5,3,4]),function(J,e,v,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(D){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(v.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,S){this._proxy.$registerExtensionStorageKeysToSync(D,S)}getValue(D,S,k){return this._proxy.$getValue(D,S).then(i=>i||k)}setValue(D,S,k){return this._proxy.$setValue(D,S,k)}$acceptValue(D,S,k){this._onDidChangeStorage.fire({shared:D,key:S,value:k})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(be[80],we([0,1,4,27,16,78,2]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,v.createDecorator)("IExtensionStoragePaths");let D=class{constructor(k,i,A){var c;this._logService=i,this._extHostFileSystem=A,this._workspace=(c=k.workspace)!==null&&c!==void 0?c:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,A=E.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch(c){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(E.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=E.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),A}catch(c){this._logService.error("[ExtHostStorage]",c);return}}workspaceValue(k){if(this._value)return E.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return E.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};D=qe([Ke(0,R.IExtHostInitDataService),Ke(1,C.ILogService),Ke(2,T.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(be[40],we([0,1,3,5,4,2,15,6,7,135,12,171,20,31,155]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class a{constructor(t,n,s,o){this._proxy=t,this._id=n,this._creationOptions=s,this._name=o,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(w=>this._pidPromiseComplete=w);const u=this;this.value={get name(){return u._name||""},get processId(){return u._pidPromise},get creationOptions(){return u._creationOptions},get exitStatus(){return u._exitStatus},sendText(w,b=!0){u._checkDisposed(),u._proxy.$sendText(u._id,w,b)},show(w){u._checkDisposed(),u._proxy.$show(u._id,w)},hide(){u._checkDisposed(),u._proxy.$hide(u._id)},dispose(){u._disposed||(u._disposed=!0,u._proxy.$dispose(u._id))},get dimensions(){if(!(u._cols===void 0||u._rows===void 0))return{columns:u._cols,rows:u._rows}}}}async create(t,n,s,o,u,w,b,I,h,_,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:o,icon:u,initialText:w,waitOnExit:b,strictEnv:I,hideFromUser:h,isFeatureTerminal:_,isExtensionOwnedTerminal:F})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=a;class p{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new v.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new v.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new v.Emitter,this._onProcessTitleChanged=new v.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new v.Emitter,this._onProcessShellTypeChanged=new v.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let m=1,y=class extends D.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new v.Emitter,this._onDidOpenTerminal=new v.Emitter,this._onDidChangeActiveTerminal=new v.Emitter,this._onDidChangeTerminalDimensions=new v.Emitter,this._proxy=n.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new v.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,o]of this._terminalProcesses)o.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(t){const n=t?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.path)||""}getDefaultShellArgs(t){const n=t?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.args)||[""]}createExtensionTerminal(t){const n=new a(this._proxy,(0,g.generateUuid)(),t,t.name),s=new p(t.pty);return n.createExtensionTerminal().then(o=>{const u=this._setupExtHostProcessListeners(o,s);this._terminalProcessDisposables[o]=u}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const o=new p(n),u=this._setupExtHostProcessListeners(t,o);this._terminalProcessDisposables[t]=u}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const o=this._getTerminalById(t);o&&o.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:o.value,dimensions:o.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const o=this._terminals.splice(s,1)[0];o.setExitCode(n),this._onDidCloseTerminal.fire(o.value)}}$acceptTerminalOpened(t,n,s,o){if(n){const b=this._getTerminalObjectIndexById(this._terminals,n);if(b!==null){this._terminals[b]._id=t,this._onDidOpenTerminal.fire(this.terminals[b]),this._terminals[b].isOpen=!0;return}}const u={name:o.name,shellPath:o.executable,shellArgs:o.args,cwd:typeof o.cwd=="string"?o.cwd:T.URI.revive(o.cwd),env:o.env,hideFromUser:o.hideFromUser},w=new a(this._proxy,t,u,s);this._terminals.push(w),this._onDidOpenTerminal.fire(w.value),w.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,k.localize)(0,null,t)};s.isOpen||await new Promise(u=>{const w=this.onDidOpenTerminal(async b=>{b===s.value&&(w.dispose(),u())})});const o=this._terminalProcesses.get(t);o?o.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new D.DisposableStore;s.add(n.onProcessReady(u=>this._proxy.$sendProcessReady(t,u.pid,u.cwd))),s.add(n.onProcessTitleChanged(u=>this._proxy.$sendProcessTitle(t,u))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(u=>this._onProcessExit(t,u))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(u=>this._proxy.$sendOverrideDimensions(t,u))),this._terminalProcesses.set(t,n);const o=this._extensionTerminalAwaitingStart[t];return o&&n instanceof p&&(n.startSendingEvents(o.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var o;try{(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(n,s)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const o=this._terminalLinkCancellationSource.get(t);o&&o.dispose(!0);const u=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,u);const w=[],b={terminal:s.value,line:n},I=[];for(const F of this._linkProviders)I.push(new Promise(async N=>{u.token.onCancellationRequested(()=>N({provider:F,links:[]}));const z=await F.provideTerminalLinks(b,u.token)||[];u.token.isCancellationRequested||N({provider:F,links:z})}));const h=await Promise.all(I);if(u.token.isCancellationRequested)return[];const _=new Map;for(const F of h)F&&F.links.length>0&&w.push(...F.links.map(N=>{const z={id:m++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return _.set(z.id,{provider:F.provider,link:N}),z}));return this._terminalLinkCache.set(t,_),w}$activateLink(t,n){var s;const o=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!o||o.provider.handleTerminalLink(o.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((o,u)=>o._id===n?(s=u,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new l,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,A.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],o=new l(n[1]);this._setEnvironmentVariableCollection(s,o)})}$acceptDefaultProfile(t,n){this._defaultProfile=t,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};y=qe([Ke(1,E.IExtHostRpcService)],y),e.BaseExtHostTerminalService=y;class l{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new v.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,o)=>t.call(n,o,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let d=class extends y{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}};d=qe([Ke(0,E.IExtHostRpcService)],d),e.WorkerExtHostTerminalService=d}),define(be[205],we([0,1,3,13,5,98,9,7]),function(J,e,v,R,C,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(i,A){this._extHostDocumentsAndEditors=A,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const A=this._extHostDocumentsAndEditors.allEditors();return i?A:A.map(c=>c.value)}async showTextDocument(i,A,c){let g;typeof A=="number"?g={position:E.ViewColumn.from(A),preserveFocus:c}:typeof A=="object"?g={position:E.ViewColumn.from(A.viewColumn),preserveFocus:A.preserveFocus,selection:typeof A.selection=="object"?E.Range.from(A.selection):void 0,pinned:typeof A.preview=="boolean"?!A.preview:void 0}:g={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(i.uri,g),a=r&&this._extHostDocumentsAndEditors.getEditor(r);if(a)return a.value;throw r?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new T.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,A){const c=this._extHostDocumentsAndEditors.getEditor(i);if(!c)throw new Error("unknown text editor");if(A.options&&c._acceptOptions(A.options),A.selections){const g=A.selections.selections.map(E.Selection.to);c._acceptSelections(g)}if(A.visibleRanges){const g=R.coalesce(A.visibleRanges.map(E.Range.to));c._acceptVisibleRanges(g)}if(A.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:Object.assign(Object.assign({},A.options),{lineNumbers:E.TextEditorLineNumbersStyle.to(A.options.lineNumbers)})}),A.selections){const g=D.TextEditorSelectionChangeKind.fromValue(A.selections.source),r=A.selections.selections.map(E.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:r,kind:g})}if(A.visibleRanges){const g=R.coalesce(A.visibleRanges.map(E.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:g})}}$acceptEditorPositionData(i){for(const A in i){const c=this._extHostDocumentsAndEditors.getEditor(A);if(!c)throw new Error("Unknown text editor");const g=E.ViewColumn.to(i[A]);c.value.viewColumn!==g&&(c._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:g}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=S});var qt=this&&this.__rest||function(J,e){var v={};for(var R in J)Object.prototype.hasOwnProperty.call(J,R)&&e.indexOf(R)<0&&(v[R]=J[R]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(J);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(J,R[C])&&(v[R[C]]=J[R[C]]);return v};define(be[206],we([0,1,2,4,5,6,7]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class D{constructor(i,A){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(C.MainContext.MainThreadTimeline),A.registerArgumentProcessor({processArgument:c=>{var g,r;if(c&&c.$mid===11){const a=c.uri===void 0?void 0:v.URI.revive(c.uri);return(r=(g=this._itemsBySourceAndUriMap.get(c.source))===null||g===void 0?void 0:g.get(S(a)))===null||r===void 0?void 0:r.get(c.handle)}return c}})}async $getTimeline(i,A,c,g,r){const a=this._providers.get(i);return a==null?void 0:a.provideTimeline(v.URI.revive(A),c,g,r)}registerTimelineProvider(i,A,c,g){const r=new T.DisposableStore,a=this.convertTimelineItem(A.id,g,r).bind(this);let p;A.onDidChange&&(p=A.onDidChange(y=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},y),{id:A.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},A),{scheme:i,onDidChange:void 0,async provideTimeline(y,l,d,f){var t;(f==null?void 0:f.resetCache)&&(r.clear(),(t=m.get(A.id))===null||t===void 0||t.clear());const n=await A.provideTimeline(y,l,d);if(n!=null){const s=a(y,f);return Object.assign(Object.assign({},n),{source:A.id,items:n.items.map(s)})}},dispose(){var y;for(const l of m.values())(y=l.get(A.id))===null||y===void 0||y.clear();p==null||p.dispose(),r.dispose()}}))}convertTimelineItem(i,A,c){return(g,r)=>{let a;if(r==null?void 0:r.cacheResults){let p=this._itemsBySourceAndUriMap.get(i);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(i,p));const m=S(g);a=p.get(m),a===void 0&&(a=new Map,p.set(m,a))}return p=>{var m,y;const{iconPath:l}=p,d=qt(p,["iconPath"]),f=`${i}|${(m=p.id)!==null&&m!==void 0?m:p.timestamp}`;a==null||a.set(f,p);let t,n,s;return p.iconPath&&(l instanceof E.ThemeIcon?s={id:l.id}:v.URI.isUri(l)?(t=l,n=l):{light:t,dark:n}=l),Object.assign(Object.assign({},d),{id:(y=d.id)!==null&&y!==void 0?y:void 0,handle:f,source:i,command:p.command?A.toInternal(p.command,c):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:p.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var c;for(const g of this._itemsBySourceAndUriMap.values())(c=g.get(i.id))===null||c===void 0||c.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=D;function S(k){return k==null?void 0:k.toString()}}),define(be[207],we([0,1,6,17,2,5]),function(J,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class E{constructor(S){this._openers=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,i,A){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const c=A.schemes.find(g=>!E.supportedSchemes.has(g));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,A.schemes,S,A.label),(0,v.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(S,k,i){const A=this._openers.get(S);if(!A)throw new Error(`Unknown opener with id: ${S}`);const c=C.URI.revive(k);return A.canOpenExternalUri(c,i)}async $openUri(S,k,i){const A=this._openers.get(S);if(!A)throw new Error(`Unknown opener id: '${S}'`);return A.openExternalUri(C.URI.revive(k.resolvedUri),{sourceUri:C.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=E,E.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(be[208],we([0,1,5,2,6,12,26]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(v.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(E.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const A=D.HandlePool++;return this.handles.add(E.ExtensionIdentifier.toKey(k)),this.handlers.set(A,i),this._proxy.$registerUriHandler(A,k),(0,C.toDisposable)(()=>{this.handles.delete(E.ExtensionIdentifier.toKey(k)),this.handlers.delete(A),this._proxy.$unregisterUriHandler(A)})}$handleExternalUri(k,i){const A=this.handlers.get(k);if(!A)return Promise.resolve(void 0);try{A.handleUri(R.URI.revive(i))}catch(c){(0,T.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(k){return R.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=D,D.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(J,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(J,v):C?C.value=v:e.set(J,v),v},Ue=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[51],we([0,1,3,2,144,164,74,5]),function(J,e,v,R,C,T,E,D){"use strict";var S,k,i,A,c,g,r,a,p,m,y,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(b,I,h,_,F,N,z){S.set(this,void 0),k.set(this,void 0),i.set(this,void 0),A.set(this,void 0),c.set(this,void 0),g.set(this,void 0),r.set(this,""),a.set(this,void 0),p.set(this,!1),m.set(this,!1),y.set(this,!1),this._onMessageEmitter=new v.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new v.Emitter),this._onDidDispose=Ue(this,l,"f").event,it(this,S,b,"f"),it(this,k,I,"f"),it(this,a,h,"f"),it(this,A,_,"f"),it(this,c,F,"f"),it(this,g,N,"f"),it(this,y,f(N),"f"),it(this,i,z,"f")}dispose(){it(this,p,!0,"f"),Ue(this,l,"f").fire(),Ue(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return it(this,m,!0,"f"),(0,E.asWebviewUri)(Ue(this,S,"f"),b,Ue(this,A,"f").remote.authority)}get cspSource(){return E.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,r,"f")}set html(b){this.assertNotDisposed(),Ue(this,r,"f")!==b&&(it(this,r,b,"f"),!Ue(this,m,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(it(this,m,!0,"f"),Ue(this,i,"f").report("Webview vscode-resource: uris",Ue(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,k,"f").$setHtml(Ue(this,S,"f"),b))}get options(){return this.assertNotDisposed(),Ue(this,a,"f")}set options(b){this.assertNotDisposed(),Ue(this,k,"f").$setOptions(Ue(this,S,"f"),s(Ue(this,g,"f"),Ue(this,c,"f"),b)),it(this,a,b,"f")}async postMessage(b){if(Ue(this,p,"f"))return!1;const I=(0,T.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Ue(this,y,"f")});return Ue(this,k,"f").$postMessage(Ue(this,S,"f"),I.message,...I.buffers)}assertNotDisposed(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=d,S=new WeakMap,k=new WeakMap,i=new WeakMap,A=new WeakMap,c=new WeakMap,g=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap,m=new WeakMap,y=new WeakMap,l=new WeakMap;function f(w){try{const b=(0,C.normalizeVersion)((0,C.parseVersion)(w.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch(b){return!1}}e.shouldSerializeBuffersForPostMessage=f;class t{constructor(b,I,h,_,F){this.initData=I,this.workspace=h,this._logService=_,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=b.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(b,I,...h){const _=this.getWebview(b);if(_){const{message:F}=(0,T.deserializeWebviewMessage)(I,h);_._onMessageEmitter.fire(F)}}$onMissingCsp(b,I){this._logService.warn(`${I} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,I,h){const _=new d(b,this._webviewProxy,o(I),this.initData,this.workspace,h,this._deprecationService);return this._webviews.set(b,_),_._onDidDispose(()=>{this._webviews.delete(b)}),_}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=t;function n(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=n;function s(w,b,I){return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,portMapping:I.portMapping,localResourceRoots:I.localResourceRoots||u(w,b)}}e.serializeWebviewOptions=s;function o(w){var b;return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:(b=w.localResourceRoots)===null||b===void 0?void 0:b.map(I=>R.URI.from(I))}}e.reviveOptions=o;function u(w,b){return[...((b==null?void 0:b.getWorkspaceFolders())||[]).map(I=>I.uri),w.extensionLocation]}}),define(be[209],we([0,1,20,57,6,17,25,2,9,51,69,5,7]),function(J,e,v,R,C,T,E,D,S,k,i,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=d(this.document.uri)+this._backupCounter++;return(0,E.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class r{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const o=this.key(t,n.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const u=new g(n,s);return this._documents.set(o,u),u}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var a;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(a||(a={}));class p{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,o){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:o}),new c.Disposable(()=>this._providers.delete(n))}}class m{constructor(t,n,s,o,u){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=o,this._extHostWebviewPanels=u,this._editorProviders=new p,this._documents=new r,this._proxy=t.getProxy(A.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,o){const u=new C.DisposableStore;return y(s)?(u.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,o.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(u.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&u.add(s.onDidChangeCustomDocument(w=>{const b=this.getCustomDocumentEntry(n,w.document.uri);if(l(w)){const I=b.addEdit(w);this._proxy.$onDidEdit(w.document.uri,n,I,w.label)}else this._proxy.$onContentChange(w.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),c.Disposable.from(u,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,o,u){var w;const b=this._editorProviders.get(n);if(!b)throw new Error(`No provider found for '${n}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${n}'`);const I=D.URI.revive(t),h=await b.provider.openCustomDocument(I,{backupId:s,untitledDocumentData:o==null?void 0:o.buffer},u);let _;return this.supportEditing(b.provider)&&this._extensionStoragePaths&&(_=(w=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&w!==void 0?w:this._extensionStoragePaths.globalValue(b.extension)),this._documents.add(n,h,_),{editable:this.supportEditing(b.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const o=D.URI.revive(t),{document:u}=this.getCustomDocumentEntry(n,o);this._documents.delete(n,u),u.dispose()}async $resolveWebviewEditor(t,n,s,o,u,w){const b=this._editorProviders.get(s);if(!b)throw new Error(`No provider found for '${s}'`);const I=S.ViewColumn.to(u),h=this._extHostWebview.createNewWebview(n,o.webviewOptions,b.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(n,s,o.title,I,o.panelOptions,h),F=D.URI.revive(t);switch(b.type){case 1:{const{document:N}=this.getCustomDocumentEntry(s,F);return b.provider.resolveCustomEditor(N,_,w)}case 0:{const N=this._extHostDocuments.getDocument(F);return b.provider.resolveCustomTextEditor(N,_,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const o=this._editorProviders.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const w=D.URI.revive(n),b=this._extHostDocuments.getDocument(w);await o.provider.moveCustomTextEditor(b,u,v.CancellationToken.None)}async $undo(t,n,s,o){return this.getCustomDocumentEntry(n,t).undo(s,o)}async $redo(t,n,s,o){return this.getCustomDocumentEntry(n,t).redo(s,o)}async $revert(t,n,s){const o=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(o.document,s),o.disposeBackup()}async $onSave(t,n,s){const o=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(o.document,s),o.disposeBackup()}async $onSaveAs(t,n,s,o){const u=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(u.document,D.URI.revive(s),o)}async $backup(t,n,s){const o=this.getCustomDocumentEntry(n,t),w=await this.getCustomEditorProvider(n).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},s);return o.updateBackup(w),w.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,D.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function y(f){return typeof f.resolveCustomTextEditor=="function"}function l(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function d(f){const t=f.scheme===T.Schemas.file||f.scheme===T.Schemas.untitled?f.fsPath:f.toString();return(0,R.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(J,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(J,v):C?C.value=v:e.set(J,v),v},Ue=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[210],we([0,1,3,6,2,31,9,51,5,7]),function(J,e,v,R,C,T,E,D,S,k){"use strict";var i,A,c,g,r,a,p,m,y,l,d,f,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends R.Disposable{constructor(w,b,I,h,_,F,N){super();i.set(this,void 0),A.set(this,void 0),c.set(this,void 0),g.set(this,void 0),r.set(this,void 0),a.set(this,void 0),p.set(this,void 0),m.set(this,void 0),y.set(this,!0),l.set(this,!0),d.set(this,!1),f.set(this,this._register(new v.Emitter)),this.onDidDispose=Ue(this,f,"f").event,t.set(this,this._register(new v.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,it(this,i,w,"f"),it(this,A,b,"f"),it(this,c,I,"f"),it(this,r,F,"f"),it(this,m,_,"f"),it(this,a,h,"f"),it(this,g,N,"f")}dispose(){Ue(this,d,"f")||(it(this,d,!0,"f"),Ue(this,f,"f").fire(),Ue(this,A,"f").$disposeWebview(Ue(this,i,"f")),Ue(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,g,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,c,"f")}get title(){return this.assertNotDisposed(),Ue(this,a,"f")}set title(w){this.assertNotDisposed(),Ue(this,a,"f")!==w&&(it(this,a,w,"f"),Ue(this,A,"f").$setTitle(Ue(this,i,"f"),w))}get iconPath(){return this.assertNotDisposed(),Ue(this,p,"f")}set iconPath(w){this.assertNotDisposed(),Ue(this,p,"f")!==w&&(it(this,p,w,"f"),Ue(this,A,"f").$setIconPath(Ue(this,i,"f"),C.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return Ue(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,m,"f")=="number"&&Ue(this,m,"f")<0))return Ue(this,m,"f")}get active(){return this.assertNotDisposed(),Ue(this,l,"f")}get visible(){return this.assertNotDisposed(),Ue(this,y,"f")}_updateViewState(w){Ue(this,d,"f")||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(it(this,l,w.active,"f"),it(this,y,w.visible,"f"),it(this,m,w.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(w,b){this.assertNotDisposed(),Ue(this,A,"f").$reveal(Ue(this,i,"f"),{viewColumn:w?E.ViewColumn.from(w):void 0,preserveFocus:!!b})}assertNotDisposed(){if(Ue(this,d,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,A=new WeakMap,c=new WeakMap,g=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap,m=new WeakMap,y=new WeakMap,l=new WeakMap,d=new WeakMap,f=new WeakMap,t=new WeakMap;class s{constructor(w,b,I){this.webviews=b,this.workspace=I,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=w.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(w,b,I,h,_={}){const F=typeof h=="object"?h.viewColumn:h,N={viewColumn:E.ViewColumn.from(F),preserveFocus:typeof h=="object"&&!!h.preserveFocus},z=(0,D.shouldSerializeBuffersForPostMessage)(w),ce=s.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(w),ce,b,{title:I,panelOptions:o(_),webviewOptions:(0,D.serializeWebviewOptions)(w,this.workspace,_),serializeBuffersForPostMessage:z},N);const de=this.webviews.createNewWebview(ce,_,w);return this.createNewWebviewPanel(ce,b,I,F,_,de)}$onDidChangeWebviewPanelViewStates(w){const b=Object.keys(w);b.sort((I,h)=>{const _=w[I],F=w[h];return _.active?1:F.active?-1:+_.visible-+F.visible});for(const I of b){const h=this.getWebviewPanel(I);if(!!h){const _=w[I];h._updateViewState({active:_.active,visible:_.visible,viewColumn:E.ViewColumn.to(_.position)})}}}async $onDidDisposeWebviewPanel(w){const b=this.getWebviewPanel(w);b==null||b.dispose(),this._webviewPanels.delete(w),this.webviews.deleteWebview(w)}registerWebviewPanelSerializer(w,b,I){if(this._serializers.has(b))throw new Error(`Serializer for '${b}' already registered`);return this._serializers.set(b,{serializer:I,extension:w}),this._proxy.$registerSerializer(b,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(w)}),new k.Disposable(()=>{this._serializers.delete(b),this._proxy.$unregisterSerializer(b)})}async $deserializeWebviewPanel(w,b,I,h){const _=this._serializers.get(b);if(!_)throw new Error(`No serializer found for '${b}'`);const{serializer:F,extension:N}=_,z=this.webviews.createNewWebview(w,I.webviewOptions,N),ce=this.createNewWebviewPanel(w,b,I.title,h,I.panelOptions,z);await F.deserializeWebviewPanel(ce,I.state)}createNewWebviewPanel(w,b,I,h,_,F){const N=new n(w,this._proxy,b,I,h,_,F);return this._webviewPanels.set(w,N),N}getWebviewPanel(w){return this._webviewPanels.get(w)}}e.ExtHostWebviewPanels=s;function o(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(J,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(J,v):C?C.value=v:e.set(J,v),v},Ue=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[211],we([0,1,3,6,51,5,7]),function(J,e,v,R,C,T,E){"use strict";var D,S,k,i,A,c,g,r,a,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends R.Disposable{constructor(d,f,t,n,s,o){super();D.set(this,void 0),S.set(this,void 0),k.set(this,void 0),i.set(this,void 0),A.set(this,!1),c.set(this,void 0),g.set(this,void 0),r.set(this,void 0),a.set(this,this._register(new v.Emitter)),this.onDidChangeVisibility=Ue(this,a,"f").event,p.set(this,this._register(new v.Emitter)),this.onDidDispose=Ue(this,p,"f").event,it(this,k,t,"f"),it(this,g,n,"f"),it(this,D,d,"f"),it(this,S,f,"f"),it(this,i,s,"f"),it(this,c,o,"f")}dispose(){Ue(this,A,"f")||(it(this,A,!0,"f"),Ue(this,p,"f").fire(),Ue(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,g,"f")}set title(d){this.assertNotDisposed(),Ue(this,g,"f")!==d&&(it(this,g,d,"f"),Ue(this,S,"f").$setWebviewViewTitle(Ue(this,D,"f"),d))}get description(){return this.assertNotDisposed(),Ue(this,r,"f")}set description(d){this.assertNotDisposed(),Ue(this,r,"f")!==d&&(it(this,r,d,"f"),Ue(this,S,"f").$setWebviewViewDescription(Ue(this,D,"f"),d))}get visible(){return Ue(this,c,"f")}get webview(){return Ue(this,i,"f")}get viewType(){return Ue(this,k,"f")}_setVisible(d){d===Ue(this,c,"f")||Ue(this,A,"f")||(it(this,c,d,"f"),Ue(this,a,"f").fire())}show(d){this.assertNotDisposed(),Ue(this,S,"f").$show(Ue(this,D,"f"),!!d)}assertNotDisposed(){if(Ue(this,A,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,S=new WeakMap,k=new WeakMap,i=new WeakMap,A=new WeakMap,c=new WeakMap,g=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap;class y{constructor(d,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,f,t,n){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:t,extension:d}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(d),f,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new E.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(d,f,t,n,s){const o=this._viewProviders.get(f);if(!o)throw new Error(`No view provider found for '${f}'`);const{provider:u,extension:w}=o,b=this._extHostWebview.createNewWebview(d,{},w),I=new m(d,this._proxy,f,t,b,!0);this._webviewViews.set(d,I),await u.resolveWebviewView(I,{state:n},s)}async $onDidChangeWebviewViewVisibility(d,f){this.getWebviewView(d)._setVisible(f)}async $disposeWebviewView(d){const f=this.getWebviewView(d);this._webviewViews.delete(d),f.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const f=this._webviewViews.get(d);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=y}),define(be[102],we([0,1,3,5,2,17,8,4,15]),function(J,e,v,R,C,T,E,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Rn{constructor(A){this._onDidChangeWindowState=new v.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Rn.InitialState,this._proxy=A.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(A){A!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:A}),this._onDidChangeWindowState.fire(this._state))}openUri(A,c){let g;if(typeof A=="string"){g=A;try{A=C.URI.parse(A)}catch(r){return Promise.reject(`Invalid uri - '${A}'`)}}return(0,E.isFalsyOrWhitespace)(A.scheme)?Promise.reject("Invalid scheme - cannot be empty"):A.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${A.scheme}'`):this._proxy.$openUri(A,g,c)}async asExternalUri(A,c){if((0,E.isFalsyOrWhitespace)(A.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(A.scheme))return Promise.reject(`Invalid scheme '${A.scheme}'`);const g=await this._proxy.$asExternalUri(A,c);return C.URI.from(g)}};k.InitialState={focused:!0},k=qe([Ke(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(be[212],we([0,1,16,5,27,15]),function(J,e,v,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let E=class extends v.AbstractLogger{constructor(S,k){super();this._proxy=S.getProxy(R.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...k){this.getLevel()<=v.LogLevel.Trace&&this._proxy.$log(this._logFile,v.LogLevel.Trace,Array.from(arguments))}debug(S,...k){this.getLevel()<=v.LogLevel.Debug&&this._proxy.$log(this._logFile,v.LogLevel.Debug,Array.from(arguments))}info(S,...k){this.getLevel()<=v.LogLevel.Info&&this._proxy.$log(this._logFile,v.LogLevel.Info,Array.from(arguments))}warn(S,...k){this.getLevel()<=v.LogLevel.Warning&&this._proxy.$log(this._logFile,v.LogLevel.Warning,Array.from(arguments))}error(S,...k){this.getLevel()<=v.LogLevel.Error&&this._proxy.$log(this._logFile,v.LogLevel.Error,Array.from(arguments))}critical(S,...k){this.getLevel()<=v.LogLevel.Critical&&this._proxy.$log(this._logFile,v.LogLevel.Critical,Array.from(arguments))}flush(){}};E=qe([Ke(0,T.IExtHostRpcService),Ke(1,C.IExtHostInitDataService)],E),e.ExtHostLogService=E}),define(be[213],we([0,1,11,20,12,3,6,114,185,99,24]),function(J,e,v,R,C,T,E,D,S,k,i){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function c(o,u){try{return JSON.stringify(o,u)}catch(w){return"null"}}function g(o,u){return JSON.stringify(o,u)}function r(o){return o?(u,w)=>w&&w.$mid===1?o.transformOutgoing(w):w:null}var a;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},y=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class d extends E.Disposable{constructor(u,w=null,b=null){super();this[A]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=u,this._logger=w,this._uriTransformer=b,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let I=0,h=k.ProxyIdentifier.count;I<h;I++)this._locals[I]=null,this._proxies[I]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new v.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(I=>this._receiveOneMessage(I))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(u=>{this._pendingRPCReplies[u].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(u){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(u){this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(u){this._responsiveState!==u&&(this._responsiveState=u,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(u){return this._uriTransformer?(0,D.transformIncomingURIs)(u,this._uriTransformer):u}getProxy(u){const{nid:w,sid:b}=u;return this._proxies[w]||(this._proxies[w]=this._createProxy(w,b)),this._proxies[w]}_createProxy(u,w){let b={get:(I,h)=>(typeof h=="string"&&!I[h]&&h.charCodeAt(0)===36&&(I[h]=(..._)=>this._remoteCall(u,h,_)),h===l?w:I[h])};return new Proxy(Object.create(null),b)}set(u,w){return this._locals[u.nid]=w,w}assertRegistered(u){for(let w=0,b=u.length;w<b;w++){const I=u[w];if(!this._locals[I.nid])throw new Error(`Missing actor ${I.sid} (isMain: ${I.isMain})`)}}_receiveOneMessage(u){if(!this._isDisposed){const w=u.byteLength,b=f.read(u,0),I=b.readUInt8(),h=b.readUInt32();switch(I){case 1:case 2:{let{rpcId:_,method:F,args:N}=t.deserializeRequestJSONArgs(b);this._uriTransformer&&(N=(0,D.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(w,h,_,F,N,I===2);break}case 3:case 4:{let{rpcId:_,method:F,args:N}=t.deserializeRequestMixedArgs(b);this._uriTransformer&&(N=(0,D.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(w,h,_,F,N,I===4);break}case 5:{this._logger&&this._logger.logIncoming(w,h,0,"ack"),this._onDidReceiveAcknowledge(h);break}case 6:{this._receiveCancel(w,h);break}case 7:{this._receiveReply(w,h,void 0);break}case 9:{let _=t.deserializeReplyOKJSON(b);this._uriTransformer&&(_=(0,D.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReply(w,h,_);break}case 8:{let _=t.deserializeReplyOKVSBuffer(b);this._receiveReply(w,h,_);break}case 10:{let _=t.deserializeReplyErrError(b);this._uriTransformer&&(_=(0,D.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReplyErr(w,h,_);break}case 11:{this._receiveReplyErr(w,h,void 0);break}default:console.error("received unexpected message"),console.error(u)}}}_receiveRequest(u,w,b,I,h,_){this._logger&&this._logger.logIncoming(u,w,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(b)}.${I}(`,h);const F=String(w);let N,z;if(_){const de=new R.CancellationTokenSource;h.push(de.token),N=this._invokeHandler(b,I,h),z=()=>de.cancel()}else N=this._invokeHandler(b,I,h),z=m;this._cancelInvokedHandlers[F]=z;const ce=t.serializeAcknowledged(w);this._logger&&this._logger.logOutgoing(ce.byteLength,w,1,"ack"),this._protocol.send(ce),N.then(de=>{delete this._cancelInvokedHandlers[F];const B=t.serializeReplyOK(w,de,this._uriReplacer);this._logger&&this._logger.logOutgoing(B.byteLength,w,1,"reply:",de),this._protocol.send(B)},de=>{delete this._cancelInvokedHandlers[F];const B=t.serializeReplyErr(w,de);this._logger&&this._logger.logOutgoing(B.byteLength,w,1,"replyErr:",de),this._protocol.send(B)})}_receiveCancel(u,w){this._logger&&this._logger.logIncoming(u,w,1,"receiveCancel");const b=String(w);this._cancelInvokedHandlers[b]&&this._cancelInvokedHandlers[b]()}_receiveReply(u,w,b){this._logger&&this._logger.logIncoming(u,w,0,"receiveReply:",b);const I=String(w);if(!!this._pendingRPCReplies.hasOwnProperty(I)){const h=this._pendingRPCReplies[I];delete this._pendingRPCReplies[I],h.resolveOk(b)}}_receiveReplyErr(u,w,b){this._logger&&this._logger.logIncoming(u,w,0,"receiveReplyErr:",b);const I=String(w);if(!!this._pendingRPCReplies.hasOwnProperty(I)){const h=this._pendingRPCReplies[I];delete this._pendingRPCReplies[I];let _;b&&(b.$isError?(_=new Error,_.name=b.name,_.message=b.message,_.stack=b.stack):_=b),h.resolveErr(_)}}_invokeHandler(u,w,b){try{return Promise.resolve(this._doInvokeHandler(u,w,b))}catch(I){return Promise.reject(I)}}_doInvokeHandler(u,w,b){const I=this._locals[u];if(!I)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(u));let h=I[w];if(typeof h!="function")throw new Error("Unknown method "+w+" on actor "+(0,k.getStringIdentifierForProxy)(u));return h.apply(I,b)}_remoteCall(u,w,b){if(this._isDisposed)return Promise.reject(C.canceled());let I=null;if(b.length>0&&R.CancellationToken.isCancellationToken(b[b.length-1])&&(I=b.pop()),I&&I.isCancellationRequested)return Promise.reject(C.canceled());const h=t.serializeRequestArguments(b,this._uriReplacer),_=++this._lastMessageId,F=String(_),N=new S.LazyPromise;I&&I.onCancellationRequested(()=>{const ce=t.serializeCancel(_);this._logger&&this._logger.logOutgoing(ce.byteLength,_,0,"cancel"),this._protocol.send(t.serializeCancel(_))}),this._pendingRPCReplies[F]=N,this._onWillSendRequest(_);const z=t.serializeRequest(_,u,w,h,!!I);return this._logger&&this._logger.logOutgoing(z.byteLength,_,0,`request: ${(0,k.getStringIdentifierForProxy)(u)}.${w}(`,b),this._protocol.send(z),N}}e.RPCProtocol=d,A=y,d.UNRESPONSIVE_TIME=3*1e3;class f{constructor(u,w){this._buff=u,this._offset=w}static alloc(u,w,b){let I=new f(i.VSBuffer.alloc(b+1+4),0);return I.writeUInt8(u),I.writeUInt32(w),I}static read(u,w){return new f(u,w)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(u){this._buff.writeUInt8(u,this._offset),this._offset+=1}readUInt8(){const u=this._buff.readUInt8(this._offset);return this._offset+=1,u}writeUInt32(u){this._buff.writeUInt32BE(u,this._offset),this._offset+=4}readUInt32(){const u=this._buff.readUInt32BE(this._offset);return this._offset+=4,u}static sizeShortString(u){return 1+u.byteLength}writeShortString(u){this._buff.writeUInt8(u.byteLength,this._offset),this._offset+=1,this._buff.set(u,this._offset),this._offset+=u.byteLength}readShortString(){const u=this._buff.readUInt8(this._offset);this._offset+=1;const b=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,b}static sizeLongString(u){return 4+u.byteLength}writeLongString(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readLongString(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,b}writeBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}static sizeVSBuffer(u){return 4+u.byteLength}writeVSBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readVSBuffer(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+u);return this._offset+=u,w}static sizeMixedArray(u,w){let b=0;b+=1;for(let I=0,h=u.length;I<h;I++){const _=u[I],F=w[I];switch(b+=1,F){case 1:b+=this.sizeLongString(_);break;case 2:b+=this.sizeVSBuffer(_);break;case 3:break}}return b}writeMixedArray(u,w){this._buff.writeUInt8(u.length,this._offset),this._offset+=1;for(let b=0,I=u.length;b<I;b++){const h=u[b];switch(w[b]){case 1:this.writeUInt8(1),this.writeLongString(h);break;case 2:this.writeUInt8(2),this.writeVSBuffer(h);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const u=this._buff.readUInt8(this._offset);this._offset+=1;let w=new Array(u);for(let b=0;b<u;b++)switch(this.readUInt8()){case 1:w[b]=this.readLongString();break;case 2:w[b]=this.readVSBuffer();break;case 3:w[b]=void 0;break}return w}}class t{static _arrayContainsBufferOrUndefined(u){for(let w=0,b=u.length;w<b;w++)if(u[w]instanceof i.VSBuffer||typeof u[w]=="undefined")return!0;return!1}static serializeRequestArguments(u,w){if(this._arrayContainsBufferOrUndefined(u)){let b=[],I=[];for(let h=0,_=u.length;h<_;h++){const F=u[h];F instanceof i.VSBuffer?(b[h]=F,I[h]=2):typeof F=="undefined"?(b[h]=i.VSBuffer.alloc(0),I[h]=3):(b[h]=i.VSBuffer.fromString(g(F,w)),I[h]=1)}return{type:"mixed",args:b,argsType:I}}return{type:"simple",args:g(u,w)}}static serializeRequest(u,w,b,I,h){return I.type==="mixed"?this._requestMixedArgs(u,w,b,I.args,I.argsType,h):this._requestJSONArgs(u,w,b,I.args,h)}static _requestJSONArgs(u,w,b,I,h){const _=i.VSBuffer.fromString(b),F=i.VSBuffer.fromString(I);let N=0;N+=f.sizeUInt8(),N+=f.sizeShortString(_),N+=f.sizeLongString(F);let z=f.alloc(h?2:1,u,N);return z.writeUInt8(w),z.writeShortString(_),z.writeLongString(F),z.buffer}static deserializeRequestJSONArgs(u){const w=u.readUInt8(),b=u.readShortString(),I=u.readLongString();return{rpcId:w,method:b,args:JSON.parse(I)}}static _requestMixedArgs(u,w,b,I,h,_){const F=i.VSBuffer.fromString(b);let N=0;N+=f.sizeUInt8(),N+=f.sizeShortString(F),N+=f.sizeMixedArray(I,h);let z=f.alloc(_?4:3,u,N);return z.writeUInt8(w),z.writeShortString(F),z.writeMixedArray(I,h),z.buffer}static deserializeRequestMixedArgs(u){const w=u.readUInt8(),b=u.readShortString(),I=u.readMixedArray(),h=new Array(I.length);for(let _=0,F=I.length;_<F;_++){const N=I[_];typeof N=="string"?h[_]=JSON.parse(N):h[_]=N}return{rpcId:w,method:b,args:h}}static serializeAcknowledged(u){return f.alloc(5,u,0).buffer}static serializeCancel(u){return f.alloc(6,u,0).buffer}static serializeReplyOK(u,w,b){return typeof w=="undefined"?this._serializeReplyOKEmpty(u):w instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(u,w):this._serializeReplyOKJSON(u,c(w,b))}static _serializeReplyOKEmpty(u){return f.alloc(7,u,0).buffer}static _serializeReplyOKVSBuffer(u,w){let b=0;b+=f.sizeVSBuffer(w);let I=f.alloc(8,u,b);return I.writeVSBuffer(w),I.buffer}static deserializeReplyOKVSBuffer(u){return u.readVSBuffer()}static _serializeReplyOKJSON(u,w){const b=i.VSBuffer.fromString(w);let I=0;I+=f.sizeLongString(b);let h=f.alloc(9,u,I);return h.writeLongString(b),h.buffer}static deserializeReplyOKJSON(u){const w=u.readLongString();return JSON.parse(w)}static serializeReplyErr(u,w){return w?this._serializeReplyErrEror(u,w):this._serializeReplyErrEmpty(u)}static _serializeReplyErrEror(u,w){const b=i.VSBuffer.fromString(c(C.transformErrorForSerialization(w),null));let I=0;I+=f.sizeLongString(b);let h=f.alloc(10,u,I);return h.writeLongString(b),h.buffer}static deserializeReplyErrError(u){const w=u.readLongString();return JSON.parse(w)}static _serializeReplyErrEmpty(u){return f.alloc(11,u,0).buffer}}var n;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyErrError=10]="ReplyErrError",o[o.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.Undefined=3]="Undefined"})(s||(s={}))}),define(be[214],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const v=function(T){const E=D=>{self.removeEventListener("message",E);const S=D.data;Object.defineProperties(self,{postMessage:{value(k,i){S.postMessage(k,i)}},onmessage:{get(){return S.onmessage},set(k){S.onmessage=k}}}),S.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",E)}.toString();class R extends EventTarget{constructor(T,E,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${v})('${E}'))`,k=new Blob([S],{type:"application/javascript"}),i=URL.createObjectURL(k),A=new MessageChannel,c=i,g={type:"_newWorker",id:c,port:A.port2,url:i,options:D};T(g,[A.port2]),this.postMessage=A.port1.postMessage.bind(A.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:c};A.port1.postMessage(r),URL.revokeObjectURL(i),A.port1.close(),A.port2.close()},Object.defineProperties(this,{onmessage:{get(){return A.port1.onmessage},set(r){A.port1.onmessage=r}},onmessageerror:{get(){return A.port1.onmessageerror},set(r){A.port1.onmessageerror=r}}}),A.port1.addEventListener("messageerror",r=>{const a=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(a)}),A.port1.addEventListener("message",r=>{const a=new MessageEvent("message",{data:r.data});this.dispatchEvent(a)}),A.port1.start()}}e.NestedWorker=R}),define(be[215],we([0,1,4]),function(J,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,v.createDecorator)("remoteAgentService")}),define(be[216],we([0,1,17,14,21,2,4,215]),function(J,e,v,R,C,T,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let S=class{constructor(i,A){this.localUserHome=i,this.remoteAgentService=A,this.resolveOS=(async()=>{const c=await this.remoteAgentService.getEnvironment();return(c==null?void 0:c.os)||C.OS})(),this.resolveUserHome=(async()=>{const c=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(c==null?void 0:c.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?R.win32:R.posix)}async fileURI(i){let A="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const g=i.indexOf("/",2);g===-1?(A=i.substring(2),i="/"):(A=i.substring(2,g),i=i.substring(g)||"/")}return T.URI.from({scheme:v.Schemas.file,authority:A,path:i,query:"",fragment:""})}};S=qe([Ke(1,D.IRemoteAgentService)],S),e.AbstractPathService=S}),define(be[103],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class v{constructor(E,D){this.line=E,this.character=D}isBefore(E){return!1}isBeforeOrEqual(E){return!1}isAfter(E){return!1}isAfterOrEqual(E){return!1}isEqual(E){return!1}compareTo(E){return 0}translate(E,D){return new v(0,0)}with(E){return new v(0,0)}}e.Position=v;class R{constructor(E,D,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(E,D),this.end=new v(S,k)}contains(E){return!1}isEqual(E){return!1}intersection(E){}union(E){return new R(0,0,0,0)}with(E){return new R(0,0,0,0)}}e.Range=R;var C;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],we([0,1,13,28,23,37,8,4,14,12,103]),function(J,e,v,R,C,T,E,D,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const A="\u27EA ",c=" characters skipped \u27EB",g=(A.length+c.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var r;(function(P){P[P.file=0]="file",P[P.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(P){P[P.File=1]="File",P[P.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function p(P){return!!P.preview}e.resultIsMatch=p;function m(P){return!!P.resource}e.isFileMatch=m;function y(P){return!!P.message}e.isProgressMessage=y;var l;(function(P){P[P.Normal=0]="Normal",P[P.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor(H){this.resource=H,this.results=[]}}e.FileMatch=d;class f{constructor(H,L,$){this.ranges=L;const Q=Array.isArray(L)?L:[L];if($&&$.matchLines===1&&t(Q)){H=(0,E.getNLines)(H,$.matchLines);let q="",ae=0,fe=0;const Le=Math.floor($.charsPerLine/5),xe=[];for(const Fe of Q){const He=Math.max(Fe.startColumn-Le,0),x=Fe.startColumn+$.charsPerLine;if(He>fe+Le+g){const G=A+(He-fe)+c;q+=G+H.slice(He,x),ae+=He-(fe+G.length)}else q+=H.slice(fe,x);xe.push(new s(0,Fe.startColumn-ae,Fe.endColumn-ae)),fe=x}this.preview={text:q,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const q=Array.isArray(L)?L[0].startLineNumber:L.startLineNumber;this.preview={text:H,matches:(0,v.mapArrayOrNot)(L,ae=>new n(ae.startLineNumber-q,ae.startColumn,ae.endLineNumber-q,ae.endColumn))}}}}e.TextSearchMatch=f;function t(P){const H=P[0].startLineNumber;for(const L of P)if(L.startLineNumber!==H||L.endLineNumber!==H)return!1;return!0}class n{constructor(H,L,$,Q){this.startLineNumber=H,this.startColumn=L,this.endLineNumber=$,this.endColumn=Q}}e.SearchRange=n;class s extends n{constructor(H,L,$){super(H,L,H,$)}}e.OneLineRange=s;var o;(function(P){P.Default="default",P.FileNames="fileNames",P.Type="type",P.Modified="modified",P.CountDescending="countDescending",P.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function u(P,H=!0){const L=P&&P.files&&P.files.exclude,$=H&&P&&P.search&&P.search.exclude;if(!(!L&&!$)){if(!L||!$)return L||$;let Q=Object.create(null);return Q=C.mixin(Q,C.deepClone(L)),Q=C.mixin(Q,C.deepClone($),!0),Q}}e.getExcludes=u;function w(P,H){return P.excludePattern&&R.match(P.excludePattern,H)?!1:P.includePattern||P.usingSearchPaths?P.includePattern&&R.match(P.includePattern,H)?!0:P.usingSearchPaths?!!P.folderQueries&&P.folderQueries.some(L=>{const $=L.folder.fsPath;if(T.isEqualOrParent(H,$)){const Q=S.relative($,H);return!L.includePattern||!!R.match(L.includePattern,Q)}else return!1}):!1:!0}e.pathIncludedInQuery=w;var b;(function(P){P[P.unknownEncoding=1]="unknownEncoding",P[P.regexParseError=2]="regexParseError",P[P.globParseError=3]="globParseError",P[P.invalidLiteral=4]="invalidLiteral",P[P.rgProcessError=5]="rgProcessError",P[P.other=6]="other",P[P.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class I extends Error{constructor(H,L){super(H);this.code=L}}e.SearchError=I;function h(P){const H=P.message;if((0,k.isPromiseCanceledError)(P))return new I(H,b.canceled);try{const L=JSON.parse(H);return new I(L.message,L.code)}catch(L){return new I(H,b.other)}}e.deserializeSearchError=h;function _(P){const H={message:P.message,code:P.code};return new Error(JSON.stringify(H))}e.serializeSearchError=_;function F(P){return P.type==="error"?!0:P.type==="success"}e.isSerializedSearchComplete=F;function N(P){return P.type==="success"}e.isSerializedSearchSuccess=N;function z(P){return!!P.path}e.isSerializedFileMatch=z;function ce(P,H){const L=P.searchPath?P.searchPath:P.relativePath;return(0,E.fuzzyContains)(L,H)}e.isFilePatternMatch=ce;class de{constructor(H){this.path=H,this.results=[]}addMatch(H){this.results.push(H)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=de;function B(P,H){const L=Object.assign(Object.assign({},P||{}),H||{});return Object.keys(L).filter($=>{const Q=L[$];return typeof Q=="boolean"&&Q})}e.resolvePatternsForProvider=B;class j{constructor(H,L){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},H.excludePattern||{}),L.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let $=H.includePattern;L.includePattern&&($?$=Object.assign(Object.assign({},$),L.includePattern):$=L.includePattern),$&&(this._parsedIncludeExpression=R.parse($))}includedInQuerySync(H,L,$){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(H,L,$)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(H,L,$))}includedInQuery(H,L,$){return Promise.resolve(this._parsedExcludeExpression(H,L,$)).then(q=>!!q).then(q=>q?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(H,L,$)).then(ae=>!!ae):Promise.resolve(!0)).then(q=>q)}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=j;function W(P){for(const H in P)if(typeof P[H]!="boolean")return!0;return!1}}),define(be[30],we([0,1,13,11,20,3,22,17,82,25,8,10,2,137,4,16,152,48,49,27,15,7,41,5]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a,p,m,y,l,d,f,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(F,N,z){return new k.ExtUri(ce=>b(ce,z)).isEqual(F,N)}function o(F,N,z){return s(F.uri,N.uri,z)?0:(0,i.compare)(F.uri.toString(),N.uri.toString())}function u(F,N,z){return F.index!==N.index?F.index<N.index?-1:1:s(F.uri,N.uri,z)?(0,i.compare)(F.name,N.name):(0,i.compare)(F.uri.toString(),N.uri.toString())}function w(F,N,z,ce){const de=F.slice(0).sort((j,W)=>z(j,W,ce)),B=N.slice(0).sort((j,W)=>z(j,W,ce));return(0,v.delta)(de,B,(j,W)=>z(j,W,ce))}function b(F,N){const z=N.getCapabilities(F.scheme);return!(z&&z&1024)}class I extends m.Workspace{constructor(N,z,ce,de,B,j){super(N,ce.map(W=>new m.WorkspaceFolder(W)),de,j);this._name=z,this._isUntitled=B,this._workspaceFolders=[],this._structure=E.TernarySearchTree.forUris(j),ce.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(N,z,ce,de){if(!N)return{workspace:null,added:[],removed:[]};const{id:B,name:j,folders:W,configuration:P,isUntitled:H}=N,L=[],$=z;z?W.forEach((fe,Le)=>{const xe=c.URI.revive(fe.uri),Fe=I._findFolder(ce||z,xe,de);Fe?(Fe.name=fe.name,Fe.index=fe.index,L.push(Fe)):L.push({uri:xe,name:fe.name,index:Le})}):L.push(...W.map(({uri:fe,name:Le,index:xe})=>({uri:c.URI.revive(fe),name:Le,index:xe}))),L.sort((fe,Le)=>fe.index<Le.index?-1:1);const Q=new I(B,j,L,P?c.URI.revive(P):null,!!H,fe=>b(fe,de)),{added:q,removed:ae}=w($?$.workspaceFolders:[],Q.workspaceFolders,o,de);return{workspace:Q,added:q,removed:ae}}static _findFolder(N,z,ce){for(let de=0;de<N.folders.length;de++){const B=N.workspaceFolders[de];if(s(B.uri,z,ce))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,z){return z&&this._structure.get(N)&&(N=(0,k.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let h=class{constructor(N,z,ce,de){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=de,this._extHostFileSystemInfo=ce,this._requestIdProvider=new S.Counter,this._barrier=new R.Barrier,this._proxy=N.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(n.MainContext.MainThreadMessageService);const B=z.workspace;this._confirmedWorkspace=B?new I(B.id,B.name,[],B.configuration?c.URI.revive(B.configuration):null,!!B.isUntitled,j=>b(j,ce)):void 0}$initializeWorkspace(N,z){this._trusted=z,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:D.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,z,ce,...de){const B=[];if(Array.isArray(de)&&de.forEach(L=>{c.URI.isUri(L.uri)&&!B.some($=>s($.uri,L.uri,this._extHostFileSystemInfo))&&B.push({uri:L.uri,name:L.name||(0,k.basenameOrAuthority)(L.uri)})}),this._unconfirmedWorkspace||[z,ce].some(L=>typeof L!="number"||L<0)||ce===0&&B.length===0)return!1;const j=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+ce>j.length)return!1;const W=j.slice(0);W.splice(z,ce,...B.map(L=>({uri:L.uri,name:L.name||(0,k.basenameOrAuthority)(L.uri),index:void 0})));for(let L=0;L<W.length;L++){const $=W[L];if(W.some((Q,q)=>q!==L&&s($.uri,Q.uri,this._extHostFileSystemInfo)))return!1}W.forEach((L,$)=>L.index=$);const{added:P,removed:H}=w(j,W,u,this._extHostFileSystemInfo);if(P.length===0&&H.length===0)return!1;if(this._proxy){const L=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(L,z,ce,B).then(void 0,$=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,g.localize)(0,null,L,$.toString()),{extension:N},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(N,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,z)}async getWorkspaceFolder2(N,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,z)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!!this._actualWorkspace){const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}}getRelativePath(N,z){let ce,de="";if(typeof N=="string"?(ce=c.URI.file(N),de=N):typeof N!="undefined"&&(ce=N,de=N.fsPath),!ce)return de;const B=this.getWorkspaceFolder(ce,!0);if(!B)return de;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let j=(0,k.relativePath)(B.uri,ce);return z&&B.name&&(j=`${B.name}/${j}`),j}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=I.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:z,added:ce,removed:de}=I.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ce,removed:de}))}findFiles(N,z,ce,de,B=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${de.value}, entryPoint: findFiles`);let j;if(z===null?j=!1:z&&(typeof z=="string"?j=z:j=z.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:P}=_(N);return this._proxy.$startFileSearch((0,A.withUndefinedAsNull)(W),(0,A.withUndefinedAsNull)(P),(0,A.withUndefinedAsNull)(j),(0,A.withUndefinedAsNull)(ce),B).then(H=>Array.isArray(H)?H.map(L=>c.URI.revive(L)):[])}async findTextInFiles(N,z,ce,de,B=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${de.value}, entryPoint: findTextInFiles`);const j=this._requestIdProvider.getNext(),W=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:P,folder:H}=_(z.include),L=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,$={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:W,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:P,excludePattern:L},Q=!1;if(this._activeSearchCallbacks[j]=q=>{if(!Q){const ae=c.URI.revive(q.resource);q.results.forEach(fe=>{(0,t.resultIsMatch)(fe)?ce({uri:ae,preview:{text:fe.preview.text,matches:(0,v.mapArrayOrNot)(fe.preview.matches,Le=>new f.Range(Le.startLineNumber,Le.startColumn,Le.endLineNumber,Le.endColumn))},ranges:(0,v.mapArrayOrNot)(fe.ranges,Le=>new f.Range(Le.startLineNumber,Le.startColumn,Le.endLineNumber,Le.endColumn))}):ce({uri:ae,text:fe.text,lineNumber:fe.lineNumber})})}},B.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(N,(0,A.withUndefinedAsNull)(H),$,j,B);return delete this._activeSearchCallbacks[j],q||{}}catch(q){throw delete this._activeSearchCallbacks[j],q}}$handleTextSearchResult(N,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};h=qe([Ke(0,d.IExtHostRpcService),Ke(1,l.IExtHostInitDataService),Ke(2,y.IExtHostFileSystemInfo),Ke(3,a.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function _(F){let N,z;return F&&(typeof F=="string"?N=F:(N=F.pattern,z=F.baseFolder||c.URI.file(F.base))),{includePattern:N,folder:z}}}),define(be[34],we([0,1,23,3,30,5,7,154,67,10,11,4,15,16,2]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(n,s){if(s){const o=s.split(".");let u=n;for(let w=0;u&&w<o.length;w++)u=u[o[w]];return u}}function p(n){return n instanceof r.URI}function m(n){return n&&n.uri instanceof r.URI&&n.languageId&&typeof n.languageId=="string"}function y(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function l(n){return n&&n.uri instanceof r.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function d(n){if(p(n))return{resource:n};if(m(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(y(n))return{overrideIdentifier:n.languageId};if(l(n))return{resource:n.uri};if(n===null)return{resource:null}}let f=class{constructor(s,o,u){this._proxy=s.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=u,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(s,o))}};f=qe([Ke(0,c.IExtHostRpcService),Ke(1,C.IExtHostWorkspace),Ke(2,g.ILogService)],f),e.ExtHostConfiguration=f;class t{constructor(s,o,u,w){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=w,this._extHostWorkspace=o,this._configuration=D.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,o){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,u))}getConfiguration(s,o,u){const w=d(o)||{},b=this._toReadonlyValue(s?a(this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,w,u==null?void 0:u.identifier);function I(_){if(_==null)return null;if(typeof _=="boolean")return _?1:4;switch(_){case E.ConfigurationTarget.Global:return 1;case E.ConfigurationTarget.Workspace:return 4;case E.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(_){return typeof a(b,_)!="undefined"},get:(_,F)=>{this._validateConfigurationAccess(s?`${s}.${_}`:_,w,u==null?void 0:u.identifier);let N=a(b,_);if(typeof N=="undefined")N=F;else{let z;const ce=(de,B)=>{let j;const W=()=>{z=z||(0,v.deepClone)(b),j=j||a(z,B)};return(0,k.isObject)(de)?new Proxy(de,{get:(P,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return W(),()=>j;if(z)return j=j||a(z,B),j[H];const L=P[H];return typeof H=="string"?ce(L,`${B}.${H}`):L},set:(P,H,L)=>(W(),j&&(j[H]=L),!0),deleteProperty:(P,H)=>(W(),j&&delete j[H],!0),defineProperty:(P,H,L)=>(W(),j&&Object.defineProperty(j,H,L),!0)}):de};N=ce(N,_)}return N},update:(_,F,N,z)=>{_=s?`${s}.${_}`:_;const ce=I(N);return F!==void 0?this._proxy.$updateConfigurationOption(ce,_,F,w,z):this._proxy.$removeConfigurationOption(ce,_,w,z)},inspect:_=>{var F,N,z,ce,de,B,j,W;_=s?`${s}.${_}`:_;const P=(0,v.deepClone)(this._configuration.inspect(_,w,this._extHostWorkspace.workspace));if(P)return{key:_,defaultValue:(F=P.default)===null||F===void 0?void 0:F.value,globalValue:(N=P.user)===null||N===void 0?void 0:N.value,workspaceValue:(z=P.workspace)===null||z===void 0?void 0:z.value,workspaceFolderValue:(ce=P.workspaceFolder)===null||ce===void 0?void 0:ce.value,defaultLanguageValue:(de=P.default)===null||de===void 0?void 0:de.override,globalLanguageValue:(B=P.user)===null||B===void 0?void 0:B.override,workspaceLanguageValue:(j=P.workspace)===null||j===void 0?void 0:j.override,workspaceFolderLanguageValue:(W=P.workspaceFolder)===null||W===void 0?void 0:W.override,languageIds:P.overrideIdentifiers}}};return typeof b=="object"&&(0,v.mixin)(h,b,!1),Object.freeze(h)}_toReadonlyValue(s){const o=u=>(0,k.isObject)(u)?new Proxy(u,{get:(w,b)=>o(w[b]),set:(w,b,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(w,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(w,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:w=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return o(s)}_validateConfigurationAccess(s,o,u){const w=S.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),b=u?`[${u.value}] `:"";if(w===4){typeof(o==null?void 0:o.resource)=="undefined"&&this._logService.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(w===3){(o==null?void 0:o.resource)&&this._logService.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,o){const u=new D.ConfigurationChangeEvent(s,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(w,b)=>u.affectsConfiguration(w,d(b))})}_toMap(s){return s.reduce((o,u)=>(o.set(u[0],u[1]),o),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,A.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(J,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(J,v):C?C.value=v:e.set(J,v),v},Ue=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[104],we([0,1,2,11,3,5,7,30,39,34,20,40,15,27,4,17,21,16,76,170,12]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a,p,m,y,l,d){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(de){function B(W){if(W!=null)return W}de.from=B;function j(W){if(W!=null)return W}de.to=j})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(de){function B(W){if(W!=null)return W}de.from=B;function j(W){if(W!=null)return W}de.to=j})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(de){function B(W){if(W!=null)return W}de.from=B;function j(W){if(W!=null)return W}de.to=j})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(de){function B(P){if(P){const H=P;return H&&!!H.process}else return!1}de.is=B;function j(P){if(P!=null){const H={process:P.process,args:P.args};return P.options&&(H.options=s.from(P.options)),H}}de.from=j;function W(P){if(P!=null)return new E.ProcessExecution(P.process,P.args,P.options)}de.to=W})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(de){function B(W){if(W!=null)return W}de.from=B;function j(W){if(W!=null)return W}de.to=j})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var w;(function(de){function B(P){if(P){const H=P;return H&&(!!H.commandLine||!!H.command)}else return!1}de.is=B;function j(P){if(P!=null){const H={};return P.commandLine!==void 0?H.commandLine=P.commandLine:(H.command=P.command,H.args=P.args),P.options&&(H.options=u.from(P.options)),H}}de.from=j;function W(P){if(!(P==null||P.command===void 0&&P.commandLine===void 0))return P.commandLine?new E.ShellExecution(P.commandLine,P.options):new E.ShellExecution(P.command,P.args?P.args:[],P.options)}de.to=W})(w=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(de){function B(P){if(P){let H=P;return H&&H.customExecution==="customExecution"}else return!1}de.is=B;function j(P){return{customExecution:"customExecution"}}de.from=j;function W(P,H){return H.get(P)}de.to=W})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var I;(function(de){function B(j,W){let P;return j.scope!==void 0&&typeof j.scope!="number"?P=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===E.TaskScope.Workspace&&W&&W.workspaceFile?P=W.workspaceFile:P=l.USER_TASKS_GROUP_KEY),{id:j._id,workspaceFolder:P}}de.from=B})(I=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(de){function B(P,H){if(P==null)return[];const L=[];for(let $ of P){const Q=j($,H);Q&&L.push(Q)}return L}de.fromMany=B;function j(P,H){if(P!=null){let L;P.execution instanceof E.ProcessExecution?L=o.from(P.execution):P.execution instanceof E.ShellExecution?L=w.from(P.execution):P.execution&&P.execution instanceof E.CustomExecution&&(L=b.from(P.execution));const $=t.from(P.definition);let Q;if(P.scope?typeof P.scope=="number"?Q=P.scope:Q=P.scope.uri:Q=E.TaskScope.Workspace,!(!$||!Q)){const q=P.group?P.group.id:void 0;return{_id:P._id,definition:$,name:P.name,source:{extensionId:H.identifier.value,label:P.source,scope:Q},execution:L,isBackground:P.isBackground,group:q,presentationOptions:n.from(P.presentationOptions),problemMatchers:P.problemMatchers,hasDefinedMatchers:P.hasDefinedMatchers,runOptions:P.runOptions?P.runOptions:{reevaluateOnRerun:!0},detail:P.detail}}}}de.from=j;async function W(P,H,L){if(P!=null){let $;o.is(P.execution)?$=o.to(P.execution):w.is(P.execution)?$=w.to(P.execution):b.is(P.execution)&&($=b.to(P._id,L));const Q=t.to(P.definition);let q;if(P.source&&(P.source.scope!==void 0?typeof P.source.scope=="number"?q=P.source.scope:q=await H.resolveWorkspaceFolder(v.URI.revive(P.source.scope)):q=E.TaskScope.Workspace),!(!Q||!q)){const ae=new E.Task(Q,q,P.name,P.source.label,$,P.problemMatchers);return P.isBackground!==void 0&&(ae.isBackground=P.isBackground),P.group!==void 0&&(ae.group=E.TaskGroup.from(P.group)),P.presentationOptions&&(ae.presentationOptions=n.to(P.presentationOptions)),P._id&&(ae._id=P._id),P.detail&&(ae.detail=P.detail),ae}}}de.to=W})(h=e.TaskDTO||(e.TaskDTO={}));var _;(function(de){function B(W){return W}de.from=B;function j(W){if(!!W)return Object.assign(Object.create(null),W)}de.to=j})(_=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(B,j,W){this._id=j,this._task=W,f.set(this,void 0),it(this,f,B,"f")}get task(){return this._task}terminate(){Ue(this,f,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}f=new WeakMap;var N;(function(de){function B(j){return{id:j._id,task:void 0}}de.from=B})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let z=class{constructor(B,j,W,P,H,L,$,Q){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=B.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=P,this._configurationService=H,this._terminalService=L,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=Q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,j,W){if(!W)return new E.Disposable(()=>{});const P=this.nextHandle();return this._handlers.set(P,{type:j,provider:W,extension:B}),this._proxy.$registerTaskProvider(P,j),new E.Disposable(()=>{this._handlers.delete(P),this._proxy.$unregisterTaskProvider(P)})}registerTaskSystem(B,j){this._proxy.$registerTaskSystem(B,j)}fetchTasks(B){return this._proxy.$fetchTasks(_.from(B)).then(async j=>{const W=[];for(let P of j){const H=await h.to(P,this._workspaceProvider,this._providedCustomExecutions2);H&&W.push(H)}return W})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(j=>B.push(j)),B}terminateTask(B){if(!(B instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,j,W){const P=this._providedCustomExecutions2.get(B.id);if(P){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,P),this._terminalService.attachPtyToTerminal(j,await P.callback(W))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const j=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:j})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const j=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:j,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const j=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:j,exitCode:B.exitCode})}$provideTasks(B,j){const W=this._handlers.get(B);if(!W)return Promise.reject(new Error("no handler found"));const P=[],H=(0,R.asPromise)(()=>W.provider.provideTasks(i.CancellationToken.None)).then(L=>this.provideTasksInternal(j,P,W,L));return new Promise(L=>{H.then($=>{Promise.all(P).then(()=>{L($)})})})}async $resolveTask(B,j){const W=this._handlers.get(B);if(!W)return Promise.reject(new Error("no handler found"));if(j.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${W.type}].`);const P=await h.to(j,this._workspaceProvider,this._providedCustomExecutions2);if(!P)throw new Error("Unexpected: Task cannot be resolved.");const H=await W.provider.resolveTask(P,i.CancellationToken.None);if(!!H){this.checkDeprecation(H,W);const L=h.from(H,W.extension);if(!L)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==P.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(L.execution)&&await this.addCustomExecution(L,H,!0),await this.resolveTaskInternal(L)}}nextHandle(){return this._handleCounter++}async addCustomExecution(B,j,W){const P=await this._proxy.$createTaskId(B);!W&&!this._providedCustomExecutions2.has(P)&&this._notProvidedCustomExecutions.add(P),this._providedCustomExecutions2.set(P,j.execution)}async getTaskExecution(B,j){if(typeof B=="string"){const H=this._taskExecutionPromises.get(B);if(!H)throw new Error("Unexpected: The specified task is missing an execution");return H}let W=this._taskExecutionPromises.get(B.id);if(W)return W;const P=new Promise(async(H,L)=>{const $=j||await h.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);$?H(new F(this,B.id,$)):L("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,P),P.then(H=>(this._taskExecutions.set(B.id,H),H),H=>Promise.reject(H))}checkDeprecation(B,j){B._deprecated&&this._deprecationService.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let W=this._notProvidedCustomExecutions.values(),P=W.next();for(;!P.done;)!this._activeCustomExecutions2.has(P.value)&&this._lastStartedTask!==P.value&&(this._providedCustomExecutions2.delete(P.value),this._notProvidedCustomExecutions.delete(P.value)),P=W.next()}};z=qe([Ke(0,c.IExtHostRpcService),Ke(1,g.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,S.IExtHostDocumentsAndEditors),Ke(4,k.IExtHostConfiguration),Ke(5,A.IExtHostTerminalService),Ke(6,m.ILogService),Ke(7,y.IExtHostApiDeprecationService)],z),e.ExtHostTaskBase=z;let ce=class extends z{constructor(B,j,W,P,H,L,$,Q){super(B,j,W,P,H,L,$,Q);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(B,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const W=h.from(j,B);if(W===void 0)throw new Error("Task is not valid");if(b.is(W.execution))await this.addCustomExecution(W,j,!1);else throw new d.NotSupportedError;const P=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),j);return this._proxy.$executeTask(W).catch(H=>{throw new Error(H)}),P}provideTasksInternal(B,j,W,P){const H=[];if(P)for(let L of P){this.checkDeprecation(L,W),(!L.definition||!B[L.definition.type])&&this._logService.warn(`The task [${L.source}, ${L.name}] uses an undefined task type. The task will be ignored in the future.`);const $=h.from(L,W.extension);$&&b.is($.execution)?(H.push($),j.push(this.addCustomExecution($,L,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:W.extension}}async resolveTaskInternal(B){if(b.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,j,W){}};ce=qe([Ke(0,c.IExtHostRpcService),Ke(1,g.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,S.IExtHostDocumentsAndEditors),Ke(4,k.IExtHostConfiguration),Ke(5,A.IExtHostTerminalService),Ke(6,m.ILogService),Ke(7,y.IExtHostApiDeprecationService)],ce),e.WorkerExtHostTask=ce,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(J,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(J,v):C?C.value=v:e.set(J,v),v},Ue=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)},qt=this&&this.__rest||function(J,e){var v={};for(var R in J)Object.prototype.hasOwnProperty.call(J,R)&&e.indexOf(R)<0&&(v[R]=J[R]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(J);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(J,R[C])&&(v[R[C]]=J[R[C]]);return v};define(be[217],we([0,1,13,11,24,20,3,54,43,6,23,10,2,31,5,39,15,71,9,7,30,181,97]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a,p,m,y,l,d,f,t){"use strict";var n,s,o,u;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const w=(W,P)=>`${W}:${P.toString()}`;let b=class{constructor(P,H,L){this.documents=H,this.workspace=L,this.resultsChangedEmitter=new E.Emitter,this.controllers=new Map,this.ownedTests=new f.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=P.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new I(this.proxy),this.workspaceObservers=new B(this.proxy),this.textDocumentObservers=new j(this.proxy,H)}registerTestController(P,H){const L=(0,g.generateUuid)();this.controllers.set(L,{instance:H,extensionId:P}),this.proxy.$registerTestController(L);const $=[...this.testControllers.keys()];return setTimeout(()=>{var Q;for(const q of $)(Q=this.testControllers.get(q))===null||Q===void 0||Q.subscribeFn(L,H)},0),new l.Disposable(()=>{this.controllers.delete(L),this.proxy.$unregisterTestController(L)})}createTextDocumentTestObserver(P){return this.textDocumentObservers.checkout(P.uri)}createWorkspaceTestObserver(P){return this.workspaceObservers.checkout(P.uri)}async runTests(P,H=T.CancellationToken.None){const L=$=>$.map(this.getInternalTestForReference,this).filter(A.isDefined).map(Q=>({src:Q.src,testId:Q.item.extId}));await this.proxy.$runTests({exclude:P.exclude?L(P.exclude).map($=>$.testId):void 0,tests:L(P.tests),debug:P.debug},H)}createTestRun(P,H,L,$=!0){return this.runQueue.createTestRun(P,H,L,$)}$publishTestResults(P){this.results=Object.freeze(P.map(H=>(0,i.deepFreeze)(y.TestResults.to(H))).concat(this.results).sort((H,L)=>L.completedAt-H.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(P,H){const L=c.URI.revive(H),$=w(P,L);if(!this.testControllers.has($)){const Q=new T.CancellationTokenSource;let q;if(P===1){let Fe=this.documents.getDocument(L);if(!Fe){const He=new k.DisposableStore;Fe=await new Promise(x=>{He.add((0,R.disposableTimeout)(()=>x(void 0),5e3)),He.add(this.documents.onDidAddDocuments(G=>{const ee=G.find(ie=>ie.document.uri.toString()===L.toString());ee&&x(ee)}))}).finally(()=>He.dispose())}if(Fe){const He=await this.workspace.getWorkspaceFolder2(L,!1);q=x=>x.createDocumentTestRoot?x.createDocumentTestRoot(Fe.document,Q.token):(0,e.createDefaultDocumentTestRoot)(x,Fe.document,He,Q.token)}}else{const Fe=await this.workspace.getWorkspaceFolder2(L,!1);Fe&&(q=He=>He.createWorkspaceTestRoot(Fe,Q.token))}if(!!q){const ae=async(Fe,He)=>{try{const x=await q(He);x&&Le.addRoot(x,Fe)}catch(x){console.error(x)}},fe=new k.DisposableStore,Le=fe.add(this.ownedTests.createForHierarchy(Fe=>this.proxy.$publishDiff(P,H,Fe)));fe.add((0,k.toDisposable)(()=>Q.dispose(!0)));const xe=[];for(const[Fe,He]of this.controllers)xe.push(ae(Fe,He.instance));Promise.all(xe).then(()=>Le.pushDiff([3,-1])),this.testControllers.set($,{store:fe,collection:Le,subscribeFn:ae})}}}async $expandTest(P,H){const L=(0,v.mapFind)(this.testControllers.values(),$=>$.collection.treeId===P.src.tree?$:void 0);await(L==null?void 0:L.collection.expand(P.testId,H<0?Infinity:H)),this.flushCollectionDiffs()}$unsubscribeFromTests(P,H){var L;const $=c.URI.revive(H),Q=w(P,$);(L=this.testControllers.get(Q))===null||L===void 0||L.store.dispose(),this.testControllers.delete(Q)}$acceptDiff(P,H,L){P===1?this.textDocumentObservers.acceptDiff(c.URI.revive(H),L):this.workspaceObservers.acceptDiff(c.URI.revive(H),L)}async $runTestsForProvider(P,H){const L=this.controllers.get(P.tests[0].src.controller);if(!!L){const $=P.tests.map(({testId:ae,src:fe})=>this.ownedTests.getTestById(ae,fe==null?void 0:fe.tree)).filter(A.isDefined).map(([ae,fe])=>fe),Q=P.excludeExtIds.map(ae=>this.ownedTests.getTestById(ae)).filter(A.isDefined).filter(([ae,fe])=>$.some(Le=>ae.comparePositions(Le,fe)===1));if(!!$.length){const q={tests:$.map(ae=>N.unwrap(ae.actual)),exclude:Q.map(([,ae])=>N.unwrap(ae.actual)),debug:P.debug};await this.runQueue.enqueueRun({dto:h.fromInternal(P),token:H,extensionId:L.extensionId,req:q,doRun:()=>L.instance.runTests(q,H)})}}}$lookupTest(P){const H=this.ownedTests.getTestById(P.testId);if(!H)return Promise.resolve(void 0);const L=H[1],{actual:$,discoverCts:Q,expandLevels:q}=L,ae=qt(L,["actual","discoverCts","expandLevels"]);return Promise.resolve(ae)}flushCollectionDiffs(){for(const{collection:P}of this.testControllers.values())P.flushDiff()}getInternalTestForReference(P){var H,L;return(L=(H=this.workspaceObservers.getMirroredTestDataByReference(P))!==null&&H!==void 0?H:(0,v.mapFind)(this.testControllers.values(),$=>$.collection.getTestByReference(P)))!==null&&L!==void 0?L:this.textDocumentObservers.getMirroredTestDataByReference(P)}};b=qe([Ke(0,p.IExtHostRpcService),Ke(1,a.IExtHostDocumentsAndEditors),Ke(2,d.IExtHostWorkspace)],b),e.ExtHostTesting=b;class I{constructor(P){this.proxy=P,this.state=new Map}enqueueRun(P){let H=this.state.get(P.extensionId);H||(H={queue:[],current:void 0},this.state.set(P.extensionId,H));const L=new R.DeferredPromise,$=()=>{const Q=[],q=new Set;H.current={publicReq:P.req,factory:ae=>{const fe=new _(ae,P.dto,q,this.proxy);return Q.push(fe),P.token.onCancellationRequested(()=>fe.end()),fe}},this.invokeRunner(P.extensionId,P.dto.id,P.doRun,Q).finally(()=>L.complete())};return H.queue.push($),H.queue.length===1&&$(),L.p}createTestRun(P,H,L,$){var Q,q;const ae=this.state.get(P);if((ae==null?void 0:ae.current.publicReq)===H)return ae.current.factory(L);const fe=h.fromPublic(H),Le=new _(L,fe,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:H.debug,exclude:(q=(Q=H.exclude)===null||Q===void 0?void 0:Q.map(xe=>xe.id))!==null&&q!==void 0?q:[],id:fe.id,tests:H.tests.map(xe=>xe.id),persist:$}),Le.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(fe.id)),Le}invokeRunner(P,H,L,$){try{const Q=L();return(0,R.isThenable)(Q)?Q.then(()=>this.handleInvokeResult(P,H,$,void 0)).catch(q=>this.handleInvokeResult(P,H,$,q)):this.handleInvokeResult(P,H,$,void 0)}catch(Q){return this.handleInvokeResult(P,H,$,Q)}}async handleInvokeResult(P,H,L,$){const Q=this.state.get(P);!Q||(Q.queue.shift(),Q.queue.length>0?Q.queue[0]():this.state.delete(P),await Promise.all(L.map(q=>q.onEnd.wait())))}}class h{constructor(P,H,L){this.id=P,this.include=H,this.exclude=L}static fromPublic(P){var H,L;return new h((0,g.generateUuid)(),new Set(P.tests.map($=>$.id)),new Set((L=(H=P.exclude)===null||H===void 0?void 0:H.map($=>$.id))!==null&&L!==void 0?L:S.Iterable.empty()))}static fromInternal(P){return new h(P.runId,new Set(P.tests.map(H=>H.testId)),new Set(P.excludeExtIds))}isIncluded(P){for(let H=P;H;H=H.parent){if(this.include.has(H.id))return!0;if(this.exclude.has(H.id))return!1}return!0}}class _{constructor(P,H,L,$){this.name=P,n.set(this,void 0),s.set(this,void 0),o.set(this,(0,g.generateUuid)()),u.set(this,void 0),this.onEnd=new R.Barrier,it(this,n,$,"f"),it(this,s,H,"f"),it(this,u,L,"f"),$.$startedTestRunTask(H.id,{id:Ue(this,o,"f"),name:P,running:!0})}setState(P,H,L){Ue(this,s,"f").isIncluded(P)&&(this.ensureTestIsKnown(P),Ue(this,n,"f").$updateTestStateInRun(Ue(this,s,"f").id,Ue(this,o,"f"),P.id,H,L))}appendMessage(P,H){Ue(this,s,"f").isIncluded(P)&&(this.ensureTestIsKnown(P),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,s,"f").id,Ue(this,o,"f"),P.id,y.TestMessage.from(H)))}appendOutput(P){Ue(this,n,"f").$appendOutputToRun(Ue(this,s,"f").id,Ue(this,o,"f"),C.VSBuffer.fromString(P))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,s,"f").id,Ue(this,o,"f")),this.onEnd.open()}ensureTestIsKnown(P){const H=Ue(this,u,"f");if(!H.has(P.id)){const L=[];for(;L.unshift(y.TestItem.from(P)),!(H.has(P.id)||(H.add(P.id),!P.parent));)P=P.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,s,"f").id,L)}}}n=new WeakMap,s=new WeakMap,o=new WeakMap,u=new WeakMap;const F=async(W,P,H,L)=>{if(!!H){const $=await W.createWorkspaceTestRoot(H,L);if(!!$){L.onCancellationRequested(()=>{N.removeFilter(P)});const Q=N.getWrapperForTestItem($,P);return Q.refreshMatch(),Q}}};e.createDefaultDocumentTestRoot=F;class N extends l.TestItemImpl{constructor(P,H,L){super(P.id,P.label,P.uri,void 0);if(this.actual=P,this.filterDocument=H,this.actualParent=L,!(P instanceof l.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${P.id} did not`);this.debuggable=P.debuggable,this.runnable=P.runnable,this.description=P.description,this.error=P.error,this.status=P.status,this.range=P.range,this.resolveHandler=P.resolveHandler;const $=(0,m.getPrivateApiFor)(this);(0,m.getPrivateApiFor)(P).bus.event(q=>{switch(q[0]){case 3:this[q[1]]=q[2];break;case 0:const ae=N.getWrapperForTestItem(q[1],this.filterDocument,this);(0,m.getPrivateApiFor)(ae).parent=P,ae.refreshMatch();break;default:$.bus.fire(q)}})}static removeFilter(P){this.wrapperMap.delete(P)}static getWrapperForTestItem(P,H,L){let $=this.wrapperMap.get(H);if($==null?void 0:$.has(P))return $.get(P);$||($=new WeakMap,this.wrapperMap.set(H,$));const Q=new N(P,H,L);return $.set(P,Q),Q}static unwrap(P){return P instanceof N?P.actual:P}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var P,H;const L=this._cachedMatchesFilter;for(const Q of this.actual.children.values()){const q=N.getWrapperForTestItem(Q,this.filterDocument,this);q.hasNodeMatchingFilter?this.children.has(q.id)||this.addChild(q):q.dispose()}const $=this.children.size>0||((P=this.actual.uri)===null||P===void 0?void 0:P.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=$,$!==L&&((H=this.actualParent)===null||H===void 0||H.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,m.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,m.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=N,N.wrapperMap=new WeakMap;class z extends t.IncrementalChangeCollector{constructor(P){super();this.emitter=P,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(P){this.added.add(P)}update(P){Object.assign(P.revived,y.TestItem.toPlain(P.item)),this.added.has(P)||this.updated.add(P)}remove(P){if(this.added.has(P)){this.added.delete(P);return}if(this.updated.delete(P),P.parent&&this.alreadyRemoved.has(P.parent)){this.alreadyRemoved.add(P.item.extId);return}this.removed.add(P)}getChangeEvent(){const{added:P,updated:H,removed:L}=this;return{get added(){return[...P].map($=>$.revived)},get updated(){return[...H].map($=>$.revived)},get removed(){return[...L].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ce extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new E.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(P){let H=[];for(const L of P){const $=this.items.get(L);$&&H.push($.revived)}return H}getMirroredTestDataById(P){return this.items.get(P)}getMirroredTestDataByReference(P){return this.items.get(P.id)}createItem(P,H){return Object.assign(Object.assign({},P),{revived:y.TestItem.toPlain(P.item),depth:H?H.depth+1:0,children:new Set})}createChangeCollector(){return new z(this.changeEmitter)}}e.MirroredTestCollection=ce;class de{constructor(){this.resources=new Map}checkout(P){var H,L;const $=P.toString(),Q=(H=this.resources.get($))!==null&&H!==void 0?H:this.createObserverData(P);return(L=Q.pendingDeletion)===null||L===void 0||L.dispose(),Q.observers++,{onDidChangeTest:Q.tests.onDidChangeTests,onDidDiscoverInitialTests:new E.Emitter().event,get tests(){return Q.tests.rootTestItems},dispose:(0,D.once)(()=>{--Q.observers||(Q.pendingDeletion=this.eventuallyDispose(P))})}}getMirroredTestDataByReference(P){for(const{tests:H}of this.resources.values()){const L=H.getMirroredTestDataByReference(P);if(L)return L}}eventuallyDispose(P){return(0,R.disposableTimeout)(()=>this.unlisten(P),10*1e3)}createObserverData(P){const H=new ce,L=this.listen(P,Q=>H.apply(Q)),$={observers:0,tests:H,listener:L};return this.resources.set(P.toString(),$),$}unlisten(P){var H;const L=P.toString(),$=this.resources.get(L);$&&($.observers=-1,(H=$.pendingDeletion)===null||H===void 0||H.dispose(),$.listener.dispose(),this.resources.delete(L))}}class B extends de{constructor(P){super();this.proxy=P,this.diffListeners=new Map}acceptDiff(P,H){var L;(L=this.diffListeners.get(P.toString()))===null||L===void 0||L(H)}listen(P,H){this.proxy.$subscribeToDiffs(0,P);const L=P.toString();return this.diffListeners.set(L,H),new l.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,P),this.diffListeners.delete(L)})}}class j extends de{constructor(P,H){super();this.proxy=P,this.documents=H,this.diffListeners=new Map}acceptDiff(P,H){var L;(L=this.diffListeners.get(P.toString()))===null||L===void 0||L(H)}listen(P,H){if(!this.documents.getDocument(P))return new l.Disposable(()=>{});const $=P.toString();return this.diffListeners.set($,H),this.proxy.$subscribeToDiffs(1,P),new l.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,P),this.diffListeners.delete($)})}}}),define(be[218],we([0,1,13,52,28,59,22,17,14,25,8,10,2,117,140,93,48,173,216,41]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a,p,m,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(I,h,_,F){this.configurationService=I,this.workspaceContextService=h,this.editorGroupsService=_,this.pathService=F}text(I,h,_={}){I=this.getContentPattern(I,_);const F=this.configurationService.getValue(),N=h&&h.some(ce=>!this.configurationService.getValue({resource:ce}).search.useRipgrep),z=this.commonQuery(h==null?void 0:h.map(p.toWorkspaceFolder),_);return Object.assign(Object.assign({},z),{type:2,contentPattern:I,previewOptions:_.previewOptions,maxFileSize:_.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:_.beforeContext,afterContext:_.afterContext,userDisabledExcludesAndIgnoreFiles:_.disregardExcludeSettings&&_.disregardIgnoreFiles})}getContentPattern(I,h){const _=this.configurationService.getValue();I.isRegExp&&(I.pattern=I.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},I),{wordSeparators:_.editor.wordSeparators});return this.isCaseSensitive(I,h)&&(F.isCaseSensitive=!0),this.isMultiline(I)&&(F.isMultiline=!0),F}file(I,h={}){const _=this.commonQuery(I,h);return Object.assign(Object.assign({},_),{type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey})}handleIncludeExclude(I,h){return I?(I=Array.isArray(I)?I.map(o):o(I),h?this.parseSearchPaths(I):{pattern:t(...Array.isArray(I)?I:[I])}):{}}commonQuery(I=[],h={}){const _=this.handleIncludeExclude(h.includePattern,h.expandPatterns),F=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),N=I.length>1,z=(_.searchPaths&&_.searchPaths.length?_.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,h,F)):I.map(B=>this.getFolderQueryForRoot(B,h,F,N))).filter(B=>!!B),ce={_reason:h._reason,folderQueries:z,usingSearchPaths:!!(_.searchPaths&&_.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:F.pattern,includePattern:_.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const j=v.coalesce(v.flatten(this.editorGroupsService.groups.map(P=>P.editors.map(H=>H.resource)))).filter(P=>(0,l.pathIncludedInQuery)(ce,P.fsPath)),W=this.commonQueryFromFileList(j);return Object.assign(Object.assign({},ce),W)}const de=h.extraFileResources&&h.extraFileResources.filter(B=>(0,l.pathIncludedInQuery)(ce,B.fsPath));return ce.extraFileResources=de&&de.length?de:void 0,ce}commonQueryFromFileList(I){const h=[],_=new E.ResourceMap,F={};let N=!1;return I.forEach(z=>{var ce,de;if(z.scheme!==D.Schemas.walkThrough)if((0,k.isAbsolutePath)(z)){const j=(de=(ce=this.workspaceContextService.getWorkspaceFolder(z))===null||ce===void 0?void 0:ce.uri)!==null&&de!==void 0?de:z.with({path:S.dirname(z.fsPath)});let W=_.get(j);W||(N=!0,W={folder:j,includePattern:{}},h.push(W),_.set(j,W));const P=S.relative(j.fsPath,z.fsPath);(0,A.assertIsDefined)(W.includePattern)[P.replace(/\\/g,"/")]=!0}else z.fsPath&&(N=!0,F[z.fsPath]=!0)}),{folderQueries:h,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(I,h){if(h.isSmartCase){if(I.isRegExp){if(i.containsUppercaseCharacter(I.pattern,!0))return!0}else if(i.containsUppercaseCharacter(I.pattern))return!0}return!!I.isCaseSensitive}isMultiline(I){return I.isMultiline||I.isRegExp&&(0,g.isMultilineRegexSource)(I.pattern)||I.pattern.indexOf(`
`)>=0?!0:!!I.isMultiline}parseSearchPaths(I){const h=W=>S.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),F=(Array.isArray(I)?I:n(I)).map(W=>{const P=this.pathService.resolvedUserHome;return P?(0,T.untildify)(W,P.scheme===D.Schemas.file?P.fsPath:P.path):W}),N=R.groupBy(F,W=>h(W)?"searchPaths":"exprSegments"),z=(N.exprSegments||[]).map(W=>i.rtrim(W,"/")).map(W=>i.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),s(W))),ce={},de=this.expandSearchPathPatterns(N.searchPaths||[]);de&&de.length&&(ce.searchPaths=de);const B=v.flatten(z),j=t(...B);return j&&(ce.pattern=j),ce}getExcludesForFolder(I,h){return h.disregardExcludeSettings?void 0:(0,l.getExcludes)(I,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(I){if(!I||!I.length)return[];const h=v.flatten(I.map(F=>{let{pathPortion:N,globPortion:z}=f(F);z&&(z=u(z));const ce=this.expandOneSearchPath(N);return v.flatten(ce.map(de=>this.resolveOneSearchPathPattern(de,z)))})),_=new Map;return h.forEach(F=>{const N=F.searchPath.toString(),z=_.get(N);z?F.pattern&&(z.pattern=z.pattern||{},z.pattern[F.pattern]=!0):_.set(N,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(_.values())}expandOneSearchPath(I){if(S.isAbsolute(I)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==D.Schemas.file?[{searchPath:h[0].uri.with({path:I})}]:[{searchPath:c.URI.file(S.normalize(I))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(I=o(I),I.startsWith("../")||I===".."){const F=S.posix.resolve(h.path,I);return[{searchPath:h.with({path:F})}]}const _=u(I);return[{searchPath:h,pattern:_}]}else{if(I==="./"||I===".\\")return[];{const h=I.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(N=>{const z=h.match(new RegExp(`^${N.name}(?:/(.*))?`));return z?{match:z,folder:N}:null}).filter(A.isDefined);if(F.length)return F.map(N=>{const z=N.match[1];return{searchPath:N.folder.uri,pattern:z&&u(z)}});{const N=I.match(/\.[\/\\](.+)[\/\\]?/),z=N?N[1]:I,ce=r.localize(0,null,z);throw new Error(ce)}}}}resolveOneSearchPathPattern(I,h){const _=I.pattern&&h?`${I.pattern}/${h}`:I.pattern||h,F=[{searchPath:I.searchPath,pattern:_}];return _&&!_.endsWith("**")&&F.push({searchPath:I.searchPath,pattern:_+"/**"}),F}getFolderQueryForSearchPath(I,h,_){const F=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(I.searchPath),h,_,!1);return F?Object.assign(Object.assign({},F),{includePattern:I.pattern}):null}getFolderQueryForRoot(I,h,_,F){let N;const z=c.URI.isUri(I)?I:I.uri;if(_.searchPaths){const W=_.searchPaths.filter(P=>(0,k.isEqual)(P.searchPath,z))[0];if(W&&!W.pattern)return null;W&&(N=W.pattern)}const ce=this.configurationService.getValue({resource:z}),de=this.getExcludesForFolder(ce,h),B=Object.assign(Object.assign({},de||{}),N||{}),j=c.URI.isUri(I)?(0,k.basename)(I):I.name;return{folder:z,folderName:F?j:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:ce.files&&ce.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!ce.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!ce.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!ce.search.followSymlinks}}};d=qe([Ke(0,a.IConfigurationService),Ke(1,p.IWorkspaceContextService),Ke(2,m.IEditorGroupsService),Ke(3,y.IPathService)],d),e.QueryBuilder=d;function f(b){const I=b.match(/[\*\{\}\(\)\[\]\?]/);if(I){const h=I.index,_=b.substr(0,h).match(/[/|\\][^/\\]*$/);if(_){let F=b.substr(0,_.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:b.substr((_.index||0)+1)}}}return{pathPortion:b}}function t(...b){return b.length?b.reduce((I,h)=>(I[h]=!0,I),Object.create(null)):void 0}function n(b){return C.splitGlobAware(b,",").map(I=>I.trim()).filter(I=>!!I.length)}function s(b){return[`**/${b}/**`,`**/${b}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function o(b){return b.replace(/\\/g,"/")}function u(b){return o(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(b,I){b=v.distinct(b,F=>F.toString());const h=[],_=I.getWorkspace();return b&&b.forEach(F=>{let N;if(I.getWorkbenchState()===2)N=(0,k.relativePath)(_.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const z=I.getWorkspaceFolder(F);if(z){const ce=z.name;if(_.folders.filter(B=>B.name===ce).length===1){const B=(0,k.relativePath)(z.uri,F);B===""?N=`./${z.name}`:N=`./${z.name}/${B}`}else N=F.fsPath}}N&&h.push(N)}),h}e.resolveResourcesForSearchIncludes=w}),define(be[219],we([0,1,25,2,20,12,4,218,41,48]),function(J,e,v,R,C,T,E,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function A(a,p){const m=p.activationEvents;if(!m)return Promise.resolve(void 0);const y=[],l=[];for(const o of m)if(/^workspaceContains:/.test(o)){const u=o.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||a.forceUsingSearch?l.push(u):y.push(u)}if(y.length===0&&l.length===0)return Promise.resolve(void 0);let d;const f=new Promise((o,u)=>{d=o}),t=o=>d({activationEvent:o}),n=Promise.all(y.map(o=>c(a,o,t))).then(()=>{}),s=g(a,p.identifier,l,t);return Promise.all([n,s]).then(()=>{d(void 0)}),f}e.checkActivateWorkspaceContainsExtension=A;async function c(a,p,m){for(const y of a.folders)if(await a.exists(v.joinPath(R.URI.revive(y),p))){m(`workspaceContains:${p}`);return}}async function g(a,p,m,y){if(m.length===0)return Promise.resolve(void 0);const l=new C.CancellationTokenSource,d=a.checkExists(a.folders,m,l.token),f=setTimeout(async()=>{l.cancel(),y(`workspaceContainsTimeout:${m.join(",")}`)},i);let t=!1;try{t=await d}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}l.dispose(),clearTimeout(f),t&&y(`workspaceContains:${m.join(",")}`)}function r(a,p,m,y){const l=a.get(E.IInstantiationService),d=a.get(S.ISearchService),t=l.createInstance(D.QueryBuilder).file(p.map(n=>(0,k.toWorkspaceFolder)(R.URI.revive(n))),{_reason:"checkExists",includePattern:m,exists:!0});return d.fileSearch(t,y).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=r});var it=this&&this.__classPrivateFieldSet||function(J,e,v,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(J,v):C?C.value=v:e.set(J,v),v},Ue=this&&this.__classPrivateFieldGet||function(J,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(J):R?R.value:e.get(J)};define(be[35],we([0,1,132,14,81,25,11,6,22,2,16,5,34,184,79,30,33,182,12,26,24,160,7,68,4,27,80,15,66,72,40,3,219,75,161]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a,p,m,y,l,d,f,t,n,s,o,u,w,b,I,h,_,F,N,z){"use strict";var ce,de,B;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let j=class Fn extends D.Disposable{constructor(L,$,Q,q,ae,fe,Le,xe,Fe,He){super();this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=$,this._extHostContext=Q,this._initData=Le,this._extHostWorkspace=q,this._extHostConfiguration=ae,this._logService=fe,this._extHostTunnelService=Fe,this._extHostTerminalService=He,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(A.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(A.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(A.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new E.Barrier,this._readyToStartExtensionHost=new E.Barrier,this._readyToRunExtensions=new E.Barrier,this._eagerExtensionsActivated=new E.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=xe,this._instaService=L.createChild(new b.ServiceCollection([r.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));const x=new Set;this._initData.hostExtensions.forEach(G=>x.add(l.ExtensionIdentifier.toKey(G))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(G,ee,ie)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(G,y.transformErrorForSerialization(ee),ie)},actualActivateExtension:async(G,ee)=>{if(x.has(l.ExtensionIdentifier.toKey(G)))return await this._mainThreadExtensionsProxy.$activateExtension(G,ee),new g.HostExtension;const ie=this._registry.getExtensionDescription(G);return this._activateExtension(ie,ee)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(L){y.onUnexpectedError(L)}}async deactivateAll(){let L=[];try{L=this._registry.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this._deactivate(ae))}catch($){}await Promise.all(L)}isActivated(L){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(L):!1}_activateByEvent(L,$){return this._activator.activateByEvent(L,$)}_activateById(L,$){return this._activator.activateById(L,$)}activateByIdWithErrors(L,$){return this._activateById(L,$).then(()=>{const Q=this._activator.getActivatedExtension(L);if(Q.activationFailed)return Promise.reject(Q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(L=>this._registry)}getExtensionExports(L){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(L).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const L=S.TernarySearchTree.forPaths(),$=this._registry.getAllExtensionDescriptions().map(Q=>{if(!!this._getEntryPoint(Q))return this._hostUtils.realpath(Q.extensionLocation.fsPath).then(q=>L.set(k.URI.file(q).fsPath,Q))});this._extensionPathIndex=Promise.all($).then(()=>L)}return this._extensionPathIndex}_deactivate(L){let $=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(L))return $;const Q=this._activator.getActivatedExtension(L);if(!Q)return $;try{typeof Q.module.deactivate=="function"&&($=Promise.resolve(Q.module.deactivate()).then(void 0,q=>(this._logService.error(q),Promise.resolve(void 0))))}catch(q){this._logService.error(q)}try{(0,D.dispose)(Q.subscriptions)}catch(q){this._logService.error(q)}return $}async _activateExtension(L,$){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(L.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(L.identifier),this._doActivateExtension(L,$).then(Q=>{const q=Q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(L.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,$),this._logExtensionActivationTimes(L,$,"success",q),Q},Q=>{throw this._logExtensionActivationTimes(L,$,"failure"),Q})}_logExtensionActivationTimes(L,$,Q,q){const ae=W(L,$);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ae),q||{}),{outcome:Q}))}_doActivateExtension(L,$){const Q=W(L,$);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Q);const q=this._getEntryPoint(L);if(!q)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${L.identifier.value} ${JSON.stringify($)}`),this._logService.flush();const ae=new g.ExtensionActivationTimesBuilder($.startup);return Promise.all([this._loadCommonJSModule(L.identifier,(0,T.joinPath)(L.extensionLocation,q),ae),this._loadExtensionContext(L)]).then(fe=>(C.mark(`code/extHost/willActivateExtension/${L.identifier.value}`),Fn._callActivate(this._logService,L.identifier,fe[0],fe[1],ae))).then(fe=>(C.mark(`code/extHost/didActivateExtension/${L.identifier.value}`),fe))}_loadExtensionContext(L){const $=new f.ExtensionGlobalMemento(L,this._storage),Q=new f.ExtensionMemento(L.identifier.value,!1,this._storage),q=new z.ExtensionSecrets(L,this._secretState),ae=L.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,fe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${L.identifier.value}`),Promise.all([$.whenReady,Q.whenReady,this._storagePath.whenReady]).then(()=>{const Le=this;let xe;return Object.freeze({globalState:$,workspaceState:Q,secrets:q,subscriptions:[],get extensionUri(){return L.extensionLocation},get extensionPath(){return L.extensionLocation.fsPath},asAbsolutePath(Fe){return R.join(L.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Le._storagePath.workspaceValue(L))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Le._storagePath.globalValue(L).fsPath},get logPath(){return R.join(Le._initData.logsLocation.fsPath,L.identifier.value)},get logUri(){return k.URI.joinPath(Le._initData.logsLocation,L.identifier.value)},get storageUri(){return Le._storagePath.workspaceValue(L)},get globalStorageUri(){return Le._storagePath.globalValue(L)},get extensionMode(){return ae},get extension(){return xe===void 0&&(xe=new P(Le,L.identifier,L,fe)),xe},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(L),Le.extensionRuntime},get environmentVariableCollection(){return Le._extHostTerminalService.getEnvironmentVariableCollection(L)}})})}static _callActivate(L,$,Q,q,ae){return Q=Q||{activate:void 0,deactivate:void 0},this._callActivateOptional(L,$,Q,q,ae).then(fe=>new g.ActivatedExtension(!1,null,ae.build(),Q,fe,q.subscriptions))}static _callActivateOptional(L,$,Q,q,ae){if(typeof Q.activate=="function")try{ae.activateCallStart(),L.trace(`ExtensionService#_callActivateOptional ${$.value}`);const fe=typeof global=="object"?global:self,Le=Q.activate.apply(fe,[q]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(Le).then(xe=>(ae.activateResolveStop(),xe))}catch(fe){return Promise.reject(fe)}else return Promise.resolve(Q)}_activateOneStartupFinished(L,$){this._activateById(L.identifier,{startup:!1,extensionId:L.identifier,activationEvent:$}).then(void 0,Q=>{this._logService.error(Q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const L of this._registry.getAllExtensionDescriptions())if(L.activationEvents)for(const $ of L.activationEvents)$==="onStartupFinished"&&this._activateOneStartupFinished(L,$)}_handleEagerExtensions(){const L=this._activateByEvent("*",!0).then(void 0,ae=>{this._logService.error(ae)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ae=>this._handleWorkspaceContainsEagerExtensions(ae.added)));const $=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Q=this._handleWorkspaceContainsEagerExtensions($),q=Promise.all([L,Q]).then(()=>{});return Promise.race([q,(0,E.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),q}_handleWorkspaceContainsEagerExtensions(L){return L.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map($=>this._handleWorkspaceContainsEagerExtension(L,$))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(L,$){if(!this.isActivated($.identifier)){const Q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={folders:L.map(fe=>fe.uri),forceUsingSearch:Q,exists:fe=>this._hostUtils.exists(fe.fsPath),checkExists:(fe,Le,xe)=>this._mainThreadWorkspaceProxy.$checkExists(fe,Le,xe)},ae=await(0,F.checkActivateWorkspaceContainsExtension)(q,$);if(!!ae)return this._activateById($.identifier,{startup:!0,extensionId:$.identifier,activationEvent:ae.activationEvent}).then(void 0,fe=>this._logService.error(fe))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(L){throw console.error(L),L}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:L,extensionTestsLocationURI:$}=this._initData.environment;if(!L||!$)throw new Error(v.localize(0,null));const Q=await this._loadCommonJSModule(null,$,new g.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(v.localize(1,null,$.toString()));return new Promise((q,ae)=>{const fe=(Fe,He)=>{Fe?ae(Fe):q(typeof He=="number"&&He>0?1:0)},Le=(0,T.originalFSPath)($),xe=Q.run(Le,fe);xe&&xe.then&&xe.then(()=>{q(0)}).catch(Fe=>{ae(Fe.toString())})})}async $extensionTestsExit(L){this._logService.info(`extension host terminating: test runner requested exit with code ${L}`),this._logService.info(`exiting with code ${L}`),this._logService.flush(),this._hostUtils.exit(L)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(L,$){return this._resolvers[L]=$,(0,D.toDisposable)(()=>{delete this._resolvers[L]})}async $resolveAuthority(L,$){const Q=L.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const q=L.substr(0,Q);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1);const ae=this._resolvers[q];if(!ae)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ae)),C.mark(`code/extHost/willResolveAuthority/${q}`);const fe=await ae.resolve(L,{resolveAttempt:$});C.mark(`code/extHost/didResolveAuthorityOK/${q}`);const Le={authority:L,host:fe.host,port:fe.port,connectionToken:fe.connectionToken},xe={extensionHostEnv:fe.extensionHostEnv,trust:fe.trust};return{type:"ok",value:{authority:Le,options:xe,tunnelInformation:{environmentTunnels:fe.environmentTunnels}}}}catch(fe){if(C.mark(`code/extHost/didResolveAuthorityError/${q}`),fe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:fe._code,message:fe._message,detail:fe._detail}};throw fe}}$startExtensionHost(L){return this._registry.keepOnly(L),this._startExtensionHost()}$activateByEvent(L,$){return $===1?this._activateByEvent(L,!1):this._readyToRunExtensions.wait().then(Q=>this._activateByEvent(L,!1))}async $activate(L,$){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(L)?(await this._activateById(L,$),!0):!1}async $deltaExtensions(L,$){L.forEach(q=>q.extensionLocation=k.URI.revive(q.extensionLocation));const Q=await this.getExtensionPathIndex();return await Promise.all($.map(async q=>{const ae=this._registry.getExtensionDescription(q);if(!!ae){const fe=await this._hostUtils.realpath(ae.extensionLocation.fsPath);Q.delete(k.URI.file(fe).fsPath)}})),await Promise.all(L.map(async q=>{const ae=await this._hostUtils.realpath(q.extensionLocation.fsPath);Q.set(k.URI.file(ae).fsPath,q)})),this._registry.deltaExtensions(L,$),Promise.resolve(void 0)}async $test_latency(L){return L}async $test_up(L){return L.byteLength}async $test_down(L){let $=d.VSBuffer.alloc(L),Q=Math.random()%256;for(let q=0;q<L;q++)$.writeUInt8(Q,q);return $}async $updateRemoteConnectionData(L){this._remoteConnectionData=L,this._onDidChangeRemoteConnectionData.fire()}};j=qe([Ke(0,s.IInstantiationService),Ke(1,e.IHostUtils),Ke(2,w.IExtHostRpcService),Ke(3,a.IExtHostWorkspace),Ke(4,c.IExtHostConfiguration),Ke(5,i.ILogService),Ke(6,o.IExtHostInitDataService),Ke(7,u.IExtensionStoragePaths),Ke(8,I.IExtHostTunnelService),Ke(9,h.IExtHostTerminalService)],j),e.AbstractExtHostExtensionService=j;function W(H,L){return{id:H.identifier.value,name:H.name,extensionVersion:H.version,publisherDisplayName:H.publisher,activationEvents:H.activationEvents?H.activationEvents.join(","):null,isBuiltin:H.isBuiltin,reason:L.activationEvent,reasonId:L.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class P{constructor(L,$,Q,q){ce.set(this,void 0),de.set(this,void 0),B.set(this,void 0),it(this,ce,L,"f"),it(this,de,$,"f"),it(this,B,Q.identifier,"f"),this.id=Q.identifier.value,this.extensionUri=Q.extensionLocation,this.extensionPath=R.normalize((0,T.originalFSPath)(Q.extensionLocation)),this.packageJSON=Q,this.extensionKind=q}get isActive(){return Ue(this,ce,"f").isActivated(Ue(this,B,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,ce,"f").getExtensionExports(Ue(this,B,"f"))}activate(){return Ue(this,ce,"f").activateByIdWithErrors(Ue(this,B,"f"),{startup:!1,extensionId:Ue(this,de,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=P,ce=new WeakMap,de=new WeakMap,B=new WeakMap}),define(be[105],we([0,1,14,2,3,11,5,7,168,30,35,39,172,34,169,15,4,10,46,70]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a,p,m,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let d=class{constructor(b,I,h,_,F,N){this._workspaceService=I,this._extensionService=h,this._editorsService=_,this._configurationService=F,this._editorTabs=N,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=b.getProxy(E.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(z=>{z.onDidChange(ce=>{this.registerAllDebugTypes(z)}),this.registerAllDebugTypes(z)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(b,I){const h=b;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let _=`debug:${encodeURIComponent(h.path||"")}`,F="?";return I&&(_+=`${F}session=${encodeURIComponent(I.id)}`,F="&"),_+=`${F}ref=${h.sourceReference}`,R.URI.parse(_)}else{if(h.path)return R.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(b){const I=[];for(const h of b.getAllExtensionDescriptions())if(h.contributes){const _=h.contributes.debuggers;if(_&&_.length>0)for(const F of _)(0,r.isDebuggerMainContribution)(F)&&I.push(F.type)}this._debugServiceProxy.$registerDebugTypes(I)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const b=[];return this._breakpoints.forEach(I=>b.push(I)),b}addBreakpoints(b){this.startBreakpoints();const I=b.filter(F=>{const N=F.id;return this._breakpoints.has(N)?!1:(this._breakpoints.set(N,F),!0)});this.fireBreakpointChanges(I,[],[]);const h=[],_=new Map;for(const F of I)if(F instanceof D.SourceBreakpoint){let N=_.get(F.location.uri.toString());N||(N={type:"sourceMulti",uri:F.location.uri,lines:[]},_.set(F.location.uri.toString(),N),h.push(N)),N.lines.push({id:F.id,enabled:F.enabled,condition:F.condition,hitCondition:F.hitCondition,logMessage:F.logMessage,line:F.location.range.start.line,character:F.location.range.start.character})}else F instanceof D.FunctionBreakpoint&&h.push({type:"function",id:F.id,enabled:F.enabled,hitCondition:F.hitCondition,logMessage:F.logMessage,condition:F.condition,functionName:F.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(b){this.startBreakpoints();const I=b.filter(N=>this._breakpoints.delete(N.id));this.fireBreakpointChanges([],I,[]);const h=I.filter(N=>N instanceof D.SourceBreakpoint).map(N=>N.id),_=I.filter(N=>N instanceof D.FunctionBreakpoint).map(N=>N.id),F=I.filter(N=>N instanceof D.DataBreakpoint).map(N=>N.id);return this._debugServiceProxy.$unregisterBreakpoints(h,_,F)}startDebugging(b,I,h){return this._debugServiceProxy.$startDebugging(b?b.uri:void 0,I,{parentSessionID:h.parentSession?h.parentSession.id:void 0,repl:h.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact})}stopDebugging(b){return this._debugServiceProxy.$stopDebugging(b?b.id:void 0)}registerDebugConfigurationProvider(b,I,h){if(!I)return new D.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:b,handle:_,provider:I}),this._debugServiceProxy.$registerDebugConfigurationProvider(b,h,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,_),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(F=>F.provider!==I),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(b,I,h){if(!h)return new D.Disposable(()=>{});if(!this.definesDebugType(b,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.getAdapterDescriptorFactoryByType(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:I,handle:_,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(I,_),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(F=>F.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(b,I){if(!I)return new D.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:b,handle:h,factory:I}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==I)})}async $runInTerminal(b,I){return Promise.resolve(void 0)}async $substituteVariables(b,I){if(!this._variableResolver){const[F,N]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(F||[],this._editorsService,N)}let h;const _=await this.getFolder(b);return _&&(h={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,I)}createDebugAdapter(b,I){if(b.type==="implementation")return new o(b.implementation)}createSignService(){}async $startDASession(b,I){const h=this,_=await this.getSession(I);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const N=this.convertToDto(F),z=this.createDebugAdapter(N,_);if(!z)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const ce=z;return this._debugAdapters.set(b,ce),this.getDebugAdapterTrackers(_).then(de=>(de&&this._debugAdaptersTrackers.set(b,de),ce.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const j=B,W={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const P=await this._signService.sign(j.arguments.value);W.body={signature:P},ce.sendResponse(W)}else throw new Error("no signer")}catch(P){W.success=!1,W.message=P.message,ce.sendResponse(W)}}else de&&de.onDidSendMessage&&de.onDidSendMessage(B),B=(0,r.convertToVSCPaths)(B,!0),h._debugServiceProxy.$acceptDAMessage(b,B)}),ce.onError(B=>{de&&de.onError&&de.onError(B),this._debugServiceProxy.$acceptDAError(b,B.name,B.message,B.stack)}),ce.onExit(B=>{de&&de.onExit&&de.onExit((0,m.withNullAsUndefined)(B),void 0),this._debugServiceProxy.$acceptDAExit(b,(0,m.withNullAsUndefined)(B),void 0)}),de&&de.onWillStartSession&&de.onWillStartSession(),ce.startSession()))})}$sendDAMessage(b,I){I=(0,r.convertToDAPaths)(I,!1);const h=this._debugAdaptersTrackers.get(b);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(I);const _=this._debugAdapters.get(b);_&&_.sendMessage(I)}$stopDASession(b){const I=this._debugAdaptersTrackers.get(b);this._debugAdaptersTrackers.delete(b),I&&I.onWillStopSession&&I.onWillStopSession();const h=this._debugAdapters.get(b);return this._debugAdapters.delete(b),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(b){const I=[],h=[],_=[];if(b.added)for(const F of b.added){const N=F.id;if(N&&!this._breakpoints.has(N)){let z;if(F.type==="function")z=new D.FunctionBreakpoint(F.functionName,F.enabled,F.condition,F.hitCondition,F.logMessage);else if(F.type==="data")z=new D.DataBreakpoint(F.label,F.dataId,F.canPersist,F.enabled,F.hitCondition,F.condition,F.logMessage);else{const ce=R.URI.revive(F.uri);z=new D.SourceBreakpoint(new D.Location(ce,new D.Position(F.line,F.character)),F.enabled,F.condition,F.hitCondition,F.logMessage)}z._id=N,this._breakpoints.set(N,z),I.push(z)}}if(b.removed)for(const F of b.removed){const N=this._breakpoints.get(F);N&&(this._breakpoints.delete(F),h.push(N))}if(b.changed){for(const F of b.changed)if(F.id){const N=this._breakpoints.get(F.id);if(N){if(N instanceof D.FunctionBreakpoint&&F.type==="function"){const z=N;z.enabled=F.enabled,z.condition=F.condition,z.hitCondition=F.hitCondition,z.logMessage=F.logMessage,z.functionName=F.functionName}else if(N instanceof D.SourceBreakpoint&&F.type==="source"){const z=N;z.enabled=F.enabled,z.condition=F.condition,z.hitCondition=F.hitCondition,z.logMessage=F.logMessage,z.location=new D.Location(R.URI.revive(F.uri),new D.Position(F.line,F.character))}_.push(N)}}}this.fireBreakpointChanges(I,h,_)}$provideDebugConfigurations(b,I,h){return(0,T.asPromise)(async()=>{const _=this.getConfigProviderByHandle(b);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const F=await this.getFolder(I);return _.provideDebugConfigurations(F,h)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(b,I,h,_){return(0,T.asPromise)(async()=>{const F=this.getConfigProviderByHandle(b);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const N=await this.getFolder(I);return F.resolveDebugConfiguration(N,h,_)})}$resolveDebugConfigurationWithSubstitutedVariables(b,I,h,_){return(0,T.asPromise)(async()=>{const F=this.getConfigProviderByHandle(b);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const N=await this.getFolder(I);return F.resolveDebugConfigurationWithSubstitutedVariables(N,h,_)})}async $provideDebugAdapter(b,I){const h=this.getAdapterDescriptorFactoryByHandle(b);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(I);return this.getAdapterDescriptor(h,_).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(F)})}async $acceptDebugSessionStarted(b){const I=await this.getSession(b);this._onDidStartDebugSession.fire(I)}async $acceptDebugSessionTerminated(b){const I=await this.getSession(b);I&&(this._onDidTerminateDebugSession.fire(I),this._debugSessions.delete(I.id))}async $acceptDebugSessionActiveChanged(b){this._activeDebugSession=b?await this.getSession(b):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(b,I){const h=await this.getSession(b);h&&h._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent(b,I){const _={session:await this.getSession(b),event:I.event,body:I.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(b){if(b instanceof D.DebugAdapterExecutable)return{type:"executable",command:b.command,args:b.args,options:b.options};if(b instanceof D.DebugAdapterServer)return{type:"server",port:b.port,host:b.host};if(b instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:b.path};if(b instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:b.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(b){const I=this._adapterFactories.filter(h=>h.type===b);if(I.length>0)return I[0].factory}getAdapterDescriptorFactoryByHandle(b){const I=this._adapterFactories.filter(h=>h.handle===b);if(I.length>0)return I[0].factory}getConfigProviderByHandle(b){const I=this._configProviders.filter(h=>h.handle===b);if(I.length>0)return I[0].provider}definesDebugType(b,I){if(b.contributes){const h=b.contributes.debuggers;if(h&&h.length>0){for(const _ of h)if(_.label&&_.type&&_.type===I)return!0}}return!1}getDebugAdapterTrackers(b){const h=b.configuration.type,_=this._trackerFactories.filter(F=>F.type===h||F.type==="*").map(F=>(0,T.asPromise)(()=>F.factory.createDebugAdapterTracker(b)).then(N=>N,N=>null));return Promise.race([Promise.all(_).then(F=>{const N=F.filter(z=>!!z);if(N.length>0)return new s(N)}),new Promise((F,N)=>{const z=setTimeout(()=>{clearTimeout(z),N(new Error("timeout"))},1e3)})]).catch(F=>{})}async getAdapterDescriptor(b,I){const h=I.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new D.DebugAdapterServer(h));if(b){const F=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>b.createDebugAdapterDescriptor(I,this.daExecutableFromPackage(I,F))).then(N=>{if(N)return N})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(I,_))}daExecutableFromPackage(b,I){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(b,I,h){(b.length>0||I.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:b,removed:I,changed:h}))}async getSession(b){if(b)if(typeof b=="string"){const I=this._debugSessions.get(b);if(I)return I}else{let I=this._debugSessions.get(b.id);if(!I){const h=await this.getFolder(b.folderUri),_=b.parent?this._debugSessions.get(b.parent):void 0;I=new f(this._debugServiceProxy,b.id,b.type,b.name,h,b.configuration,_),this._debugSessions.set(I.id,I),this._debugServiceProxy.$sessionCached(I.id)}return I}throw new Error("cannot find session")}getFolder(b){if(b){const I=R.URI.revive(b);return this._workspaceService.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}};d=qe([Ke(0,a.IExtHostRpcService),Ke(1,k.IExtHostWorkspace),Ke(2,i.IExtHostExtensionService),Ke(3,A.IExtHostDocumentsAndEditors),Ke(4,g.IExtHostConfiguration),Ke(5,l.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class f{constructor(b,I,h,_,F,N,z){this._debugServiceProxy=b,this._id=I,this._type=h,this._name=_,this._workspaceFolder=F,this._configuration=N,this._parentSession=z}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(b){this._name=b,this._debugServiceProxy.$setDebugSessionName(this._id,b)}get parentSession(){return this._parentSession}_acceptNameChanged(b){this._name=b}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(b,I){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,b,I)}getDebugProtocolBreakpoint(b){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,b.id)}}e.ExtHostDebugSession=f;class t{constructor(b){this.value=Object.freeze({append(I){b.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.ExtHostDebugConsole=t;class n extends c.AbstractVariableResolverService{constructor(b,I,h,_,F){function N(){if(I){const z=I.activeEditor();if(z)return z.document.uri;const ce=_.tabs.filter(de=>de.isActive);if(ce.length>0)return ce[0].resource}}super({getFolderUri:z=>{const ce=b.filter(de=>de.name===z);if(ce&&ce.length>0)return ce[0].uri},getWorkspaceFolderCount:()=>b.length,getConfigurationValue:(z,ce)=>h.getConfiguration(void 0,z).get(ce),getAppRoot:()=>y.cwd(),getExecPath:()=>y.env.VSCODE_EXEC_PATH,getFilePath:()=>{const z=N();if(z)return v.normalize(z.fsPath)},getWorkspaceFolderPathForFile:()=>{if(F){const z=N();if(z){const ce=F.getWorkspaceFolder(z);if(ce)return v.normalize(ce.uri.fsPath)}}},getSelectedText:()=>{if(I){const z=I.activeEditor();if(z&&!z.selection.isEmpty)return z.document.getText(z.selection)}},getLineNumber:()=>{if(I){const z=I.activeEditor();if(z)return String(z.selection.end.line+1)}}},void 0,Promise.resolve(y.env))}}e.ExtHostVariableResolverService=n;class s{constructor(b){this.trackers=b}onWillStartSession(){this.trackers.forEach(b=>b.onWillStartSession?b.onWillStartSession():void 0)}onWillReceiveMessage(b){this.trackers.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage(b):void 0)}onDidSendMessage(b){this.trackers.forEach(I=>I.onDidSendMessage?I.onDidSendMessage(b):void 0)}onWillStopSession(){this.trackers.forEach(b=>b.onWillStopSession?b.onWillStopSession():void 0)}onError(b){this.trackers.forEach(I=>I.onError?I.onError(b):void 0)}onExit(b,I){this.trackers.forEach(h=>h.onExit?h.onExit(b,I):void 0)}}class o extends S.AbstractDebugAdapter{constructor(b){super();this.implementation=b,b.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage(b){this.implementation.handleMessage(b)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends d{constructor(b,I,h,_,F,N){super(b,I,h,_,F,N)}createVariableResolver(b,I,h){return new n(b,I,h,this._editorTabs)}};u=qe([Ke(0,a.IExtHostRpcService),Ke(1,k.IExtHostWorkspace),Ke(2,i.IExtHostExtensionService),Ke(3,A.IExtHostDocumentsAndEditors),Ke(4,g.IExtHostConfiguration),Ke(5,l.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(be[220],we([0,1,81,2,5,34,33,26,15,27,4,35,46,16]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(l,d,f,t,n,s,o){this._apiFactory=l,this._extensionRegistry=d,this._instaService=f,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),v.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,d,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,d,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let d of l.nodeModuleName)this._factories.set(d,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(d=>l.alternativeModuleName(d))}};r=qe([Ke(2,i.IInstantiationService),Ke(3,T.IExtHostConfiguration),Ke(4,A.IExtHostExtensionService),Ke(5,k.IExtHostInitDataService),Ke(6,g.ILogService)],r),e.RequireInterceptor=r;class a{constructor(l,d,f,t,n){this._apiFactory=l,this._extensionPaths=d,this._extensionRegistry=f,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,d){const f=this._extensionPaths.findSubstr(d.fsPath);if(f){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(f.identifier));return t||(t=this._apiFactory(f,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(f.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(E.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(l,d){this.nodeModuleName="keytar";const{environment:f}=d,t=l.getProxy(C.MainContext.MainThreadKeytar);if(f.appRoot){let n=f.appRoot.fsPath;c.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,o)=>t.$setPassword(n,s,o),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(l,d){return this._impl}alternativeModuleName(l){const d=l.length;if(!(d<=7||!this.alternativeNames)){const f=d-7;if((l.charAt(f)==="/"||l.charAt(f)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}}};p=qe([Ke(0,S.IExtHostRpcService),Ke(1,k.IExtHostInitDataService)],p);let m=class{constructor(l,d,f){this._extensionPaths=l,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=f.getProxy(C.MainContext.MainThreadTelemetry);const t=f.getProxy(C.MainContext.MainThreadWindow);this._impl=(n,s)=>{const o=R.URI.parse(n);return s?this.callOriginal(n,s):o.scheme==="http"||o.scheme==="https"?t.$openUri(o,n,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?t.$openUri(o,n,{}):this.callOriginal(n,s)}}load(l,d,f){const t=this._extensionPaths.findSubstr(d.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=f(l),this._impl}callOriginal(l,d){return this.sendNoForwardTelemetry(),this._original(l,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=qe([Ke(2,S.IExtHostRpcService)],m)}),define(be[221],we([0,1,11,12,81,6,2,5,213,16,62,66,27,151,15,73,35,40]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class y{constructor(d,f,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new S.RPCProtocol(d,null,n),f=y._transform(f,this._rpcProtocol);const s=new A.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(c.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},f)),s.set(r.IExtHostRpcService,new r.ExtHostRpcService(this._rpcProtocol)),s.set(a.IURITransformerService,new a.URITransformerService(n)),s.set(p.IHostUtils,t);const o=new g.InstantiationService(s,!0),u=o.invokeFunction(h=>h.get(m.IExtHostTerminalService));this._disposables.add(u),this._logService=o.invokeFunction(h=>h.get(k.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",f),this._extensionService=o.invokeFunction(h=>h.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const w=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(_,F)=>{let N="",z,ce;for(const de of F)N+=`
	at ${de.toString()}`,ce=de.getFileName(),!z&&ce&&(z=h.findSubstr(ce));return w.set(_,z),`${_.name||"Error"}: ${_.message||""}${N}`}});const b=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),I=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(h=>{const _=R.transformErrorForSerialization(h),F=w.get(h);F?b.$onExtensionRuntimeError(F.identifier,_):I.$onUnexpectedError(_)})}terminate(d){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const f=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,v.timeout)(4e3),f]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(d,f){d.extensions.forEach(n=>n.extensionLocation=E.URI.revive(f.transformIncomingURIs(n.extensionLocation))),d.environment.appRoot=E.URI.revive(f.transformIncomingURIs(d.environment.appRoot));const t=d.environment.extensionDevelopmentLocationURI;return t&&(d.environment.extensionDevelopmentLocationURI=t.map(n=>E.URI.revive(f.transformIncomingURIs(n)))),d.environment.extensionTestsLocationURI=E.URI.revive(f.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=E.URI.revive(f.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=E.URI.revive(f.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=E.URI.revive(f.transformIncomingURIs(d.logsLocation)),d.logFile=E.URI.revive(f.transformIncomingURIs(d.logFile)),d.workspace=f.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=y}),define(be[222],we([0,1,14,20,61,28,25,56,41]),function(J,e,v,R,C,T,E,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(c,g,r){this.config=c,this.provider=g,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&T.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&T.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const g=this.config.folderQueries||[];return new Promise((r,a)=>{const p=m=>{this.resultCount++,c(m)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const y=m.toString(),l=v.basename(y);this.globalExcludePattern&&this.globalExcludePattern(y,l)||this.matchFile(p,{base:m,basename:l})}),Promise.all(g.map(m=>this.searchInFolder(m,p))).then(m=>{r({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{a(new Error((0,C.toErrorMessage)(m)))})})}async searchInFolder(c,g){const r=new R.CancellationTokenSource,a=this.getSearchOptionsForFolder(c),p=this.initDirectoryTree(),m=new S.QueryGlobTester(this.config,c),y=!m.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(r),l=D.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,r.token),f=l.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(n=>{const s=v.posix.relative(c.folder.path,n.path);if(y){const o=v.basename(n.path);this.matchFile(g,{base:c.folder,relativePath:s,basename:o});return}this.addDirectoryEntries(p,c.folder,s,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,m,g),{providerTime:f,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(c){const g=(0,S.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),r=(0,S.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:r,includes:g,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},g,r,a){if(r===this.filePattern){const m=v.basename(this.filePattern);this.matchFile(a,{base:g,relativePath:this.filePattern,basename:m})}function p(m){const y=v.basename(m),l=v.dirname(m);let d=c[l];d||(d=c[l]=[],p(l)),d.push({base:g,relativePath:m,basename:y})}p(r)}matchDirectoryTree({rootEntries:c,pathToEntries:g},r,a){const p=this,m=this.filePattern;function y(l){const d=T.hasSiblingFn(()=>l.map(f=>f.basename));for(let f=0,t=l.length;f<t;f++){const n=l[f],{relativePath:s,basename:o}=n;if(!!r.includedInQuerySync(s,o,m!==o?d:void 0)){const u=g[s];if(u)y(u);else{if(s===m)continue;p.matchFile(a,n)}if(p.isLimitHit)break}}}y(c)}matchFile(c,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(g))}}class i{constructor(){this.sessions=new Map}fileSearch(c,g,r,a){const p=this.getSessionTokenSource(c.cacheKey),m=new k(c,g,p&&p.token);let y=0;const l=d=>{y+=d.length,r(d.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(m,i.BATCH_SIZE,l,a).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:y,detailStats:d.stats}}))}clearCache(c){const g=this.getSessionTokenSource(c);g&&g.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new R.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:E.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,g,r,a){a.onCancellationRequested(()=>{c.cancel()});const p=y=>{y&&(m.push(y),g>0&&m.length>=g&&(r(m),m=[]))};let m=[];return c.search(p).then(y=>(m.length&&r(m),y),y=>(m.length&&r(m),Promise.reject(y)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(be[223],we([0,1,14,13,20,61,25,28,2,41,17,10]),function(J,e,v,R,C,T,E,D,S,k,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(l,d,f){this.query=l,this.provider=d,this.fileUtils=f,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,d){const f=this.query.folderQueries||[],t=new C.CancellationTokenSource;return d.onCancellationRequested(()=>t.cancel()),new Promise((n,s)=>{this.collector=new r(l);let o=!1;const u=(w,b)=>{if(!o&&!this.isLimitHit){const I=this.resultSize(w);p(w)&&typeof this.query.maxResults=="number"&&this.resultCount+I>this.query.maxResults&&(this.isLimitHit=!0,o=!0,t.cancel(),w=this.trimResultToSize(w,this.query.maxResults-this.resultCount));const h=this.resultSize(w);this.resultCount+=h,(h>0||!p(w))&&this.collector.add(w,b)}};Promise.all(f.map((w,b)=>this.searchInFolder(w,I=>u(I,b),t.token))).then(w=>{t.dispose(),this.collector.flush();const b=w.some(I=>!!I&&!!I.limitHit);n({limitHit:this.isLimitHit||b,messages:(0,R.flatten)(w.map(I=>(I==null?void 0:I.message)?(0,A.isArray)(I.message)?I.message:[I.message]:[])),stats:{type:"textSearchProvider"}})},w=>{t.dispose();const b=(0,T.toErrorMessage)(w);s(new Error(b))})})}resultSize(l){return p(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,d){const f=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:f.slice(0,d),preview:{matches:t.slice(0,d),text:l.preview.text},uri:l.uri}}async searchInFolder(l,d,f){const t=new k.QueryGlobTester(this.query,l),n=[],s={report:w=>{if(!!this.validateProviderResult(w)){const b=l.folder.scheme===i.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(E.dirname(w.uri))):void 0,I=E.relativePath(l.folder,w.uri);I&&n.push(t.includedInQuery(I,v.basename(I),b).then(h=>{h&&d(w)}))}}},o=this.getSearchOptionsForFolder(l),u=await this.provider.provideTextSearchResults(g(this.query.contentPattern),o,s,f);return await Promise.all(n),u}validateProviderResult(l){if(p(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const d=(0,k.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),f=(0,k.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),t={folder:S.URI.from(l.folder),excludes:f,includes:d,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=c;function g(y){return{isCaseSensitive:y.isCaseSensitive||!1,isRegExp:y.isRegExp||!1,isWordMatch:y.isWordMatch||!1,isMultiline:y.isMultiline||!1,pattern:y.pattern}}class r{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,d=>this.sendItems(d))}add(l,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!E.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(a(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=r;function a(y){return p(y)?{preview:{matches:(0,R.mapArrayOrNot)(y.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:y.preview.text},ranges:(0,R.mapArrayOrNot)(y.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:y.text,lineNumber:y.lineNumber}}function p(y){return!!y.preview}e.extensionResultIsMatch=p;class m{constructor(l,d){this.maxBatchSize=l,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,d){!l||this.addItemToBatch(l,d)}addItems(l,d){!l||this.addItemsToBatch(l,d)}addItemToBatch(l,d){this.batch.push(l),this.batchSize+=d,this.onUpdate()}addItemsToBatch(l,d){this.batch=this.batch.concat(l),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m,m.TIMEOUT=4e3,m.START_BATCH_AFTER_COUNT=50}),define(be[106],we([0,1,6,5,4,222,15,73,16,2,223]),function(J,e,v,R,C,T,E,D,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let A=class{constructor(a,p,m){this.extHostRpc=a,this._uriTransformer=p,this._logService=m,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,p){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const m=this._handlePool++;return this._textSearchProvider.set(m,p),this._proxy.$registerTextSearchProvider(m,this._transformScheme(a)),(0,v.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(a,p){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const m=this._handlePool++;return this._fileSearchProvider.set(m,p),this._proxy.$registerFileSearchProvider(m,this._transformScheme(a)),(0,v.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(a,p,m,y){const l=c(m),d=this._fileSearchProvider.get(a);if(d)return this._fileSearchManager.fileSearch(l,d,f=>{this._proxy.$handleFileMatch(a,p,f.map(t=>t.resource))},y);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,p,m,y){const l=this._textSearchProvider.get(a);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const d=c(m);return this.createTextSearchManager(d,l).search(t=>this._proxy.$handleTextMatch(a,p,t),y)}createTextSearchManager(a,p){return new i.TextSearchManager(a,p,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};A=qe([Ke(0,E.IExtHostRpcService),Ke(1,D.IURITransformerService),Ke(2,S.ILogService)],A),e.ExtHostSearch=A;function c(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(g),extraFileResources:r.extraFileResources&&r.extraFileResources.map(a=>k.URI.revive(a))})}e.reviveQuery=c;function g(r){return Object.assign(Object.assign({},r),{folder:k.URI.revive(r.folder)})}}),define(be[224],we([0,1,20,12,3,47,2,124,86,118,60,65,5,189,188,77,190,34,191,192,193,175,194,39,35,195,176,197,198,199,101,179,202,203,204,79,40,205,180,9,7,208,51,102,30,33,52,165,196,94,100,104,105,106,16,73,15,27,200,163,72,76,186,206,162,80,78,211,209,210,187,49,217,207,75,70,95,201,68,103]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a,p,m,y,l,d,f,t,n,s,o,u,w,b,I,h,_,F,N,z,ce,de,B,j,W,P,H,L,$,Q,q,ae,fe,Le,xe,Fe,He,x,G,ee,ie,ue,Ee,$e,he,Ce,Te,We,ve,Ge,V,Z,ge,Ne,Ve,Be,Ze,Se,ye,ke,ne,oe,O,Y,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ie(_e){const Re=_e.get(Ee.IExtHostInitDataService),ze=_e.get(Ze.IExtHostFileSystemInfo),Xe=_e.get(Z.IExtHostConsumerFileSystem),st=_e.get(s.IExtHostExtensionService),Ye=_e.get(Q.IExtHostWorkspace),et=_e.get(oe.IExtHostTelemetry),pt=_e.get(m.IExtHostConfiguration),_t=_e.get(ie.IURITransformerService),je=_e.get(ue.IExtHostRpcService),me=_e.get(ce.IExtHostStorage),pe=_e.get(V.IExtensionStoragePaths),se=_e.get(ee.ILogService),K=_e.get(Ce.IExtHostTunnelService),Oe=_e.get(Te.IExtHostApiDeprecationService),Ae=_e.get($.IExtHostWindow),rt=_e.get(ke.IExtHostSecretState),tt=_e.get(ne.IExtHostEditorTabs);je.set(c.ExtHostContext.ExtHostFileSystemInfo,ze),je.set(c.ExtHostContext.ExtHostLogService,se),je.set(c.ExtHostContext.ExtHostWorkspace,Ye),je.set(c.ExtHostContext.ExtHostConfiguration,pt),je.set(c.ExtHostContext.ExtHostExtensionService,st),je.set(c.ExtHostContext.ExtHostStorage,me),je.set(c.ExtHostContext.ExtHostTunnelService,K),je.set(c.ExtHostContext.ExtHostWindow,Ae),je.set(c.ExtHostContext.ExtHostSecretState,rt),je.set(c.ExtHostContext.ExtHostTelemetry,et),je.set(c.ExtHostContext.ExtHostEditorTabs,tt);const ct=je.set(c.ExtHostContext.ExtHostDecorations,_e.get(Fe.IExtHostDecorations)),at=je.set(c.ExtHostContext.ExtHostDocumentsAndEditors,_e.get(n.IExtHostDocumentsAndEditors)),Je=je.set(c.ExtHostContext.ExtHostCommands,_e.get(a.IExtHostCommands)),ft=je.set(c.ExtHostContext.ExtHostTerminalService,_e.get(de.IExtHostTerminalService)),ut=je.set(c.ExtHostContext.ExtHostDebugService,_e.get(x.IExtHostDebugService)),mt=je.set(c.ExtHostContext.ExtHostSearch,_e.get(G.IExtHostSearch)),bt=je.set(c.ExtHostContext.ExtHostTask,_e.get(He.IExtHostTask)),kt=je.set(c.ExtHostContext.ExtHostOutputService,_e.get(h.IExtHostOutputService)),Ft=je.set(c.ExtHostContext.ExtHostUrls,new H.ExtHostUrls(je)),Et=je.set(c.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(je,at)),Lt=je.set(c.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(je,at,se)),Kt=je.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new f.ExtHostDocumentSaveParticipant(se,Et,je.getProxy(c.MainContext.MainThreadBulkEdits))),gt=je.set(c.ExtHostContext.ExtHostNotebook,new $e.ExtHostNotebookController(je,Je,at,Et,se,pe)),Gt=je.set(c.ExtHostContext.ExtHostNotebookKernels,new O.ExtHostNotebookKernels(je,Re,gt,se)),St=je.set(c.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(je,at)),zt=je.set(c.ExtHostContext.ExtHostTreeViews,new j.ExtHostTreeViews(je.getProxy(c.MainContext.MainThreadTreeViews),Je,se)),Qt=je.set(c.ExtHostContext.ExtHostEditorInsets,new fe.ExtHostEditorInsets(je.getProxy(c.MainContext.MainThreadEditorInsets),St,Re)),Ut=je.set(c.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(je,se)),dt=je.set(c.ExtHostContext.ExtHostLanguageFeatures,new w.ExtHostLanguageFeatures(je,_t,Et,Je,Ut,se,Oe)),Yt=je.set(c.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(je,dt)),It=je.set(c.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(je,se,at)),$t=je.set(c.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(je,Ye,Je)),an=je.set(c.ExtHostContext.ExtHostSCM,new N.ExtHostSCM(je,Je,se)),pn=je.set(c.ExtHostContext.ExtHostComments,new p.ExtHostComments(je,Je,Et)),ln=je.set(c.ExtHostContext.ExtHostProgress,new _.ExtHostProgress(je.getProxy(c.MainContext.MainThreadProgress))),vn=je.set(c.ExtHostContext.ExtHosLabelService,new Le.ExtHostLabelService(je)),Vt=je.set(c.ExtHostContext.ExtHostTheming,new he.ExtHostTheming(je)),At=je.set(c.ExtHostContext.ExtHostAuthentication,new We.ExtHostAuthentication(je)),bn=je.set(c.ExtHostContext.ExtHostTimeline,new ve.ExtHostTimeline(je,Je)),Jt=je.set(c.ExtHostContext.ExtHostWebviews,new L.ExtHostWebviews(je,{remote:Re.remote},Ye,se,Oe)),Xt=je.set(c.ExtHostContext.ExtHostWebviewPanels,new Ve.ExtHostWebviewPanels(je,Jt,Ye)),wn=je.set(c.ExtHostContext.ExtHostCustomEditors,new Ne.ExtHostCustomEditors(je,Et,pe,Jt,Xt)),jt=je.set(c.ExtHostContext.ExtHostWebviewViews,new ge.ExtHostWebviewViews(je,Jt)),Mt=je.set(c.ExtHostContext.ExtHostTesting,new Se.ExtHostTesting(je,at,Ye)),_n=je.set(c.ExtHostContext.ExtHostUriOpeners,new ye.ExtHostUriOpeners(je)),Zt=(0,ae.values)(c.ExtHostContext);je.assertRegistered(Zt);const En=new Be.ExtHostBulkEdits(je,at),Bt=new r.ExtHostClipboard(je),xt=new I.ExtHostMessageService(je,se),Wt=new l.ExtHostDialogs(je),Tt=new z.ExtHostStatusBar(je,Je.converter),en=new b.ExtHostLanguages(je,Et);return g.ExtHostApiCommands.register(Je),function(Me,tn,un){const vt=function(){let X=!Me.isUnderDevelopment;function le(Pe){X||(se.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Pe(ot){if(Array.isArray(ot))ot.forEach(Pe);else if(typeof ot=="string")le(ot);else{const wt=ot;typeof wt.scheme=="undefined"&&le(ot),!Me.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,q.throwProposedApiError)(Me)}return ot}}(),yn={getSession(X,le,Pe){return At.getSession(Me,X,le,Pe)},get onDidChangeSessions(){return At.onDidChangeSessions},registerAuthenticationProvider(X,le,Pe,ot){return At.registerAuthenticationProvider(X,le,Pe,ot)},get onDidChangeAuthenticationProviders(){return(0,q.checkProposedApiEnabled)(Me),At.onDidChangeAuthenticationProviders},get providers(){return(0,q.checkProposedApiEnabled)(Me),At.providers},logout(X,le){return(0,q.checkProposedApiEnabled)(Me),At.removeSession(X,le)}},Sn={registerCommand(X,le,Pe){return Je.registerCommand(!0,X,le,Pe)},registerTextEditorCommand(X,le,Pe){return Je.registerCommand(!0,X,(...ot)=>{const wt=St.getActiveTextEditor();if(!wt){se.warn("Cannot execute "+X+" because there is no active text editor.");return}return wt.edit(Dt=>{le.apply(Pe,[wt,Dt,...ot])}).then(Dt=>{Dt||se.warn("Edits from command "+X+" were not applied.")},Dt=>{se.warn("An error occurred while running command "+X,Dt)})})},registerDiffInformationCommand:(X,le,Pe)=>((0,q.checkProposedApiEnabled)(Me),Je.registerCommand(!0,X,async(...ot)=>{const wt=at.activeEditor(!0);if(!wt){se.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await St.getDiffInformation(wt.id);le.apply(Pe,[Dt,...ot])})),executeCommand(X,...le){return Je.executeCommand(X,...le)},getCommands(X=!1){return Je.getCommands(X)}},cn={get machineId(){return Re.telemetryInfo.machineId},get sessionId(){return Re.telemetryInfo.sessionId},get language(){return Re.environment.appLanguage},get appName(){return Re.environment.appName},get appRoot(){var X,le;return(le=(X=Re.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&le!==void 0?le:""},get uriScheme(){return Re.environment.appUriScheme},get clipboard(){return Bt.value},get shell(){return ft.getDefaultShell(!1)},get isTelemetryEnabled(){return et.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return et.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(Re.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,le){return Ae.openUri(X,{allowTunneling:!!Re.remote.authority,allowContributedOpeners:le==null?void 0:le.allowContributedOpeners})},asExternalUri(X){return X.scheme===Re.environment.appUriScheme?Ft.createAppUri(X):Ae.asExternalUri(X,{allowTunneling:!!Re.remote.authority})},get remoteName(){return(0,xe.getRemoteName)(Re.remote.authority)},get uiKind(){return Re.uiKind}};Re.environment.extensionTestsLocationURI||Object.freeze(cn);const dn=Re.remote.isRemote?P.ExtensionKind.Workspace:P.ExtensionKind.UI,nn={registerTestController(X){return(0,q.checkProposedApiEnabled)(Me),Mt.registerTestController(Me.identifier.value,X)},createDocumentTestObserver(X){return(0,q.checkProposedApiEnabled)(Me),Mt.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return(0,q.checkProposedApiEnabled)(Me),Mt.createWorkspaceTestObserver(X)},runTests(X){return(0,q.checkProposedApiEnabled)(Me),Mt.runTests(X)},createTestItem(X,le){return new P.TestItemImpl(X.id,X.label,X.uri,le)},createTestRun(X,le,Pe){return(0,q.checkProposedApiEnabled)(Me),Mt.createTestRun(Me.identifier.value,X,le,Pe)},get onDidChangeTestResults(){return(0,q.checkProposedApiEnabled)(Me),Mt.onResultsChanged},get testResults(){return(0,q.checkProposedApiEnabled)(Me),Mt.results}};nn.createTestRunTask=nn.createTestRun;const rn={getExtension(X){const le=tn.getExtensionDescription(X);if(le)return new s.Extension(st,Me.identifier,le,dn)},get all(){return tn.getAllExtensionDescriptions().map(X=>new s.Extension(st,Me.identifier,X,dn))},get onDidChange(){return tn.onDidChange}},Dn={createDiagnosticCollection(X){return Ut.createDiagnosticCollection(Me.identifier,X)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:X=>Ut.getDiagnostics(X),getLanguages(){return en.getLanguages()},setTextDocumentLanguage(X,le){return en.changeLanguage(X.uri,le)},match(X,le){return(0,i.score)(W.LanguageSelector.from(X),le.uri,le.languageId,!0)},registerCodeActionsProvider(X,le,Pe){return dt.registerCodeActionProvider(Me,vt(X),le,Pe)},registerCodeLensProvider(X,le){return dt.registerCodeLensProvider(Me,vt(X),le)},registerDefinitionProvider(X,le){return dt.registerDefinitionProvider(Me,vt(X),le)},registerDeclarationProvider(X,le){return dt.registerDeclarationProvider(Me,vt(X),le)},registerImplementationProvider(X,le){return dt.registerImplementationProvider(Me,vt(X),le)},registerTypeDefinitionProvider(X,le){return dt.registerTypeDefinitionProvider(Me,vt(X),le)},registerHoverProvider(X,le){return dt.registerHoverProvider(Me,vt(X),le,Me.identifier)},registerEvaluatableExpressionProvider(X,le){return dt.registerEvaluatableExpressionProvider(Me,vt(X),le,Me.identifier)},registerInlineValuesProvider(X,le){return dt.registerInlineValuesProvider(Me,vt(X),le,Me.identifier)},registerDocumentHighlightProvider(X,le){return dt.registerDocumentHighlightProvider(Me,vt(X),le)},registerLinkedEditingRangeProvider(X,le){return dt.registerLinkedEditingRangeProvider(Me,vt(X),le)},registerReferenceProvider(X,le){return dt.registerReferenceProvider(Me,vt(X),le)},registerRenameProvider(X,le){return dt.registerRenameProvider(Me,vt(X),le)},registerDocumentSymbolProvider(X,le,Pe){return dt.registerDocumentSymbolProvider(Me,vt(X),le,Pe)},registerWorkspaceSymbolProvider(X){return dt.registerWorkspaceSymbolProvider(Me,X)},registerDocumentFormattingEditProvider(X,le){return dt.registerDocumentFormattingEditProvider(Me,vt(X),le)},registerDocumentRangeFormattingEditProvider(X,le){return dt.registerDocumentRangeFormattingEditProvider(Me,vt(X),le)},registerOnTypeFormattingEditProvider(X,le,Pe,...ot){return dt.registerOnTypeFormattingEditProvider(Me,vt(X),le,[Pe].concat(ot))},registerDocumentSemanticTokensProvider(X,le,Pe){return dt.registerDocumentSemanticTokensProvider(Me,vt(X),le,Pe)},registerDocumentRangeSemanticTokensProvider(X,le,Pe){return dt.registerDocumentRangeSemanticTokensProvider(Me,vt(X),le,Pe)},registerSignatureHelpProvider(X,le,Pe,...ot){return typeof Pe=="object"?dt.registerSignatureHelpProvider(Me,vt(X),le,Pe):dt.registerSignatureHelpProvider(Me,vt(X),le,typeof Pe=="undefined"?[]:[Pe,...ot])},registerCompletionItemProvider(X,le,...Pe){return dt.registerCompletionItemProvider(Me,vt(X),le,Pe)},registerDocumentLinkProvider(X,le){return dt.registerDocumentLinkProvider(Me,vt(X),le)},registerColorProvider(X,le){return dt.registerColorProvider(Me,vt(X),le)},registerFoldingRangeProvider(X,le){return dt.registerFoldingRangeProvider(Me,vt(X),le)},registerSelectionRangeProvider(X,le){return dt.registerSelectionRangeProvider(Me,X,le)},registerCallHierarchyProvider(X,le){return dt.registerCallHierarchyProvider(Me,X,le)},setLanguageConfiguration:(X,le)=>dt.setLanguageConfiguration(Me,X,le),getTokenInformationAtPosition(X,le){return(0,q.checkProposedApiEnabled)(Me),en.tokenAtPosition(X,le)},registerInlayHintsProvider(X,le){return(0,q.checkProposedApiEnabled)(Me),dt.registerInlayHintsProvider(Me,X,le)}},Cn={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(X,le,Pe){const ot=await(E.URI.isUri(X)?Promise.resolve(hn.openTextDocument(X)):Promise.resolve(X));return St.showTextDocument(ot,le,Pe)},createTextEditorDecorationType(X){return St.createTextEditorDecorationType(X)},onDidChangeActiveTextEditor(X,le,Pe){return St.onDidChangeActiveTextEditor(X,le,Pe)},onDidChangeVisibleTextEditors(X,le,Pe){return St.onDidChangeVisibleTextEditors(X,le,Pe)},onDidChangeTextEditorSelection(X,le,Pe){return St.onDidChangeTextEditorSelection(X,le,Pe)},onDidChangeTextEditorOptions(X,le,Pe){return St.onDidChangeTextEditorOptions(X,le,Pe)},onDidChangeTextEditorVisibleRanges(X,le,Pe){return St.onDidChangeTextEditorVisibleRanges(X,le,Pe)},onDidChangeTextEditorViewColumn(X,le,Pe){return St.onDidChangeTextEditorViewColumn(X,le,Pe)},onDidCloseTerminal(X,le,Pe){return ft.onDidCloseTerminal(X,le,Pe)},onDidOpenTerminal(X,le,Pe){return ft.onDidOpenTerminal(X,le,Pe)},onDidChangeActiveTerminal(X,le,Pe){return ft.onDidChangeActiveTerminal(X,le,Pe)},onDidChangeTerminalDimensions(X,le,Pe){return(0,q.checkProposedApiEnabled)(Me),ft.onDidChangeTerminalDimensions(X,le,Pe)},onDidWriteTerminalData(X,le,Pe){return(0,q.checkProposedApiEnabled)(Me),ft.onDidWriteTerminalData(X,le,Pe)},get state(){return Ae.state},onDidChangeWindowState(X,le,Pe){return Ae.onDidChangeWindowState(X,le,Pe)},showInformationMessage(X,...le){return xt.showMessage(Me,T.default.Info,X,le[0],le.slice(1))},showWarningMessage(X,...le){return xt.showMessage(Me,T.default.Warning,X,le[0],le.slice(1))},showErrorMessage(X,...le){return xt.showMessage(Me,T.default.Error,X,le[0],le.slice(1))},showQuickPick(X,le,Pe){return $t.showQuickPick(X,!!Me.enableProposedApi,le,Pe)},showWorkspaceFolderPick(X){return $t.showWorkspaceFolderPick(X)},showInputBox(X,le){return $t.showInput(X,le)},showOpenDialog(X){return Wt.showOpenDialog(X)},showSaveDialog(X){return Wt.showSaveDialog(X)},createStatusBarItem(X,le,Pe){let ot,wt,Dt;return typeof X=="string"?(ot=X,wt=le,Dt=Pe):(wt=X,Dt=le),Tt.createStatusBarEntry(Me,ot,wt,Dt)},setStatusBarMessage(X,le){return Tt.setStatusBarMessage(X,le)},withScmProgress(X){return Oe.report("window.withScmProgress",Me,"Use 'withProgress' instead."),ln.withProgress(Me,{location:P.ProgressLocation.SourceControl},(le,Pe)=>X({report(ot){}}))},withProgress(X,le){return ln.withProgress(Me,X,le)},createOutputChannel(X){return kt.createOutputChannel(X)},createWebviewPanel(X,le,Pe,ot){return Xt.createWebviewPanel(Me,X,le,Pe,ot)},createWebviewTextEditorInset(X,le,Pe,ot){return(0,q.checkProposedApiEnabled)(Me),Qt.createWebviewEditorInset(X,le,Pe,ot,Me)},createTerminal(X,le,Pe){return typeof X=="object"?"pty"in X?ft.createExtensionTerminal(X):(X.icon&&(0,q.checkProposedApiEnabled)(Me),ft.createTerminalFromOptions(X)):ft.createTerminal(X,le,Pe)},registerTerminalLinkProvider(X){return ft.registerLinkProvider(X)},registerTreeDataProvider(X,le){return zt.registerTreeDataProvider(X,le,Me)},createTreeView(X,le){return zt.createTreeView(X,le,Me)},registerWebviewPanelSerializer:(X,le)=>Xt.registerWebviewPanelSerializer(Me,X,le),registerCustomEditorProvider:(X,le,Pe={})=>wn.registerCustomEditorProvider(Me,X,le,Pe),registerFileDecorationProvider(X){return ct.registerFileDecorationProvider(X,Me.identifier)},registerUriHandler(X){return Ft.registerUriHandler(Me.identifier,X)},createQuickPick(){return $t.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return $t.createInputBox(Me.identifier)},get activeColorTheme(){return Vt.activeColorTheme},onDidChangeActiveColorTheme(X,le,Pe){return Vt.onDidChangeActiveColorTheme(X,le,Pe)},registerWebviewViewProvider(X,le,Pe){return jt.registerWebviewViewProvider(Me,X,le,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,q.checkProposedApiEnabled)(Me),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,le,Pe){return(0,q.checkProposedApiEnabled)(Me),gt.onDidChangeActiveNotebookEditor(X,le,Pe)},get visibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Me),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Me),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,le,Pe){return(0,q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookEditorSelection(X,le,Pe)},onDidChangeNotebookEditorVisibleRanges(X,le,Pe){return(0,q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookEditorVisibleRanges(X,le,Pe)},showNotebookDocument(X,le){return(0,q.checkProposedApiEnabled)(Me),gt.showNotebookDocument(X,le)},registerExternalUriOpener(X,le,Pe){return(0,q.checkProposedApiEnabled)(Me),_n.registerExternalUriOpener(Me.identifier,X,le,Pe)},get openEditors(){return(0,q.checkProposedApiEnabled)(Me),tt.tabs},get onDidChangeOpenEditors(){return(0,q.checkProposedApiEnabled)(Me),tt.onDidChangeTabs}},hn={get rootPath(){return Oe.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ye.getPath()},set rootPath(X){throw R.readonly()},getWorkspaceFolder(X){return Ye.getWorkspaceFolder(X)},get workspaceFolders(){return Ye.getWorkspaceFolders()},get name(){return Ye.name},set name(X){throw R.readonly()},get workspaceFile(){return Ye.workspaceFile},set workspaceFile(X){throw R.readonly()},updateWorkspaceFolders:(X,le,...Pe)=>Ye.updateWorkspaceFolders(Me,X,le||0,...Pe),onDidChangeWorkspaceFolders:function(X,le,Pe){return Ye.onDidChangeWorkspace(X,le,Pe)},asRelativePath:(X,le)=>Ye.getRelativePath(X,le),findFiles:(X,le,Pe,ot)=>Ye.findFiles(W.GlobPattern.from(X),W.GlobPattern.from(le),Pe,Me.identifier,ot),findTextInFiles:(X,le,Pe,ot)=>{let wt,Dt;return typeof le=="object"?(wt=le,Dt=Pe):(wt={},Dt=le,ot=Pe),Ye.findTextInFiles(X,wt||{},Dt,Me.identifier,ot)},saveAll:X=>Ye.saveAll(X),applyEdit(X){return En.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,le,Pe,ot)=>It.createFileSystemWatcher(W.GlobPattern.from(X),le,Pe,ot),get textDocuments(){return Et.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw R.readonly()},openTextDocument(X){let le;const Pe=X;if(typeof X=="string")le=Promise.resolve(E.URI.file(X));else if(E.URI.isUri(X))le=Promise.resolve(X);else if(!Pe||typeof Pe=="object")le=Et.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ot=>Et.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(X,le,Pe)=>Et.onDidAddDocument(X,le,Pe),onDidCloseTextDocument:(X,le,Pe)=>Et.onDidRemoveDocument(X,le,Pe),onDidChangeTextDocument:(X,le,Pe)=>Et.onDidChangeDocument(X,le,Pe),onDidSaveTextDocument:(X,le,Pe)=>Et.onDidSaveDocument(X,le,Pe),onWillSaveTextDocument:(X,le,Pe)=>Kt.getOnWillSaveTextDocumentEvent(Me)(X,le,Pe),onDidChangeConfiguration:(X,le,Pe)=>un.onDidChangeConfiguration(X,le,Pe),getConfiguration(X,le){return le=arguments.length===1?void 0:le,un.getConfiguration(X,le,Me)},registerTextDocumentContentProvider(X,le){return Lt.registerTextDocumentContentProvider(X,le)},registerTaskProvider:(X,le)=>(Oe.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Me,X,le)),registerFileSystemProvider(X,le,Pe){return Yt.registerFileSystemProvider(Me.identifier,X,le,Pe,Me.enableProposedApi)},get fs(){return Xe.value},registerFileSearchProvider:(X,le)=>((0,q.checkProposedApiEnabled)(Me),mt.registerFileSearchProvider(X,le)),registerTextSearchProvider:(X,le)=>((0,q.checkProposedApiEnabled)(Me),mt.registerTextSearchProvider(X,le)),registerRemoteAuthorityResolver:(X,le)=>((0,q.checkProposedApiEnabled)(Me),st.registerRemoteAuthorityResolver(X,le)),registerResourceLabelFormatter:X=>((0,q.checkProposedApiEnabled)(Me),vn.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,le,Pe)=>It.onDidCreateFile(X,le,Pe),onDidDeleteFiles:(X,le,Pe)=>It.onDidDeleteFile(X,le,Pe),onDidRenameFiles:(X,le,Pe)=>It.onDidRenameFile(X,le,Pe),onWillCreateFiles:(X,le,Pe)=>It.getOnWillCreateFileEvent(Me)(X,le,Pe),onWillDeleteFiles:(X,le,Pe)=>It.getOnWillDeleteFileEvent(Me)(X,le,Pe),onWillRenameFiles:(X,le,Pe)=>It.getOnWillRenameFileEvent(Me)(X,le,Pe),openTunnel:X=>((0,q.checkProposedApiEnabled)(Me),K.openTunnel(Me,X).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,q.checkProposedApiEnabled)(Me),K.getTunnels()},onDidChangeTunnels:(X,le,Pe)=>((0,q.checkProposedApiEnabled)(Me),K.onDidChangeTunnels(X,le,Pe)),registerPortAttributesProvider:(X,le)=>((0,q.checkProposedApiEnabled)(Me),K.registerPortsAttributesProvider(X,le)),registerTimelineProvider:(X,le)=>((0,q.checkProposedApiEnabled)(Me),bn.registerTimelineProvider(X,le,Me.identifier,Je.converter)),get isTrusted(){return Ye.trusted},requestWorkspaceTrust:X=>((0,q.checkProposedApiEnabled)(Me),Ye.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,le,Pe)=>Ye.onDidGrantWorkspaceTrust(X,le,Pe)},kn={get inputBox(){return Oe.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),an.getLastInputBox(Me)},createSourceControl(X,le,Pe){return an.createSourceControl(Me,X,le,Pe)}},In={createCommentController(X,le){return pn.createCommentController(Me,X,le)}},Pn={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(X,le,Pe){return ut.onDidStartDebugSession(X,le,Pe)},onDidTerminateDebugSession(X,le,Pe){return ut.onDidTerminateDebugSession(X,le,Pe)},onDidChangeActiveDebugSession(X,le,Pe){return ut.onDidChangeActiveDebugSession(X,le,Pe)},onDidReceiveDebugSessionCustomEvent(X,le,Pe){return ut.onDidReceiveDebugSessionCustomEvent(X,le,Pe)},onDidChangeBreakpoints(X,le,Pe){return ut.onDidChangeBreakpoints(X,le,Pe)},registerDebugConfigurationProvider(X,le,Pe){return ut.registerDebugConfigurationProvider(X,le,Pe||P.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,le){return ut.registerDebugAdapterDescriptorFactory(Me,X,le)},registerDebugAdapterTrackerFactory(X,le){return ut.registerDebugAdapterTrackerFactory(X,le)},startDebugging(X,le,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?ut.startDebugging(X,le,{parentSession:Pe}):ut.startDebugging(X,le,Pe||{})},stopDebugging(X){return ut.stopDebugging(X)},addBreakpoints(X){return ut.addBreakpoints(X)},removeBreakpoints(X){return ut.removeBreakpoints(X)},asDebugSourceUri(X,le){return ut.asDebugSourceUri(X,le)}},fn={registerTaskProvider:(X,le)=>bt.registerTaskProvider(Me,X,le),fetchTasks:X=>bt.fetchTasks(X),executeTask:X=>bt.executeTask(Me,X),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(X,le,Pe)=>bt.onDidStartTask(X,le,Pe),onDidEndTask:(X,le,Pe)=>bt.onDidEndTask(X,le,Pe),onDidStartTaskProcess:(X,le,Pe)=>bt.onDidStartTaskProcess(X,le,Pe),onDidEndTaskProcess:(X,le,Pe)=>bt.onDidEndTaskProcess(X,le,Pe)},mn={async openNotebookDocument(X,le){(0,q.checkProposedApiEnabled)(Me);let Pe;if(E.URI.isUri(X))Pe=X,await gt.openNotebookDocument(X);else if(typeof X=="string")Pe=E.URI.revive(await gt.createNotebookDocument({viewType:X,content:le}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Pe).apiNotebook},get onDidOpenNotebookDocument(){return(0,q.checkProposedApiEnabled)(Me),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,q.checkProposedApiEnabled)(Me),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,q.checkProposedApiEnabled)(Me),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,q.checkProposedApiEnabled)(Me),gt.notebookDocuments.map(X=>X.apiNotebook)},registerNotebookSerializer(X,le,Pe,ot){return(0,q.checkProposedApiEnabled)(Me),gt.registerNotebookSerializer(Me,X,le,Pe,Me.enableProposedApi?ot:void 0)},registerNotebookContentProvider:(X,le,Pe,ot)=>((0,q.checkProposedApiEnabled)(Me),gt.registerNotebookContentProvider(Me,X,le,Pe,Me.enableProposedApi?ot:void 0)),registerNotebookCellStatusBarItemProvider:(X,le)=>((0,q.checkProposedApiEnabled)(Me),gt.registerNotebookCellStatusBarItemProvider(Me,X,le)),createNotebookEditorDecorationType(X){return(0,q.checkProposedApiEnabled)(Me),gt.createNotebookEditorDecorationType(X)},onDidChangeNotebookDocumentMetadata(X,le,Pe){return(0,q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookDocumentMetadata(X,le,Pe)},onDidChangeNotebookCells(X,le,Pe){return(0,q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCells(X,le,Pe)},onDidChangeNotebookCellExecutionState(X,le,Pe){return(0,q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCellExecutionState(X,le,Pe)},onDidChangeCellOutputs(X,le,Pe){return(0,q.checkProposedApiEnabled)(Me),gt.onDidChangeCellOutputs(X,le,Pe)},onDidChangeCellMetadata(X,le,Pe){return(0,q.checkProposedApiEnabled)(Me),gt.onDidChangeCellMetadata(X,le,Pe)},createConcatTextDocument(X,le){return(0,q.checkProposedApiEnabled)(Me),new Ge.ExtHostNotebookConcatDocument(gt,Et,X,le)},createNotebookController(X,le,Pe,ot,wt){return(0,q.checkProposedApiEnabled)(Me),Gt.createNotebookController(Me,X,le,Pe,ot,wt)}};return{version:Re.version,authentication:yn,commands:Sn,comments:In,debug:Pn,env:cn,extensions:rn,languages:Dn,notebook:mn,scm:kn,tasks:fn,test:nn,window:Cn,workspace:hn,Breakpoint:P.Breakpoint,CallHierarchyIncomingCall:P.CallHierarchyIncomingCall,CallHierarchyItem:P.CallHierarchyItem,CallHierarchyOutgoingCall:P.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:v.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:P.CodeAction,CodeActionKind:P.CodeActionKind,CodeActionTriggerKind:P.CodeActionTriggerKind,CodeLens:P.CodeLens,Color:P.Color,ColorInformation:P.ColorInformation,ColorPresentation:P.ColorPresentation,ColorThemeKind:P.ColorThemeKind,CommentMode:P.CommentMode,CommentThreadCollapsibleState:P.CommentThreadCollapsibleState,CompletionItem:P.CompletionItem,CompletionItemKind:P.CompletionItemKind,CompletionItemTag:P.CompletionItemTag,CompletionList:P.CompletionList,CompletionTriggerKind:P.CompletionTriggerKind,ConfigurationTarget:P.ConfigurationTarget,CustomExecution:P.CustomExecution,DebugAdapterExecutable:P.DebugAdapterExecutable,DebugAdapterInlineImplementation:P.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:P.DebugAdapterNamedPipeServer,DebugAdapterServer:P.DebugAdapterServer,DebugConfigurationProviderTriggerKind:P.DebugConfigurationProviderTriggerKind,DebugConsoleMode:P.DebugConsoleMode,DecorationRangeBehavior:P.DecorationRangeBehavior,Diagnostic:P.Diagnostic,DiagnosticRelatedInformation:P.DiagnosticRelatedInformation,DiagnosticSeverity:P.DiagnosticSeverity,DiagnosticTag:P.DiagnosticTag,Disposable:P.Disposable,DocumentHighlight:P.DocumentHighlight,DocumentHighlightKind:P.DocumentHighlightKind,DocumentLink:P.DocumentLink,DocumentSymbol:P.DocumentSymbol,EndOfLine:P.EndOfLine,EnvironmentVariableMutatorType:P.EnvironmentVariableMutatorType,EvaluatableExpression:P.EvaluatableExpression,InlineValueText:P.InlineValueText,InlineValueVariableLookup:P.InlineValueVariableLookup,InlineValueEvaluatableExpression:P.InlineValueEvaluatableExpression,EventEmitter:C.Emitter,ExtensionKind:P.ExtensionKind,ExtensionMode:P.ExtensionMode,ExternalUriOpenerPriority:P.ExternalUriOpenerPriority,FileChangeType:P.FileChangeType,FileDecoration:P.FileDecoration,FileSystemError:P.FileSystemError,FileType:A.FileType,FilePermission:A.FilePermission,FoldingRange:P.FoldingRange,FoldingRangeKind:P.FoldingRangeKind,FunctionBreakpoint:P.FunctionBreakpoint,Hover:P.Hover,IndentAction:k.IndentAction,Location:P.Location,MarkdownString:P.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:P.ParameterInformation,PortAutoForwardAction:P.PortAutoForwardAction,Position:P.Position,ProcessExecution:P.ProcessExecution,ProgressLocation:P.ProgressLocation,QuickInputButtons:P.QuickInputButtons,Range:P.Range,RelativePattern:P.RelativePattern,Selection:P.Selection,SelectionRange:P.SelectionRange,SemanticTokens:P.SemanticTokens,SemanticTokensBuilder:P.SemanticTokensBuilder,SemanticTokensEdit:P.SemanticTokensEdit,SemanticTokensEdits:P.SemanticTokensEdits,SemanticTokensLegend:P.SemanticTokensLegend,ShellExecution:P.ShellExecution,ShellQuoting:P.ShellQuoting,SignatureHelp:P.SignatureHelp,SignatureHelpTriggerKind:P.SignatureHelpTriggerKind,SignatureInformation:P.SignatureInformation,SnippetString:P.SnippetString,SourceBreakpoint:P.SourceBreakpoint,StandardTokenType:P.StandardTokenType,StatusBarAlignment:P.StatusBarAlignment,SymbolInformation:P.SymbolInformation,SymbolKind:P.SymbolKind,SymbolTag:P.SymbolTag,Task:P.Task,TaskGroup:P.TaskGroup,TaskPanelKind:P.TaskPanelKind,TaskRevealKind:P.TaskRevealKind,TaskScope:P.TaskScope,TextDocumentSaveReason:P.TextDocumentSaveReason,TextEdit:P.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:P.TextEditorLineNumbersStyle,TextEditorRevealType:P.TextEditorRevealType,TextEditorSelectionChangeKind:P.TextEditorSelectionChangeKind,ThemeColor:P.ThemeColor,ThemeIcon:P.ThemeIcon,TreeItem:P.TreeItem,TreeItemCollapsibleState:P.TreeItemCollapsibleState,UIKind:c.UIKind,Uri:E.URI,ViewColumn:P.ViewColumn,WorkspaceEdit:P.WorkspaceEdit,InlayHint:P.InlayHint,InlayHintKind:P.InlayHintKind,RemoteAuthorityResolverError:P.RemoteAuthorityResolverError,RemoteTrustOption:Y.RemoteTrustOption,ResolvedAuthority:P.ResolvedAuthority,SourceControlInputBoxValidationType:P.SourceControlInputBoxValidationType,ExtensionRuntime:P.ExtensionRuntime,TimelineItem:P.TimelineItem,NotebookRange:P.NotebookRange,NotebookCellKind:P.NotebookCellKind,NotebookCellExecutionState:P.NotebookCellExecutionState,NotebookDocumentMetadata:P.NotebookDocumentMetadata,NotebookCellMetadata:P.NotebookCellMetadata,NotebookCellData:P.NotebookCellData,NotebookData:P.NotebookData,NotebookKernelPreload:P.NotebookKernelPreload,NotebookCellStatusBarAlignment:P.NotebookCellStatusBarAlignment,NotebookEditorRevealType:P.NotebookEditorRevealType,NotebookCellOutput:P.NotebookCellOutput,NotebookCellOutputItem:P.NotebookCellOutputItem,NotebookCellStatusBarItem:P.NotebookCellStatusBarItem,NotebookControllerAffinity:P.NotebookControllerAffinity,PortAttributes:P.PortAttributes,LinkedEditingRanges:P.LinkedEditingRanges,TestItemStatus:P.TestItemStatus,TestResultState:P.TestResultState,TestMessage:P.TestMessage,TextSearchCompleteMessageType:re.TextSearchCompleteMessageType,TestMessageSeverity:P.TestMessageSeverity,WorkspaceTrustState:P.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ie}),define(be[225],we([0,1,62,101,30,100,34,77,39,40,104,105,106,80,79,72,76,102,78,49,75,95,70]),function(J,e,v,R,C,T,E,D,S,k,i,A,c,g,r,a,p,m,y,l,d,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,v.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,v.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,v.registerSingleton)(E.IExtHostConfiguration,E.ExtHostConfiguration),(0,v.registerSingleton)(y.IExtHostConsumerFileSystem,y.ExtHostConsumerFileSystem),(0,v.registerSingleton)(A.IExtHostDebugService,A.WorkerExtHostDebugService),(0,v.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,v.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,v.registerSingleton)(l.IExtHostFileSystemInfo,l.ExtHostFileSystemInfo),(0,v.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,v.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,v.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,v.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,v.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,v.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,v.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,v.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,v.registerSingleton)(d.IExtHostSecretState,d.ExtHostSecretState),(0,v.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,v.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(be[226],we([0,1,224,35,220,7,11,5]),function(J,e,v,R,C,T,E,D){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(r){var a;const p=(a=self.trustedTypes)===null||a===void 0?void 0:a.createPolicy("TrustedFunctionWorkaround",{createScript:(y,...l)=>{l.forEach(n=>{var s;if(!((s=self.trustedTypes)===null||s===void 0?void 0:s.isScript(n)))throw new Error("TrustedScripts only, please")});const d=l.slice(0,-1).join(","),f=l.pop().toString();return`(function anonymous(${d}) {
${f}
})`}});function m(...y){return p?self.eval(p.createScript("",...y)):new Function(...y)}r.create=m})(k||(k={}));class i extends C.RequireInterceptor{_installInterceptor(){}getModule(a,p){for(let m of this._alternatives){let y=m(a);if(y){a=y;break}}if(this._factories.has(a))return this._factories.get(a).load(a,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends R.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);g(a,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(v.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,p,m){var y,l,d,f,t,n,s,o;p=p.with({path:c(p.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const u=await fetch(p.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),u.status!==200)throw new Error(u.statusText);const w=await u.text(),b=`${p.toString(!0)}#vscode-extension`,I=`${w}
//# sourceURL=${b}`;let h;try{h=k.create((l=(y=A._ttpExtensionScripts)===null||y===void 0?void 0:y.createScript("module"))!==null&&l!==void 0?l:"module",(f=(d=A._ttpExtensionScripts)===null||d===void 0?void 0:d.createScript("exports"))!==null&&f!==void 0?f:"exports",(n=(t=A._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(o=(s=A._ttpExtensionScripts)===null||s===void 0?void 0:s.createScript(I))!==null&&o!==void 0?o:I)}catch(z){throw a?console.error(`Loading code for extension ${a.value} failed: ${z.message}`):console.error(`Loading code failed: ${z.message}`),console.error(`${p.toString(!0)}${typeof z.line=="number"?` line ${z.line}`:""}${typeof z.column=="number"?` column ${z.column}`:""}`),console.error(z),z}const _={},F={exports:_},N=z=>{const ce=this._fakeModules.getModule(z,p);if(ce===void 0)throw new Error(`Cannot load module '${z}'`);return ce};try{return m.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),h(F,_,N),F.exports!==_?F.exports:_}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(a){throw new Error("Not supported")}async _waitForDebuggerAttachment(a=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const p=Date.now()+a;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,E.timeout)(10)}}}e.ExtHostExtensionService=A,A._ttpExtensionScripts=(S=self.trustedTypes)===null||S===void 0?void 0:S.createPolicy("ExtensionScripts",{createScript:r=>r});function c(r,a){return r.endsWith(a)?r:r+a}function g(r,a){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(l,d){const f=console[l];console[l]=function(){r.$logExtensionHostMessage({type:"__$console",severity:d,arguments:y(arguments)}),a&&f.apply(console,arguments)}}const m=1e5;function y(l){const d=[],f=[];if(l.length)for(let t=0;t<l.length;t++){if(typeof l[t]=="undefined")l[t]="undefined";else if(l[t]instanceof Error){const n=l[t];n.stack?l[t]=n.stack:l[t]=n.toString()}f.push(l[t])}try{const t=JSON.stringify(f,function(n,s){if(s&&typeof s=="object"){if(d.indexOf(s)!==-1)return"[Circular]";d.push(s)}return s});return t.length>m?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[227],we([0,1,62,16,35,226,212]),function(J,e,v,R,C,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(C.IExtHostExtensionService,T.ExtHostExtensionService),(0,v.registerSingleton)(R.ILogService,E.ExtHostLogService)}),define(be[229],we([0,1,24,3,183,221,214,14,81,225,227]),function(J,e,v,R,C,T,E,D,S){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const A=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const p=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("extensionHostWorker",{createScriptURL:y=>y}),m=self.Worker;Worker=function(y,l){const d=`importScripts('${y}');`;l=l||{},l.name=l.name||D.basename(y.toString());const f=new Blob([d],{type:"application/javascript"}),t=URL.createObjectURL(f);return new m(p?p.createScriptURL(t):t,l)}}else self.Worker=class extends E.NestedWorker{constructor(p,m){super(A,p,Object.assign({name:D.basename(p.toString())},m))}};const c=new class{exit(p){i()}async exists(p){return!0}async realpath(p){return p}};class g{constructor(){const m=new MessageChannel,y=new R.Emitter;let l=!1;A(m.port2,[m.port2]),m.port1.onmessage=d=>{const{data:f}=d;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const t=v.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if((0,C.isMessageOfType)(t,2)){l=!0,a("received terminate message from renderer");return}y.fire(t)},this.protocol={onMessage:y.event,send:d=>{if(!l){const f=d.buffer.buffer.slice(d.buffer.byteOffset,d.buffer.byteOffset+d.buffer.byteLength);m.port1.postMessage(f,[f])}}}}}function r(p){return new Promise(m=>{const y=p.onMessage(l=>{y.dispose();const d=JSON.parse(l.toString());p.send((0,C.createMessageOfType)(0)),m({protocol:p,initData:d})});p.send((0,C.createMessageOfType)(1))})}let a=p=>i();(function(){const m=new g;S.mark("code/extHost/willConnectToRenderer"),r(m.protocol).then(y=>{S.mark("code/extHost/didWaitForInitData");const l=new T.ExtensionHostMain(y.protocol,y.initData,c,null);a=d=>l.terminate(d)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0b355ffc89b2020a941ce149f2704acf13a49afd/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
